/* Note from nottud to other scripters - the input for functions like sin and cos
need to be converted from degrees into radians first before they will work
properly.

Use the command: rmDegreesToRadians(<degree input>);

I learnt the hard way :(.  I also thank Wolfenhex for making the following functions available for public use */

float PI = 3.141592;

float pow(float n = 0,int x = 0) {
	float r = n;
	for(i = 1; < x) {
		r = r * n;
	}
	return (r);
}

float atan(float n = 0) {
	float m = n;
	if(n > 1) m = 1.0 / n;
	if(n < -1) m = -1.0 / n;
	float r = m;
	for(i = 1; < 100) {
		int j = i * 2 + 1;
		float k = pow(m,j) / j;
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	if(n > 1 || n < -1) r = PI / 2.0 - r;
	if(n < -1) r = 0.0 - r;
	return (r);
}

float atan2(float z = 0,float x = 0) {
	if(x > 0) return (atan(z / x));
	if(x < 0) {
		if(z < 0) return (atan(z / x) - PI);
		if(z > 0) return (atan(z / x) + PI);
		return (PI);
	}
	if(z > 0) return (PI / 2.0);
	if(z < 0) return (0.0 - (PI / 2.0));
	return (0);
}

float fact(float n = 0) {
	float r = 1;
	for(i = 1; <= n) {
		r = r * i;
	}
	return (r);
}

float cos(float n = 0) {
	float r = 1;
	for(i = 1; < 100) {
		int j = i * 2;
		float k = pow(n,j) / fact(j);
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	return (r);
}

float sin(float n = 0) {
	float r = n;
	for(i = 1; < 100) {
		int j = i * 2 + 1;
		float k = pow(n,j) / fact(j);
		if(k == 0) break;
		if(i % 2 == 0) r = r + k;
		if(i % 2 == 1) r = r - k;
	}
	return (r);
}

// Circle placement stuff by Nottud

float circlex(float locationx = 0.0, int totalnumber = 0, int currentnumber = 0, float radius = 0.0, int displacement = 0){
	float a = ((360.0/totalnumber * (currentnumber-1)) + displacement + 45) % 360.0;
	float i = rmDegreesToRadians(a);
	float k = (((sin(i)*radius*2+1)/2)-0.5)+locationx;
	return(k);
}

float circley(float locationy = 0.0, int totalnumber = 0, int currentnumber = 0, float radius = 0.0, int displacement = 0){
	float a = ((360.0/totalnumber * (currentnumber-1)) + displacement + 45) % 360.0;
	float i = rmDegreesToRadians(a);
	float k = (((cos(i)*radius*2+1)/2)-0.5)+locationy;
	return(k);
}

float getCircleRot(int totalnumber = 0, int currentnumber = 0, int displacement = 0){
	float a = ((360.0/totalnumber * (currentnumber-1)) + displacement + 45) % 360.0;
	return(a);
}

// Custom trigger creator - By Nottud with a little help from Twenty One Score's bloodsport script

void code(string xs="", string xs2 = "", string xs3 = "") {
	if(xs2 == "" && xs3 == ""){
		rmAddTriggerEffect("SetIdleProcessing");
		rmSetTriggerEffectParam("IdleProc",");"+xs+"//");
	} else if(xs3 == "") {
		rmAddTriggerEffect("SetIdleProcessing");
		rmSetTriggerEffectParam("IdleProc",");"+xs+"/*");
		rmAddTriggerEffect("SetIdleProcessing");
		rmSetTriggerEffectParam("IdleProc",");*/"+xs2+"//");
	} else {
		rmAddTriggerEffect("SetIdleProcessing");
		rmSetTriggerEffectParam("IdleProc",");"+xs+"/*");
		rmAddTriggerEffect("SetIdleProcessing");
		rmSetTriggerEffectParam("IdleProc",");*/"+xs2+"/*");
		rmAddTriggerEffect("SetIdleProcessing");
		rmSetTriggerEffectParam("IdleProc",");*/"+xs3+"//");
	}
}

void codedebug(string xs2="") {
	rmAddTriggerEffect("Send Chat To Player");
	rmSetTriggerEffectParamInt("PlayerID", 0);
	rmSetTriggerEffectParamInt("ToPlayerID", 0);
	rmSetTriggerEffectParam("Message","\");/**/"+xs2+"/**///");
}

void con(string xs3="") {
	rmAddTriggerCondition("Player Defeated");
	rmSetTriggerConditionParam("PlayerID","0)||("+xs3+"));//");
}

void globalStart(){
	rmAddTriggerEffect("SetIdleProcessing");
	rmSetTriggerEffectParam("IdleProc",");}}/*");
}

void g(string xs=""){
	rmAddTriggerEffect("SetIdleProcessing");
	rmSetTriggerEffectParam("IdleProc",");*/"+xs+"/*");
}

void globalEnd(){
	rmAddTriggerEffect("SetIdleProcessing");
	rmSetTriggerEffectParam("IdleProc",");*/rule _globalEnd active {if(true){//");
}

void defineTrigger(string name = "", bool isActive = true, bool isLooping = false, bool isRunImmediately = false){
	rmSwitchToTrigger(rmCreateTrigger(name));
	rmSetTriggerPriority(4);
	rmSetTriggerActive(isActive);
	rmSetTriggerLoop(isLooping);
	rmSetTriggerRunImmediately(isRunImmediately);
}

void addToDatabaseAnytime(string name = "", int unitName = 0){
	code("trQuestVarSet(\"yDatabase"+name+"\"+(1*trQuestVarGet(\"yCount"+name+"\")), ",
			""+unitName+");");
	code("trQuestVarSet(\"yCount"+name+"\", trQuestVarGet(\"yCount"+name+"\") + 1);");
}

void addToDatabase(string name = ""){
	code("trQuestVarSet(\"yDatabase"+name+"\"+(1*trQuestVarGet(\"yCount"+name+"\")), ",
			"trQuestVarGet(\"cow\"));");
	code("trQuestVarSet(\"yCount"+name+"\", trQuestVarGet(\"yCount"+name+"\") + 1);");
}

void addToDatabaseFromDatabase(string name  = ""){
	code("trQuestVarSet(\"yDatabase"+name+"\"+(1*trQuestVarGet(\"yCount"+name+"\")), ",
			"trQuestVarGet(\"ySearchUnit\"));");
	code("trQuestVarSet(\"yCount"+name+"\", trQuestVarGet(\"yCount"+name+"\") + 1);");
}

void removeFromDatabase(string name = ""){
	code("if(ySearchRemoved == 0){");
		code("trQuestVarSet(\"yCount"+name+"\", trQuestVarGet(\"yCount"+name+"\") - 1);");
		code("trQuestVarSet(\"yDatabase"+name+"\" + ySearchId, ",
				"trQuestVarGet(\"yDatabase"+name+"\"+(1*trQuestVarGet(\"yCount"+name+"\"))));");
		code("ySearchRemoved = 1;");
	code("}");
}

void databaseSearchStart(string name  = ""){
	code("for(ySearchUnitOld = 0; > 1){}");
	code("for(ySearchId = -1; > 0){}");
	code("for(ySearchRemoved = 0; > 1){}");
	code("for(type = -1; > 0){}");
	code("ySearchUnitOld = trQuestVarGet(\"ySearchUnit\");");
	code("ySearchId = trQuestVarGet(\"yCount"+name+"\") - 1;");
	code("while(ySearchId >= 0){");
		code("ySearchRemoved = 0;");
		code("trQuestVarSet(\"ySearchUnit\", trQuestVarGet(\"yDatabase"+name+"\" + ySearchId));");
		code("if(0 > kbGetBlockID(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true)){");
			removeFromDatabase(name);
		code("} else {");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
			code("type = kbGetUnitBaseTypeID(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true));");
}

void databaseSearchEnd(){
		code("}");
		code("ySearchId = ySearchId - 1;");
	code("}");
	code("trQuestVarSet(\"ySearchUnit\", ySearchUnitOld);");
}

void removeFromDatabaseGlobal(string name = ""){
	g("if(ySearchRemoved == 0){");
		g("trQuestVarSet(\"yCount"+name+"\", trQuestVarGet(\"yCount"+name+"\") - 1);");
		g("trQuestVarSet(\"yDatabase"+name+"\" + ySearchId, ");
				g("trQuestVarGet(\"yDatabase"+name+"\"+(1*trQuestVarGet(\"yCount"+name+"\"))));");
		g("ySearchRemoved = 1;");
	g("}");
}

void databaseSearchStartGlobal(string name = ""){
	g("for(ySearchUnitOld = 0; > 1){}");
	g("for(ySearchId = -1; > 0){}");
	g("for(ySearchRemoved = 0; > 1){}");
	g("for(type = -1; > 0){}");
	g("ySearchUnitOld = trQuestVarGet(\"ySearchUnit\");");
	g("ySearchId = trQuestVarGet(\"yCount"+name+"\") - 1;");
	g("while(ySearchId >= 0){");
		g("ySearchRemoved = 0;");
		g("trQuestVarSet(\"ySearchUnit\", trQuestVarGet(\"yDatabase"+name+"\" + ySearchId));");
		g("if(0 > kbGetBlockID(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true)){");
			removeFromDatabaseGlobal(name);
		g("} else {");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
			g("type = kbGetUnitBaseTypeID(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true));");
}

void databaseSearchEndGlobal(){
		g("}");
		g("ySearchId = ySearchId - 1;");
	g("}");
	g("trQuestVarSet(\"ySearchUnit\", ySearchUnitOld);");
}

void addToVanishbase(string name = ""){
	code("trQuestVarSet(\"vanishbase"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"trQuestVarGet(\"cow\"));");
	code("trQuestVarSet(\"vanishbaseX"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"xsVectorGetX(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"cow\"), true)));");
	code("trQuestVarSet(\"vanishbaseY"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"xsVectorGetY(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"cow\"), true)));");
	code("trQuestVarSet(\"vanishbaseZ"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"xsVectorGetZ(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"cow\"), true)));");
	code("trQuestVarSet(\"vanishbaseOwner"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"getOwner(trQuestVarGet(\"cow\")));");
	code("trQuestVarSet(\"vanishbaseCount"+name+"\", trQuestVarGet(\"vanishbaseCount"+name+"\") + 1);");
}

void addToVanishbaseFromDatabase(string name = ""){
	code("trQuestVarSet(\"vanishbase"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"trQuestVarGet(\"ySearchUnit\"));");
	code("trQuestVarSet(\"vanishbaseX"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"xsVectorGetX(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)));");
	code("trQuestVarSet(\"vanishbaseY"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"xsVectorGetY(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)));");
	code("trQuestVarSet(\"vanishbaseZ"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"xsVectorGetZ(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)));");
	code("trQuestVarSet(\"vanishbaseOwner"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\")), ",
			"getOwner(trQuestVarGet(\"ySearchUnit\")));");
	code("trQuestVarSet(\"vanishbaseCount"+name+"\", trQuestVarGet(\"vanishbaseCount"+name+"\") + 1);");
}

void startVanishbaseSearch(string name = "", bool first = true){
	code("for(ySearchUnitOld = 0; > 1){}");
	code("for(ySearchVanishbaseId = 0; > 1){}");
	code("ySearchUnitOld = trQuestVarGet(\"ySearchUnit\");");
	code("ySearchVanishbaseId = trQuestVarGet(\"vanishbaseCount"+name+"\") - 1;");
	code("while(ySearchVanishbaseId >= 0){");
		code("trQuestVarSet(\"ySearchUnit\", trQuestVarGet(\"vanishbase"+name+"\" + ySearchVanishbaseId));");
		code("if(kbGetBlockID(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true) >= 0){");
			code("trQuestVarSet(\"vanishbaseX"+name+"\"+ySearchVanishbaseId, ",
					"xsVectorGetX(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)));");
			code("trQuestVarSet(\"vanishbaseY"+name+"\"+ySearchVanishbaseId, ",
					"xsVectorGetY(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)));");
			code("trQuestVarSet(\"vanishbaseZ"+name+"\"+ySearchVanishbaseId, ",
					"xsVectorGetZ(kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)));");
			code("trQuestVarSet(\"vanishbaseOwner"+name+"\"+ySearchVanishbaseId, ",
					"getOwner(trQuestVarGet(\"ySearchUnit\")));");
		code("} else {");
			code("trQuestVarSet(\"vanishbaseCount"+name+"\", trQuestVarGet(\"vanishbaseCount"+name+"\") - 1);");
			if(first){
				code("float x = trQuestVarGet(\"vanishbaseX"+name+"\"+ySearchVanishbaseId);");
				code("float y = trQuestVarGet(\"vanishbaseY"+name+"\"+ySearchVanishbaseId);");
				code("float z = trQuestVarGet(\"vanishbaseZ"+name+"\"+ySearchVanishbaseId);");
				code("vector v = xsVectorSet(x,y,z);");
				code("int owner = trQuestVarGet(\"vanishbaseOwner"+name+"\"+ySearchVanishbaseId);");
			} else {
				code("x = trQuestVarGet(\"vanishbaseX"+name+"\"+ySearchVanishbaseId);");
				code("y = trQuestVarGet(\"vanishbaseY"+name+"\"+ySearchVanishbaseId);");
				code("z = trQuestVarGet(\"vanishbaseZ"+name+"\"+ySearchVanishbaseId);");
				code("v = xsVectorSet(x,y,z);");
				code("owner = trQuestVarGet(\"vanishbaseOwner"+name+"\"+ySearchVanishbaseId);");
			}
			code("trQuestVarSet(\"vanishbase"+name+"\" + ySearchVanishbaseId, ",
					"trQuestVarGet(\"vanishbase"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\"))));");
			code("trQuestVarSet(\"vanishbaseX"+name+"\"+ySearchVanishbaseId, ",
					"trQuestVarGet(\"vanishbaseX"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\"))));");
			code("trQuestVarSet(\"vanishbaseY"+name+"\"+ySearchVanishbaseId, ",
					"trQuestVarGet(\"vanishbaseY"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\"))));");
			code("trQuestVarSet(\"vanishbaseZ"+name+"\"+ySearchVanishbaseId, ",
					"trQuestVarGet(\"vanishbaseZ"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\"))));");
			code("trQuestVarSet(\"vanishbaseOwner"+name+"\"+ySearchVanishbaseId, ",
					"trQuestVarGet(\"vanishbaseOwner"+name+"\"+(1*trQuestVarGet(\"vanishbaseCount"+name+"\"))));");
}
	
void endVanishbaseSearch(){
		code("}");
		code("ySearchVanishbaseId = ySearchVanishbaseId - 1;");
	code("}");
	code("trQuestVarSet(\"ySearchUnit\", ySearchUnitOld);");
}

void addToTimebase(string name = ""){
	code("trQuestVarSet(\"timebase"+name+"\"+(1*trQuestVarGet(\"timebaseCount"+name+"\")), trQuestVarGet(\"cow\"));");
	code("trQuestVarSet(\"timebaseTime"+name+"\"+(1*trQuestVarGet(\"timebaseCount"+name+"\")), trTimeMS());");
	code("trQuestVarSet(\"timebaseCount"+name+"\", trQuestVarGet(\"timebaseCount"+name+"\") + 1);");
}

void addToTimebaseFromDatabase(string name = ""){
	code("trQuestVarSet(\"timebase"+name+"\"+(1*trQuestVarGet(\"timebaseCount"+name+"\")), trQuestVarGet(\"ySearchUnit\"));");
	code("trQuestVarSet(\"timebaseTime"+name+"\"+(1*trQuestVarGet(\"timebaseCount"+name+"\")), trTimeMS());");
	code("trQuestVarSet(\"timebaseCount"+name+"\", trQuestVarGet(\"timebaseCount"+name+"\") + 1);");
}

void addToTimebaseFromDatabaseGlobal(string name = ""){
	g("trQuestVarSet(\"timebase"+name+"\"+(1*trQuestVarGet(\"timebaseCount"+name+"\")), trQuestVarGet(\"ySearchUnit\"));");
	g("trQuestVarSet(\"timebaseTime"+name+"\"+(1*trQuestVarGet(\"timebaseCount"+name+"\")), trTimeMS());");
	g("trQuestVarSet(\"timebaseCount"+name+"\", trQuestVarGet(\"timebaseCount"+name+"\") + 1);");
}

void removeFromTimebase(string name = ""){
	code("if(ySearchRemoved == 0){");
		code("trQuestVarSet(\"timebaseCount"+name+"\", trQuestVarGet(\"timebaseCount"+name+"\") - 1);");
		code("trQuestVarSet(\"timebase"+name+"\" + ySearchTimebaseId, ",
				"trQuestVarGet(\"timebase"+name+"\"+(1*trQuestVarGet(\"timebaseCount"+name+"\"))));");
		code("trQuestVarSet(\"timebaseTime"+name+"\" + ySearchTimebaseId, ",
				"trQuestVarGet(\"timebaseTime"+name+"\"+(1*trQuestVarGet(\"timebaseCount"+name+"\"))));");
		code("ySearchRemoved = 1;");
	code("}");
}

void startTimebaseSearch(string name = "", int timeMS = 1000){
	code("for(ySearchUnitOld = 0; > 1){}");
	code("for(ySearchTimebaseId = -1; > 0){}");
	code("for(ySearchRemoved = 0; > 1){}");
	code("for(type = -1; > 0){}");
	code("ySearchUnitOld = trQuestVarGet(\"ySearchUnit\");");
	code("ySearchTimebaseId = trQuestVarGet(\"timebaseCount"+name+"\") - 1;");
	code("while(ySearchTimebaseId >= 0){");
		code("ySearchRemoved = 0;");
		code("trQuestVarSet(\"ySearchUnit\", trQuestVarGet(\"timebase"+name+"\" + ySearchTimebaseId));");
		code("if(0 > kbGetBlockID(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true)){");
			removeFromTimebase(name);
		code("} else if(trTimeMS() - "+timeMS+" >= trQuestVarGet(\"timebaseTime"+name+"\"+ySearchTimebaseId)) {");
			code("trQuestVarSet(\"timebaseTime"+name+"\" + ySearchTimebaseId, ",
					"trQuestVarGet(\"timebaseTime"+name+"\" + ySearchTimebaseId) + "+timeMS+");");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
			code("type = kbGetUnitBaseTypeID(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true));");
}

void startTimebaseSearchCustom(string name = "", string custom = ""){
	code("for(ySearchUnitOld = 0; > 1){}");
	code("for(ySearchTimebaseId = -1; > 0){}");
	code("for(ySearchRemoved = 0; > 1){}");
	code("for(type = -1; > 0){}");
	code("for(timeMS = -1; > 0){}");
	code("ySearchUnitOld = trQuestVarGet(\"ySearchUnit\");");
	code("ySearchTimebaseId = trQuestVarGet(\"timebaseCount"+name+"\") - 1;");
	code("while(ySearchTimebaseId >= 0){");
		code("trQuestVarSet(\"ySearchUnit\", trQuestVarGet(\"timebase"+name+"\" + ySearchTimebaseId));");
		code("timeMS = "+custom+";");
		code("if(0 > kbGetBlockID(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true)){");
			removeFromTimebase(name);
		code("} else if(trTimeMS() - timeMS >= trQuestVarGet(\"timebaseTime"+name+"\"+ySearchTimebaseId)) {");
			code("ySearchRemoved = 0;");
			code("trQuestVarSet(\"timebaseTime"+name+"\" + ySearchTimebaseId, ",
					"trQuestVarGet(\"timebaseTime"+name+"\" + ySearchTimebaseId) + timeMS);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
			code("type = kbGetUnitBaseTypeID(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true));");
}
	
void endTimebaseSearch(){
		code("}");
		code("ySearchTimebaseId = ySearchTimebaseId - 1;");
	code("}");
	code("trQuestVarSet(\"ySearchUnit\", ySearchUnitOld);");
}

// Other

void randomlight() {
	code("trQuestVarSetFromRand(\"1R\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"1G\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"1B\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"2R\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"2G\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"2B\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"3R\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"3G\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"3B\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"4R\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"4G\", 0, 255, false);");
	code("trQuestVarSetFromRand(\"4B\", 0, 255, false);");
	code("fakeSpecularSunColor(trQuestVarGet(\"1R\"),trQuestVarGet(\"1G\"),trQuestVarGet(\"1B\"));");
	code("terrainAmbient(trQuestVarGet(\"2R\"),trQuestVarGet(\"2G\"),trQuestVarGet(\"2B\"));");
	code("sunColor(trQuestVarGet(\"3R\"),trQuestVarGet(\"3G\"),trQuestVarGet(\"3B\"));");
	code("ambientColor(trQuestVarGet(\"4R\"),trQuestVarGet(\"4G\"),trQuestVarGet(\"4B\"));");
}

void advancedLighting(int w1 = 0,int w2 = 0,int w3 = 0,int s1 = 0,int s2 = 0,int s3 = 0,int a1 = 0,int a2 = 0,int a3 = 0,int t1 = 0,int t2 = 0,int t3 = 0){
	code("fakeSpecularSunColor("+w1+","+w2+","+w3+");");
	code("sunColor("+s1+","+s2+","+s3+");");
	code("ambientColor("+a1+","+a2+","+a3+");");
	code("terrainAmbient("+t1+","+t2+","+t3+");");
}

void lightingRotation(int inc = 0,int rot = 0){
	code("subModeEnter(\"Simulation\", \"Editor\");");
	code("uiMessageBox(\"moo\",\"setSunPosition("+inc+","+rot+",false)\");");
	code("uiCycleCurrentActivate();");
	code("subModeLeave(\"Simulation\", \"Editor\");");
	code("modeEnter(\"pregame\");");
	code("modeEnter(\"Simulation\");");
	code("subModeEnter(\"Simulation\", \"Singleplayer\");");
}

void trCameraCut(string v1 = "(0,0,0)", string v2 = "(0,0,0)", string v3 = "(0,0,0)", string v4 = "(0,0,0)"){
	code("trCameraCut(vector" + v1 + ",/* ");
	code("*/vector" + v2 + ",/* ");
	code("*/vector" + v3 + ",/* ");
	code("*/vector" + v4 + ");");
}

void modifyProtounitAbsolute(string protounit = "", int p = 0, int field = 0, float value = 0.0){
	code("if("+field+" == 6){");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", -9999999999999999999.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", "+value+");");
	code("} else if("+field+" == 5 || "+field+" == 7 || "+field+" == 10 || "+field+" == 13){");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", 2147483648.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", 2147483648.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", "+value+");");
	code("} else {");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", 9999999999999999999.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", -9999999999999999999.0);");
	code("trModifyProtounit(\""+protounit+"\", "+p+", "+field+", "+value+");");
	code("}");
}

void modifyProtounitAbsoluteAllHumanPlayers(string protounit = "", int field = 0, float value = 0.0){
	code("for(p = 1; <= "+cNumberNonGaiaPlayers+"){");
		code("if("+field+" == 6){");
		code("trModifyProtounit(\""+protounit+"\", p, "+field+", -9999999999999999999.0);");
		code("trModifyProtounit(\""+protounit+"\", p, "+field+", "+value+");");
		code("} else if("+field+" == 5 || "+field+" == 7 || "+field+" == 10 || "+field+" == 13){");
		code("trModifyProtounit(\""+protounit+"\", p, "+field+", 2147483648.0);");
		code("trModifyProtounit(\""+protounit+"\", p, "+field+", 2147483648.0);");
		code("trModifyProtounit(\""+protounit+"\", p, "+field+", "+value+");");
		code("} else {");
		code("trModifyProtounit(\""+protounit+"\", p, "+field+", 9999999999999999999.0);");
		code("trModifyProtounit(\""+protounit+"\", p, "+field+", -9999999999999999999.0);");
		code("trModifyProtounit(\""+protounit+"\", p, "+field+", "+value+");");
		code("}");
	code("}");
}

void characterDialog(string character = "", string message = "", string portrait = ""){
	code("tempS = \""+message+"\";");
	code("tempS2 = \""+portrait+"\";");
	code("trSoundPlayFN(\"\",\"1\",-1,\""+character+":\"+tempS,tempS2);");
}

void playMusic(string musicName = ""){
	code("trFadeOutMusic(0);");
	code("trSoundPlayDialog(\""+musicName+"\", \"1\", 2, true, \"\", \"\");");
}

void createGlobalStringArray(string name = "Array", int count = 1, string initialValue = ""){
	for(i = 0; < count){
		g("string "+name+""+i+" = \""+initialValue+"\";");
	}
	g("string get"+name+"(int i = 0){");
		for(i = 0; < count){
			g("i--;if(i<0)return ("+name+""+i+");");
		}
	g("}");
	g("void set"+name+"(int i = 0, string value = \""+initialValue+"\"){");
		for(i = 0; < count){
			g("i--;if(i<0){"+name+""+i+" = value; return;}");
		}
	g("}");
}

void createGlobalIntArray(string name = "Array", int count = 1, int initialValue = 0){
	for(i = 0; < count){
		g("int "+name+""+i+" = "+initialValue+";");
	}
	g("int get"+name+"(int i = 0){");
		for(i = 0; < count){
			g("i--;if(i<0)return ("+name+""+i+");");
		}
	g("}");
	g("void set"+name+"(int i = 0, int value = "+initialValue+"){");
		for(i = 0; < count){
			g("i--;if(i<0){"+name+""+i+" = value; return;}");
		}
	g("}");
}

void createGlobalFloatArray(string name = "Array", int count = 1, float initialValue = 0.0){
	for(i = 0; < count){
		g("float "+name+""+i+" = "+initialValue+";");
	}
	g("float get"+name+"(int i = 0){");
		for(i = 0; < count){
			g("i--;if(i<0)return ("+name+""+i+");");
		}
	g("}");
	g("void set"+name+"(int i = 0, float value = "+initialValue+"){");
		for(i = 0; < count){
			g("i--;if(i<0){"+name+""+i+" = value; return;}");
		}
	g("}");
}

void createGlobalBoolArray(string name = "Array", int count = 1, bool initialValue = false){
	string boolValue = "false";
	if(initialValue){
		boolValue = "true";
	}
	for(i = 0; < count){
		g("bool "+name+""+i+" = "+boolValue+";");
	}
	g("bool get"+name+"(int i = 0){");
		for(i = 0; < count){
			g("i--;if(i<0)return ("+name+""+i+");");
		}
	g("}");
	g("void set"+name+"(int i = 0, bool value = "+boolValue+"){");
		for(i = 0; < count){
			g("i--;if(i<0){"+name+""+i+" = value; return;}");
		}
	g("}");
}

void createPlayerGlobalStringArray(string name = "Array", string initialValue = ""){
	for(i = 1; <= cNumberNonGaiaPlayers-2){
		g("string "+name+""+i+" = \""+initialValue+"\";");
	}
	g("string get"+name+"(int i = 1){");
		for(i = 1; <= cNumberNonGaiaPlayers-2){
			g("i--;if(i<1)return ("+name+""+i+");");
		}
	g("}");
	g("void set"+name+"(int i = 1, string value = \""+initialValue+"\"){");
		for(i = 1; <= cNumberNonGaiaPlayers-2){
			g("i--;if(i<1){"+name+""+i+" = value; return;}");
		}
	g("}");
}

void createPlayerGlobalIntArray(string name = "Array", int initialValue = 0){
	for(i = 1; <= cNumberNonGaiaPlayers-2){
		g("int "+name+""+i+" = "+initialValue+";");
	}
	g("int get"+name+"(int i = 1){");
		for(i = 1; <= cNumberNonGaiaPlayers-2){
			g("i--;if(i<1)return ("+name+""+i+");");
		}
	g("}");
	g("void set"+name+"(int i = 1, int value = "+initialValue+"){");
		for(i = 1; <= cNumberNonGaiaPlayers-2){
			g("i--;if(i<1){"+name+""+i+" = value; return;}");
		}
	g("}");
}

void createPlayerGlobalFloatArray(string name = "Array", float initialValue = 0.0){
	for(i = 1; <= cNumberNonGaiaPlayers-2){
		g("float "+name+""+i+" = "+initialValue+";");
	}
	g("float get"+name+"(int i = 1){");
		for(i = 1; <= cNumberNonGaiaPlayers-2){
			g("i--;if(i<1)return ("+name+""+i+");");
		}
	g("}");
	g("void set"+name+"(int i = 1, float value = "+initialValue+"){");
		for(i = 1; <= cNumberNonGaiaPlayers-2){
			g("i--;if(i<1){"+name+""+i+" = value; return;}");
		}
	g("}");
}

void createPlayerGlobalBoolArray(string name = "Array", bool initialValue = false){
	string boolValue = "false";
	if(initialValue){
		boolValue = "true";
	}
	for(i = 1; <= cNumberNonGaiaPlayers-2){
		g("bool "+name+""+i+" = "+boolValue+";");
	}
	g("bool get"+name+"(int i = 1){");
		for(i = 1; <= cNumberNonGaiaPlayers-2){
			g("i--;if(i<1)return ("+name+""+i+");");
		}
	g("}");
	g("void set"+name+"(int i = 1, bool value = "+boolValue+"){");
		for(i = 1; <= cNumberNonGaiaPlayers-2){
			g("i--;if(i<1){"+name+""+i+" = value; return;}");
		}
	g("}");
}

int getUnitIdFromName(string name = ""){
	if(name == "Hawk")return (0);
	if(name == "Palm Stump")return (1);
	if(name == "Bush")return (2);
	if(name == "Arrow")return (3);
	if(name == "Axe")return (4);
	if(name == "Blood")return (5);
	if(name == "Scarab Blood")return (6);
	if(name == "Waypoint Flag")return (7);
	if(name == "Moveto")return (8);
	if(name == "Test Object")return (9);
	if(name == "Yardstick")return (10);
	if(name == "Smoke")return (11);
	if(name == "Cloud")return (12);
	if(name == "Tornado")return (13);
	if(name == "Revealer")return (14);
	if(name == "Attack Revealer")return (15);
	if(name == "Construction Small")return (16);
	if(name == "Construction Medium")return (17);
	if(name == "Construction Large")return (18);
	if(name == "Construction Extra Large")return (19);
	if(name == "Ice Block")return (20);
	if(name == "Papyrus")return (21);
	if(name == "Wave")return (22);
	if(name == "Rainfall")return (23);
	if(name == "Ice Sheet")return (24);
	if(name == "Camera")return (25);
	if(name == "Camera Motion Arrow")return (26);
	if(name == "Camera Start")return (27);
	if(name == "Whale")return (28);
	if(name == "Fire Pit")return (29);
	if(name == "Rock Symbols")return (30);
	if(name == "Stalagmite")return (31);
	if(name == "Runestone")return (32);
	if(name == "Rock Snow")return (33);
	if(name == "Water Lilly")return (34);
	if(name == "Water Reeds")return (35);
	if(name == "Snowfall")return (36);
	if(name == "Mist")return (37);
	if(name == "Waterfall")return (38);
	if(name == "Garrison Flag")return (39);
	if(name == "Crate")return (40);
	if(name == "Rugs")return (41);
	if(name == "Market Stall")return (42);
	if(name == "Catapult Shot")return (43);
	if(name == "Misc Objects")return (44);
	if(name == "Inferno Fire Ground")return (45);
	if(name == "Lightning Strike")return (46);
	if(name == "Ballista Shot")return (47);
	if(name == "Splash")return (48);
	if(name == "Misc Stairs")return (49);
	if(name == "Coral Reef")return (50);
	if(name == "Hero Birth")return (51);
	if(name == "Cinematic Block")return (52);
	if(name == "Footprint Villager")return (53);
	if(name == "Flaming Footprint")return (54);
	if(name == "Icy Footprint")return (55);
	if(name == "Oar Footprint")return (56);
	if(name == "Meteor")return (57);
	if(name == "Lightning sparks")return (58);
	if(name == "Lightning Scorch")return (59);
	if(name == "Dust Small")return (60);
	if(name == "Dust Medium")return (61);
	if(name == "Dust Large")return (62);
	if(name == "Arrow Flaming")return (63);
	if(name == "Lightning Cloud")return (64);
	if(name == "Lightning Rain")return (65);
	if(name == "UI Army Banner Furled")return (66);
	if(name == "UI Army Banner Plain")return (67);
	if(name == "UI Army Banner Infantry")return (68);
	if(name == "UI Army Banner Cavalry")return (69);
	if(name == "UI Army Banner Archer")return (70);
	if(name == "UI Army Banner Villager")return (71);
	if(name == "Blood Gore")return (72);
	if(name == "Lightning Sparks Ground")return (73);
	if(name == "Hoofprint")return (74);
	if(name == "Footprint Military")return (75);
	if(name == "Fire Object")return (76);
	if(name == "UI Hero Banner")return (77);
	if(name == "UI Idle Villager Banner")return (78);
	if(name == "Giant Footprint")return (79);
	if(name == "Shark")return (80);
	if(name == "Orca")return (81);
	if(name == "Rock Granite Small")return (82);
	if(name == "Rock Limestone Small")return (83);
	if(name == "Grass")return (84);
	if(name == "Seagull")return (85);
	if(name == "Rock Granite Big")return (86);
	if(name == "Rock Limestone Big")return (87);
	if(name == "Rock Sandstone Big")return (88);
	if(name == "Rock Sandstone Small")return (89);
	if(name == "Rock River Sandy")return (90);
	if(name == "Rock River Grassy")return (91);
	if(name == "Rock River Icy")return (92);
	if(name == "Shifting Sands In")return (93);
	if(name == "UI Army Banner Myth")return (94);
	if(name == "UI Idle Military Banner")return (95);
	if(name == "Heavenlight")return (96);
	if(name == "Shifting Sands Out")return (97);
	if(name == "Shifting Sands Out Effect")return (98);
	if(name == "Inferno Unit Flame")return (99);
	if(name == "Revealer to Player")return (100);
	if(name == "Skeleton")return (101);
	if(name == "Sand Drift Dune")return (102);
	if(name == "Sand Drift Plain")return (103);
	if(name == "Sand Drift Patch")return (104);
	if(name == "Healing SFX")return (105);
	if(name == "Healing Area SFX")return (106);
	if(name == "Frost Drift")return (107);
	if(name == "Dust Devil")return (108);
	if(name == "Fountain")return (109);
	if(name == "Fire Wood")return (110);
	if(name == "Campfire")return (111);
	if(name == "Columns")return (112);
	if(name == "Columns Fallen")return (113);
	if(name == "Columns Broken")return (114);
	if(name == "Milestone")return (115);
	if(name == "Sign")return (116);
	if(name == "Clone SFX")return (117);
	if(name == "Invisible Ram")return (118);
	if(name == "Spear")return (119);
	if(name == "Sling Stone")return (120);
	if(name == "Rain")return (121);
	if(name == "Snow Storm")return (122);
	if(name == "Fertile Plants SFX")return (123);
	if(name == "Cinematic rocks")return (124);
	if(name == "Cinematic Trees")return (125);
	if(name == "Cinematic Dead Bodies")return (126);
	if(name == "Destroyed Buildings Small")return (127);
	if(name == "Cinematic Scorch")return (128);
	if(name == "undermine ground decal long")return (129);
	if(name == "undermine ground decal short")return (130);
	if(name == "undermine ground decal corner")return (131);
	if(name == "Armor Glow Small")return (132);
	if(name == "Tornado Debris")return (133);
	if(name == "Raft")return (134);
	if(name == "Meteor Impact Water")return (135);
	if(name == "Meteor Impact Ground")return (136);
	if(name == "Rain Small")return (137);
	if(name == "Ball of Fire")return (138);
	if(name == "Increase Prosperity Large")return (139);
	if(name == "Increase Prosperity Small")return (140);
	if(name == "Ball of fire impact")return (141);
	if(name == "Dove")return (142);
	if(name == "Snow Drift Archery")return (143);
	if(name == "Snow Drift Barracks")return (144);
	if(name == "Snow Drift Stable")return (145);
	if(name == "Snow Drift Settlements")return (146);
	if(name == "Snow Drift Tower")return (147);
	if(name == "Snow Drift Siege")return (148);
	if(name == "Snow Drift Major Temple")return (149);
	if(name == "Tunnel Opening")return (150);
	if(name == "Volley")return (151);
	if(name == "Hades Fire")return (152);
	if(name == "Rock Granite Sprite")return (153);
	if(name == "Vision Revealer")return (154);
	if(name == "Bolt Strike")return (155);
	if(name == "Spy Eye")return (156);
	if(name == "Curse SFX")return (157);
	if(name == "Sentinel Base")return (158);
	if(name == "Bolt Scorch")return (159);
	if(name == "Citadel SFX")return (160);
	if(name == "Vision SFX")return (161);
	if(name == "Ragnorok SFX")return (162);
	if(name == "Fimbulwinter SFX")return (163);
	if(name == "Plenty Flare")return (164);
	if(name == "Osiris Lightning")return (165);
	if(name == "Osiris SFX")return (166);
	if(name == "Priest Projectile")return (167);
	if(name == "UI Army Banner Siege")return (168);
	if(name == "Rock Limestone Sprite")return (169);
	if(name == "Rock Sandstone Sprite")return (170);
	if(name == "Pine Stump")return (171);
	if(name == "Oak stump")return (172);
	if(name == "Earthquake")return (173);
	if(name == "Barrel")return (174);
	if(name == "Pots")return (175);
	if(name == "Broken Siege Weapons")return (176);
	if(name == "Kraken Bits")return (177);
	if(name == "Flowers")return (178);
	if(name == "Seaweed")return (179);
	if(name == "Fern")return (180);
	if(name == "Flag Numbered")return (181);
	if(name == "Scorpion Tail")return (182);
	if(name == "Generic Corpse")return (183);
	if(name == "Wadjet Spit")return (184);
	if(name == "Hero Death")return (185);
	if(name == "Petosuchus Beam")return (186);
	if(name == "Earthquake CrackA")return (187);
	if(name == "Earthquake CrackB")return (188);
	if(name == "Earthquake CrackC")return (189);
	if(name == "Earthquake CrackD")return (190);
	if(name == "Forest Fire SFX")return (191);
	if(name == "Petosuchus projectile")return (192);
	if(name == "Recognizer")return (193);
	if(name == "Manticore Barb")return (194);
	if(name == "Arrow Splash SFX")return (195);
	if(name == "Petrobolos Shot")return (196);
	if(name == "UI Town Bell Banner")return (197);
	if(name == "Pestilence SFX1")return (198);
	if(name == "Pestilence SFX2")return (199);
	if(name == "Hero Death Revealer")return (200);
	if(name == "Testomatic")return (201);
	if(name == "Gate Ram Destroyed")return (202);
	if(name == "Spear Flaming")return (203);
	if(name == "Destroyed Buildings Med")return (204);
	if(name == "Destroyed Buildings Large")return (205);
	if(name == "Osiris")return (206);
	if(name == "SPCMeteor")return (207);
	if(name == "Avalanche")return (208);
	if(name == "Einheriar Boost SFX")return (209);
	if(name == "Arrow Signal")return (210);
	if(name == "Osiris Birth")return (211);
	if(name == "Osiris Box Glow")return (212);
	if(name == "UI Banner Objective")return (213);
	if(name == "Oak stump burnt")return (214);
	if(name == "Fire Object Big")return (215);
	if(name == "Smoke Big")return (216);
	if(name == "UI Army Banner Hero")return (217);
	if(name == "Mummy Flies")return (218);
	if(name == "Vulture")return (219);
	if(name == "Conversion SFX")return (220);
	if(name == "UI Army Banner Naval")return (221);
	if(name == "Fire Hades")return (222);
	if(name == "Destruction 3x3")return (223);
	if(name == "Destruction 4x4")return (224);
	if(name == "Destruction 5x5")return (225);
	if(name == "Destruction 8x8")return (226);
	if(name == "Thor hammer")return (227);
	if(name == "Regeneration SFX")return (228);
	if(name == "Poison SFX")return (229);
	if(name == "Taproot large")return (230);
	if(name == "Taproot Small")return (231);
	if(name == "Shadow")return (232);
	if(name == "Destruction Settlement")return (233);
	if(name == "Destruction 2x2")return (234);
	if(name == "Destruction 1x1")return (235);
	if(name == "UI Army Banner Caravan")return (236);
	if(name == "UI Army Banner Oxcart")return (237);
	if(name == "MIne Pieces")return (238);
	if(name == "Underworld Smoke")return (239);
	if(name == "Underworld Explosion")return (240);
	if(name == "UI Cloud Boarder")return (241);
	if(name == "Blood Cinematic")return (242);
	if(name == "Skeleton Giant")return (243);
	if(name == "Skeleton Animal")return (244);
	if(name == "Shipwreck")return (245);
	if(name == "Ruins")return (246);
	if(name == "Rotting Log")return (247);
	if(name == "Underbrush")return (248);
	if(name == "Grass Tall")return (249);
	if(name == "Rock Cliff")return (250);
	if(name == "UI Range Indicator Egypt SFX")return (251);
	if(name == "Harpy")return (252);
	if(name == "Blowing Leaves")return (253);
	if(name == "Hawksbill")return (254);
	if(name == "Blood Flow")return (255);
	if(name == "Ball of Fire invisible")return (256);
	if(name == "Splash Footprint")return (257);
	if(name == "Lava Bubbling")return (258);
	if(name == "Wood Pile 1")return (259);
	if(name == "Wood Pile 2")return (260);
	if(name == "Wood Pile 3")return (261);
	if(name == "Trident")return (262);
	if(name == "Destruction Citadel")return (263);
	if(name == "Forest Fire Attack")return (264);
	if(name == "UI Range Indicator Greek SFX")return (265);
	if(name == "UI Range Indicator Norse SFX")return (266);
	if(name == "Invisible Gate")return (267);
	if(name == "UI Army Banner Building")return (268);
	if(name == "Water decoration")return (269);
	if(name == "Footprint Cavalry")return (270);
	if(name == "Footprint Animal Large")return (271);
	if(name == "Footprint Animal Small")return (272);
	if(name == "Footprint Siege")return (273);
	if(name == "Evil Cloud SFX ")return (274);
	if(name == "Smoke Giant")return (275);
	if(name == "Crate Small")return (276);
	if(name == "Cinematic Wake")return (277);
	if(name == "Weapons")return (278);
	if(name == "Footprint Giant")return (279);
	if(name == "Footprint Elephant")return (280);
	if(name == "Footprint Wheel")return (281);
	if(name == "Footprint Hydra")return (282);
	if(name == "Footprint Portable Ram")return (283);
	if(name == "Footprint Scorpion")return (284);
	if(name == "Footprint Scarab")return (285);
	if(name == "Savannah stump")return (286);
	if(name == "Chicken Blood")return (287);
	if(name == "Crab Blood")return (288);
	if(name == "Arkantos Boost SFX")return (289);
	if(name == "Tremor")return (290);
	if(name == "Meteorite")return (291);
	if(name == "Iceberg")return (292);
	if(name == "GaiaCreepFlowers")return (293);
	if(name == "Deconstruct Unit")return (294);
	if(name == "Deconstruct Building")return (295);
	if(name == "Chaos effect")return (296);
	if(name == "Traitors effect")return (297);
	if(name == "Meteorite death")return (298);
	if(name == "Marsh Brush")return (299);
	if(name == "Tundra Brush")return (300);
	if(name == "Audrey Base")return (301);
	if(name == "Audrey Water Base")return (302);
	if(name == "Vortex start")return (303);
	if(name == "Vortex finish")return (304);
	if(name == "Marsh stump")return (305);
	if(name == "Tundra stump")return (306);
	if(name == "Fireball Launch Damage Effect")return (307);
	if(name == "Spider")return (308);
	if(name == "Implode Sphere")return (309);
	if(name == "Implode Sphere Effect")return (310);
	if(name == "Implode Lightning Effect")return (311);
	if(name == "Implode Pull Effect")return (312);
	if(name == "Javelin Flaming")return (313);
	if(name == "Implode Shockwave")return (314);
	if(name == "Spider Door")return (315);
	if(name == "Lampades Blood")return (316);
	if(name == "Acid Pool")return (317);
	if(name == "Spider Warn")return (318);
	if(name == "Gaia Forest effect")return (319);
	if(name == "Vortex start linked")return (320);
	if(name == "Vortex finish linked")return (321);
	if(name == "Vortex landing")return (322);
	if(name == "Implode Debris")return (323);
	if(name == "Titan Atlantean Footprint")return (324);
	if(name == "Timeshift out")return (325);
	if(name == "Timeshift in")return (326);
	if(name == "Tartarian Gate flame")return (327);
	if(name == "Heka Shockwave SFX")return (328);
	if(name == "Tartarian Gate creature effect")return (329);
	if(name == "Garrison Flag Sky Passage")return (330);
	if(name == "Lampades Bolt")return (331);
	if(name == "Fire Siphon Fire")return (332);
	if(name == "Stymph Bird Feather")return (333);
	if(name == "Osiris Pyramid Dead")return (334);
	if(name == "Rocket")return (335);
	if(name == "UI Range Indicator Atlantean SFX")return (336);
	if(name == "Tower Mirror Focuser")return (337);
	if(name == "Kronny Birth")return (338);
	if(name == "Mist Olympus")return (339);
	if(name == "Seagull High")return (340);
	if(name == "Seagull Low")return (341);
	if(name == "Repeat Flag")return (342);
	if(name == "Ball of Fire Prometheus")return (343);
	if(name == "Shockwave stun effect")return (344);
	if(name == "Arkantos God Out")return (345);
	if(name == "Olympus Temple SFX")return (346);
	if(name == "Kronny Birth SFX")return (347);
	if(name == "Lava Sheet")return (348);
	if(name == "Sound Gaia SFX")return (349);
	if(name == "Footprint Prometheanbig")return (350);
	if(name == "Footprint Prometheansmall")return (351);
	if(name == "Cinematic Dead Bodies Xpack")return (352);
	if(name == "Tartarian Rubble")return (353);
	if(name == "Titan Death")return (354);
	if(name == "Spearman")return (355);
	if(name == "Axeman")return (356);
	if(name == "Slinger")return (357);
	if(name == "Raiding Cavalry")return (358);
	if(name == "Camelry")return (359);
	if(name == "Dwarf")return (360);
	if(name == "Barracks")return (361);
	if(name == "Dock")return (362);
	if(name == "Farm")return (363);
	if(name == "Granary")return (364);
	if(name == "Armory")return (365);
	if(name == "Gate")return (366);
	if(name == "Market")return (367);
	if(name == "Stable")return (368);
	if(name == "Fortress")return (369);
	if(name == "Monument")return (370);
	if(name == "Siege Camp")return (371);
	if(name == "Wonder")return (372);
	if(name == "Cyclops")return (373);
	if(name == "Goat")return (374);
	if(name == "Wolf")return (375);
	if(name == "Pine")return (376);
	if(name == "Storehouse")return (377);
	if(name == "Scarab")return (378);
	if(name == "Ballista")return (379);
	if(name == "Siege Tower")return (380);
	if(name == "Crocodile")return (381);
	if(name == "Hippo")return (382);
	if(name == "Palm")return (383);
	if(name == "Flag")return (384);
	if(name == "Anubite")return (385);
	if(name == "Bear")return (386);
	if(name == "Fire Giant")return (387);
	if(name == "Locust Swarm")return (388);
	if(name == "Boar")return (389);
	if(name == "Frost Giant")return (390);
	if(name == "Wall Long")return (391);
	if(name == "Catapult")return (392);
	if(name == "Caravan Norse")return (393);
	if(name == "Troll")return (394);
	if(name == "Mountain Giant")return (395);
	if(name == "Einheriar")return (396);
	if(name == "Kraken")return (397);
	if(name == "Sea Turtle")return (398);
	if(name == "Valkyrie")return (399);
	if(name == "Battle Boar")return (400);
	if(name == "Trireme")return (401);
	if(name == "Fishing Ship Greek")return (402);
	if(name == "Bridge")return (403);
	if(name == "Cow")return (404);
	if(name == "Giraffe")return (405);
	if(name == "Statue Pharaoh")return (406);
	if(name == "Torch")return (407);
	if(name == "Pig")return (408);
	if(name == "Lazer Bear")return (409);
	if(name == "Zebra")return (410);
	if(name == "Water Buffalo")return (411);
	if(name == "Gazelle")return (412);
	if(name == "Baboon")return (413);
	if(name == "Centaur")return (414);
	if(name == "Phoenix")return (415);
	if(name == "Manticore")return (416);
	if(name == "Chimera")return (417);
	if(name == "Sphinx")return (418);
	if(name == "Minotaur")return (419);
	if(name == "Hydra")return (420);
	if(name == "Chicken")return (421);
	if(name == "Monkey")return (422);
	if(name == "Colossus")return (423);
	if(name == "Mummy")return (424);
	if(name == "Roc")return (425);
	if(name == "Medusa")return (426);
	if(name == "Obelisk")return (427);
	if(name == "Hades Door")return (428);
	if(name == "Ajax")return (429);
	if(name == "Arkantos")return (430);
	if(name == "Gargarensis")return (431);
	if(name == "Setna")return (432);
	if(name == "Shaba Ka")return (433);
	if(name == "Odysseus")return (434);
	if(name == "Chiron")return (435);
	if(name == "Amanra")return (436);
	if(name == "Wall Connector")return (437);
	if(name == "Wall Short")return (438);
	if(name == "Leviathan")return (439);
	if(name == "Statue Lion Right")return (440);
	if(name == "Statue Lion Left")return (441);
	if(name == "Egyptian Vulture")return (442);
	if(name == "Reginleif")return (443);
	if(name == "Scout")return (444);
	if(name == "Archery Range")return (445);
	if(name == "Scorpion Man")return (446);
	if(name == "Minion")return (447);
	if(name == "Fish - Perch")return (448);
	if(name == "Great Box")return (449);
	if(name == "Great Box Cart")return (450);
	if(name == "Gold Mine")return (451);
	if(name == "Kamos")return (452);
	if(name == "Oak Tree")return (453);
	if(name == "Pyramid Large")return (454);
	if(name == "Pyramid Small")return (455);
	if(name == "Lion")return (456);
	if(name == "Rhinocerous")return (457);
	if(name == "Hyena")return (458);
	if(name == "Crowned Crane")return (459);
	if(name == "Aurochs")return (460);
	if(name == "Fish - Mahi")return (461);
	if(name == "Fish - Salmon")return (462);
	if(name == "Giant Duck-billed Platypus")return (463);
	if(name == "Temple")return (464);
	if(name == "House")return (465);
	if(name == "Tent")return (466);
	if(name == "Elephant")return (467);
	if(name == "Tunnel")return (468);
	if(name == "Tower")return (469);
	if(name == "Settlement")return (470);
	if(name == "Pegasus")return (471);
	if(name == "Scylla")return (472);
	if(name == "Avenger")return (473);
	if(name == "Raven")return (474);
	if(name == "Excavation")return (475);
	if(name == "Guardian")return (476);
	if(name == "Guardian Sleeping")return (477);
	if(name == "Sword Bearers")return (478);
	if(name == "Deer")return (479);
	if(name == "Settlement Level 1")return (480);
	if(name == "Ox Cart")return (481);
	if(name == "Fence Stone")return (482);
	if(name == "Fence Wood")return (483);
	if(name == "Villager Norse")return (484);
	if(name == "Longhouse")return (485);
	if(name == "Academy")return (486);
	if(name == "Villager Greek")return (487);
	if(name == "Portable Ram")return (488);
	if(name == "Hill Fort")return (489);
	if(name == "Villager Egyptian")return (490);
	if(name == "Throwing Axeman")return (491);
	if(name == "Ulfsark")return (492);
	if(name == "Huskarl")return (493);
	if(name == "Shrine")return (494);
	if(name == "Hero Norse")return (495);
	if(name == "Hero Greek Achilles")return (496);
	if(name == "Pharaoh")return (497);
	if(name == "Lumber Camp")return (498);
	if(name == "Mining Camp")return (499);
	if(name == "Hero Greek Odysseus")return (500);
	if(name == "Hero Greek Chiron")return (501);
	if(name == "Hero Greek Polyphemus")return (502);
	if(name == "Hoplite")return (503);
	if(name == "Hypaspist")return (504);
	if(name == "Hippikon")return (505);
	if(name == "Prodromos")return (506);
	if(name == "Peltast")return (507);
	if(name == "Toxotes")return (508);
	if(name == "Petrobolos")return (509);
	if(name == "Helepolis")return (510);
	if(name == "Priest")return (511);
	if(name == "Migdol Stronghold")return (512);
	if(name == "Chariot Archer")return (513);
	if(name == "Myrmidon")return (514);
	if(name == "Hetairoi")return (515);
	if(name == "Cataphract")return (516);
	if(name == "Mercenary")return (517);
	if(name == "Monument 2")return (518);
	if(name == "Monument 3")return (519);
	if(name == "Monument 4")return (520);
	if(name == "Monument 5")return (521);
	if(name == "Statue of Major God")return (522);
	if(name == "Dwarven Forge")return (523);
	if(name == "Folstag Flag Bearer")return (524);
	if(name == "Trojan Horse")return (525);
	if(name == "Berry Bush")return (526);
	if(name == "Bolder Wall")return (527);
	if(name == "Mercenary Cavalry")return (528);
	if(name == "Pirate Ship")return (529);
	if(name == "Gate Ram")return (530);
	if(name == "Jarl")return (531);
	if(name == "Wall Long Destruction SFX")return (532);
	if(name == "Wall Short Destruction SFX")return (533);
	if(name == "Wall Connector Destruction SFX")return (534);
	if(name == "Outpost")return (535);
	if(name == "Transport Ship Greek")return (536);
	if(name == "Kebenit")return (537);
	if(name == "Longboat")return (538);
	if(name == "Lighthouse")return (539);
	if(name == "Hero Boar")return (540);
	if(name == "Hero Greek Heracles")return (541);
	if(name == "Hero Greek Jason")return (542);
	if(name == "Fishing Ship Norse")return (543);
	if(name == "Fishing Ship Egyptian")return (544);
	if(name == "Transport Ship Egyptian")return (545);
	if(name == "Troy Gate")return (546);
	if(name == "Troy Wall Connector")return (547);
	if(name == "Troy Wall Long")return (548);
	if(name == "Troy Wall Short")return (549);
	if(name == "Hero Greek Hippolyta")return (550);
	if(name == "Hero Greek Theseus")return (551);
	if(name == "Hero Greek Bellerophon")return (552);
	if(name == "Hero Greek Ajax")return (553);
	if(name == "Hero Greek Atalanta")return (554);
	if(name == "Hero Greek Perseus")return (555);
	if(name == "Flying Purple Hippo")return (556);
	if(name == "Caravan Greek")return (557);
	if(name == "Caravan Egyptian")return (558);
	if(name == "Relic")return (559);
	if(name == "Skult")return (560);
	if(name == "Bolder Rolling")return (561);
	if(name == "Gold Mine Small")return (562);
	if(name == "Pine Snow")return (563);
	if(name == "Circe")return (564);
	if(name == "Stop Combat")return (565);
	if(name == "Naval Shipyard")return (566);
	if(name == "Ramming Ship Greek")return (567);
	if(name == "Siege Ship Greek")return (568);
	if(name == "Hero Greek Argo")return (569);
	if(name == "Ramming Ship Norse")return (570);
	if(name == "Ramming Ship Egyptian")return (571);
	if(name == "Siege Ship Norse")return (572);
	if(name == "Siege Ship Egyptian")return (573);
	if(name == "Shade")return (574);
	if(name == "Animal Attractor")return (575);
	if(name == "Healing Spring Object")return (576);
	if(name == "Serpent")return (577);
	if(name == "Sentinel Main")return (578);
	if(name == "Citadel Center")return (579);
	if(name == "Walking Woods Pine")return (580);
	if(name == "Walking Woods Oak")return (581);
	if(name == "Walking Woods Palm")return (582);
	if(name == "Hero Ragnorok")return (583);
	if(name == "Nidhogg")return (584);
	if(name == "Fimbulwinter Wolf")return (585);
	if(name == "Plenty Vault")return (586);
	if(name == "Pharaoh of Osiris")return (587);
	if(name == "Gold Mine Dwarven")return (588);
	if(name == "Fenris Wolf")return (589);
	if(name == "Athena")return (590);
	if(name == "Walrus")return (591);
	if(name == "Wadjet")return (592);
	if(name == "Petsuchos")return (593);
	if(name == "Nemean Lion")return (594);
	if(name == "Agamemnon")return (595);
	if(name == "Theocrat")return (596);
	if(name == "Shade of Hades")return (597);
	if(name == "Atlantis Wall Connector")return (598);
	if(name == "Atlantis Wall Long")return (599);
	if(name == "Atlantis Gate")return (600);
	if(name == "Tamarisk Tree")return (601);
	if(name == "Phoenix Egg")return (602);
	if(name == "Polar Bear")return (603);
	if(name == "Walking Woods Pine Snow")return (604);
	if(name == "Caribou")return (605);
	if(name == "Elk")return (606);
	if(name == "Pig Special")return (607);
	if(name == "Titan Bad")return (608);
	if(name == "Palm Burning")return (609);
	if(name == "Oak Tree Burning")return (610);
	if(name == "Pine Burning")return (611);
	if(name == "Great Box Cart 2")return (612);
	if(name == "Transport Ship Norse")return (613);
	if(name == "Thor Hammer Haft")return (614);
	if(name == "Thor Hammer Head")return (615);
	if(name == "Pine Snow Burning")return (616);
	if(name == "War Elephant")return (617);
	if(name == "Oak Autumn")return (618);
	if(name == "Brokk")return (619);
	if(name == "Eitri")return (620);
	if(name == "Dwarf Foundry")return (621);
	if(name == "Hippocampus")return (622);
	if(name == "Oak Autumn Burning")return (623);
	if(name == "Skraeling")return (624);
	if(name == "Underworld Passage SPC")return (625);
	if(name == "Carcinos")return (626);
	if(name == "Jormund Elver")return (627);
	if(name == "Militia")return (628);
	if(name == "Kastor")return (629);
	if(name == "Sea Snake")return (630);
	if(name == "Old Man")return (631);
	if(name == "Jail Wall")return (632);
	if(name == "Dig Pile")return (633);
	if(name == "Golden Fleece")return (634);
	if(name == "Temple Underworld")return (635);
	if(name == "Arkantosman")return (636);
	if(name == "Bolder Rolling Dead")return (637);
	if(name == "Bolder Rolling 2")return (638);
	if(name == "Pine Dead")return (639);
	if(name == "Gate Ram 2")return (640);
	if(name == "Mini Atlantis")return (641);
	if(name == "Atlantis Tile")return (642);
	if(name == "Atlantis Tile Dead")return (643);
	if(name == "Well of Urd")return (644);
	if(name == "Troy Gate Dead")return (645);
	if(name == "Plenty Vault KOTH")return (646);
	if(name == "Poseidon Statue")return (647);
	if(name == "Pharaoh Secondary")return (648);
	if(name == "Savannah Tree")return (649);
	if(name == "Golden Lion")return (650);
	if(name == "Monkey Relic")return (651);
	if(name == "Ghost Ship")return (652);
	if(name == "Shade of Erebus")return (653);
	if(name == "Bandit Migdol")return (654);
	if(name == "Gold Mine Tiny")return (655);
	if(name == "Wall Medium")return (656);
	if(name == "Statue of Lightning")return (657);
	if(name == "Crossbowman")return (658);
	if(name == "Fence Iron")return (659);
	if(name == "Charon Ferry")return (660);
	if(name == "Hero Boar 2")return (661);
	if(name == "Taproot")return (662);
	if(name == "Female")return (663);
	if(name == "Theris")return (664);
	if(name == "Ornlu")return (665);
	if(name == "Polaris")return (666);
	if(name == "Tamarisk Tree Dead")return (667);
	if(name == "Prisoner")return (668);
	if(name == "Folstag Flag")return (669);
	if(name == "Undermine Building Destruction SFX")return (670);
	if(name == "Pine Dead Burning")return (671);
	if(name == "Ape of Set")return (672);
	if(name == "Gazelle of Set")return (673);
	if(name == "Hyena of Set")return (674);
	if(name == "Crocodile of Set")return (675);
	if(name == "Hippo of Set")return (676);
	if(name == "Rhinoceros of Set")return (677);
	if(name == "Giraffe of Set")return (678);
	if(name == "Kraken SPC")return (679);
	if(name == "Savannah Tree Burning")return (680);
	if(name == "Wonder SPC")return (681);
	if(name == "Monkey Raft")return (682);
	if(name == "Forkboy")return (683);
	if(name == "Walking Berry Bush")return (684);
	if(name == "Chicken Exploding")return (685);
	if(name == "Walking Woods Savannah")return (686);
	if(name == "Erebus Tree")return (687);
	if(name == "Villager Atlantean")return (688);
	if(name == "Manor")return (689);
	if(name == "Villager Atlantean Hero")return (690);
	if(name == "Swordsman")return (691);
	if(name == "Trident Soldier")return (692);
	if(name == "Trident Soldier Hero")return (693);
	if(name == "Swordsman Hero")return (694);
	if(name == "Fishing Ship Atlantean")return (695);
	if(name == "Bireme")return (696);
	if(name == "Transport Ship Atlantean")return (697);
	if(name == "Fire Ship Atlantean")return (698);
	if(name == "Siege Ship Atlantean")return (699);
	if(name == "Lancer")return (700);
	if(name == "Lancer Hero")return (701);
	if(name == "Counter Building")return (702);
	if(name == "Chieroballista")return (703);
	if(name == "Fire Siphon")return (704);
	if(name == "Caravan Atlantean")return (705);
	if(name == "Palace")return (706);
	if(name == "Royal Guard")return (707);
	if(name == "Royal Guard Hero")return (708);
	if(name == "Sky Passage")return (709);
	if(name == "Titan Atlantean")return (710);
	if(name == "Barracks Atlantean")return (711);
	if(name == "Archer Atlantean")return (712);
	if(name == "Archer Atlantean Hero")return (713);
	if(name == "Maceman")return (714);
	if(name == "Maceman Hero")return (715);
	if(name == "Javelin Cavalry")return (716);
	if(name == "Javelin Cavalry Hero")return (717);
	if(name == "Audrey")return (718);
	if(name == "Audrey Water")return (719);
	if(name == "Guild")return (720);
	if(name == "Volcano")return (721);
	if(name == "Behemoth")return (722);
	if(name == "Flying Medic")return (723);
	if(name == "Tower Mirror")return (724);
	if(name == "Promethean")return (725);
	if(name == "Servant")return (726);
	if(name == "Satyr")return (727);
	if(name == "Stymphalian Bird")return (728);
	if(name == "Automaton")return (729);
	if(name == "Man O War")return (730);
	if(name == "Promethean Small")return (731);
	if(name == "Oracle Hero")return (732);
	if(name == "Gaia Forest tree")return (733);
	if(name == "Heka Gigantes")return (734);
	if(name == "Tundra Tree")return (735);
	if(name == "Marsh Tree")return (736);
	if(name == "Tartarian Gate")return (737);
	if(name == "Oracle Scout")return (738);
	if(name == "Tartarian Gate spawn")return (739);
	if(name == "Lampades")return (740);
	if(name == "Kastor Adult")return (741);
	if(name == "Marsh Tree Burning")return (742);
	if(name == "Tundra Tree Burning")return (743);
	if(name == "Phoenix From Egg")return (744);
	if(name == "Hesperides Tree")return (745);
	if(name == "Dryad")return (746);
	if(name == "Nereid")return (747);
	if(name == "Titan Gate")return (748);
	if(name == "Walking Woods Marsh")return (749);
	if(name == "Walking Woods Tundra")return (750);
	if(name == "Titan Prometheus")return (751);
	if(name == "General Melagius")return (752);
	if(name == "Pharaoh of Osiris XP")return (753);
	if(name == "Guardian Sleeping XP")return (754);
	if(name == "Statue of Automaton")return (755);
	if(name == "Statue of Automaton Base")return (756);
	if(name == "Argus")return (757);
	if(name == "Gaia Pool")return (758);
	if(name == "Spider Egg")return (759);
	if(name == "King Folstag")return (760);
	if(name == "Odins Tower")return (761);
	if(name == "Statue Manticore")return (762);
	if(name == "Statue Cyclops")return (763);
	if(name == "Statue Nemean Lion")return (764);
	if(name == "Statue Valkyrie")return (765);
	if(name == "Statue Hydra")return (766);
	if(name == "Statue Chimera")return (767);
	if(name == "Gaia Forest tree burning")return (768);
	if(name == "Tartarian Gate placement")return (769);
	if(name == "Tartarian Gate birth")return (770);
	if(name == "Krios")return (771);
	if(name == "Kronny")return (772);
	if(name == "Ajax Older")return (773);
	if(name == "Amanra Older")return (774);
	if(name == "Titan Gate Dead")return (775);
	if(name == "Temple Kronos")return (776);
	if(name == "Arkantos God")return (777);
	if(name == "Earth")return (778);
	if(name == "Kronny Flying")return (779);
	if(name == "Victory Marker")return (780);
	if(name == "Invisible Wall")return (781);
	if(name == "Invisible Target")return (782);
	if(name == "Pyramid Osiris Xpack")return (783);
	if(name == "Statue of Melagius")return (784);
	if(name == "Temple Overgrown")return (785);
	if(name == "Roc Tent")return (786);
	if(name == "Guardian XP")return (787);
	if(name == "Automaton SPC")return (788);
	if(name == "Summoning Tree")return (789);
	if(name == "Summoning Tree 2")return (790);
	if(name == "Bolder Rolling Small")return (791);
	if(name == "Tree Finale")return (792);
	if(name == "Kastor Staff")return (793);
	if(name == "Hades Door Small")return (794);
	if(name == "Titan Kronos")return (795);
	if(name == "Titan Gaia")return (796);
	if(name == "Wolf Arctic")return (797);
	if(name == "Shade XP")return (798);
	if(name == "Wolf Arctic 2")return (799);
	if(name == "Bella")return (800);
	if(name == "Alfred")return (801);
	if(name == "Ulfsark Starting")return (802);
	if(name == "Ram")return (803);
	if(name == "Eagle")return (804);
	if(name == "Cypress")return (805);
	if(name == "Fish - Herring")return (806);
	if(name == "Villager Chinese")return (807);
	if(name == "Villager Chinese Dead Replacement")return (808);
	if(name == "Bamboo Tree")return (809);
	if(name == "Bamboo Tree Burning")return (810);
	if(name == "Bamboo stump")return (811);
	if(name == "Panda Bear")return (812);
	if(name == "Storage Pit")return (813);
	if(name == "Barracks Chinese")return (814);
	if(name == "Stable Chinese")return (815);
	if(name == "Garden")return (816);
	if(name == "Scout Chinese")return (817);
	if(name == "Halberdier")return (818);
	if(name == "Chu Ko Nu")return (819);
	if(name == "Lizard")return (820);
	if(name == "Yak")return (821);
	if(name == "Tiger")return (822);
	if(name == "Mounted Archer")return (823);
	if(name == "Cataphract Chinese")return (824);
	if(name == "War Chariot")return (825);
	if(name == "Fire Lance")return (826);
	if(name == "Castle")return (827);
	if(name == "Sitting Tiger")return (828);
	if(name == "Hero Chinese General")return (829);
	if(name == "Hero Chinese Immortal")return (830);
	if(name == "Hero Chinese Monk")return (831);
	if(name == "Fishing Ship Chinese")return (832);
	if(name == "Junk")return (833);
	if(name == "Fire Ship Chinese")return (834);
	if(name == "Siege Ship Chinese")return (835);
	if(name == "Transport Ship Chinese")return (836);
	if(name == "Caravan Chinese")return (837);
	if(name == "UI Range Indicator Chinese SFX")return (838);
	if(name == "Jungle Tree")return (839);
	if(name == "Jungle Tree Burning")return (840);
	if(name == "Jungle Tree Stump")return (841);
	if(name == "Qilin")return (842);
	if(name == "Terracotta Soldier")return (843);
	if(name == "Terracotta Soldier Dead Replacement")return (844);
	if(name == "Monkey King")return (845);
	if(name == "War Salamander")return (846);
	if(name == "Pixiu")return (847);
	if(name == "Jiangshi")return (848);
	if(name == "Azure Dragon")return (849);
	if(name == "Vermilion Bird")return (850);
	if(name == "White Tiger")return (851);
	if(name == "Dragon Turtle")return (852);
	if(name == "Griffon")return (853);
	if(name == "Apep")return (854);
	if(name == "Bondi")return (855);
	if(name == "Pirate Ship Norse")return (856);
	if(name == "Bush Short")return (857);
	if(name == "William Walrus")return (858);
	if(name == "Golem")return (859);
	if(name == "Trollkarien")return (860);
	if(name == "Vulture Scout")return (861);
	if(name == "Harpy Scout")return (862);
	if(name == "Rock Dirt Sprite")return (863);
	if(name == "Rock Dirt Small")return (864);
	if(name == "Rock Dirt Big")return (865);
	if(name == "Rock Overgrown Sprite")return (866);
	if(name == "Rock Overgrown Small")return (867);
	if(name == "Rock Overgrown Big")return (868);
	if(name == "Jade Mine")return (869);
	if(name == "Jade Mine Small")return (870);
	if(name == "Jade Mine Tiny")return (871);
	if(name == "Ball of Fire Vermilion Bird")return (872);
	if(name == "Tornado Vermilion Bird")return (873);
	if(name == "Parrot")return (874);
	if(name == "Elephant Indian")return (875);
	if(name == "Duck")return (876);
	if(name == "Dog")return (877);
	if(name == "Earth Dragon")return (878);
	if(name == "Barrage")return (879);
	if(name == "Goat Chinese")return (880);
	if(name == "Jialong")return (881);
	if(name == "Shun")return (882);
	if(name == "Flood")return (883);
	if(name == "Regent")return (884);
	if(name == "Jungle Palm")return (885);
	if(name == "Jungle Palm Burning")return (886);
	if(name == "Jungle Palm Stump")return (887);
	if(name == "Dam")return (888);
	if(name == "Zhi")return (889);
	if(name == "Danzhu")return (890);
	if(name == "Destruction 1x1 SPC")return (891);
	if(name == "Destruction 2x2 SPC")return (892);
	if(name == "Destruction 3x3 SPC")return (893);
	if(name == "Destruction 4x4 SPC")return (894);
	if(name == "Destruction 5x5 SPC")return (895);
	if(name == "Destruction 8x8 SPC")return (896);
	if(name == "Earth Dragon Hole")return (897);
	if(name == "Kraken SPC2")return (898);
	if(name == "Geyser")return (899);
	if(name == "Uproot 1x1")return (900);
	if(name == "Uproot 2x2")return (901);
	if(name == "Uproot 3x3")return (902);
	if(name == "Uproot 4x4")return (903);
	if(name == "Uproot 5x5")return (904);
	if(name == "Uproot 6x6")return (905);
	if(name == "Uproot 7x7")return (906);
	if(name == "Uproot 8x8")return (907);
	if(name == "Inferno Field")return (908);
	if(name == "Bolder Wall Asian")return (909);
	if(name == "Physician")return (910);
	if(name == "Bogsveigir")return (911);
	if(name == "Khopesh")return (912);
	if(name == "Onager")return (913);
	if(name == "Fire Lance Projectile")return (914);
	if(name == "Tsunami")return (915);
	if(name == "Emperor")return (916);
	if(name == "Lazer Panda")return (917);
	if(name == "Tsunami Range Indicator")return (918);
	if(name == "Big Splash")return (919);
	if(name == "Timberharvest")return (920);
	if(name == "Imperial Examination")return (921);
	if(name == "Blessed Construction")return (922);
	if(name == "Recreation")return (923);
	if(name == "Sitting Tiger Shennong")return (924);
	if(name == "Qilin Heal")return (925);
	if(name == "Fire Lance Shennong")return (926);
	if(name == "Servant Chinese")return (927);
	if(name == "Ao Kuang")return (928);
	if(name == "Walking Woods Jungle Tree")return (929);
	if(name == "Walking Woods Jungle Palm")return (930);
	if(name == "Walking Woods Bamboo")return (931);
	if(name == "Snowman")return (932);
	if(name == "Santa")return (933);
	if(name == "Reindeer")return (934);
}

int playerColor(int p = 0, int t = 1){
	int c = 0;
	if((p == 0)&&(t == 1))c = 153;
	if((p == 0)&&(t == 2))c = 102;
	if((p == 0)&&(t == 3))c = 0;
	if((p == 1)&&(t == 1))c = 50;
	if((p == 1)&&(t == 2))c = 50;
	if((p == 1)&&(t == 3))c = 255;
	if((p == 2)&&(t == 1))c = 255;
	if((p == 2)&&(t == 2))c = 50;
	if((p == 2)&&(t == 3))c = 50;
	if((p == 3)&&(t == 1))c = 0;
	if((p == 3)&&(t == 2))c = 150;
	if((p == 3)&&(t == 3))c = 0;
	if((p == 4)&&(t == 1))c = 50;
	if((p == 4)&&(t == 2))c = 235;
	if((p == 4)&&(t == 3))c = 255;
	if((p == 5)&&(t == 1))c = 223;
	if((p == 5)&&(t == 2))c = 52;
	if((p == 5)&&(t == 3))c = 238;
	if((p == 6)&&(t == 1))c = 255;
	if((p == 6)&&(t == 2))c = 255;
	if((p == 6)&&(t == 3))c = 0;
	if((p == 7)&&(t == 1))c = 255;
	if((p == 7)&&(t == 2))c = 102;
	if((p == 7)&&(t == 3))c = 0;
	if((p == 8)&&(t == 1))c = 128;
	if((p == 8)&&(t == 2))c = 0;
	if((p == 8)&&(t == 3))c = 64;
	if((p == 9)&&(t == 1))c = 50;
	if((p == 9)&&(t == 2))c = 255;
	if((p == 9)&&(t == 3))c = 50;
	if((p == 10)&&(t == 1))c = 179;
	if((p == 10)&&(t == 2))c = 251;
	if((p == 10)&&(t == 3))c = 186;
	if((p == 11)&&(t == 1))c = 80;
	if((p == 11)&&(t == 2))c = 80;
	if((p == 11)&&(t == 3))c = 80;
	if((p == 12)&&(t == 1))c = 255;
	if((p == 12)&&(t == 2))c = 0;
	if((p == 12)&&(t == 3))c = 102;
	return(c);
}

//Map size

int getMapSize(){
	if(cMapSize == 0)return (120);
	if(cMapSize == 1)return (120);
	if(cMapSize == 2)return (120);
}

int getMapSizeSquared(){
	return (getMapSize() * getMapSize());
}

//Shortcut methods

void setAreaAbsoluteSize(int id = 0, float size = 0.0){
	float areaSize = (1.0 * size) / getMapSizeSquared();
	rmSetAreaSize(id,areaSize,areaSize);
}

void setAreaFractionSize(int id = 0, float size = 0.0){
	rmSetAreaSize(id,size,size);
}

// Main entry point for random map script
void main(void) {
	rmSetStatusText("",0.01);
	rmSetMapSize(getMapSize(),getMapSize());
	rmSetSeaLevel(0);
	rmSetSeaType("greek river");
	rmTerrainInitialize("grassB",1);
	rmSetGaiaCiv(cCivZeus);
	rmSetLightingSet("Default");
// DONE_BASIC_MAP_INFO

// Define some constants
	int i	= 0;
	int j	= 0;
	int k	= 0;
	int l	= 0;
	float x = 0.0;
	float y = 0.0;
	float z = 0.0;
	int c = cNumberNonGaiaPlayers;
	int a = c - 1;
	int h = c - 2;
	int id = 0;
// DONE_DEFINE_CONSTANTS

	id = rmCreateArea("a1a");
	rmSetAreaTerrainType(id,"GrassB");
	rmSetAreaBaseHeight(id,5);
	rmSetAreaCoherence(id,1.0);
	rmSetAreaHeightBlend(id,10);
	rmSetAreaLocation(id,0.5,0.5);
	rmSetAreaSize(id,1,1);
	rmSetAreaSmoothDistance(id,5);
	rmBuildArea(id);

	for(p = 1; <= h) {
		id = rmCreateArea("playerArea"+p);
		rmSetAreaCoherence(id,1.0);
		rmSetAreaLocation(id,circlex(0.5, h, p, 0.1, 0), circley(0.5, h, p, 0.1, 0));
		rmSetPlayerArea(p,id);
		rmSetAreaHeightBlend(id,2);
		rmSetAreaSize(id,0.01,0.01);
		rmBuildArea(id);
	}

	string quote = "\\";
	
	int heroCount = 16;
	int passiveCount = 3;
	int abilityCount = 8;
	
	int killBase = 40;
	int killIncrease = 20;
	
	string relicDatabaseName = ""; //Mutated in some triggers
	
	defineTrigger("globals", false, false, false);
	globalStart();
	g("vector tempCameraPos = vector(0.0, 0.0, 0.0);");
	g("vector tempCameraMx = vector(0.0, 0.0, 0.0);");
	g("vector tempCameraMy = vector(0.0, 0.0, 0.0);");
	g("vector tempCameraMz = vector(0.0, 0.0, 0.0);");
	g("float tempH = 0.0;");
	g("float tempT = 0.0;");
	g("float tempSinH = 0.0;");
	g("float tempCosH = 0.0;");
	g("float tempSinT = 0.0;");
	g("float tempCosT = 0.0;");
	g("float tempPosX = 0.0;");
	g("float tempPosY = 0.0;");
	g("float tempPosZ = 0.0;");
	g("int tempI = -1;");
	g("float tempF = 0.0;");
	g("int cameraTrackTime = 0;");
	g("bool cameraFirstWaypoint = false;");
	g("int heroOffset = -1;");
	g("int heroesChosen = 0;");
	g("int centrePosX = 0;");
	g("int centrePosZ = 0;");
	g("vector tempV = vector(0,0,0);");
	g("vector tempV2 = vector(0,0,0);");
	g("vector tempV3 = vector(0,0,0);");
	g("int round = -1;");
	g("bool time250 = false;");
	g("int time250Target = 250;");
	g("int gameTime = 0;");
	g("int spawnOffset = -1;");
	g("int spawnPointCount = 0;");
	g("int enemyCount = 0;");
	g("int roundTime = 0;");
	g("int roundEventCount = 0;");
	g("int roundEventCountToDo = 0;");
	g("int boss0 = -1;");
	g("int boss1 = -1;");
	g("int boss2 = -1;");
	g("int boss3 = -1;");
	g("int boss4 = -1;");
	g("int boss5 = -1;");
	g("int boss6 = -1;");
	g("int bossAction = -1;");
	g("int dead = 0;");
	g("int ceaseFireTime = -1;");
	g("string tempS = \"\";");
	g("string tempS2 = \"\";");
	g("int musicType = 0;");
	g("int boltCredit = -1;");
	g("int tornadoCredit = -1;");
	g("int infernoCredit = -1;");
	g("bool allowDebris = true;");
	g("bool volatileDestroy = true;");
	g("bool switchToVolatile = false;");
	g("bool waterMap = false;");
	g("bool cinematicForestMap = false;");
	g("bool inShop = false;");
	g("bool roundActive = false;");
	g("float difficulty = 1.0;");
	g("float difficultyEasy = 1.0;");
	g("float difficultyModerate = 1.5;");
	g("float difficultyHard = 2.0;");
	g("float difficultyTitan = 3.0;");
	g("int activePlayers = "+h+";");
	g("int iceCount = 0;");
	g("string olympusTreeAnimationPath = \"\";");
	g("int armageddonCredit = -1;");
	g("int statsPlayerOverride = -1;");
	g("int waterRiseCount = -1;");
	g("int rocksToDrop = 0;");
	createGlobalIntArray("RoundUnitTime", 30, 0);
	createGlobalStringArray("RoundUnitType", 30, "");
	createGlobalIntArray("RoundUnitCount", 30, 1);
	createGlobalIntArray("BossVariation", 5, 0);
	createGlobalFloatArray("ShopX", h, 0.0);
	createGlobalFloatArray("ShopZ", h, 0.0);
	createGlobalIntArray("ShopPlayer", h, 0);
	createPlayerGlobalIntArray("HeroIndex", -1);
	createPlayerGlobalIntArray("Kills", 0);
	createPlayerGlobalIntArray("KillsPrevious", 0);
	createPlayerGlobalIntArray("SpyEye0", -1);
	createPlayerGlobalIntArray("SpyEye1", -1);
	createPlayerGlobalIntArray("HeroAction", -1);
	createPlayerGlobalIntArray("KillTarget", killBase);
	createPlayerGlobalIntArray("KillIncrease", killBase);
	createPlayerGlobalIntArray("Level", 0);
	createPlayerGlobalIntArray("StatKills", 0);
	createPlayerGlobalIntArray("ReviveTime", -1);
	createPlayerGlobalIntArray("RevivedByPlayer", -1);
	createPlayerGlobalIntArray("Lampades", -1);
	createPlayerGlobalIntArray("RangeBoost", 0);
	createPlayerGlobalIntArray("RangeBoostCalculated", 0);
	createPlayerGlobalFloatArray("HealthMultiplier", 1.0);
	createPlayerGlobalFloatArray("AttackMultiplier", 1.0);
	createPlayerGlobalFloatArray("AttackMultiplierFinal", 1.0);
	createPlayerGlobalFloatArray("IronMaidenHealth", -1);
	createPlayerGlobalBoolArray("Dead", false);
	createPlayerGlobalBoolArray("FirstDeath", true);
	createPlayerGlobalBoolArray("GhostWalk", false);
	createPlayerGlobalIntArray("GhostWalkTime", 0);
	createPlayerGlobalBoolArray("Enraged", false);
	createPlayerGlobalIntArray("EnragedTime", 0);
	createPlayerGlobalBoolArray("LightningTriggered", false);
	createPlayerGlobalBoolArray("DuplicateTriggered", false);
	createPlayerGlobalBoolArray("ArmageddonUsed", false);
	createPlayerGlobalIntArray("MarkerCount", 0);
	createPlayerGlobalIntArray("RelicTypeCount", 0);
	createPlayerGlobalIntArray("AttackRelicCount", 0);
	createPlayerGlobalIntArray("ProjectileRelicCount", 0);
	createPlayerGlobalIntArray("RangeRelicCount", 0);
	createPlayerGlobalIntArray("FavourRelicCount", 0);
	createPlayerGlobalIntArray("RechargeRelicCount", 0);
	createPlayerGlobalIntArray("RelicMultiplier", 1);
	createPlayerGlobalFloatArray("BuilderArmoryBoost", 0.0);
	createPlayerGlobalIntArray("LifebondTree", -1);
	createPlayerGlobalBoolArray("LifebondActive", false);
	createPlayerGlobalStringArray("PlayerName", "");
	createPlayerGlobalIntArray("PlayerGameTime", 0);
	createPlayerGlobalIntArray("ExtraTimeAdvance", 0);
	createPlayerGlobalBoolArray("WizardProjectileActive", false);
	createPlayerGlobalBoolArray("RogueProjectileActive", false);
	createPlayerGlobalIntArray("SelfDamageCount", 0);
	createPlayerGlobalBoolArray("ArcherSpecialActive", false);
	createPlayerGlobalIntArray("AuraCarryTime", 0);
	createPlayerGlobalBoolArray("AttackBoostActive", false);
	createPlayerGlobalBoolArray("FlareAllowed", true);
	createPlayerGlobalIntArray("RelicRechargeStore", 0);
	createPlayerGlobalBoolArray("FireRingActive", false);
	createPlayerGlobalIntArray("ShopOffset", 0);
	createPlayerGlobalIntArray("ShopIndex", 0);
	createPlayerGlobalIntArray("MiningCamp", -1);
	createPlayerGlobalIntArray("Lighthouse", -1);
	createPlayerGlobalIntArray("LighthouseSpawn", -1);
	createPlayerGlobalFloatArray("GoldToGive", 0);
	createPlayerGlobalFloatArray("FoodToGive", 0);
	g("int randomInt(int low = 0, int high = 0){");
		g("trQuestVarSetFromRand(\"r\", low, high, true);");
		g("return (1*trQuestVarGet(\"r\"));");
	g("}");
	g("float randomFloat(float low = 0.0, float high = 0.0){");
		g("trQuestVarSetFromRand(\"r\", low, high, false);");
		g("return (trQuestVarGet(\"r\"));");
	g("}");
	g("int randomIntWeighted(int min = 0, int max = 1, int weight = 1){");
		g("int value = max;");
		g("for(i = 0; < weight){");
			g("value = randomInt(min, value);");
		g("}");
		g("return (value);");
	g("}");
	g("float randomFloatWeighted(float min = 0.0, float max = 1.0, int weight = 1){");
		g("float value = max;");
		g("for(i = 0; < weight){");
			g("value = randomFloat(min, value);");
		g("}");
		g("return (value);");
	g("}");
	g("float toMetres(float fraction = 0.0){");
		g("return (fraction * "+getMapSize()+");");
	g("}");
	g("float toTiles(float fraction = 0.0){");
		g("return (fraction * "+(getMapSize() / 2)+");");
	g("}");
	g("float interpolate(float from = 0.0, float to = 0.0, float fraction = 0.0){");
		g("return ((1.0 - fraction) * from + fraction * to);");
	g("}");
	g("float interpolateRange(float from0 = 0.0, float to0 = 0.0, float from1 = 0.0, float to1 = 0.0, float pos0 = 0.0){");
		g("float range0 = to0 - from0;");
		g("float pos0Proportion = (pos0 - from0) / range0;");
		g("return (interpolate(from1, to1, pos0Proportion));");
	g("}");
	g("vector interpolateVector(vector from = vector(0.0, 0.0, 0.0), vector to = vector(0.0, 0.0, 0.0), float fraction = 0.0){");
		g("return (xsVectorSet(interpolate(xsVectorGetX(from), xsVectorGetX(to), fraction), ");
				g("interpolate(xsVectorGetY(from), xsVectorGetY(to), fraction), ");
				g("interpolate(xsVectorGetZ(from), xsVectorGetZ(to), fraction)));");
	g("}");
	g("float clamp(float minValue = 0.0, float maxValue = 0.0, float value = 0.0){");
		g("return (xsMin(maxValue, xsMax(minValue, value)));");
	g("}");
	g("int modInt(int value = 0, int ceiling = 1){");
		g("return (value - (value / ceiling) * ceiling);");
	g("}");
	g("float modFloat(float value = 0.0, float ceiling = 1.0){");
		g("return (value - (1.0*(1*(value / ceiling))) * ceiling);");
	g("}");
	g("bool heroNearby(int p = 0, float distance = 0.0, int unitName = -1){");
		g("if(unitName < 0)return (false);");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+unitName, true);");
		g("if(trUnitDistanceToUnit(\"\"+p) <= distance)return (true);");
		g("return (false);");
	g("}");
	g("int anyHeroNearby(float distance = 0.0, int unitName = -1){");
		g("if(unitName < 0)return (-1);");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+unitName, true);");
		g("for(p = 1; <= "+h+"){");
			g("if(kbIsPlayerResigned("+p+") == false){");
				g("if(trUnitDistanceToUnit(\"\"+p) <= distance)return (p);");
			g("}");
		g("}");
		g("return (-1);");
	g("}");
	g("bool shopOldManNear(int oldManIndex = -1, float distance = 0.0, int unitName = -1){");
		g("if(unitName < 0 || oldManIndex < 0)return (false);");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+oldManIndex, true);");
		g("vector v = kbGetBlockPosition(\"\"+unitName, true);");
		g("if(trUnitDistanceToPoint(xsVectorGetX(v), xsVectorGetY(v), xsVectorGetZ(v)) <= distance)return (true);");
		g("return (false);");
	g("}");
	g("float circleX(float centre = 0.0, int i = 0, int total = 0, float radius = 0.0, float disp = 0){");
		g("return(centre + radius * xsSin((6.283185 * i) / total + (45.0 - disp) * 0.017453));");
	g("}");
	g("float circleZ(float centre = 0.0, int i = 0, int total = 0, float radius = 0.0, float disp = 0){");
		g("return(centre + radius * xsCos((6.283185 * i) / total + (45.0 - disp) * 0.017453));");
	g("}");
	g("void cameraLookAt(vector dest = vector(0.0, 0.0, 0.0), float distance = 0.0, float heading = 0.0, float tilt = 0.0){");
		g("tempH = "+PI+" * heading / 180.0;");
		g("tempT = "+PI+" * tilt / 180.0;");
		g("tempSinH = xsSin(tempH);");
		g("tempCosH = xsCos(tempH);");
		g("tempSinT = xsSin(tempT);");
		g("tempCosT = xsCos(tempT);");
		g("tempPosX = 0.0+xsVectorGetX(dest)-tempCosH*tempCosT*distance;");
		g("tempPosY = tempSinT*distance+xsVectorGetY(dest);");
		g("tempPosZ = 0.0+xsVectorGetZ(dest)-tempSinH*tempCosT*distance;");
		g("tempCameraPos = xsVectorSet(tempPosX, tempPosY, tempPosZ);");
		g("tempCameraMx = xsVectorSet(tempCosH*tempCosT, 0.0-tempSinT, tempSinH*tempCosT);");
		g("tempCameraMy = xsVectorSet(tempCosH*tempSinT, tempCosT, tempSinH*tempSinT);");
		g("tempCameraMz = xsVectorSet(tempSinH, 0, 0.0-tempCosH);");
		g("trCameraCut(tempCameraPos, tempCameraMx, tempCameraMy, tempCameraMz);");
	g("}");
	g("void createCameraTrack(int timeMS = 0){");
		g("cameraFirstWaypoint = true;");
		g("cameraTrackTime = timeMS;");
		g("trackInsert();");
		g("trackPlay(cameraTrackTime, -1);");
	g("}");
	g("void addCameraTrackWaypoint(){");
		g("if(cameraFirstWaypoint){");
			g("cameraFirstWaypoint = false;");
		g("} else {");
			g("trackAddWaypoint();");
		g("}");
		g("trackEditWaypoint();");
	g("}");
	g("void playCameraTrack(int eventId = -1){");
		g("trackPlay(cameraTrackTime, eventId);");
	g("}");
	g("bool unitSelected(int unitName = 0, bool backwards = false){");
		g("if(unitName < 0)return (false);");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+unitName, backwards);");
		g("return (trUnitIsSelected());");
	g("}");
	g("void modifyProtounitAbsolute(string protounit = \"\", int p = 0, int field = 0, float value = 0.0){");
		g("if(field == 6){");
			g("trModifyProtounit(protounit, p, field, -9999999999999999999.0);");
			g("trModifyProtounit(protounit, p, field, value);");
		g("} else if(field == 5 || field == 7 || field == 10 || field == 13){");
			g("trModifyProtounit(protounit, p, field, 2147483648.0);");
			g("trModifyProtounit(protounit, p, field, 2147483648.0);");
			g("trModifyProtounit(protounit, p, field, value);");
		g("} else {");
			g("trModifyProtounit(protounit, p, field, 9999999999999999999.0);");
			g("trModifyProtounit(protounit, p, field, -9999999999999999999.0);");
			g("trModifyProtounit(protounit, p, field, value);");
		g("}");
	g("}");
	g("void modifyProtounitAbsoluteAllHumanPlayers(string protounit = \"\", int field = 0, float value = 0.0){");
		g("for(p = 1; <= "+c+"){");
			g("if(field == 6){");
				g("trModifyProtounit(protounit, p, field, -9999999999999999999.0);");
				g("trModifyProtounit(protounit, p, field, value);");
			g("} else if(field == 5 || field == 7 || field == 10 || field == 13){");
				g("trModifyProtounit(protounit, p, field, 2147483648.0);");
				g("trModifyProtounit(protounit, p, field, 2147483648.0);");
				g("trModifyProtounit(protounit, p, field, value);");
			g("} else {");
				g("trModifyProtounit(protounit, p, field, 9999999999999999999.0);");
				g("trModifyProtounit(protounit, p, field, -9999999999999999999.0);");
				g("trModifyProtounit(protounit, p, field, value);");
			g("}");
		g("}");
	g("}");
	g("void damageEnemyInArea(int p = 1, float posX = 0.0, float posZ = 0.0, float d = 0.0, float r = 0.0, int old = -1){");
		databaseSearchStartGlobal("Enemy");
		g("if(trUnitDistanceToPoint(posX, 0.0, posZ) <= r && trUnitPercentDamaged() < 100.0){");
			g("trDamageUnit(d);");
			g("if(trUnitPercentDamaged() >= 100.0){");
				g("setKills(p, getKills(p) + 1);");
			g("}");
		g("}");
		databaseSearchEndGlobal();
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+(1*old), true);");
	g("}");
	g("void damageEnemyInVectorArea(int p = 1, vector pos = vector(0,0,0), float d = 0.0, float r = 0.0, int old = -1){");
		g("damageEnemyInArea(p, xsVectorGetX(pos), xsVectorGetZ(pos), d, r, old);");
	g("}");
	g("void damageEnemyInAreaRing(int p = 1, float posX = 0.0, float posZ = 0.0, float d = 0.0, float r1 = 0.0, ");
			g("float r2 = 0.0, int old = -1){");
		databaseSearchStartGlobal("Enemy");
		g("if(trUnitDistanceToPoint(posX, 0.0, posZ) >= r1 && trUnitDistanceToPoint(posX, 0.0, posZ) <= r2 ");
				g("&& trUnitPercentDamaged() < 100.0){");
			g("trDamageUnit(d);");
			g("if(trUnitPercentDamaged() >= 100.0){");
				g("setKills(p, getKills(p) + 1);");
			g("}");
		g("}");
		databaseSearchEndGlobal();
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+(1*old), true);");
	g("}");
	g("void damageEnemyInVectorAreaRing(int p = 1, vector pos = vector(0,0,0), float d = 0.0, float r1 = 0.0, ");
			g("float r2 = 0.0, int old = -1){");
		g("damageEnemyInAreaRing(p, xsVectorGetX(pos), xsVectorGetZ(pos), d, r1, r2, old);");
	g("}");
	g("void damagePlayersInArea(float posX = 0.0, float posZ = 0.0, float d = 0.0, float r = 0.0, ");
			g("int old = -1, bool applyDifficulty = true, bool excludeTemples = false){");
		g("float damage = d;");
		g("if(applyDifficulty){");
			g("damage = damage * difficulty;");
		g("}");
		databaseSearchStartGlobal("Player");
		g("if(trUnitDistanceToPoint(posX, 0.0, posZ) <= r){");
			g("if(excludeTemples == false || type != "+getUnitIdFromName("Temple")+"){");
				g("trDamageUnit(damage);");
			g("}");
		g("}");
		databaseSearchEndGlobal();
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+(1*old), true);");
	g("}");
	g("void damagePlayersInVectorArea(vector pos = vector(0,0,0), float d = 0.0, float r = 0.0, ");
			g("int old = -1, bool applyDifficulty = true, bool excludeTemples = false){");
		g("damagePlayersInArea(xsVectorGetX(pos), xsVectorGetZ(pos), d, r, old, applyDifficulty, excludeTemples);");
	g("}");
	g("bool enemyInArea(float posX = 0.0, float posZ = 0.0, float r = 0.0, int old = -1){");
		g("bool result = false;");
		databaseSearchStartGlobal("Enemy");
		g("if(trUnitDistanceToPoint(posX, 0.0, posZ) <= r && trUnitPercentDamaged() < 100.0){");
			g("result = true;");
		g("}");
		databaseSearchEndGlobal();
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+(1*old), true);");
		g("return (result);");
	g("}");
	g("bool enemyInVectorArea(vector pos = vector(0,0,0), float r = 0.0, int old = -1){");
		g("return (enemyInArea(xsVectorGetX(pos), xsVectorGetZ(pos), r, old));");
	g("}");
	g("int getOwner(int unitName = -1){");
		g("return (kbUnitGetOwner(kbGetBlockID(\"\"+(1*unitName), true)));");
	g("}");
	g("vector getPosition(int unitName = -1){");
		g("return (kbGetBlockPosition(\"\"+(1*unitName), true));");
	g("}");
	g("void grantGodPowerNoRechargeNextPosition(int p = 0, string power = \"\", int count = 0){");
		g("for(tempPowerTech = -1; > 1){}");
		g("for(tempPosition = -1; > 1){}");
		g("if(power==\"Animal Magnetism\")tempPowerTech=227;");
		g("if(power==\"Audrey\")tempPowerTech=407;");
		g("if(power==\"Barrage\")tempPowerTech=546;");
		g("if(power==\"Blessing of Zeus\")tempPowerTech=351;");
		g("if(power==\"Bolt\")tempPowerTech=221;");
		g("if(power==\"Bronze\")tempPowerTech=175;");
		g("if(power==\"Bronze XP05\")tempPowerTech=457;");
		g("if(power==\"Call to Arms\")tempPowerTech=547;");
		g("if(power==\"Cease Fire\")tempPowerTech=147;");
		g("if(power==\"Cease Fire Nomad\")tempPowerTech=376;");
		g("if(power==\"Change Caladria\")tempPowerTech=464;");
		g("if(power==\"Change Chimera\")tempPowerTech=463;");
		g("if(power==\"Change Cyclops\")tempPowerTech=462;");
		g("if(power==\"Change Hydra\")tempPowerTech=467;");
		g("if(power==\"Change Manticore\")tempPowerTech=465;");
		g("if(power==\"Change Nemean\")tempPowerTech=466;");
		g("if(power==\"Chaos\")tempPowerTech=409;");
		g("if(power==\"Chicken Storm\")tempPowerTech=388;");
		g("if(power==\"Citadel\")tempPowerTech=232;");
		g("if(power==\"Create Gold\")tempPowerTech=84;");
		g("if(power==\"Curse\")tempPowerTech=229;");
		g("if(power==\"Earth Dragon\")tempPowerTech=557;");
		g("if(power==\"Earthquake\")tempPowerTech=239;");
		g("if(power==\"Eclipse\")tempPowerTech=214;");
		g("if(power==\"Examination\")tempPowerTech=550;");
		g("if(power==\"Flaming Weapons\")tempPowerTech=223;");
		g("if(power==\"Flood\")tempPowerTech=555;");
		g("if(power==\"Flood Weak\")tempPowerTech=556;");
		g("if(power==\"Forest Fire\")tempPowerTech=248;");
		g("if(power==\"Forest Fire SPC\")tempPowerTech=594;");
		g("if(power==\"Frost\")tempPowerTech=57;");
		g("if(power==\"Gaia Forest\")tempPowerTech=418;");
		g("if(power==\"Gaia Forest SPC\")tempPowerTech=505;");
		g("if(power==\"Geyser\")tempPowerTech=552;");
		g("if(power==\"Goatunheim\")tempPowerTech=391;");
		g("if(power==\"Great Hunt\")tempPowerTech=146;");
		g("if(power==\"Healing Spring\")tempPowerTech=228;");
		g("if(power==\"Heroize\")tempPowerTech=439;");
		g("if(power==\"Hesperides\")tempPowerTech=436;");
		g("if(power==\"Implode\")tempPowerTech=442;");
		g("if(power==\"Inferno\")tempPowerTech=558;");
		g("if(power==\"Journey\")tempPowerTech=548;");
		g("if(power==\"Lightning Storm\")tempPowerTech=42;");
		g("if(power==\"Locust Swarm\")tempPowerTech=43;");
		g("if(power==\"Meteor\")tempPowerTech=61;");
		g("if(power==\"Nidhogg\")tempPowerTech=235;");
		g("if(power==\"Pestilence\")tempPowerTech=249;");
		g("if(power==\"Plenty\")tempPowerTech=236;");
		g("if(power==\"Prosperity\")tempPowerTech=211;");
		g("if(power==\"Ragnorok\")tempPowerTech=234;");
		g("if(power==\"Rain\")tempPowerTech=156;");
		g("if(power==\"Recreation\")tempPowerTech=543;");
		g("if(power==\"Restoration\")tempPowerTech=134;");
		g("if(power==\"Reverse Time\")tempPowerTech=406;");
		g("if(power==\"Reverse Wonder\")tempPowerTech=434;");
		g("if(power==\"Sandstorm\")tempPowerTech=231;");
		g("if(power==\"Seed of Gaia\")tempPowerTech=485;");
		g("if(power==\"Sentinel\")tempPowerTech=230;");
		g("if(power==\"Serpents\")tempPowerTech=226;");
		g("if(power==\"Skeleton Power\")tempPowerTech=129;");
		g("if(power==\"Snow Storm\")tempPowerTech=172;");
		g("if(power==\"Son of Osiris\")tempPowerTech=237;");
		g("if(power==\"SPCLightning Storm\")tempPowerTech=468;");
		g("if(power==\"SPCMeteor\")tempPowerTech=334;");
		g("if(power==\"Spiders\")tempPowerTech=438;");
		g("if(power==\"Spy\")tempPowerTech=222;");
		g("if(power==\"Tartarian Gate\")tempPowerTech=419;");
		g("if(power==\"Timber Harvest\")tempPowerTech=545;");
		g("if(power==\"TitanGate\")tempPowerTech=444;");
		g("if(power==\"Tornado\")tempPowerTech=44;");
		g("if(power==\"Tornado XP05\")tempPowerTech=458;");
		g("if(power==\"Traitors\")tempPowerTech=408;");
		g("if(power==\"Traitors SPC\")tempPowerTech=491;");
		g("if(power==\"Tremor\")tempPowerTech=414;");
		g("if(power==\"Tsunami\")tempPowerTech=598;");
		g("if(power==\"Undermine\")tempPowerTech=152;");
		g("if(power==\"Underworld Passage\")tempPowerTech=133;");
		g("if(power==\"Uproot\")tempPowerTech=553;");
		g("if(power==\"Uproot SPC\")tempPowerTech=554;");
		g("if(power==\"Vision\")tempPowerTech=220;");
		g("if(power==\"Volcano\")tempPowerTech=410;");
		g("if(power==\"Vortex\")tempPowerTech=431;");
		g("if(power==\"Walking Berry Bushes\")tempPowerTech=389;");
		g("if(power==\"Walking Woods\")tempPowerTech=233;");
		g("if(power==\"Water Damage\")tempPowerTech=615;");
		g("if(power==\"Well of Urd\")tempPowerTech=366;");
		g("if(power==\"Year of the Goat\")tempPowerTech=544;");
		g("if(tempPowerTech>=0){");
			g("if(trGetGPData(p, 0, 0) == tempPowerTech)tempPosition=0;");
			g("if(trGetGPData(p, 0, 1) == tempPowerTech)tempPosition=1;");
			g("if(trGetGPData(p, 0, 2) == tempPowerTech)tempPosition=2;");
			g("if(trGetGPData(p, 0, 3) == tempPowerTech)tempPosition=3;");
			g("if(trGetGPData(p, 0, 4) == tempPowerTech)tempPosition=4;");
			g("if(tempPosition>=0){");
				g("trSetGPData(p, 5, tempPosition, 0 - trGetGPData(p, 5, tempPosition));");
				g("trSetGPData(p, 1, tempPosition, count);");
				g("trSetGPData(p, 2, tempPosition, 0 - trGetGPData(p, 2, tempPosition));");
			g("} else {");
				g("if((trGetGPData(p, 1, 0) > 0 || trGetGPData(p, 2, 0) > 0) == false){");
					g("tempPosition=0;");
				g("} else if((trGetGPData(p, 1, 1) > 0 || trGetGPData(p, 2, 1) > 0) == false){");
					g("tempPosition=1;");
				g("} else if((trGetGPData(p, 1, 2) > 0 || trGetGPData(p, 2, 2) > 0) == false){");
					g("tempPosition=2;");
				g("} else {");
					g("tempPosition=3;");
				g("}");
				g("trTechGodPowerAtPosition(p, power, 0, tempPosition + 1);");
				g("trSetGPData(p, 5, tempPosition, 0 - trGetGPData(p, 5, tempPosition));");
				g("trSetGPData(p, 1, tempPosition, count - trGetGPData(p, 1, tempPosition) + trGetGPData(p, 2, tempPosition));");
				g("trSetGPData(p, 2, tempPosition, 0 - trGetGPData(p, 2, tempPosition));");
			g("}");
		g("}");
	g("}");
	g("void addTimelineEntry(int time = 0, string unit = \"\", int count = 1){");
		g("setRoundUnitTime(roundEventCount, time);");
		g("setRoundUnitType(roundEventCount, unit);");
		g("setRoundUnitCount(roundEventCount, count);");
		g("roundEventCount = roundEventCount + 1;");
	g("}");
	g("int unitPercentDamaged(int unitName = 0, bool backwards = true){");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+unitName, backwards);");
		g("return (trUnitPercentDamaged());");
	g("}");
	g("bool heroDead(int unitName = 0){");
		g("if(unitName < 0)return (false);");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+unitName);");
		g("return (trUnitDead());");
	g("}");
	g("vector vectorMultiply(vector v = vector(0,0,0), float amount = 0.0){");
		g("return (xsVectorSet(xsVectorGetX(v)*amount,xsVectorGetY(v)*amount,xsVectorGetZ(v)*amount));");
	g("}");
	g("void sunVector(vector sun = vector(0,0,0)){");
		g("sunColor(xsVectorGetX(sun),xsVectorGetY(sun),xsVectorGetZ(sun));");
	g("}");
	g("void ambientVector(vector ambient = vector(0,0,0)){");
		g("ambientColor(xsVectorGetX(ambient),xsVectorGetY(ambient),xsVectorGetZ(ambient));");
	g("}");
	g("float clampColor(float value = 0.0){");
		g("return (clamp(0.0, 255.0, value));");
	g("}");
	g("vector randomHue(){");
		g("int hueType = randomInt(0, 2);");
		g("float first = randomFloat(0.0, 255.0);");
		g("float second = 255.0 - first;");
		g("if(hueType == 0)return (xsVectorSet(first, second, 0.0));");
		g("if(hueType == 1)return (xsVectorSet(0.0, first, second));");
		g("if(hueType == 2)return (xsVectorSet(first, 0.0, second));");
	g("}");
	g("void setSelectedUnitHeadingDegrees(float heading = 0.0){");
		g("float headingRadians = heading * "+PI+" / 180.0;");
		g("trSetUnitOrientation(xsVectorSet(xsCos(headingRadians), 0.0, xsSin(headingRadians)), xsVectorSet(0.0, 1.0, 0.0), true);");
	g("}");
	g("string displayFloat(float value = 0.0){");
		g("string valueAsString = \"\"+(1.0*value);");
		g("for(i = 0; < 6){");
			g("if(xsSubString(valueAsString, 1, xsStringLength(valueAsString) - 1) != \"0\"){");
				g("return (valueAsString);");
			g("} else {");
				g("valueAsString = xsSubString(valueAsString, xsStringLength(valueAsString) - 1, 0);");
			g("}");
		g("}");
		g("return (xsSubString(valueAsString, xsStringLength(valueAsString) - 1, 0));");
	g("}");
	g("float getDistanceSquared(vector from = vector(0.0,0.0,0.0), vector to = vector(0.0,0.0,0.0)){");
		g("float diffX = xsVectorGetX(from) - xsVectorGetX(to);");
		g("float diffZ = xsVectorGetZ(from) - xsVectorGetZ(to);");
		g("return (diffX*diffX + diffZ*diffZ);");
	g("}");
	// ### TERRAIN
	g("int getTerrainType(string name = \"\"){");
		g("if(name == \"GrassA\")return (0);");
		g("if(name == \"GrassB\")return (0);");
		g("if(name == \"GrassDirt25\")return (0);");
		g("if(name == \"GrassDirt50\")return (0);");
		g("if(name == \"GrassDirt75\")return (0);");
		g("if(name == \"CliffGreekB\")return (0);");
		g("if(name == \"GreekRoad Burnt\")return (0);");
		g("if(name == \"GreekRoad BurntB\")return (0);");
		g("if(name == \"GaiaCreepA\")return (0);");
		g("if(name == \"GaiaCreepASnow\")return (0);");
		g("if(name == \"GaiaCreepASand\")return (0);");
		g("if(name == \"GaiaCreepB\")return (0);");
		g("if(name == \"GaiaCreepBorder\")return (0);");
		g("if(name == \"GaiaCreepBorderSnow\")return (0);");
		g("if(name == \"GaiaCreepBorderSand\")return (0);");
		g("if(name == \"SavannahA\")return (0);");
		g("if(name == \"SavannahB\")return (0);");
		g("if(name == \"SavannahC\")return (0);");
		g("if(name == \"SavannahD\")return (0);");
		g("if(name == \"JungleA\")return (0);");
		g("if(name == \"JungleB\")return (0);");
		g("if(name == \"JungleDirt25\")return (0);");
		g("if(name == \"JungleDirt50\")return (0);");
		g("if(name == \"JungleDirt75\")return (0);");
		g("if(name == \"CliffJungleB\")return (0);");
		g("if(name == \"PlainA\")return (0);");
		g("if(name == \"PlainB\")return (0);");
		g("if(name == \"PlainDirt25\")return (0);");
		g("if(name == \"PlainDirt50\")return (0);");
		g("if(name == \"PlainDirt75\")return (0);");
		g("if(name == \"CliffPlainB\")return (0);");
		g("if(name == \"DirtA\")return (0);");
		g("if(name == \"DirtB\")return (0);");
		g("if(name == \"DirtC\")return (0);");
		g("if(name == \"SandA\")return (0);");
		g("if(name == \"SandB\")return (0);");
		g("if(name == \"SandC\")return (0);");
		g("if(name == \"SandD\")return (0);");
		g("if(name == \"CliffEgyptianB\")return (0);");
		g("if(name == \"SandDirt50\")return (0);");
		g("if(name == \"SandDirt50b\")return (0);");
		g("if(name == \"SnowA\")return (0);");
		g("if(name == \"SnowB\")return (0);");
		g("if(name == \"SnowGrass25\")return (0);");
		g("if(name == \"SnowGrass50\")return (0);");
		g("if(name == \"SnowGrass75\")return (0);");
		g("if(name == \"SnowSand25\")return (0);");
		g("if(name == \"SnowSand50\")return (0);");
		g("if(name == \"SnowSand75\")return (0);");
		g("if(name == \"CliffNorseB\")return (0);");
		g("if(name == \"OlympusA\")return (0);");
		g("if(name == \"OlympusB\")return (0);");
		g("if(name == \"OlympusC\")return (0);");
		g("if(name == \"OlympusTile\")return (0);");
		g("if(name == \"TundraGrassA\")return (0);");
		g("if(name == \"TundraGrassB\")return (0);");
		g("if(name == \"TundraRockA\")return (0);");
		g("if(name == \"TundraRockB\")return (0);");
		g("if(name == \"MarshA\")return (0);");
		g("if(name == \"MarshB\")return (0);");
		g("if(name == \"MarshC\")return (0);");
		g("if(name == \"MarshD\")return (0);");
		g("if(name == \"MarshE\")return (0);");
		g("if(name == \"MarshF\")return (0);");
		g("if(name == \"EgyptianRoadA\")return (0);");
		g("if(name == \"GreekRoadA\")return (0);");
		g("if(name == \"NorseRoadA\")return (0);");
		g("if(name == \"JungleRoadA\")return (0);");
		g("if(name == \"PlainRoadA\")return (0);");
		g("if(name == \"TundraRoadA\")return (0);");
		g("if(name == \"CityTileA\")return (0);");
		g("if(name == \"CityTileAtlantis\")return (0);");
		g("if(name == \"CityTileAtlantisCoral\")return (0);");
		g("if(name == \"CityTileWaterPool\")return (0);");
		g("if(name == \"CityTileWaterEdgeA\")return (0);");
		g("if(name == \"CityTileWaterEdgeB\")return (0);");
		g("if(name == \"CityTileWaterEdgeEndA\")return (0);");
		g("if(name == \"CityTileWaterEdgeEndB\")return (0);");
		g("if(name == \"CityTileWaterEdgeEndC\")return (0);");
		g("if(name == \"CityTileWaterEdgeEndD\")return (0);");
		g("if(name == \"CityTileWaterCornerA\")return (0);");
		g("if(name == \"CityTileWaterCornerB\")return (0);");
		g("if(name == \"CityTileWaterCornerC\")return (0);");
		g("if(name == \"CityTileWaterCornerD\")return (0);");
		g("if(name == \"HadesBuildable1\")return (0);");
		g("if(name == \"HadesBuildable2\")return (0);");
		g("if(name == \"ForestFloorPalm\")return (0);");
		g("if(name == \"ForestFloorPine\")return (0);");
		g("if(name == \"ForestFloorPineSnow\")return (0);");
		g("if(name == \"ForestFloorOak\")return (0);");
		g("if(name == \"ForestFloorGaia\")return (0);");
		g("if(name == \"ForestFloorSavannah\")return (0);");
		g("if(name == \"ForestFloorDeadPine\")return (0);");
		g("if(name == \"ForestFloorTundra\")return (0);");
		g("if(name == \"ForestFloorMarsh\")return (0);");
		g("if(name == \"ForestFloorJungle\")return (0);");
		g("if(name == \"Water\")return (1);");
		g("if(name == \"CliffA\")return (2);");
		g("if(name == \"CliffGreekA\")return (2);");
		g("if(name == \"CliffEgyptianA\")return (2);");
		g("if(name == \"CliffNorseA\")return (2);");
		g("if(name == \"CliffJungleA\")return (2);");
		g("if(name == \"CliffPlainA\")return (2);");
		g("if(name == \"Dam\")return (2);");
		g("if(name == \"Hades3\")return (2);");
		g("if(name == \"Hades5\")return (2);");
		g("if(name == \"Hades6\")return (2);");
		g("if(name == \"Hades7\")return (2);");
		g("if(name == \"HadesCliff\")return (2);");
		g("if(name == \"Hades4\")return (2);");
		g("if(name == \"BlackRock\")return (2);");
		g("if(name == \"UnderwaterRockA\")return (3);");
		g("if(name == \"UnderwaterRockB\")return (3);");
		g("if(name == \"UnderwaterRockC\")return (3);");
		g("if(name == \"UnderwaterRockD\")return (3);");
		g("if(name == \"UnderwaterRockE\")return (3);");
		g("if(name == \"UnderwaterRockF\")return (3);");
		g("if(name == \"UnderwaterIceA\")return (3);");
		g("if(name == \"UnderwaterIceB\")return (3);");
		g("if(name == \"UnderwaterIceC\")return (3);");
		g("if(name == \"CoralA\")return (3);");
		g("if(name == \"CoralB\")return (3);");
		g("if(name == \"CoralC\")return (3);");
		g("if(name == \"CoralC2\")return (3);");
		g("if(name == \"CoralD\")return (3);");
		g("if(name == \"CoralE\")return (3);");
		g("if(name == \"CoralF\")return (3);");
		g("if(name == \"ShorelineSandA\")return (4);");
		g("if(name == \"ShorelineAegeanA\")return (4);");
		g("if(name == \"ShorelineAegeanB\")return (4);");
		g("if(name == \"ShorelineAegeanC\")return (4);");
		g("if(name == \"ShorelineRedSeaA\")return (4);");
		g("if(name == \"ShorelineRedSeaB\")return (4);");
		g("if(name == \"ShorelineRedSeaC\")return (4);");
		g("if(name == \"ShorelineNorwegianA\")return (4);");
		g("if(name == \"ShorelineNorwegianB\")return (4);");
		g("if(name == \"ShorelineNorwegianC\")return (4);");
		g("if(name == \"ShorelineMediterraneanA\")return (4);");
		g("if(name == \"ShorelineMediterraneanB\")return (4);");
		g("if(name == \"ShorelineMediterraneanC\")return (4);");
		g("if(name == \"ShorelineMediterraneanD\")return (4);");
		g("if(name == \"ShorelineAtlanticA\")return (4);");
		g("if(name == \"ShorelineAtlanticB\")return (4);");
		g("if(name == \"ShorelineAtlanticC\")return (4);");
		g("if(name == \"ShorelineTundraA\")return (4);");
		g("if(name == \"ShorelineTundraB\")return (4);");
		g("if(name == \"ShorelineTundraC\")return (4);");
		g("if(name == \"ShorelineTundraD\")return (4);");
		g("if(name == \"ShorelineJungleA\")return (4);");
		g("if(name == \"ShorelineJungleB\")return (4);");
		g("if(name == \"ShorelineJungleC\")return (4);");
		g("if(name == \"ShorelinePlainA\")return (4);");
		g("if(name == \"ShorelinePlainB\")return (4);");
		g("if(name == \"ShorelinePlainC\")return (4);");
		g("if(name == \"ShorelinePlainD\")return (4);");
		g("if(name == \"RiverSandyA\")return (4);");
		g("if(name == \"RiverSandyB\")return (4);");
		g("if(name == \"RiverSandyC\")return (4);");
		g("if(name == \"RiverSandyShallowA\")return (4);");
		g("if(name == \"RiverGrassyA\")return (4);");
		g("if(name == \"RiverGrassyB\")return (4);");
		g("if(name == \"RiverGrassyC\")return (4);");
		g("if(name == \"RiverIcyA\")return (4);");
		g("if(name == \"RiverIcyB\")return (4);");
		g("if(name == \"RiverIcyC\")return (4);");
		g("if(name == \"RiverMarshA\")return (4);");
		g("if(name == \"RiverMarshB\")return (4);");
		g("if(name == \"RiverMarshC\")return (4);");
		g("if(name == \"IceA\")return (5);");
		g("if(name == \"IceB\")return (5);");
		g("if(name == \"IceC\")return (5);");
		g("if(name == \"MiningGround\")return (5);");
		g("if(name == \"Black\")return (5);");
		g("if(name == \"Hades1\")return (5);");
		g("if(name == \"Hades2\")return (5);");
		g("if(name == \"Hades4Passable\")return (5);");
		g("if(name == \"Hades8\")return (5);");
		g("if(name == \"Hades9\")return (5);");
	g("}");
	g("int getTerrainSubType(string name = \"\"){");
		g("if(name == \"GrassA\")return (0);");
		g("if(name == \"GrassB\")return (1);");
		g("if(name == \"GrassDirt25\")return (2);");
		g("if(name == \"GrassDirt50\")return (3);");
		g("if(name == \"GrassDirt75\")return (4);");
		g("if(name == \"CliffGreekB\")return (5);");
		g("if(name == \"GreekRoad Burnt\")return (6);");
		g("if(name == \"GreekRoad BurntB\")return (7);");
		g("if(name == \"GaiaCreepA\")return (8);");
		g("if(name == \"GaiaCreepASnow\")return (9);");
		g("if(name == \"GaiaCreepASand\")return (10);");
		g("if(name == \"GaiaCreepB\")return (11);");
		g("if(name == \"GaiaCreepBorder\")return (12);");
		g("if(name == \"GaiaCreepBorderSnow\")return (13);");
		g("if(name == \"GaiaCreepBorderSand\")return (14);");
		g("if(name == \"SavannahA\")return (15);");
		g("if(name == \"SavannahB\")return (16);");
		g("if(name == \"SavannahC\")return (17);");
		g("if(name == \"SavannahD\")return (18);");
		g("if(name == \"JungleA\")return (19);");
		g("if(name == \"JungleB\")return (20);");
		g("if(name == \"JungleDirt25\")return (21);");
		g("if(name == \"JungleDirt50\")return (22);");
		g("if(name == \"JungleDirt75\")return (23);");
		g("if(name == \"CliffJungleB\")return (24);");
		g("if(name == \"PlainA\")return (25);");
		g("if(name == \"PlainB\")return (26);");
		g("if(name == \"PlainDirt25\")return (27);");
		g("if(name == \"PlainDirt50\")return (28);");
		g("if(name == \"PlainDirt75\")return (29);");
		g("if(name == \"CliffPlainB\")return (30);");
		g("if(name == \"DirtA\")return (31);");
		g("if(name == \"DirtB\")return (32);");
		g("if(name == \"DirtC\")return (33);");
		g("if(name == \"SandA\")return (34);");
		g("if(name == \"SandB\")return (35);");
		g("if(name == \"SandC\")return (36);");
		g("if(name == \"SandD\")return (37);");
		g("if(name == \"CliffEgyptianB\")return (38);");
		g("if(name == \"SandDirt50\")return (39);");
		g("if(name == \"SandDirt50b\")return (40);");
		g("if(name == \"SnowA\")return (41);");
		g("if(name == \"SnowB\")return (42);");
		g("if(name == \"SnowGrass25\")return (43);");
		g("if(name == \"SnowGrass50\")return (44);");
		g("if(name == \"SnowGrass75\")return (45);");
		g("if(name == \"SnowSand25\")return (46);");
		g("if(name == \"SnowSand50\")return (47);");
		g("if(name == \"SnowSand75\")return (48);");
		g("if(name == \"CliffNorseB\")return (49);");
		g("if(name == \"OlympusA\")return (50);");
		g("if(name == \"OlympusB\")return (51);");
		g("if(name == \"OlympusC\")return (52);");
		g("if(name == \"OlympusTile\")return (53);");
		g("if(name == \"TundraGrassA\")return (54);");
		g("if(name == \"TundraGrassB\")return (55);");
		g("if(name == \"TundraRockA\")return (56);");
		g("if(name == \"TundraRockB\")return (57);");
		g("if(name == \"MarshA\")return (58);");
		g("if(name == \"MarshB\")return (59);");
		g("if(name == \"MarshC\")return (60);");
		g("if(name == \"MarshD\")return (61);");
		g("if(name == \"MarshE\")return (62);");
		g("if(name == \"MarshF\")return (63);");
		g("if(name == \"EgyptianRoadA\")return (64);");
		g("if(name == \"GreekRoadA\")return (65);");
		g("if(name == \"NorseRoadA\")return (66);");
		g("if(name == \"JungleRoadA\")return (67);");
		g("if(name == \"PlainRoadA\")return (68);");
		g("if(name == \"TundraRoadA\")return (69);");
		g("if(name == \"CityTileA\")return (70);");
		g("if(name == \"CityTileAtlantis\")return (71);");
		g("if(name == \"CityTileAtlantisCoral\")return (72);");
		g("if(name == \"CityTileWaterPool\")return (73);");
		g("if(name == \"CityTileWaterEdgeA\")return (74);");
		g("if(name == \"CityTileWaterEdgeB\")return (75);");
		g("if(name == \"CityTileWaterEdgeEndA\")return (76);");
		g("if(name == \"CityTileWaterEdgeEndB\")return (77);");
		g("if(name == \"CityTileWaterEdgeEndC\")return (78);");
		g("if(name == \"CityTileWaterEdgeEndD\")return (79);");
		g("if(name == \"CityTileWaterCornerA\")return (80);");
		g("if(name == \"CityTileWaterCornerB\")return (81);");
		g("if(name == \"CityTileWaterCornerC\")return (82);");
		g("if(name == \"CityTileWaterCornerD\")return (83);");
		g("if(name == \"HadesBuildable1\")return (84);");
		g("if(name == \"HadesBuildable2\")return (85);");
		g("if(name == \"ForestFloorPalm\")return (86);");
		g("if(name == \"ForestFloorPine\")return (87);");
		g("if(name == \"ForestFloorPineSnow\")return (88);");
		g("if(name == \"ForestFloorOak\")return (89);");
		g("if(name == \"ForestFloorGaia\")return (90);");
		g("if(name == \"ForestFloorSavannah\")return (91);");
		g("if(name == \"ForestFloorDeadPine\")return (92);");
		g("if(name == \"ForestFloorTundra\")return (93);");
		g("if(name == \"ForestFloorMarsh\")return (94);");
		g("if(name == \"ForestFloorJungle\")return (95);");
		g("if(name == \"Water\")return (0);");
		g("if(name == \"CliffA\")return (0);");
		g("if(name == \"CliffGreekA\")return (1);");
		g("if(name == \"CliffEgyptianA\")return (2);");
		g("if(name == \"CliffNorseA\")return (3);");
		g("if(name == \"CliffJungleA\")return (4);");
		g("if(name == \"CliffPlainA\")return (5);");
		g("if(name == \"Dam\")return (6);");
		g("if(name == \"Hades3\")return (7);");
		g("if(name == \"Hades5\")return (8);");
		g("if(name == \"Hades6\")return (9);");
		g("if(name == \"Hades7\")return (10);");
		g("if(name == \"HadesCliff\")return (11);");
		g("if(name == \"Hades4\")return (12);");
		g("if(name == \"BlackRock\")return (13);");
		g("if(name == \"UnderwaterRockA\")return (0);");
		g("if(name == \"UnderwaterRockB\")return (1);");
		g("if(name == \"UnderwaterRockC\")return (2);");
		g("if(name == \"UnderwaterRockD\")return (3);");
		g("if(name == \"UnderwaterRockE\")return (4);");
		g("if(name == \"UnderwaterRockF\")return (5);");
		g("if(name == \"UnderwaterIceA\")return (6);");
		g("if(name == \"UnderwaterIceB\")return (7);");
		g("if(name == \"UnderwaterIceC\")return (8);");
		g("if(name == \"CoralA\")return (9);");
		g("if(name == \"CoralB\")return (10);");
		g("if(name == \"CoralC\")return (11);");
		g("if(name == \"CoralC2\")return (12);");
		g("if(name == \"CoralD\")return (13);");
		g("if(name == \"CoralE\")return (14);");
		g("if(name == \"CoralF\")return (15);");
		g("if(name == \"ShorelineSandA\")return (0);");
		g("if(name == \"ShorelineAegeanA\")return (1);");
		g("if(name == \"ShorelineAegeanB\")return (2);");
		g("if(name == \"ShorelineAegeanC\")return (3);");
		g("if(name == \"ShorelineRedSeaA\")return (4);");
		g("if(name == \"ShorelineRedSeaB\")return (5);");
		g("if(name == \"ShorelineRedSeaC\")return (6);");
		g("if(name == \"ShorelineNorwegianA\")return (7);");
		g("if(name == \"ShorelineNorwegianB\")return (8);");
		g("if(name == \"ShorelineNorwegianC\")return (9);");
		g("if(name == \"ShorelineMediterraneanA\")return (10);");
		g("if(name == \"ShorelineMediterraneanB\")return (11);");
		g("if(name == \"ShorelineMediterraneanC\")return (12);");
		g("if(name == \"ShorelineMediterraneanD\")return (13);");
		g("if(name == \"ShorelineAtlanticA\")return (14);");
		g("if(name == \"ShorelineAtlanticB\")return (15);");
		g("if(name == \"ShorelineAtlanticC\")return (16);");
		g("if(name == \"ShorelineTundraA\")return (17);");
		g("if(name == \"ShorelineTundraB\")return (18);");
		g("if(name == \"ShorelineTundraC\")return (19);");
		g("if(name == \"ShorelineTundraD\")return (20);");
		g("if(name == \"ShorelineJungleA\")return (21);");
		g("if(name == \"ShorelineJungleB\")return (22);");
		g("if(name == \"ShorelineJungleC\")return (23);");
		g("if(name == \"ShorelinePlainA\")return (24);");
		g("if(name == \"ShorelinePlainB\")return (25);");
		g("if(name == \"ShorelinePlainC\")return (26);");
		g("if(name == \"ShorelinePlainD\")return (27);");
		g("if(name == \"RiverSandyA\")return (28);");
		g("if(name == \"RiverSandyB\")return (29);");
		g("if(name == \"RiverSandyC\")return (30);");
		g("if(name == \"RiverSandyShallowA\")return (31);");
		g("if(name == \"RiverGrassyA\")return (32);");
		g("if(name == \"RiverGrassyB\")return (33);");
		g("if(name == \"RiverGrassyC\")return (34);");
		g("if(name == \"RiverIcyA\")return (35);");
		g("if(name == \"RiverIcyB\")return (36);");
		g("if(name == \"RiverIcyC\")return (37);");
		g("if(name == \"RiverMarshA\")return (38);");
		g("if(name == \"RiverMarshB\")return (39);");
		g("if(name == \"RiverMarshC\")return (40);");
		g("if(name == \"IceA\")return (0);");
		g("if(name == \"IceB\")return (1);");
		g("if(name == \"IceC\")return (2);");
		g("if(name == \"MiningGround\")return (3);");
		g("if(name == \"Black\")return (4);");
		g("if(name == \"Hades1\")return (5);");
		g("if(name == \"Hades2\")return (6);");
		g("if(name == \"Hades4Passable\")return (7);");
		g("if(name == \"Hades8\")return (8);");
		g("if(name == \"Hades9\")return (9);");
	g("}");
	g("vector randomCircleLoc(float centreX = 0.0, float centreZ = 0.0, float radius = 0.0){");
		g("bool terminate = false;");
		g("float posX = -1;");
		g("float posZ = -1;");
		g("float radiusCheck = radius * radius + radius;");
		g("while(terminate == false){");
			g("posX = randomFloat(0.0-radius, radius);");
			g("posZ = randomFloat(0.0-radius, radius);");
			g("if(posX*posX + posZ*posZ <= radiusCheck){");
				g("terminate = true;");
			g("}");
		g("}");
		g("return (xsVectorSet(posX + centreX, 0, posZ + centreZ));");
	g("}");
	g("vector randomOutsideCircleLocBrokenLegacy(float centreX = 0.0, float centreZ = 0.0, float radius = 0.0){");
		g("bool terminate = false;");
		g("float posX = -1;");
		g("float posZ = -1;");
		g("float radiusCheck = radius * radius + radius;");
		g("while(terminate == false){");
			g("posX = randomFloat(0.0-"+(getMapSize() / 2)+", "+(getMapSize() / 2)+");");
			g("posZ = randomFloat(0.0-"+(getMapSize() / 2)+", "+(getMapSize() / 2)+");");
			g("if(posX*posX + posZ*posZ > radiusCheck){");
				g("terminate = true;");
			g("}");
		g("}");
		g("return (xsVectorSet(posX + centreX, 0, posZ + centreZ));");
	g("}");
	g("vector randomOutsideCircleLoc(float centreX = 0.0, float centreZ = 0.0, float radius = 0.0){");
		g("bool terminate = false;");
		g("float posX = -1;");
		g("float posZ = -1;");
		g("float radiusCheck = radius * radius + radius;");
		g("while(terminate == false){");
			g("posX = randomFloat(0.0, "+(getMapSize() / 2)+");");
			g("posZ = randomFloat(0.0, "+(getMapSize() / 2)+");");
			g("float distX = centreX - posX;");
			g("float distZ = centreZ - posZ;");
			g("if(distX*distX + distZ*distZ > radiusCheck){");
				g("terminate = true;");
			g("}");
		g("}");
		g("return (xsVectorSet(posX, 0, posZ));");
	g("}");
	g("void paintCircle(int posX = 0, int posZ = 0, int radius = 0, string terrain = \"\"){");
		g("int terrainType = getTerrainType(terrain);");
		g("int terrainSubType = getTerrainSubType(terrain);");
		g("int tempMinX = xsMax(0.0 - posX, 0.0 - radius);");
		g("int tempMinZ = xsMax(0.0 - posZ, 0.0 - radius);");
		g("int tempMaxX = xsMin("+(getMapSize() / 2)+" - posX, radius);");
		g("int tempMaxZ = xsMin("+(getMapSize() / 2)+" - posZ, radius);");
		g("int tempRadiusCheck = radius * radius + radius;");
		g("for(tempZ = tempMaxZ; >= tempMinZ){");
			g("for(tempX = tempMaxX; >= tempMinX){");
				g("if(tempRadiusCheck >= (tempX*tempX + tempZ*tempZ)){");
					g("trPaintTerrain(tempX + posX, tempZ + posZ, tempX + posX, tempZ + posZ, terrainType, terrainSubType, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void replaceCircle(int posX = 0, int posZ = 0, int radius = 0, string oldTerrain = \"\", string newTerrain = \"\"){");
		g("int oldTerrainType = getTerrainType(oldTerrain);");
		g("int oldTerrainSubType = getTerrainSubType(oldTerrain);");
		g("int newTerrainType = getTerrainType(newTerrain);");
		g("int newTerrainSubType = getTerrainSubType(newTerrain);");
		g("int tempMinX = xsMax(0.0 - posX, 0.0 - radius);");
		g("int tempMinZ = xsMax(0.0 - posZ, 0.0 - radius);");
		g("int tempMaxX = xsMin("+(getMapSize() / 2)+" - posX, radius);");
		g("int tempMaxZ = xsMin("+(getMapSize() / 2)+" - posZ, radius);");
		g("int tempRadiusCheck = radius * radius + radius;");
		g("for(tempZ = tempMaxZ; >= tempMinZ){");
			g("for(tempX = tempMaxX; >= tempMinX){");
				g("if(tempRadiusCheck >= (tempX*tempX + tempZ*tempZ)){");
					g("int terrainType = trGetTerrainType(tempX + posX, tempZ + posZ);");
					g("int terrainSubType = trGetTerrainSubType(tempX + posX, tempZ + posZ);");
					g("if(terrainType == oldTerrainType && terrainSubType == oldTerrainSubType){");
						g("trPaintTerrain(tempX + posX, tempZ + posZ, tempX + posX, tempZ + posZ, newTerrainType, newTerrainSubType, false);");
					g("}");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void changeCircleHeight(int posX = 0, int posZ = 0, int radius = 0, int h = 0){");
		g("int tempMinX = xsMax(0.0 - posX, 0.0 - radius);");
		g("int tempMinZ = xsMax(0.0 - posZ, 0.0 - radius);");
		g("int tempMaxX = xsMin("+(getMapSize() / 2)+" - posX, radius);");
		g("int tempMaxZ = xsMin("+(getMapSize() / 2)+" - posZ, radius);");
		g("int tempRadiusCheck = radius * radius + radius;");
		g("for(tempZ = tempMaxZ; >= tempMinZ){");
			g("for(tempX = tempMaxX; >= tempMinX){");
				g("if(tempRadiusCheck >= (tempX*tempX + tempZ*tempZ)){");
					g("trChangeTerrainHeight(tempX + posX, tempZ + posZ, tempX + posX + 1, tempZ + posZ + 1, h, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void paintCircleHeight(int posX = 0, int posZ = 0, int radius = 0, string terrain = \"\", int h = 0){");
		g("int terrainType = getTerrainType(terrain);");
		g("int terrainSubType = getTerrainSubType(terrain);");
		g("int tempMinX = xsMax(0.0 - posX, 0.0 - radius);");
		g("int tempMinZ = xsMax(0.0 - posZ, 0.0 - radius);");
		g("int tempMaxX = xsMin("+(getMapSize() / 2)+" - posX, radius);");
		g("int tempMaxZ = xsMin("+(getMapSize() / 2)+" - posZ, radius);");
		g("int tempRadiusCheck = radius * radius + radius;");
		g("for(tempZ = tempMaxZ; >= tempMinZ){");
			g("for(tempX = tempMaxX; >= tempMinX){");
				g("if(tempRadiusCheck >= (tempX*tempX + tempZ*tempZ)){");
					g("trPaintTerrain(tempX + posX, tempZ + posZ, tempX + posX, tempZ + posZ, terrainType, terrainSubType, false);");
					g("trChangeTerrainHeight(tempX + posX, tempZ + posZ, tempX + posX + 1, tempZ + posZ + 1, h, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void paintCircleHeightLowerOnly(int posX = 0, int posZ = 0, int radius = 0, string terrain = \"\", int h = 0){");
		g("int terrainType = getTerrainType(terrain);");
		g("int terrainSubType = getTerrainSubType(terrain);");
		g("int tempMinX = xsMax(0.0 - posX, 0.0 - radius);");
		g("int tempMinZ = xsMax(0.0 - posZ, 0.0 - radius);");
		g("int tempMaxX = xsMin("+(getMapSize() / 2)+" - posX, radius);");
		g("int tempMaxZ = xsMin("+(getMapSize() / 2)+" - posZ, radius);");
		g("int tempRadiusCheck = radius * radius + radius;");
		g("for(tempZ = tempMaxZ; >= tempMinZ){");
			g("for(tempX = tempMaxX; >= tempMinX){");
				g("if(tempRadiusCheck >= (tempX*tempX + tempZ*tempZ)){");
					g("trPaintTerrain(tempX + posX, tempZ + posZ, tempX + posX, tempZ + posZ, terrainType, terrainSubType, false);");
					g("if(trGetTerrainHeight(tempX + posX, tempZ + posZ) >= h){");
						g("trChangeTerrainHeight(tempX + posX, tempZ + posZ, tempX + posX + 1, tempZ + posZ + 1, h, false);");
					g("}");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void paintCircleRemovingWater(int posX = 0, int posZ = 0, int radius = 0, string terrain = \"\"){");
		g("int terrainType = getTerrainType(terrain);");
		g("int terrainSubType = getTerrainSubType(terrain);");
		g("int tempMinX = xsMax(0.0 - posX, 0.0 - radius);");
		g("int tempMinZ = xsMax(0.0 - posZ, 0.0 - radius);");
		g("int tempMaxX = xsMin("+(getMapSize() / 2)+" - posX, radius);");
		g("int tempMaxZ = xsMin("+(getMapSize() / 2)+" - posZ, radius);");
		g("int tempRadiusCheck = radius * radius + radius;");
		g("for(tempZ = tempMaxZ; >= tempMinZ){");
			g("for(tempX = tempMaxX; >= tempMinX){");
				g("if(tempRadiusCheck >= (tempX*tempX + tempZ*tempZ)){");
					g("trPaintTerrain(tempX + posX, tempZ + posZ, tempX + posX, tempZ + posZ, terrainType, terrainSubType, false);");
					g("int height = xsMax(trGetTerrainHeight(tempX + posX, tempZ + posZ), trGetWaterHeight(tempX + posX, tempZ + posZ));");
					g("trChangeTerrainHeight(tempX + posX, tempZ + posZ, tempX + posX + 1, tempZ + posZ + 1, 15.0, false);");
					g("trChangeTerrainHeight(tempX + posX, tempZ + posZ, tempX + posX + 1, tempZ + posZ + 1, height, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void paintCircleHeight2(int posX = 0, int posZ = 0, int radius = 0, string terrain = \"\", int h = 0){");
		g("int terrainType = getTerrainType(terrain);");
		g("int terrainSubType = getTerrainSubType(terrain);");
		g("int tempMinX = xsMax(0.0 - posX, 0.0 - radius);");
		g("int tempMinZ = xsMax(0.0 - posZ, 0.0 - radius);");
		g("int tempMaxX = xsMin("+(getMapSize() / 2)+" - posX, radius);");
		g("int tempMaxZ = xsMin("+(getMapSize() / 2)+" - posZ, radius);");
		g("int tempRadiusCheck = radius * radius + radius;");
		g("for(tempZ = tempMaxZ; >= tempMinZ){");
			g("for(tempX = tempMaxX; >= tempMinX){");
				g("if(tempRadiusCheck >= (tempX*tempX + tempZ*tempZ)){");
					g("trPaintTerrain(tempX + posX, tempZ + posZ, tempX + posX, tempZ + posZ, terrainType, terrainSubType, false);");
				g("}");
			g("}");
		g("}");
		g("tempRadiusCheck = (radius - 1) * (radius - 1) + (radius - 1);");
		g("for(tempZ = tempMaxZ; >= tempMinZ){");
			g("for(tempX = tempMaxX; >= tempMinX){");
				g("if(tempRadiusCheck >= (tempX*tempX + tempZ*tempZ)){");
					g("trChangeTerrainHeight(tempX + posX, tempZ + posZ, tempX + posX + 1, tempZ + posZ + 1, h, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void changeTerrainHeight(int amount = 0){");
		g("for(z = 0; <= "+(getMapSize() / 2)+") {");
			g("for(x = 0; <= "+(getMapSize() / 2)+") {");
				g("float height = trGetTerrainHeight(x, z);");
				g("trChangeTerrainHeight(x, z, x, z, height + amount, false);");
			g("}");
		g("}");
	g("}");
	g("void refreshPassability(){");
		g("trPaintTerrain(0, 0, 0, 0, trGetTerrainType(0, 0), trGetTerrainSubType(0, 0), true);");
	g("}");
	g("void paintMap(string terrain = \"\"){");
		g("trPaintTerrain(0, 0, "+(getMapSize() / 2)+" - 1, "+(getMapSize() / 2)+" - 1, getTerrainType(terrain), getTerrainSubType(terrain), false);");
	g("}");
	g("void normalise(string terrain = \"\", float height = 0.0, int natureCulture = 0){");
		databaseSearchStartGlobal("Destroy");
		g("trUnitDestroy();");
		removeFromDatabaseGlobal("Destroy");
		databaseSearchEndGlobal();
		databaseSearchStartGlobal("VolatileDestroy");
		g("trUnitDestroy();");
		removeFromDatabaseGlobal("VolatileDestroy");
		databaseSearchEndGlobal();
		g("trUnitSelectClear();");
		g("trUnitSelect(\"0\");");
		g("trMutateSelected("+getUnitIdFromName("Revealer")+");");
		g("trPaintTerrain(0, 0, "+(getMapSize() / 2)+" - 1, "+(getMapSize() / 2)+" - 1, getTerrainType(terrain), getTerrainSubType(terrain), false);");
		g("trChangeTerrainHeight(0, 0, "+(getMapSize() / 2)+", "+(getMapSize() / 2)+", 15, false);");
		g("trChangeTerrainHeight(0, 0, "+(getMapSize() / 2)+", "+(getMapSize() / 2)+", height, false);");
		g("refreshPassability();");
		for(i = 0; < passiveCount){
			g("xsDisableRule(\"_selectPassive"+i+"\");");
			for(p = 1; <= h){
				g("xsDisableRule(\"_buyPassive"+i+"p"+p+"\");");
			}
		}
		for(j = 0; < heroCount){
			for(i = 0; < abilityCount){
				g("xsDisableRule(\"_selectAbility"+j+"i"+i+"\");");
				for(p = 1; <= h){
					g("xsDisableRule(\"_buyAbility"+i+"j"+j+"p"+p+"\");");
				}
			}
		}
		g("if(aiIsMultiplayer() == false){");
			g("for(p = 1; <= "+h+"){");
				g("xsDisableRule(\"_ChangePlayerOldMan\"+p);");
			g("}");
		g("}");
		g("for(p = 1; <= "+h+"){");
			g("trPlayerKillAllGodPowers(p);");
			g("trPlayerGrantResources(p, \"Food\", -999999);");
			g("trPlayerGrantResources(p, \"Wood\", -999999);");
			g("if(getHeroIndex(p) == 0)trPlayerGrantResources(p, \"Wood\", 10000);");
			g("trPlayerGrantResources(p, \"Gold\", -999999);");
			g("if(getHeroIndex(p) == 0)trPlayerGrantResources(p, \"Gold\", 100);");
			g("if(getHeroIndex(p) == 15)trPlayerGrantResources(p, \"Gold\", 100);");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+p);");
			g("trDamageUnitPercent(-100);");
		g("}");
		g("trRenderSnow(0.0);");
		g("sunColor(255, 255, 255);");
		g("ambientColor(115, 115, 115);");
		g("trSetSunPosition(38, 280, false);");
		g("trSetCloudData(1.5, 0.6, 0.6, 2, 0, 1);");
		g("trSetCivAndCulture("+a+", 0, natureCulture);");
		g("trSetCivAndCulture(0, 0, natureCulture);");
		g("waterMap = false;");
		g("inShop = false;");
		g("cinematicForestMap = false;");
	g("}");
	g("void smooth(int amount = 0){");
		g("subModeEnter(\"Simulation\", \"Editor\");");
		g("for(i = 0; < amount){");
			g("terrainFilter();");
		g("}");
		g("subModeLeave(\"Simulation\", \"Editor\");");
		g("modeEnter(\"Pregame\");");
		g("modeEnter(\"Simulation\");");
	g("}");
	g("void changeGlobalHeight(float height = 0){");
		g("subModeEnter(\"Simulation\", \"Editor\");");
		g("terrainAdjustGlobalHeight(height);");
		g("subModeLeave(\"Simulation\", \"Editor\");");
		g("modeEnter(\"Pregame\");");
		g("modeEnter(\"Simulation\");");
	g("}");
	g("void replaceTerrainBelowHeightMin(string oldTerrain = \"\", string newTerrain = \"\", float height = 0.0){");
		g("int oldTerrainType = getTerrainType(oldTerrain);");
		g("int oldTerrainSubType = getTerrainSubType(oldTerrain);");
		g("int newTerrainType = getTerrainType(newTerrain);");
		g("int newTerrainSubType = getTerrainSubType(newTerrain);");
		g("int maxX = "+(getMapSize() / 2)+";");
		g("int maxZ = "+(getMapSize() / 2)+";");
		g("for(z = 0; < maxZ) {");
			g("for(x = 0; < maxX) {");
				g("int terrainType = trGetTerrainType(x, z);");
				g("int terrainSubType = trGetTerrainSubType(x, z);");
				g("float height0 = trGetTerrainHeight(x, z);");
				g("float height1 = trGetTerrainHeight(x + 1, z);");
				g("float height2 = trGetTerrainHeight(x, z + 1);");
				g("float height3 = trGetTerrainHeight(x + 1, z + 1);");
				g("float minHeight = xsMin(xsMin(height0, height1), xsMin(height2, height3));");
				g("if(terrainType == oldTerrainType && terrainSubType == oldTerrainSubType && minHeight <= height){");
					g("trPaintTerrain(x, z, x, z, newTerrainType, newTerrainSubType, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void replaceTerrainBelowHeightMax(string oldTerrain = \"\", string newTerrain = \"\", float height = 0.0){");
		g("int oldTerrainType = getTerrainType(oldTerrain);");
		g("int oldTerrainSubType = getTerrainSubType(oldTerrain);");
		g("int newTerrainType = getTerrainType(newTerrain);");
		g("int newTerrainSubType = getTerrainSubType(newTerrain);");
		g("int maxX = "+(getMapSize() / 2)+";");
		g("int maxZ = "+(getMapSize() / 2)+";");
		g("for(z = 0; < maxZ) {");
			g("for(x = 0; < maxX) {");
				g("int terrainType = trGetTerrainType(x, z);");
				g("int terrainSubType = trGetTerrainSubType(x, z);");
				g("float height0 = trGetTerrainHeight(x, z);");
				g("float height1 = trGetTerrainHeight(x + 1, z);");
				g("float height2 = trGetTerrainHeight(x, z + 1);");
				g("float height3 = trGetTerrainHeight(x + 1, z + 1);");
				g("float maxHeight = xsMax(xsMax(height0, height1), xsMax(height2, height3));");
				g("if(terrainType == oldTerrainType && terrainSubType == oldTerrainSubType && maxHeight <= height){");
					g("trPaintTerrain(x, z, x, z, newTerrainType, newTerrainSubType, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void replaceTerrainAboveHeightMin(string oldTerrain = \"\", string newTerrain = \"\", float height = 0.0){");
		g("int oldTerrainType = getTerrainType(oldTerrain);");
		g("int oldTerrainSubType = getTerrainSubType(oldTerrain);");
		g("int newTerrainType = getTerrainType(newTerrain);");
		g("int newTerrainSubType = getTerrainSubType(newTerrain);");
		g("int maxX = "+(getMapSize() / 2)+";");
		g("int maxZ = "+(getMapSize() / 2)+";");
		g("for(z = 0; < maxZ) {");
			g("for(x = 0; < maxX) {");
				g("int terrainType = trGetTerrainType(x, z);");
				g("int terrainSubType = trGetTerrainSubType(x, z);");
				g("float height0 = trGetTerrainHeight(x, z);");
				g("float height1 = trGetTerrainHeight(x + 1, z);");
				g("float height2 = trGetTerrainHeight(x, z + 1);");
				g("float height3 = trGetTerrainHeight(x + 1, z + 1);");
				g("float minHeight = xsMin(xsMin(height0, height1), xsMin(height2, height3));");
				g("if(terrainType == oldTerrainType && terrainSubType == oldTerrainSubType && minHeight >= height){");
					g("trPaintTerrain(x, z, x, z, newTerrainType, newTerrainSubType, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void replaceTerrainAboveHeightMax(string oldTerrain = \"\", string newTerrain = \"\", float height = 0.0){");
		g("int oldTerrainType = getTerrainType(oldTerrain);");
		g("int oldTerrainSubType = getTerrainSubType(oldTerrain);");
		g("int newTerrainType = getTerrainType(newTerrain);");
		g("int newTerrainSubType = getTerrainSubType(newTerrain);");
		g("int maxX = "+(getMapSize() / 2)+";");
		g("int maxZ = "+(getMapSize() / 2)+";");
		g("for(z = 0; < maxZ) {");
			g("for(x = 0; < maxX) {");
				g("int terrainType = trGetTerrainType(x, z);");
				g("int terrainSubType = trGetTerrainSubType(x, z);");
				g("float height0 = trGetTerrainHeight(x, z);");
				g("float height1 = trGetTerrainHeight(x + 1, z);");
				g("float height2 = trGetTerrainHeight(x, z + 1);");
				g("float height3 = trGetTerrainHeight(x + 1, z + 1);");
				g("float maxHeight = xsMax(xsMax(height0, height1), xsMax(height2, height3));");
				g("if(terrainType == oldTerrainType && terrainSubType == oldTerrainSubType && maxHeight >= height){");
					g("trPaintTerrain(x, z, x, z, newTerrainType, newTerrainSubType, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void replaceTerrainAtMaxSteepness(string oldTerrain = \"\", string newTerrain = \"\", float difference = 0.0){");
		g("int oldTerrainType = getTerrainType(oldTerrain);");
		g("int oldTerrainSubType = getTerrainSubType(oldTerrain);");
		g("int newTerrainType = getTerrainType(newTerrain);");
		g("int newTerrainSubType = getTerrainSubType(newTerrain);");
		g("int maxX = "+(getMapSize() / 2)+";");
		g("int maxZ = "+(getMapSize() / 2)+";");
		g("for(z = 0; < maxZ) {");
			g("for(x = 0; < maxX) {");
				g("int terrainType = trGetTerrainType(x, z);");
				g("int terrainSubType = trGetTerrainSubType(x, z);");
				g("float height0 = trGetTerrainHeight(x, z);");
				g("float height1 = trGetTerrainHeight(x + 1, z);");
				g("float height2 = trGetTerrainHeight(x, z + 1);");
				g("float height3 = trGetTerrainHeight(x + 1, z + 1);");
				g("float minHeight = xsMin(xsMin(height0, height1), xsMin(height2, height3));");
				g("float maxHeight = xsMax(xsMax(height0, height1), xsMax(height2, height3));");
				g("if(terrainType == oldTerrainType && terrainSubType == oldTerrainSubType && (maxHeight - minHeight <= difference)){");
					g("trPaintTerrain(x, z, x, z, newTerrainType, newTerrainSubType, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("void replaceTerrainAtMinSteepness(string oldTerrain = \"\", string newTerrain = \"\", float difference = 0.0){");
		g("int oldTerrainType = getTerrainType(oldTerrain);");
		g("int oldTerrainSubType = getTerrainSubType(oldTerrain);");
		g("int newTerrainType = getTerrainType(newTerrain);");
		g("int newTerrainSubType = getTerrainSubType(newTerrain);");
		g("int maxX = "+(getMapSize() / 2)+";");
		g("int maxZ = "+(getMapSize() / 2)+";");
		g("for(z = 0; < maxZ) {");
			g("for(x = 0; < maxX) {");
				g("int terrainType = trGetTerrainType(x, z);");
				g("int terrainSubType = trGetTerrainSubType(x, z);");
				g("float height0 = trGetTerrainHeight(x, z);");
				g("float height1 = trGetTerrainHeight(x + 1, z);");
				g("float height2 = trGetTerrainHeight(x, z + 1);");
				g("float height3 = trGetTerrainHeight(x + 1, z + 1);");
				g("float minHeight = xsMin(xsMin(height0, height1), xsMin(height2, height3));");
				g("float maxHeight = xsMax(xsMax(height0, height1), xsMax(height2, height3));");
				g("if(terrainType == oldTerrainType && terrainSubType == oldTerrainSubType && (maxHeight - minHeight >= difference)){");
					g("trPaintTerrain(x, z, x, z, newTerrainType, newTerrainSubType, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	g("float heightAboveTerrain(vector posV = vector(0.0, 0.0, 0.0)){");
		g("float tilesFloatX = xsVectorGetX(posV) / 2.0;");
		g("float tilesFloatZ = xsVectorGetZ(posV) / 2.0;");
		g("float tilesModX = modFloat(tilesFloatX, 1.0);");
		g("float tilesModZ = modFloat(tilesFloatZ, 1.0);");
		g("int minHeightX = xsFloor(tilesFloatX);");
		g("int minHeightZ = xsFloor(tilesFloatZ);");
		g("int maxHeightX = xsCeil(tilesFloatX);");
		g("int maxHeightZ = xsCeil(tilesFloatZ);");
		g("float terrainHeightMinMin = trGetTerrainHeight(minHeightX, minHeightZ);");
		g("float terrainHeightMaxMin = trGetTerrainHeight(maxHeightX, minHeightZ);");
		g("float terrainHeightMinMax = trGetTerrainHeight(minHeightX, maxHeightZ);");
		g("float terrainHeightMaxMax = trGetTerrainHeight(maxHeightX, maxHeightZ);");
		g("float heightMinZ = interpolate(terrainHeightMinMin, terrainHeightMaxMin, tilesModX);");
		g("float heightMaxZ = interpolate(terrainHeightMinMax, terrainHeightMaxMax, tilesModX);");
		g("return (xsVectorGetY(posV) - interpolate(heightMinZ, heightMaxZ, tilesModZ));");
	g("}");
	g("void setTerrainHeightForTerrain(string oldTerrain = \"\", float h = 0.0){");
		g("int oldTerrainType = getTerrainType(oldTerrain);");
		g("int oldTerrainSubType = getTerrainSubType(oldTerrain);");
		g("int maxX = "+(getMapSize() / 2)+";");
		g("int maxZ = "+(getMapSize() / 2)+";");
		g("for(z = 0; < maxZ) {");
			g("for(x = 0; < maxX) {");
				g("int terrainType = trGetTerrainType(x, z);");
				g("int terrainSubType = trGetTerrainSubType(x, z);");
				g("if(terrainType == oldTerrainType && terrainSubType == oldTerrainSubType){");
					g("trChangeTerrainHeight(x, z, x + 1, z + 1, h, false);");
				g("}");
			g("}");
		g("}");
	g("}");
	// ### UNIT
	g("void deployLoc(float posX = 0.0, float posZ = 0.0, string unit = \"\", int p = 0){");
		g("trArmyDispatch(\"\"+p+\",0\",unit,1,posX,0,posZ,randomInt(0, 359),true);");
	g("}");
	g("int deployLocUsingCineBlock(float posX = 0.0, float posZ = 0.0, string unit = \"\", int p = 0){");
		g("int cineBlockId = trGetNextUnitScenarioNameNumber();");
		g("deployLoc(posX, posZ, \"Cinematic Block\", p);");
		g("trUnitSelectClear();");
		g("if(cineBlockId == trGetNextUnitScenarioNameNumber())return (-1);");
		g("trUnitSelect(\"\"+cineBlockId, true);");
		g("trUnitChangeProtoUnit(unit);");
		g("return (cineBlockId);");
	g("}");
	g("void deployLocHeading(float posX = 0.0, float posZ = 0.0, string unit = \"\", int p = 0, float heading = 0.0){");
		g("trArmyDispatch(\"\"+p+\",0\",unit,1,posX,0,posZ,heading,true);");
	g("}");
	g("void deployCluster(float posX = 0.0, float posZ = 0.0, string unit = \"\", int p = 0, int count = 0, ");
			g("float radius = 0.0, bool forceOnMap = false){");
		g("for(i = 0; < count){");
			g("vector loc = randomCircleLoc(posX, posZ, radius);");
			g("float finalPosX = xsVectorGetX(loc);");
			g("float finalPosZ = xsVectorGetZ(loc);");
			g("if(forceOnMap){");
				g("finalPosX = clamp(0.0, toMetres(1.0), finalPosX);");
				g("finalPosZ = clamp(0.0, toMetres(1.0), finalPosZ);");
			g("}");
			g("deployLoc(finalPosX, finalPosZ, unit, p);");
		g("}");
	g("}");
	g("void dC(float pX = 0.0, float pZ = 0.0, string u = \"\", int p = 0, int c = 0, float r = 0.0, int c2 = 0, ");
			g("float r2 = 0.0, bool forceOnMap = false){");
		g("for(i = 0; < c2){");
			g("vector loc = randomCircleLoc(pX, pZ, r2);");
			g("float finalPosX = xsVectorGetX(loc);");
			g("float finalPosZ = xsVectorGetZ(loc);");
			g("deployCluster(finalPosX, finalPosZ, u, p, c, r, forceOnMap);");
		g("}");
	g("}");
	g("void dM(string u = \"\", int p = 0, int c = 0, float r = 0.0, int c2 = 0){");
		g("for(i = 0; < c2){");
			g("deployCluster(randomFloat(0.0, toMetres(1.0)), randomFloat(0.0, toMetres(1.0)), u, p, c, r);");
		g("}");
	g("}");
	g("void paintTrees(string terrain = \"\", string tree = \"\"){");
		g("int terrainType = getTerrainType(terrain);");
		g("int terrainSubType = getTerrainSubType(terrain);");
		g("int k = 0;");
		g("for(i = 0; < "+(getMapSize() / 2)+") {");
			g("for(j = 0; < "+(getMapSize() / 2)+") {");
				g("if(k == 0 && trGetTerrainType(i, j) == terrainType && trGetTerrainSubType(i, j) == terrainSubType){");
					g("deployLoc(i * 2  + 1, j * 2 + 1, \"Victory Marker\", 0);");
				g("}");
				g("k = 1 - k;");
			g("}");
			g("k = 1 - k;");
		g("}");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"0\");");
		g("trUnitChangeInArea(0, 0, \"Victory Marker\", tree, 999.0);");
	g("}");
	g("void paintUnit(string terrain = \"\", string unit = \"\", int p = 0, float c = 0.1, bool useCineBlock = false){");
		g("int terrainType = getTerrainType(terrain);");
		g("int terrainSubType = getTerrainSubType(terrain);");
		g("if(useCineBlock){");
			g("for(i = 0; < "+(getMapSize() / 2)+") {");
				g("for(j = 0; < "+(getMapSize() / 2)+") {");
					g("if(trGetTerrainType(i, j) == terrainType && trGetTerrainSubType(i, j) == terrainSubType && randomFloat(0.0, 1.0) <= c){");
						g("deployLocUsingCineBlock(i * 2 + 1, j * 2 + 1, unit, p);");
					g("}");
				g("}");
			g("}");
		g("} else {");
			g("for(i = 0; < "+(getMapSize() / 2)+") {");
				g("for(j = 0; < "+(getMapSize() / 2)+") {");
					g("if(trGetTerrainType(i, j) == terrainType && trGetTerrainSubType(i, j) == terrainSubType && randomFloat(0.0, 1.0) <= c){");
						g("deployLoc(i * 2 + 1, j * 2 + 1, unit, p);");
					g("}");
				g("}");
			g("}");
		g("}");
	g("}");
	//Database
	g("void addToDatabaseAnytime(string name = \"\", int unitName = 0){");
		g("trQuestVarSet(\"yDatabase\"+name+(1*trQuestVarGet(\"yCount\"+name)), ");
				g("unitName);");
		g("trQuestVarSet(\"yCount\"+name, trQuestVarGet(\"yCount\"+name) + 1);");
	g("}");
	g("void addToTimebaseAnytime(string name = \"\", int unitName = 0){");
		g("trQuestVarSet(\"timebase\"+name+(1*trQuestVarGet(\"timebaseCount\"+name)), unitName);");
		g("trQuestVarSet(\"timebaseTime\"+name+(1*trQuestVarGet(\"timebaseCount\"+name)), trTimeMS());");
		g("trQuestVarSet(\"timebaseCount\"+name, trQuestVarGet(\"timebaseCount\"+name) + 1);");
	g("}");
	g("void addToVanishbaseAnytime(string name = \"\", int unitName = 0){");
		g("trQuestVarSet(\"vanishbase\"+name+(1*trQuestVarGet(\"vanishbaseCount\"+name)), ");
				g("unitName);");
		g("trQuestVarSet(\"vanishbaseX\"+name+(1*trQuestVarGet(\"vanishbaseCount\"+name)), ");
				g("xsVectorGetX(kbGetBlockPosition(\"\"+unitName, true)));");
		g("trQuestVarSet(\"vanishbaseY\"+name+(1*trQuestVarGet(\"vanishbaseCount\"+name)), ");
				g("xsVectorGetY(kbGetBlockPosition(\"\"+unitName, true)));");
		g("trQuestVarSet(\"vanishbaseZ\"+name+(1*trQuestVarGet(\"vanishbaseCount\"+name)), ");
				g("xsVectorGetZ(kbGetBlockPosition(\"\"+unitName, true)));");
		g("trQuestVarSet(\"vanishbaseOwner\"+name+(1*trQuestVarGet(\"vanishbaseCount\"+name)), ");
				g("getOwner(unitName));");
		g("trQuestVarSet(\"vanishbaseCount\"+name, trQuestVarGet(\"vanishbaseCount\"+name) + 1);");
	g("}");
	// ### HEROES
	g("int heroCount = "+heroCount+";");
	g("string heroName(int i = 0){");
		g("i--;if(i<0)return (\"Builder\");");
		g("i--;if(i<0)return (\"Paladin\");");
		g("i--;if(i<0)return (\"Summoner\");");
		g("i--;if(i<0)return (\"Amazon\");");
		g("i--;if(i<0)return (\"Wizard\");");
		g("i--;if(i<0)return (\"Iron Maiden\");");
		g("i--;if(i<0)return (\"Necromancer\");");
		g("i--;if(i<0)return (\"Archer\");");
		g("i--;if(i<0)return (\"Shaman\");");
		g("i--;if(i<0)return (\"Assassin\");");
		g("i--;if(i<0)return (\"Witch\");");
		g("i--;if(i<0)return (\"Rogue\");");
		g("i--;if(i<0)return (\"Birdmistress\");");
		g("i--;if(i<0)return (\"Artificer\");");
		g("i--;if(i<0)return (\"Fire Warlock\");");
		g("i--;if(i<0)return (\"Miner\");");
	g("}");
	g("string heroDescription(int i = 0){");
		g("i--;if(i<0)return (\"Constructs buildings and traps to protect and attack. Resources come from building Guilds.\");");
		g("i--;if(i<0)return (\"Tanky hero with a powerful jump as well as the ability to help cheat death.\");");
		g("i--;if(i<0)return (\"Focus on summoning minions to attack indirectly remaining out of danger themselves.\");");
		g("i--;if(i<0)return (\"Close ranged fighter with a mix of skills and utilities natural based.\");");
		g("i--;if(i<0)return (\"A squishy fighter relying on spells and long ranged attack to attack from a distance.\");");
		g("i--;if(i<0)return (\"Doesn't directly attack but instead reflects damage back to adjacent attackers.\");");
		g("i--;if(i<0)return (\"Fights by amassing an army of the undead to aid in battle. Great against mass enemies.\");");
		g("i--;if(i<0)return (\"Long ranged fighter with ability to unlock specialised arrows with additional effects.\");");
		g("i--;if(i<0)return (\"Makes use of auras. Non combat auras require special concentration. Great for support.\");");
		g("i--;if(i<0)return (\"High attack low health hero with a focus of risky but high damage play.\");");
		g("i--;if(i<0)return (\"Powerful and slow attack which increase frequency. Mistress of cursing and cloning.\");");
		g("i--;if(i<0)return (\"Very weak character with a slow and deadly attacks with extremely high range.\");");
		g("i--;if(i<0)return (\"Average fighter using birds for combat and healing. However birds are unpredictable.\");");
		g("i--;if(i<0)return (\"Support character forging powerful artefacts for other heroes to use during battle.\");");
		g("i--;if(i<0)return (\"Battle mage fighting close range with fire attacks coupled with some powerful spells.\");");
		g("i--;if(i<0)return (\"Greedy hero obsessed with collecting gold but can cash in for ranged fighters.\");");
	g("}");
	g("string heroUnit(int i = 0){");
		g("i--;if(i<0)return (\"Villager Atlantean Hero\");");
		g("i--;if(i<0)return (\"Hero Greek Bellerophon\");");
		g("i--;if(i<0)return (\"Hero Greek Chiron\");");
		g("i--;if(i<0)return (\"Reginleif\");");
		g("i--;if(i<0)return (\"Setna\");");
		g("i--;if(i<0)return (\"Athena\");");
		g("i--;if(i<0)return (\"Arkantos\");");
		g("i--;if(i<0)return (\"Archer Atlantean Hero\");");
		g("i--;if(i<0)return (\"Oracle Hero\");");
		g("i--;if(i<0)return (\"Shaba Ka\");");
		g("i--;if(i<0)return (\"Circe\");");
		g("i--;if(i<0)return (\"Hero Greek Hippolyta\");");
		g("i--;if(i<0)return (\"Hero Greek Atalanta\");");
		g("i--;if(i<0)return (\"Pharaoh\");");
		g("i--;if(i<0)return (\"Zhi\");");
		g("i--;if(i<0)return (\"Eitri\");");
	g("}");
	g("string heroIcon(int i = 0){");
		g("i--;if(i<0)return (\"icons\villager x male hero icons 64\");");
		g("i--;if(i<0)return (\"icons\hero g bellerophon icon 64\");");
		g("i--;if(i<0)return (\"icons\hero g chiron icon 64\");");
		g("i--;if(i<0)return (\"icons\scenario n reginleif icon 64\");");
		g("i--;if(i<0)return (\"icons\special e setna icon 64\");");
		g("i--;if(i<0)return (\"icons\improvement athena icon\");");
		g("i--;if(i<0)return (\"icons\special g arkantos icon 64\");");
		g("i--;if(i<0)return (\"icons\archer x arcus hero icons 64\");");
		g("i--;if(i<0)return (\"icons\infantry x oracle hero icons 64\");");
		g("i--;if(i<0)return (\"icons\scenario kemsyt icon 64\");");
		g("i--;if(i<0)return (\"icons\special g circe icon 64\");");
		g("i--;if(i<0)return (\"icons\hero g hippolyta\");");
		g("i--;if(i<0)return (\"icons\hero g atalanta icon 64\");");
		g("i--;if(i<0)return (\"icons\special e pharaoh icon 64\");");
		g("i--;if(i<0)return (\"icons\scenario c zhi icon\");");
		g("i--;if(i<0)return (\"icons\scenario eitri icon 64\");");
	g("}");
	// ### PASSIVE UPGRADES
	g("int passiveCount = "+passiveCount+";");
	g("string passiveName(int i = 0){");
		g("i--;if(i<0)return (\"20 percent base health for hero/spells/buildings/minions\");");
		g("i--;if(i<0)return (\"20 percent base attack for hero/spells/buildings/minions/reflect/mana\");");
		g("i--;if(i<0)return (\"+0.5 speed for all units\");");
	g("}");
	g("int passiveCost(int i = 0){");
		g("i--;if(i<0)return (1);");
		g("i--;if(i<0)return (1);");
		g("i--;if(i<0)return (1);");
	g("}");
	g("string passiveUnit(int i = 0){");
		g("i--;if(i<0)return (\"Promethean\");");
		g("i--;if(i<0)return (\"Anubite\");");
		g("i--;if(i<0)return (\"Valkyrie\");");
	g("}");
	// ### CHARACTER SKILLS
	g("int abilityCount = "+abilityCount+";");
	g("string abilityName(int c = 0, int i = 0){");
		g("c--;if(c<0){");
			g("i--;if(i<0)return (\"+1 guild limit (income)\");");
			g("i--;if(i<0)return (\"+2 tower and ship range and LOS\");");
			g("i--;if(i<0)return (\"+1 tower and ship arrow\");");
			g("i--;if(i<0)return (\"Unlock healing temple/+1 healing rate to heal everything but temples\");");
			g("i--;if(i<0)return (\"Unlock 10x character damage rechargeable mines/+1 mine damage multiplier\");");
			g("i--;if(i<0)return (\"Unlock fast character damage magic haze/+10 seconds lifespan\");");
			g("i--;if(i<0)return (\"Unlock dock (double income) and ships (Needs dock to live)/+1 dock limit\");");
			g("i--;if(i<0)return (\"Unlock armoury (food for arrow, +10 percent temp base attack for 1000)/+1 food\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+1x character damage multiplier to jump\");");
			g("i--;if(i<0)return (\"-25 percent current jump recharge time\");");
			g("i--;if(i<0)return (\"+10 percent chance to temporarily revive nearby killed enemy as your own\");");
			g("i--;if(i<0)return (\"+1 teleport on death marker per round and heal 10 percent health\");");
			g("i--;if(i<0)return (\"Unlock revive single hero/+1 extra cast and +30 seconds duration\");");
			g("i--;if(i<0)return (\"+1 heal self and neighbouring heroes 30 percent every 120 seconds\");");
			g("i--;if(i<0)return (\"+20 percent character trample damage per second while attacking\");");
			g("i--;if(i<0)return (\"+1 teleport other hero to you and fully heal them once per round\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+20 summon lifespan\");");
			g("i--;if(i<0)return (\"+2 range and LOS\");");
			g("i--;if(i<0)return (\"+3 percent chance to duplicate nearest summon on attack\");");
			g("i--;if(i<0)return (\"+2 percent chance of minotaur every second\");");
			g("i--;if(i<0)return (\"+2 percent chance of wadjet every second\");");
			g("i--;if(i<0)return (\"+2 percent chance of stymphalian bird every second\");");
			g("i--;if(i<0)return (\"+1 full heal and reset of minion lifespans per round\");");
			g("i--;if(i<0)return (\"Unlock change all minions to one type every 120 seconds/+2 bonus minions of same type\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+10 percent chance character damage poison spear\");");
			g("i--;if(i<0)return (\"+2 percent chance any death summons carnivora with half stats\");");
			g("i--;if(i<0)return (\"+1 overgrow (Remove water and cliff) every 120 seconds\");");
			g("i--;if(i<0)return (\"+1 percent summon dryad chance every second\");");
			g("i--;if(i<0)return (\"+1 endless geyser every 120 seconds\");");
			g("i--;if(i<0)return (\"Unlock/+1x character damage forest fire every 120 seconds\");");
			g("i--;if(i<0)return (\"Unlock tree lifebond (+1 spear and double summon chance)/+3 radius\");");
			g("i--;if(i<0)return (\"+2 range and LOS\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+2 range and LOS\");");
			g("i--;if(i<0)return (\"+1 wizard blast spell 4x character damage every 60 seconds\");");
			g("i--;if(i<0)return (\"+1 teleport every 120 seconds\");");
			g("i--;if(i<0)return (\"+1 heal all characters 20 percent every 120 seconds\");");
			g("i--;if(i<0)return (\"+2 percent chance of 10x character damage flash at projectile destination\");");
			g("i--;if(i<0)return (\"Unlock/Increase 25 percent character damage lightning storm every 90 seconds\");");
			g("i--;if(i<0)return (\"+10 percent chance of 2 for 1 when receiving spells including initial\");");
			g("i--;if(i<0)return (\"Unlock 20 percent chance of +4 projectile on attack/+4 extra projectiles on occurance\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+Unlock/+4 taunt (Force enemy to attack you) radius every 60 seconds\");");
			g("i--;if(i<0)return (\"+5 percent of damage taken directed back at attackers (Modified by difficulty)\");");
			g("i--;if(i<0)return (\"+2 percent of regaining 1 percent health on hit\");");
			g("i--;if(i<0)return (\"+4 percent chance of bolting random enemy for 20x character damage on hit\");");
			g("i--;if(i<0)return (\"+4 percent chance of blinking 3 random nearby areas for 5x character damage\");");
			g("i--;if(i<0)return (\"+1 teleport every 120 seconds\");");
			g("i--;if(i<0)return (\"+1 self damage by 1 percent base health 12 times every 60 seconds\");");
			g("i--;if(i<0)return (\"+10 percent chance to trigger effects on gaining health (As if you took damage)\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+15 minion lifespan\");");
			g("i--;if(i<0)return (\"+2 raise dead radius\");");
			g("i--;if(i<0)return (\"Unlock/Increase +40 percent character damage on battle cry from minions\");");
			g("i--;if(i<0)return (\"+2 extra minions on battle cry\");");
			g("i--;if(i<0)return (\"-25 percent current recharge for battle cry\");");
			g("i--;if(i<0)return (\"+10 percent chance of more powerful minion with double stats\");");
			g("i--;if(i<0)return (\"+1 runestone every per round summoning minion 2 percent chance per second\");");
			g("i--;if(i<0)return (\"+1 sacrifice all minions and deal attack to cast location every 120 seconds/+1 multiplier\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+1 projectile\");");
			g("i--;if(i<0)return (\"+2 range and LOS\");");
			g("i--;if(i<0)return (\"+1 percent magic explosion arrow for 10x character damage\");");
			g("i--;if(i<0)return (\"+1 percent chance shockwave arrow at destination\");");
			g("i--;if(i<0)return (\"+1 percent chance burning trail arrow for 5x character damage\");");
			g("i--;if(i<0)return (\"Unlock/+10x character damage barrage every 90 seconds\");");
			g("i--;if(i<0)return (\"+1 archer apprentice with quarter stats but same special arrows chance\");");
			g("i--;if(i<0)return (\"+1 special arrow chance multiplier when hero below 50 percent health\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"Unlock/+50 percent character damage per second aura\");");
			g("i--;if(i<0)return (\"Unlock/+1 healing rate for heroes in aura\");");
			g("i--;if(i<0)return (\"Unlock/+3 range for heroes and their controlled units/buildings in aura\");");
			g("i--;if(i<0)return (\"+1 aura radius\");");
			g("i--;if(i<0)return (\"Unlock/+10 radius scare enemies every 60 seconds\");");
			g("i--;if(i<0)return (\"+1 raise sentinel quarter health and half attack every 60 seconds\");");
			g("i--;if(i<0)return (\"+3 additional seconds of aura time if concentration is broken\");");
			g("i--;if(i<0)return (\"+1 teleport and enter immediate concentration per round\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+1 percent health every kill\");");
			g("i--;if(i<0)return (\"+25 percent character damage flare on kill max 4 per second\");");
			g("i--;if(i<0)return (\"Unlock ghost walk (Walk through everything anywhere) every 60 seconds/+5 seconds duration\");");
			g("i--;if(i<0)return (\"Unlock 10 percent enrage into poseidon statue 4x stats every kill/+5 seconds duration\");");
			g("i--;if(i<0)return (\"+1 shockwave every 60 seconds\");");
			g("i--;if(i<0)return (\"+1 endless poison cloud per round dealing 30 percent character damage per second\");");
			g("i--;if(i<0)return (\"+1 reduce all enemies on map to 75 percent health if above one per round\");");
			g("i--;if(i<0)return (\"+200 percent base attack if health is below 50 percent\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+1x mana damage to melee enemies on attack\");");
			g("i--;if(i<0)return (\"+10 percent chance of shockwave at character on attack\");");
			g("i--;if(i<0)return (\"+1 curse every 60 seconds - nearby enemies take 25 percent mana damage every second\");");
			g("i--;if(i<0)return (\"Unlock/+1x mana damage +10 percent heal armageddon when below 40 percent health first time\");");
			g("i--;if(i<0)return (\"+1 clone 3 copies of non boss enemy as yours per round without lifespan\");");
			g("i--;if(i<0)return (\"Unlock/+30 seconds to duplicate temporary self every 120 seconds\");");
			g("i--;if(i<0)return (\"Unlock/+1 create 10 copies of nearest non boss enemy at location for extra kills\");");
			g("i--;if(i<0)return (\"+10 percent chance of 1x mana flare at enemy death nearby to main hero max 4 per second\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+5 range, LOS, and arrow speed\");");
			g("i--;if(i<0)return (\"+1 bird transform (2 casts for start and end) every 60 seconds\");");
			g("i--;if(i<0)return (\"+10 percent chance of shot healing nearby allies 5 percent on landing\");");
			g("i--;if(i<0)return (\"+1 percent chance of obliterating shot dealing 10x character damage to large area\");");
			g("i--;if(i<0)return (\"+1 steal power of enemy hitpoints to heal yourself every 60 seconds\");");
			g("i--;if(i<0)return (\"Unlock/+5x character damage forest explosion every 60 seconds\");");
			g("i--;if(i<0)return (\"+1 percent chance of +50 projectiles on attack\");");
			g("i--;if(i<0)return (\"+1 ring of 20 character percent hitpoints obelisks every 120 seconds/+20 percent hitpoints\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+10 percent chance of 2x character damage shot every quarter second while attacking\");");
			g("i--;if(i<0)return (\"+1 5x character damage shot per kill (Max 1 qualifying kill per quarter second)\");");
			g("i--;if(i<0)return (\"Unlock ravens to eat enemies 3x character damage every 90 seconds/+1x damage multiplier\");");
			g("i--;if(i<0)return (\"+1 temporary invincible roc spell every 120 seconds (Dies ejecting after 25 seconds)\");");
			g("i--;if(i<0)return (\"Unlock healing eagle spell every level/+1 healing speed\");");
			g("i--;if(i<0)return (\"Unlock 10 second enemy only cease fire per level/+10 seconds cease fire time\");");
			g("i--;if(i<0)return (\"Unlock 3 bombing harpies to drop 20x damage bomb every 60 seconds/+1 extra cast\");");
			g("i--;if(i<0)return (\"+10 percent chance of extra shot whenever a shot is created from attack or unit death\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+1 self and +0.25 global carry limit and -20 percent current forge time\");");
			g("i--;if(i<0)return (\"Unlock 100 percent base attack increase/+1 forge limit\");");
			g("i--;if(i<0)return (\"Unlock +1 (+4 if Archer) projectile/+1 forge limit\");");
			g("i--;if(i<0)return (\"Unlock +5 range and LOS\+1 forge limit\");");
			g("i--;if(i<0)return (\"Unlock +1 bonus favour if holding at round end/+1 forge limit\");");
			g("i--;if(i<0)return (\"Unlock +1/3 spell recharge speed/+1 forge limit\");");
			g("i--;if(i<0)return (\"Unlock empowerable mining camp, 40 gold for weak priest/+1 gather speed\");");
			g("i--;if(i<0)return (\"Unlock empowerable lighthouse firing with 50x damage, 4 food fires/+1 gather speed\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+10 extra percent chance of character damage per second fire tornado on attack\");");
			g("i--;if(i<0)return (\"+1 seconds lifespan on fire tornado\");");
			g("i--;if(i<0)return (\"+1 teleport random location spell every 60 seconds dealing 20x character damage nearby\");");
			g("i--;if(i<0)return (\"+1 character damage fire wall per second every 120 seconds/+10 seconds duration\");");
			g("i--;if(i<0)return (\"+1 slow sky trident spell dealing 20x character damage per level/+1 spell cast\");");
			g("i--;if(i<0)return (\"+1 temporary fireball tower spell dealing 5x character damage every 120 seconds\");");
			g("i--;if(i<0)return (\"+10 chance enemies dying nearby setting on fire for 5 seconds doing character damage\");");
			g("i--;if(i<0)return (\"Unlock character damage fire ring below 10 percent health/+10 percent health threshold\");");
		g("} c--;if(c<0){");
			g("i--;if(i<0)return (\"+1 extra gold mining spot\");");
			g("i--;if(i<0)return (\"+4 extra gold for hero and +1 extra gold for dwarves while mining\");");
			g("i--;if(i<0)return (\"+1 summon mining dwarf every 120 seconds\");");
			g("i--;if(i<0)return (\"+2 range and LOS for trained units\");");
			g("i--;if(i<0)return (\"+1 create temporary blocking golden forest every 120 seconds\");");
			g("i--;if(i<0)return (\"+1 summon underground tunnel per level\");");
			g("i--;if(i<0)return (\"+1 throwing axe for trained units\");");
			g("i--;if(i<0)return (\"+10 percent chance of getting 2 for 1 when training\");");
		g("}");
	g("}");
	g("int abilityCost(int c = 0, int i = 0){");
		g("return (2);");
	g("}");
	
	// ### STATS
	g("int losRangeOffset = 5;");
	g("int arrowSpeedOffset = 20;");
	g("int minionRangePenalty = 5;");
	g("int playerUnitCount = 32;");
	g("int playerRangedUnitCount = 15;");
	g("string unitList(int i = 0){");
		g("i--;if(i<0)return (\"Tower\");");
		g("i--;if(i<0)return (\"Wall Connector\");");
		g("i--;if(i<0)return (\"Wall Short\");");
		g("i--;if(i<0)return (\"Wall Medium\");");
		g("i--;if(i<0)return (\"Wall Long\");");
		g("i--;if(i<0)return (\"Gate\");");
		g("i--;if(i<0)return (\"Sky Passage\");");
		g("i--;if(i<0)return (\"Guild\");");
		g("i--;if(i<0)return (\"Manor\");");
		g("i--;if(i<0)return (\"Farm\");");
		g("i--;if(i<0)return (\"Minotaur\");");
		g("i--;if(i<0)return (\"Wadjet\");");
		g("i--;if(i<0)return (\"Stymphalian Bird\");");
		g("i--;if(i<0)return (\"Audrey\");");
		g("i--;if(i<0)return (\"Dryad\");");
		g("i--;if(i<0)return (\"Minion\");");
		g("i--;if(i<0)return (\"Jiangshi\");");
		g("i--;if(i<0)return (\"Temple\");");
		g("i--;if(i<0)return (\"Tunnel\");");
		g("i--;if(i<0)return (\"Sentinel Main\");");
		g("i--;if(i<0)return (\"Titan Bad\");");
		g("i--;if(i<0)return (\"Raven\");");
		g("i--;if(i<0)return (\"Roc\");");
		g("i--;if(i<0)return (\"Dwarf\");");
		g("i--;if(i<0)return (\"Throwing Axeman\");");
		g("i--;if(i<0)return (\"Dock\");");
		g("i--;if(i<0)return (\"Bireme\");");
		g("i--;if(i<0)return (\"Armory\");");
		g("i--;if(i<0)return (\"Archer Atlantean\");");
		g("i--;if(i<0)return (\"Mining Camp\");");
		g("i--;if(i<0)return (\"Lighthouse\");");
		g("i--;if(i<0)return (\"Priest\");");
	g("}");
	g("string allRangedUnitList(int i = 0){");
		g("i--;if(i<0)return (\"Hero Greek Chiron\");");
		g("i--;if(i<0)return (\"Reginleif\");");
		g("i--;if(i<0)return (\"Setna\");");
		g("i--;if(i<0)return (\"Archer Atlantean Hero\");");
		g("i--;if(i<0)return (\"Hero Greek Hippolyta\");");
		g("i--;if(i<0)return (\"Pharaoh\");");
		g("i--;if(i<0)return (\"Zhi\");");
		g("i--;if(i<0)return (\"Tower\");");
		g("i--;if(i<0)return (\"Wadjet\");");
		g("i--;if(i<0)return (\"Stymphalian Bird\");");
		g("i--;if(i<0)return (\"Sentinel Main\");");
		g("i--;if(i<0)return (\"Throwing Axeman\");");
		g("i--;if(i<0)return (\"Bireme\");");
		g("i--;if(i<0)return (\"Archer Atlantean\");");
		g("i--;if(i<0)return (\"Priest\");");
	g("}");
	g("float heroBaseHealth(int i = 0){");
		g("i--;if(i<0)return (10000.0);");
		g("i--;if(i<0)return (25000.0);");
		g("i--;if(i<0)return (10000.0);");
		g("i--;if(i<0)return (15000.0);");
		g("i--;if(i<0)return (8000.0);");
		g("i--;if(i<0)return (25000.0);");
		g("i--;if(i<0)return (25000.0);");
		g("i--;if(i<0)return (12000.0);");
		g("i--;if(i<0)return (25000.0);");
		g("i--;if(i<0)return (15000.0);");
		g("i--;if(i<0)return (10000.0);");
		g("i--;if(i<0)return (5000.0);");
		g("i--;if(i<0)return (20000.0);");
		g("i--;if(i<0)return (10000.0);");
		g("i--;if(i<0)return (20000.0);");
		g("i--;if(i<0)return (15000.0);");
	g("}");
	g("float heroBaseAttack(int i = 0){");
		g("i--;if(i<0)return (10.0);");
		g("i--;if(i<0)return (40.0);");
		g("i--;if(i<0)return (20.0);");
		g("i--;if(i<0)return (40.0);");
		g("i--;if(i<0)return (20.0);");
		g("i--;if(i<0)return (10.0);");
		g("i--;if(i<0)return (20.0);");
		g("i--;if(i<0)return (12.0);");
		g("i--;if(i<0)return (35.0);");
		g("i--;if(i<0)return (50.0);");
		g("i--;if(i<0)return (100.0);");
		g("i--;if(i<0)return (50.0);");
		g("i--;if(i<0)return (30.0);");
		g("i--;if(i<0)return (20.0);");
		g("i--;if(i<0)return (25.0);");
		g("i--;if(i<0)return (30.0);");
	g("}");
	g("float buildTime(string unit = \"\"){");
		g("if(unit == \"Guild\")return (1.0);");
		g("if(unit == \"Tower\")return (0.2);");
		g("if(unit == \"Sky Passage\")return (1.0);");
		g("if(unit == \"Farm\")return (0.1);");
		g("if(unit == \"Manor\")return (0.1);");
		g("if(unit == \"Wall Connector\")return (0.01);");
		g("if(unit == \"Wall Short\")return (0.015);");
		g("if(unit == \"Wall Medium\")return (0.02);");
		g("if(unit == \"Wall Long\")return (0.025);");
		g("if(unit == \"Temple\")return (2.5);");
		g("if(unit == \"Dock\")return (1.0);");
		g("if(unit == \"Bireme\")return (0.2);");
		g("if(unit == \"Armory\")return (2.5);");
	g("}");
	
	//Drawn stats
	createPlayerGlobalIntArray("BuilderGuildLimit", 2);
	createPlayerGlobalIntArray("BuilderRange", 10);
	createPlayerGlobalIntArray("BuilderProjectiles", 2);
	createPlayerGlobalBoolArray("BuilderTempleUnlocked", false);
	createPlayerGlobalFloatArray("BuilderBuildPoints", 5.0);
	createPlayerGlobalIntArray("BuilderHealSpeed", 1);
	createPlayerGlobalBoolArray("BuilderMineUnlocked", false);
	createPlayerGlobalIntArray("BuilderMineBlastMultiplier", 1);
	createPlayerGlobalBoolArray("BuilderMagicHazeUnlocked", false);
	createPlayerGlobalIntArray("BuilderMagicHazeLifespan", 20);
	createPlayerGlobalBoolArray("BuilderDockUnlocked", false);
	createPlayerGlobalIntArray("BuilderDockLimit", 1);
	createPlayerGlobalBoolArray("BuilderArmoryUnlocked", false);
	createPlayerGlobalIntArray("BuilderArmoryFood", 1);
	
	createPlayerGlobalIntArray("PaladinJumpDamageMultiplier", 1);
	createPlayerGlobalFloatArray("PaladinRechargeTime", 12.0);
	createPlayerGlobalIntArray("PaladinRechargeReduction", 0);
	createPlayerGlobalIntArray("PaladinReviveChance", 0);
	createPlayerGlobalIntArray("PaladinDeathTeleportCount", 0);
	createPlayerGlobalBoolArray("PaladinReviveUnlocked", false);
	createPlayerGlobalIntArray("PaladinReviveTime", 60);
	createPlayerGlobalIntArray("PaladinReviveCount", 1);
	createPlayerGlobalIntArray("PaladinHealCount", 0);
	createPlayerGlobalIntArray("PaladinTrampleDamagePercent", 0);
	createPlayerGlobalIntArray("PaladinTeleportCount", 0);
	
	createPlayerGlobalIntArray("SummonerLifespan", 40);
	createPlayerGlobalIntArray("SummonerRange", 15);
	createPlayerGlobalIntArray("SummonerCallToArmsChance", 0);
	createPlayerGlobalIntArray("SummonerMinotaur", 2);
	createPlayerGlobalIntArray("SummonerWadjet", 2);
	createPlayerGlobalIntArray("SummonerBird", 2);
	createPlayerGlobalIntArray("SummonerHealCount", 0);
	createPlayerGlobalBoolArray("SummonerChangeUnlocked", false);
	createPlayerGlobalIntArray("SummonerChangeBonus", 0);
	
	createPlayerGlobalIntArray("AmazonPoisonChance", 0);
	createPlayerGlobalIntArray("AmazonCarnivoraChance", 0);
	createPlayerGlobalIntArray("AmazonOvergrowCount", 0);
	createPlayerGlobalIntArray("AmazonDryad", 0);
	createPlayerGlobalIntArray("AmazonGeyserCount", 0);
	createPlayerGlobalBoolArray("AmazonForestFireUnlocked", false);
	createPlayerGlobalIntArray("AmazonForestFireDamageMultiplier", 1);
	createPlayerGlobalBoolArray("AmazonLifebondUnlocked", false);
	createPlayerGlobalIntArray("AmazonLifebondDistance", 3);
	createPlayerGlobalIntArray("AmazonRange", 16);
	
	createPlayerGlobalIntArray("WizardRange", 16);
	createPlayerGlobalIntArray("WizardBlastCount", 0);
	createPlayerGlobalIntArray("WizardTeleportCount", 0);
	createPlayerGlobalIntArray("WizardHealCount", 0);
	createPlayerGlobalIntArray("WizardFlashChance", 0);
	createPlayerGlobalBoolArray("WizardLightningStormUnlocked", false);
	createPlayerGlobalIntArray("WizardLightningStormDamagePercent", 25);
	createPlayerGlobalIntArray("WizardTwoForOneChance", 0);
	createPlayerGlobalIntArray("WizardProjectile", 0);
	
	createPlayerGlobalBoolArray("MaidenTauntUnlocked", false);
	createPlayerGlobalIntArray("MaidenTauntRadius", 4);
	createPlayerGlobalIntArray("MaidenPercentageDamageTakenReflectBack", 0);
	createPlayerGlobalIntArray("MaidenHealChance", 0);
	createPlayerGlobalIntArray("MaidenBoltChance", 0);
	createPlayerGlobalIntArray("MaidenBlinkChance", 0);
	createPlayerGlobalIntArray("MaidenTeleportCount", 0);
	createPlayerGlobalIntArray("MaidenSelfDamageCount", 0);
	createPlayerGlobalIntArray("MaidenHealRetaliationChance", 0);
	
	createPlayerGlobalIntArray("NecromancerLifespan", 30);
	createPlayerGlobalIntArray("NecromancerRaiseDeadRadius", 5);
	createPlayerGlobalIntArray("NecromancerCryDamagePercent", 0);
	createPlayerGlobalIntArray("NecromancerCryMinions", 0);
	createPlayerGlobalFloatArray("NecromancerRecharge", 20.0);
	createPlayerGlobalIntArray("NecromancerRechargeReduction", 0);
	createPlayerGlobalIntArray("NecromancerPowerfulMinionChance", 0);
	createPlayerGlobalIntArray("NecromancerRuneCount", 0);
	createPlayerGlobalBoolArray("NecromancerSacrificeUnlocked", false);
	createPlayerGlobalIntArray("NecromancerSacrificeMultiplier", 1);
	
	createPlayerGlobalIntArray("ArcherProjectiles", 2);
	createPlayerGlobalIntArray("ArcherRange", 14);
	createPlayerGlobalIntArray("ArcherMagicArrowChance", 0);
	createPlayerGlobalIntArray("ArcherShockwaveArrowChance", 0);
	createPlayerGlobalIntArray("ArcherBurningArrowChance", 0);
	createPlayerGlobalBoolArray("ArcherBarrageUnlocked", false);
	createPlayerGlobalIntArray("ArcherBarrageAttackMultiplier", 1);
	createPlayerGlobalIntArray("ArcherApprenticeCount", 0);
	createPlayerGlobalIntArray("ArcherSpecialMultiplier", 0);
	
	createPlayerGlobalIntArray("ShamanDamagePercent", 0);
	createPlayerGlobalIntArray("ShamanHealingRate", 0);
	createPlayerGlobalIntArray("ShamanRange", 0);
	createPlayerGlobalIntArray("ShamanRadius", 6);
	createPlayerGlobalBoolArray("ShamanScareUnlocked", false);
	createPlayerGlobalIntArray("ShamanScareRadius", 10);
	createPlayerGlobalIntArray("ShamanSentinelCount", 0);
	createPlayerGlobalIntArray("ShamanAuraCarryTime", 0);
	createPlayerGlobalIntArray("ShamanTeleportCount", 0);
	
	createPlayerGlobalIntArray("AssassinPercentHealth", 0);
	createPlayerGlobalBoolArray("AssassinFlareUnlocked", false);
	createPlayerGlobalIntArray("AssassinFlarePercentDamage", 25);
	createPlayerGlobalBoolArray("AssassinGhostWalkUnlocked", false);
	createPlayerGlobalIntArray("AssassinGhostWalkDuration", 5);
	createPlayerGlobalBoolArray("AssassinRageUnlocked", false);
	createPlayerGlobalIntArray("AssassinRageDuration", 5);
	createPlayerGlobalIntArray("AssassinShockwaveCount", 0);
	createPlayerGlobalIntArray("AssassinPoisonCount", 0);
	createPlayerGlobalIntArray("AssassinReduceCount", 0);
	createPlayerGlobalIntArray("AssassinAttackBoostCount", 0);
	
	createPlayerGlobalBoolArray("WitchMeleeDamageUnlocked", false);
	createPlayerGlobalIntArray("WitchMeleeDamageMultiplier", 1);
	createPlayerGlobalIntArray("WitchShockwaveChance", 0);
	createPlayerGlobalIntArray("WitchCurseCount", 0);
	createPlayerGlobalBoolArray("WitchArmageddonUnlocked", false);
	createPlayerGlobalIntArray("WitchArmageddonMultiplier", 1);
	createPlayerGlobalIntArray("WitchCloneCount", 0);
	createPlayerGlobalBoolArray("WitchDuplicateUnlocked", false);
	createPlayerGlobalIntArray("WitchDuplicateDuration", 30);
	createPlayerGlobalIntArray("WitchCloneEnemyCount", 0);
	createPlayerGlobalIntArray("WitchManaFlareChance", 0);
	
	createPlayerGlobalIntArray("RogueRange", 30);
	createPlayerGlobalIntArray("RogueBirdCount", 0);
	createPlayerGlobalIntArray("RogueHealChance", 0);
	createPlayerGlobalIntArray("RogueObliteratingChance", 0);
	createPlayerGlobalIntArray("RogueStealCount", 0);
	createPlayerGlobalBoolArray("RogueForestExplosionUnlocked", false);
	createPlayerGlobalIntArray("RogueForestExplosionAttackMultiplier", 1);
	createPlayerGlobalIntArray("RogueProjectileChance", 0);
	createPlayerGlobalBoolArray("RogueObeliskUnlocked", false);
	createPlayerGlobalIntArray("RogueObeliskHitpointPercent", 20);
	
	createPlayerGlobalIntArray("BirdProjectileChance", 10);
	createPlayerGlobalIntArray("BirdProjectileKill", 0);
	createPlayerGlobalBoolArray("BirdRavenUnlocked", false);
	createPlayerGlobalIntArray("BirdRavenDamageMultiplier", 1);
	createPlayerGlobalIntArray("BirdRocCount", 0);
	createPlayerGlobalBoolArray("BirdHealingEagleUnlocked", false);
	createPlayerGlobalIntArray("BirdHealingEagleSpeed", 1);
	createPlayerGlobalBoolArray("BirdCeaseFireUnlocked", false);
	createPlayerGlobalIntArray("BirdCeaseFireDuration", 10);
	createPlayerGlobalBoolArray("BirdBombHarpyUnlocked", false);
	createPlayerGlobalIntArray("BirdBombHarpyCount", 1);
	createPlayerGlobalIntArray("BirdDoubleShotChance", 0);
	
	g("float globalCarryLimit = 1.0;");
	createPlayerGlobalIntArray("ArtificerRelicExtraCarry", 0);
	createPlayerGlobalFloatArray("ArtificerTime", 60.0);
	createPlayerGlobalIntArray("ArtificerTimeReduction", 0);
	createPlayerGlobalIntArray("ArtificerAttackCount", 0);
	createPlayerGlobalIntArray("ArtificerProjectileCount", 0);
	createPlayerGlobalIntArray("ArtificerRangeCount", 0);
	createPlayerGlobalIntArray("ArtificerFavourCount", 0);
	createPlayerGlobalIntArray("ArtificerRechargeCount", 0);
	createPlayerGlobalBoolArray("ArtificerMiningCampUnlocked", false);
	createPlayerGlobalIntArray("ArtificerMiningCampSpeed", 1);
	createPlayerGlobalBoolArray("ArtificerLighthouseUnlocked", false);
	createPlayerGlobalIntArray("ArtificerLighthouseSpeed", 1);
	
	createPlayerGlobalIntArray("WarlockFireTornadoChance", 10);
	createPlayerGlobalIntArray("WarlockFireTornadoLifespan", 2);
	createPlayerGlobalIntArray("WarlockTeleportCount", 0);
	createPlayerGlobalBoolArray("WarlockFireWallUnlocked", false);
	createPlayerGlobalIntArray("WarlockFireWallTime", 10);
	createPlayerGlobalIntArray("WarlockTridentCount", 0);
	createPlayerGlobalIntArray("WarlockFireballTowerCount", 0);
	createPlayerGlobalIntArray("WarlockDeathFireChance", 0);
	createPlayerGlobalIntArray("WarlockFireRingHealth", 0);
	
	createPlayerGlobalIntArray("MinerGoldMineCount", 1);
	createPlayerGlobalIntArray("MinerMiningSpeed", 1);
	createPlayerGlobalIntArray("MinerDwarfCount", 1);
	createPlayerGlobalIntArray("MinerUnitRange", 10);
	createPlayerGlobalIntArray("MinerForestCount", 0);
	createPlayerGlobalIntArray("MinerPassageCount", 0);
	createPlayerGlobalIntArray("MinerProjectileCount", 1);
	createPlayerGlobalIntArray("MinerTwoForOneChance", 0);
	
	createGlobalStringArray("DrawnStats", 5, " ");
	
	g("string existingStat(string prefix = \"\", float value = 0.0){");
		g("return (prefix + \": \" + displayFloat(value));");
	g("}");	
	g("string lockedStat(string prefix = \"\", bool unlocked = true, string additionalText = \"\", ");
			g("float value = 0.0){");
		g("string toReturn = \"\";");
		g("if(unlocked){");
			g("toReturn = prefix + \" \" + additionalText;");
			g("toReturn = toReturn + \": \" + displayFloat(value);");
		g("} else {");
			g("toReturn = prefix + \" locked\";");
		g("}");
		g("return (toReturn);");
	g("}");
	g("void combineStats(int index = 0, string first = \"\", string second = \"\"){");
		g("setDrawnStats(index, first + \" | \" + second);");
	g("}");
	g("void drawStats(){");
		g("int p = trCurrentPlayer();");
		g("if(statsPlayerOverride >= 1){");
			g("p = statsPlayerOverride;");
		g("}");
		g("setDrawnStats(0, \" \");");
		g("setDrawnStats(1, \" \");");
		g("setDrawnStats(2, \" \");");
		g("setDrawnStats(3, \" \");");
		g("setDrawnStats(4, \" \");");
		g("trCounterAbort(\"StatsBlank\");");
		g("trCounterAbort(\"Stats0\");");
		g("trCounterAbort(\"Stats1\");");
		g("trCounterAbort(\"Stats2\");");
		g("trCounterAbort(\"Stats3\");");
		g("trCounterAbort(\"Stats4\");");
		g("if(getHeroIndex(p) == 0){");
			g("combineStats(1, ");
				g("existingStat(\"Guild\", getBuilderGuildLimit(p)), ");
				g("existingStat(\"Range\", getBuilderRange(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Arrow\", getBuilderProjectiles(p)), ");
				g("lockedStat(\"Temple\", getBuilderTempleUnlocked(p), \"heal\", getBuilderHealSpeed(p)));");
			g("combineStats(3, ");
				g("lockedStat(\"Mine\", getBuilderMineUnlocked(p), \"multiplier\", getBuilderMineBlastMultiplier(p)), ");
				g("lockedStat(\"Haze\", getBuilderMagicHazeUnlocked(p), \"lifespan\", getBuilderMagicHazeLifespan(p)));");
			g("combineStats(4, ");
				g("lockedStat(\"Dock\", getBuilderDockUnlocked(p), \"limit\", getBuilderDockLimit(p)), ");
				g("lockedStat(\"Armoury\", getBuilderArmoryUnlocked(p), \"food\", getBuilderArmoryFood(p)));");
			g("if(getBuilderDockUnlocked(p)){");
				g("setDrawnStats(0, existingStat(\"Guild + Dock income\", getBuilderGuildLimit(p) + 2 * getBuilderDockLimit(p)));");
			g("}");
		g("} else if(getHeroIndex(p) == 1){");
			g("combineStats(1, ");
				g("existingStat(\"Jump multiplier\", getPaladinJumpDamageMultiplier(p)), ");
				g("existingStat(\"Jump recharge\", getPaladinRechargeTime(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Revive enemy %%\", getPaladinReviveChance(p)), ");
				g("existingStat(\"Teleport\", getPaladinDeathTeleportCount(p)));");
			g("combineStats(3, ");
				g("lockedStat(\"Revive hero\", getPaladinReviveUnlocked(p), \"count\", getPaladinReviveCount(p)), ");
				g("existingStat(\"Heal\", getPaladinHealCount(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Trample %%\", getPaladinTrampleDamagePercent(p)), ");
				g("existingStat(\"Rescue\", getPaladinTeleportCount(p)));");
			g("if(getPaladinReviveUnlocked(p)){");
				g("setDrawnStats(0, existingStat(\"Hero revive time\", getPaladinReviveTime(p)));");
			g("}");
		g("} else if(getHeroIndex(p) == 2){");
			g("combineStats(1, ");
				g("existingStat(\"Lifespan\", getSummonerLifespan(p)), ");
				g("existingStat(\"Range\", getPaladinRechargeTime(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Duplicate %%\", getSummonerCallToArmsChance(p)), ");
				g("existingStat(\"Minotaur %%\", getSummonerMinotaur(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Wadjet %%\", getSummonerWadjet(p)), ");
				g("existingStat(\"Bird %%\", getSummonerBird(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Heal\", getSummonerHealCount(p)), ");
				g("lockedStat(\"Change\", getSummonerChangeUnlocked(p), \"bonus\", getSummonerChangeBonus(p)));");
			g("setDrawnStats(0, existingStat(\"Minion range\", getSummonerRange(p) - minionRangePenalty));");
		g("} else if(getHeroIndex(p) == 3){");
			g("combineStats(1, ");
				g("existingStat(\"Poison %%\", getAmazonPoisonChance(p)), ");
				g("existingStat(\"Carnivora %%\", getAmazonCarnivoraChance(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Overgrow\", getAmazonOvergrowCount(p)), ");
				g("existingStat(\"Dryad %%\", getAmazonDryad(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Geyser\", getAmazonGeyserCount(p)), ");
				g("lockedStat(\"Forest fire\", getAmazonForestFireUnlocked(p), \"multiplier\", getAmazonForestFireDamageMultiplier(p)));");
			g("combineStats(4, ");
				g("lockedStat(\"Lifebond\", getAmazonLifebondUnlocked(p), \"distance\", getAmazonLifebondDistance(p)), ");
				g("existingStat(\"Range\", getAmazonRange(p)));");
		g("} else if(getHeroIndex(p) == 4){");
			g("combineStats(1, ");
				g("existingStat(\"Range\", getWizardRange(p)), ");
				g("existingStat(\"Blast\", getWizardBlastCount(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Teleport\", getWizardTeleportCount(p)), ");
				g("existingStat(\"Heal\", getWizardHealCount(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Flash %%\", getWizardFlashChance(p)), ");
				g("lockedStat(\"Storm\", getWizardLightningStormUnlocked(p), \"%%\", getWizardLightningStormDamagePercent(p)));");
			g("combineStats(4, ");
				g("existingStat(\"2 for 1 %%\", getWizardTwoForOneChance(p)), ");
				g("existingStat(\"Projectile\", getWizardProjectile(p)));");
			g("setDrawnStats(0, existingStat(\"Average projectiles\", 1.0 + 0.2 * getWizardProjectile(p)));");
		g("} else if(getHeroIndex(p) == 5){");
			g("combineStats(1, ");
				g("lockedStat(\"Taunt\", getMaidenTauntUnlocked(p), \"radius\", getMaidenTauntRadius(p)), ");
				g("existingStat(\"Reflect %%\", getMaidenPercentageDamageTakenReflectBack(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Heal %%\", getMaidenHealChance(p)), ");
				g("existingStat(\"Bolt %%\", getMaidenBoltChance(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Blink %%\", getMaidenBlinkChance(p)), ");
				g("existingStat(\"Teleport\", getMaidenTeleportCount(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Self\", getMaidenSelfDamageCount(p)), ");
				g("existingStat(\"Heal ret. %%\", getMaidenHealRetaliationChance(p)));");
		g("} else if(getHeroIndex(p) == 6){");
			g("combineStats(1, ");
				g("existingStat(\"Lifespan\", getNecromancerLifespan(p)), ");
				g("existingStat(\"Radius\", getNecromancerRaiseDeadRadius(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Cry damage %%\", getNecromancerCryDamagePercent(p)), ");
				g("existingStat(\"Cry minions\", getNecromancerCryMinions(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Recharge\", getNecromancerRechargeReduction(p)), ");
				g("existingStat(\"Powerful %%\", getNecromancerPowerfulMinionChance(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Rune\", getNecromancerRuneCount(p)), ");
				g("lockedStat(\"Sacrifice\", getNecromancerSacrificeUnlocked(p), \"multiplier\", getNecromancerSacrificeMultiplier(p)));");
			g("setDrawnStats(0, existingStat(\"Cry recharge time\", getNecromancerRecharge(p)));");
		g("} else if(getHeroIndex(p) == 7){");
			g("combineStats(1, ");
				g("existingStat(\"Arrow\", getArcherProjectiles(p)), ");
				g("existingStat(\"Range\", getArcherRange(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Magic %%\", getArcherMagicArrowChance(p)), ");
				g("existingStat(\"Shockwave %%\", getArcherShockwaveArrowChance(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Burning %%\", getArcherBurningArrowChance(p)), ");
				g("lockedStat(\"Barrage\", getArcherBarrageUnlocked(p), \"multiplier\", getArcherBarrageAttackMultiplier(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Apprentice\", getArcherApprenticeCount(p)), ");
				g("existingStat(\"Special\", getArcherSpecialMultiplier(p)));");
			g("if(getArcherApprenticeCount(p) > 0){");
				g("setDrawnStats(0, existingStat(\"Arrow potential\", getArcherProjectiles(p) * (1 + getArcherApprenticeCount(p))));");
			g("}");
		g("} else if(getHeroIndex(p) == 8){");
			g("combineStats(1, ");
				g("existingStat(\"Damage %%\", getShamanDamagePercent(p)), ");
				g("existingStat(\"Healing\", getShamanHealingRate(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Range inc.\", getShamanRange(p)), ");
				g("existingStat(\"Radius\", getShamanRadius(p)));");
			g("combineStats(3, ");
				g("lockedStat(\"Scare\", getShamanScareUnlocked(p), \"radius\", getShamanScareRadius(p)), ");
				g("existingStat(\"Sentinel\", getShamanSentinelCount(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Carry\", getShamanAuraCarryTime(p)), ");
				g("existingStat(\"Teleport\", getShamanTeleportCount(p)));");
		g("} else if(getHeroIndex(p) == 9){");
			g("combineStats(1, ");
				g("existingStat(\"Health %%\", getAssassinPercentHealth(p)), ");
				g("lockedStat(\"Flare\", getAssassinFlareUnlocked(p), \"%%\", getAssassinFlarePercentDamage(p)));");
			g("combineStats(2, ");
				g("lockedStat(\"Ghost\", getAssassinGhostWalkUnlocked(p), \"duration\", getAssassinGhostWalkDuration(p)), ");
				g("lockedStat(\"Rage\", getAssassinRageUnlocked(p), \"duration\", getAssassinRageDuration(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Shockwave\", getAssassinShockwaveCount(p)), ");
				g("existingStat(\"Poison\", getAssassinPoisonCount(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Reduce\", getAssassinReduceCount(p)), ");
				g("existingStat(\"Attack\", getAssassinAttackBoostCount(p)));");
		g("} else if(getHeroIndex(p) == 10){");
			g("combineStats(1, ");
				g("lockedStat(\"Melee\", getWitchMeleeDamageUnlocked(p), \"multiplier\", getWitchMeleeDamageMultiplier(p)), ");
				g("existingStat(\"Shockwave %%\", getWitchShockwaveChance(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Curse\", getWitchCurseCount(p)), ");
				g("lockedStat(\"Armageddon\", getWitchArmageddonUnlocked(p), \"multiplier\", getWitchArmageddonMultiplier(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Clone\", getWitchCloneCount(p)), ");
				g("lockedStat(\"Clone self\", getWitchDuplicateUnlocked(p), \"duration\", getWitchDuplicateDuration(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Clone for kills\", getWitchCloneEnemyCount(p)), ");
				g("existingStat(\"Flare %%\", getWitchManaFlareChance(p)));");
			g("setDrawnStats(0, existingStat(\"Mana damage\", heroBaseAttack(10) * getAttackMultiplier(p)));");
		g("} else if(getHeroIndex(p) == 11){");
			g("combineStats(1, ");
				g("existingStat(\"Range\", getRogueRange(p)), ");
				g("existingStat(\"Bird\", getRogueBirdCount(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Heal %%\", getRogueHealChance(p)), ");
				g("existingStat(\"Obliterate\", getRogueObliteratingChance(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Steal\", getRogueStealCount(p)), ");
				g("lockedStat(\"Forest\", getRogueForestExplosionUnlocked(p), \"multiplier\", getRogueForestExplosionAttackMultiplier(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Projectile %%\", getRogueProjectileChance(p)), ");
				g("lockedStat(\"Obelisk\", getRogueObeliskUnlocked(p), \"%%\", getRogueObeliskHitpointPercent(p)));");
			g("setDrawnStats(0, existingStat(\"Average projectiles\", 1.0 + 50.0 * 0.01 * getRogueProjectileChance(p)));");
		g("} else if(getHeroIndex(p) == 12){");
			g("combineStats(1, ");
				g("existingStat(\"Projectile %%\", getBirdProjectileChance(p)), ");
				g("existingStat(\"Kill\", getBirdProjectileKill(p)));");
			g("combineStats(2, ");
				g("lockedStat(\"Raven\", getBirdRavenUnlocked(p), \"multiplier\", getBirdRavenDamageMultiplier(p)), ");
				g("existingStat(\"Roc\", getBirdRocCount(p)));");
			g("combineStats(3, ");
				g("lockedStat(\"Healing\", getBirdHealingEagleUnlocked(p), \"speed\", getBirdHealingEagleSpeed(p)), ");
				g("lockedStat(\"Cease fire\", getBirdCeaseFireUnlocked(p), \"duration\", getBirdCeaseFireDuration(p)));");
			g("combineStats(4, ");
				g("lockedStat(\"Harpy\", getBirdBombHarpyUnlocked(p), \"casts\", getBirdBombHarpyCount(p)), ");
				g("existingStat(\"Double %%\", getBirdDoubleShotChance(p)));");
		g("} else if(getHeroIndex(p) == 13){");
			g("combineStats(1, ");
				g("existingStat(\"Carry limit\", 1*globalCarryLimit + getArtificerRelicExtraCarry(p)), ");
				g("existingStat(\"Attack\", getArtificerAttackCount(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Projectile\", getArtificerProjectileCount(p)), ");
				g("existingStat(\"Range\", getArtificerRangeCount(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Favour\", getArtificerFavourCount(p)), ");
				g("existingStat(\"Recharge\", getArtificerRechargeCount(p)));");
			g("combineStats(4, ");
				g("lockedStat(\"Mining camp\", getArtificerMiningCampUnlocked(p), \"gold\", getArtificerMiningCampSpeed(p)), ");
				g("lockedStat(\"Lighthouse\", getArtificerLighthouseUnlocked(p), \"food\", getArtificerLighthouseSpeed(p)));");
			g("setDrawnStats(0, existingStat(\"Forge time\", getArtificerTime(p)));");
		g("} else if(getHeroIndex(p) == 14){");
			g("combineStats(1, ");
				g("existingStat(\"Tornado %%\", getWarlockFireTornadoChance(p)), ");
				g("existingStat(\"Lifespan\", getWarlockFireTornadoLifespan(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Teleport\", getWarlockTeleportCount(p)), ");
				g("lockedStat(\"Fire wall\", getWarlockFireWallUnlocked(p), \"duration\", getWarlockFireWallTime(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Trident\", getWarlockTridentCount(p)), ");
				g("existingStat(\"Tower\", getWarlockFireballTowerCount(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Death %%\", getWarlockDeathFireChance(p)), ");
				g("existingStat(\"Ring %%\", getWarlockFireRingHealth(p)));");
		g("} else if(getHeroIndex(p) == 15){");
			g("combineStats(1, ");
				g("existingStat(\"Mine\", getMinerGoldMineCount(p)), ");
				g("existingStat(\"Speed\", getMinerMiningSpeed(p)));");
			g("combineStats(2, ");
				g("existingStat(\"Dwarf\", getMinerDwarfCount(p)), ");
				g("existingStat(\"Range\", getMinerUnitRange(p)));");
			g("combineStats(3, ");
				g("existingStat(\"Forest\", getMinerForestCount(p)), ");
				g("existingStat(\"Passage\", getMinerPassageCount(p)));");
			g("combineStats(4, ");
				g("existingStat(\"Axe\", getMinerProjectileCount(p)), ");
				g("existingStat(\"2 for 1 %%\", getMinerTwoForOneChance(p)));");
			g("setDrawnStats(0, existingStat(\"Start potential mining\", (4 + getMinerDwarfCount(p)) * getMinerMiningSpeed(p)));");
		g("}");
		g("if(statsPlayerOverride >= 1){");
			g("setDrawnStats(0, \"<color={playercolor(\"+statsPlayerOverride+\")}>\" + getDrawnStats(0));");
			g("setDrawnStats(1, \"<color={playercolor(\"+statsPlayerOverride+\")}>\" + getDrawnStats(1));");
			g("setDrawnStats(2, \"<color={playercolor(\"+statsPlayerOverride+\")}>\" + getDrawnStats(2));");
			g("setDrawnStats(3, \"<color={playercolor(\"+statsPlayerOverride+\")}>\" + getDrawnStats(3));");
			g("setDrawnStats(4, \"<color={playercolor(\"+statsPlayerOverride+\")}>\" + getDrawnStats(4));");
		g("}");
		g("trCounterAddTime(\"StatsBlank\", -999999, 0, getDrawnStats(0), -1);");
		g("trCounterAddTime(\"Stats0\", -999999, 0, getDrawnStats(0), -1);");
		g("trCounterAddTime(\"Stats1\", -999999, 0, getDrawnStats(1), -1);");
		g("trCounterAddTime(\"Stats2\", -999999, 0, getDrawnStats(2), -1);");
		g("trCounterAddTime(\"Stats3\", -999999, 0, getDrawnStats(3), -1);");
		g("trCounterAddTime(\"Stats4\", -999999, 0, getDrawnStats(4), -1);");
	g("}");
	
	//Set stats
	g("void applyStartingStats(int p = 0){");
		g("for(i = 0; < heroCount){");
			g("modifyProtounitAbsolute(heroUnit(i), p, 1, 5.0);");
			g("modifyProtounitAbsolute(heroUnit(i), p, 24, 0.0);");
			g("modifyProtounitAbsolute(heroUnit(i), p, 25, 0.0);");
			g("modifyProtounitAbsolute(heroUnit(i), p, 26, 0.0);");
			g("modifyProtounitAbsolute(heroUnit(i), p, 28, 0.0);");
			g("modifyProtounitAbsolute(heroUnit(i), p, 29, 0.0);");
			g("modifyProtounitAbsolute(heroUnit(i), p, 30, 0.0);");
			g("modifyProtounitAbsolute(heroUnit(i), p, 31, 0.0);");
		g("}");
		g("for(i = 0; < playerUnitCount){");
			g("modifyProtounitAbsolute(unitList(i), p, 24, 0.0);");
			g("modifyProtounitAbsolute(unitList(i), p, 25, 0.0);");
			g("modifyProtounitAbsolute(unitList(i), p, 26, 0.0);");
			g("modifyProtounitAbsolute(unitList(i), p, 28, 0.0);");
			g("modifyProtounitAbsolute(unitList(i), p, 29, 0.0);");
			g("modifyProtounitAbsolute(unitList(i), p, 30, 0.0);");
			g("modifyProtounitAbsolute(unitList(i), p, 31, 0.0);");
		g("}");
		g("modifyProtounitAbsolute(\"Guild\", p, 10, getBuilderGuildLimit(p));");
		g("modifyProtounitAbsolute(\"Guild\", p, 4, buildTime(\"Guild\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Tower\", p, 2, getBuilderRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Tower\", p, 11, getBuilderRange(p));");
		g("modifyProtounitAbsolute(\"Tower\", p, 13, getBuilderProjectiles(p));");
		g("modifyProtounitAbsolute(\"Tower\", p, 4, buildTime(\"Tower\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Wall Connector\", p, 4, buildTime(\"Wall Connector\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Wall Short\", p, 4, buildTime(\"Wall Short\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Wall Medium\", p, 4, buildTime(\"Wall Medium\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Wall Long\", p, 4, buildTime(\"Wall Long\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Manor\", p, 4, buildTime(\"Manor\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Manor\", p, 10, 9999);");
		g("modifyProtounitAbsolute(\"Farm\", p, 4, buildTime(\"Farm\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Tartarian Gate\", p, 8, getBuilderMagicHazeLifespan(p));");
		g("modifyProtounitAbsolute(\"Dock\", p, 10, getBuilderDockLimit(p));");
		g("modifyProtounitAbsolute(\"Dock\", p, 4, buildTime(\"Dock\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Bireme\", p, 2, getBuilderRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Bireme\", p, 11, getBuilderRange(p));");
		g("modifyProtounitAbsolute(\"Bireme\", p, 13, getBuilderProjectiles(p));");
		g("modifyProtounitAbsolute(\"Bireme\", p, 3, buildTime(\"Tower\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Armory\", p, 10, getBuilderDockLimit(p));");
		g("modifyProtounitAbsolute(\"Armory\", p, 4, buildTime(\"Armory\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Hero Greek Bellerophon\", p, 9, getPaladinRechargeTime(p));");
		g("modifyProtounitAbsolute(\"Minotaur\", p, 8, getSummonerLifespan(p));");
		g("modifyProtounitAbsolute(\"Wadjet\", p, 8, getSummonerLifespan(p));");
		g("modifyProtounitAbsolute(\"Wadjet\", p, 2, getSummonerRange(p) + losRangeOffset - minionRangePenalty);");
		g("modifyProtounitAbsolute(\"Wadjet\", p, 11, getSummonerRange(p) - minionRangePenalty);");
		g("modifyProtounitAbsolute(\"Stymphalian Bird\", p, 8, getSummonerLifespan(p));");
		g("modifyProtounitAbsolute(\"Stymphalian Bird\", p, 2, getSummonerRange(p) + losRangeOffset - minionRangePenalty);");
		g("modifyProtounitAbsolute(\"Stymphalian Bird\", p, 11, getSummonerRange(p) - minionRangePenalty);");
		g("modifyProtounitAbsolute(\"Reginleif\", p, 2, getAmazonRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Reginleif\", p, 11, getAmazonRange(p));");
		g("modifyProtounitAbsolute(\"Setna\", p, 2, getWizardRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Setna\", p, 11, getWizardRange(p));");
		g("modifyProtounitAbsolute(\"Arkantos\", p, 9, getNecromancerRecharge(p));");
		g("modifyProtounitAbsolute(\"Minion\", p, 8, getNecromancerLifespan(p));");
		g("modifyProtounitAbsolute(\"Jiangshi\", p, 8, getNecromancerLifespan(p));");
		g("modifyProtounitAbsolute(\"Archer Atlantean Hero\", p, 2, getArcherRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Archer Atlantean Hero\", p, 11, getArcherRange(p));");
		g("modifyProtounitAbsolute(\"Archer Atlantean\", p, 2, getArcherRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Archer Atlantean\", p, 11, getArcherRange(p));");
		g("modifyProtounitAbsolute(\"Sky Passage\", p, 4, buildTime(\"Sky Passage\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Temple\", p, 4, buildTime(\"Temple\") * getBuilderBuildPoints(p));");
		g("modifyProtounitAbsolute(\"Hero Greek Chiron\", p, 2, getSummonerRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Hero Greek Chiron\", p, 11, getSummonerRange(p));");
		g("modifyProtounitAbsolute(\"Hero Greek Hippolyta\", p, 2, getRogueRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Hero Greek Hippolyta\", p, 11, getRogueRange(p));");
		g("modifyProtounitAbsolute(\"Raven\", p, 1, 5.0);");
		g("modifyProtounitAbsolute(\"Titan Bad\", p, 1, 5.0);");
		g("modifyProtounitAbsolute(\"Ape of Set\", p, 3, getArtificerTime(p));");
		g("modifyProtounitAbsolute(\"Gazelle of Set\", p, 3, getArtificerTime(p));");
		g("modifyProtounitAbsolute(\"Hyena of Set\", p, 3, getArtificerTime(p));");
		g("modifyProtounitAbsolute(\"Crocodile of Set\", p, 3, getArtificerTime(p));");
		g("modifyProtounitAbsolute(\"Giraffe of Set\", p, 3, getArtificerTime(p));");
		g("modifyProtounitAbsolute(\"Hippo of Set\", p, 3, getArtificerTime(p));");
		g("modifyProtounitAbsolute(\"Rhinoceros of Set\", p, 3, getArtificerTime(p));");
		g("modifyProtounitAbsolute(\"Throwing Axeman\", p, 2, getMinerUnitRange(p) + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Throwing Axeman\", p, 11, getMinerUnitRange(p));");
		g("modifyProtounitAbsolute(\"Priest\", p, 2, 15.0 + losRangeOffset);");
		g("modifyProtounitAbsolute(\"Priest\", p, 11, 15.0);");
		g("modifyProtounitAbsolute(\"Mining Camp\", p, 4, 0.0);");
		g("modifyProtounitAbsolute(\"Lighthouse\", p, 4, 0.0);");
		g("if(getHeroIndex(p) == 12){");
			g("modifyProtounitAbsolute(\"Minion\", p, 55, 4.0);");
			g("modifyProtounitAbsolute(\"Ghost Ship\", p, 55, 4.0);");
		g("}");
		g("if(getHeroIndex(p) == 9){");
			g("modifyProtounitAbsolute(\"Valkyrie\", p, 0, 999999999.0);");
		g("}");
	g("}");
	g("void applyHealth(int p = 0){");
		databaseSearchStartGlobal("Building");
		g("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		g("if(owner == p && trUnitPercentComplete() < 100.0){");
			g("trUnitChangeProtoUnit(\"Anubite\");");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
			g("trUnitChangeProtoUnit(kbGetProtoUnitName(type));");
		g("}");
		databaseSearchEndGlobal();
		g("float adjustedHealth = heroBaseHealth(getHeroIndex(p)) * getHealthMultiplier(p);");
		g("for(i = 0; < heroCount){");
			g("modifyProtounitAbsolute(heroUnit(i), p, 0, adjustedHealth);");
		g("}");
		g("modifyProtounitAbsolute(\"Tower\", p, 0, 0.1 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Wall Connector\", p, 0, 0.5 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Wall Short\", p, 0, 0.5 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Wall Medium\", p, 0, 0.5 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Wall Long\", p, 0, 0.5 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Gate\", p, 0, 0.5 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Sky Passage\", p, 0, 0.2 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Temple\", p, 0, 0.3 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Guild\", p, 0, 0.2 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Dock\", p, 0, 0.2 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Bireme\", p, 0, 0.1 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Armory\", p, 0, 0.3 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Minotaur\", p, 0, 0.8 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Wadjet\", p, 0, 0.5 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Stymphalian Bird\", p, 0, 0.2 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Audrey\", p, 0, 0.5 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Dryad\", p, 0, 0.4 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Minion\", p, 0, 0.1 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Jiangshi\", p, 0, 0.2 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Archer Atlantean\", p, 0, 0.25 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Sentinel Main\", p, 0, 0.25 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Titan Bad\", p, 0, 4.0 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Raven\", p, 0, adjustedHealth);");
		g("modifyProtounitAbsolute(\"Roc\", p, 0, 0.5 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Dwarf\", p, 0, 0.1 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Throwing Axeman\", p, 0, 0.2 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Outpost\", p, 0, 0.01 * getRogueObeliskHitpointPercent(p) * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Mining Camp\", p, 0, 0.3 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Lighthouse\", p, 0, 0.3 * adjustedHealth);");
		g("modifyProtounitAbsolute(\"Priest\", p, 0, 0.3 * adjustedHealth);");
	g("}");
	g("void applyAttack(int p = 0){");
		g("float attackMultiplier = getAttackMultiplier(p) + getAttackRelicCount(p) + getBuilderArmoryBoost(p);");
		g("if(getAttackBoostActive(p)){");
			g("attackMultiplier = attackMultiplier + 2 * getAssassinAttackBoostCount(p);");
		g("}");
		g("setAttackMultiplierFinal(p, attackMultiplier);");
		g("float adjustedAttack = heroBaseAttack(getHeroIndex(p)) * (attackMultiplier);");
		g("for(i = 0; < heroCount){");
			g("modifyProtounitAbsolute(heroUnit(i), p, 27, adjustedAttack);");
			g("modifyProtounitAbsolute(heroUnit(i), p, 31, adjustedAttack);");
		g("}");
		g("modifyProtounitAbsolute(\"Villager Atlantean hero\", p, 27, 0.0 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Tower\", p, 27, 1.0 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Tower\", p, 31, 1.0 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Bireme\", p, 27, 1.0 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Bireme\", p, 31, 1.0 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Minotaur\", p, 27, 0.8 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Wadjet\", p, 31, 0.5 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Stymphalian Bird\", p, 31, 0.2 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Audrey\", p, 27, 0.5 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Dryad\", p, 27, 0.4 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Minion\", p, 27, 0.25 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Jiangshi\", p, 27, 0.5 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Archer Atlantean\", p, 31, 0.25 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Sentinel Main\", p, 31, 0.5 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Titan Bad\", p, 27, 4.0 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Circe\", p, 9, 10.0 * 1.0 / getAttackMultiplier(p));");
		g("modifyProtounitAbsolute(\"Dwarf\", p, 27, 0.0);");
		g("modifyProtounitAbsolute(\"Throwing Axeman\", p, 31, 0.3 * adjustedAttack);");
		g("modifyProtounitAbsolute(\"Priest\", p, 31, 0.4 * adjustedAttack);");
	g("}");
	//Enemy stats
	g("void enemyStatsMelee(string unit = \"\", float hp = 0, float speed = 0, float los = 0, float meleeAttack = 0.0){");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 0, hp);");
		g("modifyProtounitAbsolute(unit, "+c+", 0, hp * difficulty);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 1, speed);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 2, los);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 6, 1);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 11, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 13, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 24, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 25, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 26, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 27, meleeAttack);");
		g("modifyProtounitAbsolute(unit, "+c+", 27, meleeAttack * difficulty);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 28, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 29, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 30, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 31, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 32, 0.0);");
		g("for(p = 1; <= "+h+"){");
			g("modifyProtounitAbsolute(unit, p, 8, 60.0);");
		g("}");
	g("}");
	g("void enemyStatsRange(string unit = \"\", float hp = 0, float speed = 0, float los = 0, float range = 0, ");
			g("float projectiles = 0, float rangedAttack = 0.0){");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 0, hp);");
		g("modifyProtounitAbsolute(unit, "+c+", 0, hp * difficulty);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 1, speed);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 2, los);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 6, 1);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 11, range);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 13, projectiles);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 24, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 25, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 26, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 27, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 28, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 29, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 30, 0.0);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 31, rangedAttack);");
		g("modifyProtounitAbsolute(unit, "+c+", 31, rangedAttack * difficulty);");
		g("modifyProtounitAbsoluteAllHumanPlayers(unit, 32, 0.0);");
		g("for(p = 1; <= "+h+"){");
			g("modifyProtounitAbsolute(unit, p, 8, 60.0);");
		g("}");
	g("}");
	// ### SPECIFIC GAMEPLAY
	g("vector teleportUnitsToMiddle(){");
		g("int placeRadius = 0.0;");
		g("int currentName = trGetNextUnitScenarioNameNumber();");
		g("while(currentName == trGetNextUnitScenarioNameNumber()){");
			g("deployCluster(toMetres(0.5), toMetres(0.5), \"Tartarian gate placement\", "+a+", 1, placeRadius);");
			g("placeRadius = placeRadius + 5;");
		g("}");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+currentName, true);");
		g("trUnitChangeProtoUnit(\"Roc\");");
		g("for(p = 1; <= "+h+"){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+p);");
			g("trUnitChangeProtoUnit(heroUnit(getHeroIndex(p)));");
			g("trImmediateUnitGarrison(\"\"+currentName);");
		g("}");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+currentName, true);");
		g("trMutateSelected("+getUnitIdFromName("Cinematic Block")+");");
		g("vector pos = getPosition(currentName);");
		g("trUnitDestroy();");
		g("for(p = 1; <= "+h+"){");
			g("setSpyEye0(p, -1);");
			g("setSpyEye1(p, -1);");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+p);");
			g("if(getHeroIndex(p) == 0 || getHeroIndex(p) == 5 || getHeroIndex(p) == 8 || getHeroIndex(p) == 10){");
				g("trUnitSetStance(\"Passive\");");
			g("}");
			g("setArmageddonUsed(p, false);");
			g("setMarkerCount(p, 0);");
			g("if(kbIsPlayerResigned(p) == false){");
				g("if(getDead(p)){");
					g("setDead(p, false);");
					g("dead = dead - 1;");
				g("}");
				g("trUnitSelectClear();");
				g("trUnitSelect(\"\"+p);");
				g("trTechInvokeGodPower(0, \"Spy\");");
				g("trTechInvokeGodPower(0, \"Spy\");");
			g("}");
		g("}");
		g("return (pos);");
	g("}");
	g("void generateSpawnPoints(vector startLoc = vector(0,0,0), int count = 1){");
		g("spawnPointCount = count;");
		g("spawnOffset = trGetNextUnitScenarioNameNumber();");
		g("int placeRadius = 0.0;");
		g("for(i = 0; < count){");
			g("int currentName = trGetNextUnitScenarioNameNumber();");
			g("while(currentName == trGetNextUnitScenarioNameNumber()){");
				g("deployCluster(xsVectorGetX(startLoc), xsVectorGetZ(startLoc), \"Egyptian Vulture\", "+a+", 1, placeRadius);");
				g("placeRadius = placeRadius + 5;");
			g("}");
		g("}");
		g("for(i = 0; < count){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+(spawnOffset+i), true);");
			g("trUnitMoveToPoint(toMetres(randomFloat(0.0, 1.0)), 0.0, toMetres(randomFloat(0.0, 1.0)), -1, false);");
		g("}");
	g("}");
	g("void revealSpawnPoints(){");
		g("for(i = 0; < spawnPointCount){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+(spawnOffset+i), true);");
			g("trUnitChangeProtoUnit(\"Tartarian Gate\");");
		g("}");
	g("}");
	g("int deployRandomSpawnPoint(string unit = \"\", int count = 1){");
		g("vector v = getPosition(spawnOffset+randomInt(0,spawnPointCount-1));");
		g("if(count > 1){");
			g("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), unit, "+c+", count, 5.0, true);");
			g("return (-1);");
		g("} else {");
			//Guarantee successful placement if single enemy
			g("int placeRadius = 0.0;");
			g("int currentName = trGetNextUnitScenarioNameNumber();");
			g("while(currentName == trGetNextUnitScenarioNameNumber()){");
				g("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), unit, "+c+", 1, placeRadius);");
				g("placeRadius = placeRadius + 5;");
			g("}");
			g("return (currentName);");
		g("}");
	g("}");
	g("void hideHeroes(){");
		g("int currentName = trGetNextUnitScenarioNameNumber();");
		g("while(currentName == trGetNextUnitScenarioNameNumber()){");
			g("deployLoc(toMetres(randomFloat(0.0, 1.0)), toMetres(randomFloat(0.0, 1.0)), \"Roc\", "+a+");");
		g("}");
		g("for(p = 1; <= "+h+"){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+p);");
			g("trUnitChangeProtoUnit(\"Victory Marker\");");
			g("trImmediateUnitGarrison(\"\"+currentName);");
		g("}");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+currentName, true);");
		g("trMutateSelected("+getUnitIdFromName("Victory Marker")+");");
	g("}");
	g("void applyHealingEffect(vector v = vector(0,0,0), float radius = 0.0, string effect = \"Fimbulwinter Sfx\"){");
		databaseSearchStartGlobal("Player");
		g("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		g("xsSetContextPlayer(owner);");
		g("if(kbUnitIsType(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\")), 935)){");
			g("if(trUnitDistanceToPoint(xsVectorGetX(v), 0.0, xsVectorGetZ(v)) <= radius){");
				g("vector unitPos = getPosition(trQuestVarGet(\"ySearchUnit\"));");
				g("deployLocUsingCineBlock(xsVectorGetX(unitPos), xsVectorGetZ(unitPos), effect, owner);");
			g("}");
		g("}");
		databaseSearchEndGlobal();
	g("}");
	g("void applyDamageEffect(vector v = vector(0,0,0), float radius = 0.0){");
		databaseSearchStartGlobal("Enemy");
		g("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		g("xsSetContextPlayer(owner);");
		g("if(kbUnitIsType(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\")), 935)){");
			g("if(trUnitDistanceToPoint(xsVectorGetX(v), 0.0, xsVectorGetZ(v)) <= radius){");
				g("vector unitPos = getPosition(trQuestVarGet(\"ySearchUnit\"));");
				g("int unitName = deployLocUsingCineBlock(xsVectorGetX(unitPos), xsVectorGetZ(unitPos), \"Spy Eye\", owner);");
				g("if(unitName >= 0){");
					g("trMutateSelected("+getUnitIdFromName("Monkey King")+");");
					g("trUnitSelectClear();");
					g("trUnitSelect(\"\"+unitName, true);");
					g("trSetSelectedScale(0, 0, 0);");
					g("trUnitSelectClear();");
					g("trUnitSelect(\"\"+unitName, true);");
					g("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
					g("trUnitSelectClear();");
					g("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
					g("trQuestVarSet(\"timebaseDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), unitName);");
					g("trQuestVarSet(\"timebaseTimeDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), trTimeMS());");
					g("trQuestVarSet(\"timebaseCountDestroy1S\", trQuestVarGet(\"timebaseCountDestroy1S\") + 1);");
				g("}");
			g("}");
		g("}");
		databaseSearchEndGlobal();
	g("}");
	g("void applyRangeEffect(int p = 1, vector v = vector(0,0,0), float radius = 0.0){");
		databaseSearchStartGlobal("Hero");
		g("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		g("xsSetContextPlayer(owner);");
		g("if(getDead(owner) == false && trUnitDistanceToPoint(xsVectorGetX(v), 0.0, xsVectorGetZ(v)) <= radius){");
			g("vector unitPos = getPosition(trQuestVarGet(\"ySearchUnit\"));");
			g("deployLocUsingCineBlock(xsVectorGetX(unitPos), xsVectorGetZ(unitPos), \"Regeneration Sfx\", owner);");
			g("setRangeBoostCalculated(owner, getRangeBoostCalculated(owner) + getShamanRange(p));");
		g("}");
		databaseSearchEndGlobal();
	g("}");
	g("void calculateDifficulty(){");
		g("difficulty = 0.2 * (activePlayers + 2);");
		g("if(trGetWorldDifficulty() == 0)difficulty = difficulty * difficultyEasy;");
		g("if(trGetWorldDifficulty() == 1)difficulty = difficulty * difficultyModerate;");
		g("if(trGetWorldDifficulty() == 2)difficulty = difficulty * difficultyHard;");
		g("if(trGetWorldDifficulty() == 3)difficulty = difficulty * difficultyTitan;");
	g("}");
	g("void applyRangeBoost(int p = 0, float value = 0.0){");
		g("for(i = 0; < playerRangedUnitCount){");
			g("trModifyProtounit(allRangedUnitList(i), p, 2, value);");
			g("trModifyProtounit(allRangedUnitList(i), p, 11, value);");
		g("}");
	g("}");
	g("void launchPetAttack(int p = 1, string databaseName = \"\"){");
		g("int createdObject = trGetNextUnitScenarioNameNumber() + 1;");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+getSpyEye1(p));");
		g("trUnitChangeProtoUnit(\"Ajax\");");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+getSpyEye1(p));");
		g("trUnitChangeProtoUnit(\"Camera Start\");");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"\"+createdObject, true);");
		g("if(createdObject + 2 == trGetNextUnitScenarioNameNumber()){");
			g("trUnitChangeProtoUnit(\"Anubite\");");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+createdObject, true);");
			g("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+createdObject, true);");
			g("trDamageUnitPercent(100.0);");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+createdObject, true);");
			g("trSetSelectedScale(0.0, -2.0, 0.0);");
			g("float fireAngle = randomFloat(0, 360.0);");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+createdObject, true);");
			g("setSelectedUnitHeadingDegrees(fireAngle);");
			g("modifyProtounitAbsolute(\"Kronny Flying\", p, 1, randomFloat(1.0, 10.0));");
			g("addToDatabaseAnytime(databaseName, createdObject);");
			g("addToDatabaseAnytime(\"DetectLand\", createdObject);");
			g("addToVanishbaseAnytime(databaseName, createdObject);");
		g("}");
	g("}");
	g("string getRelicName(int i = 0){");
		g("i--;if(i<0)return (\"+100 percent base attack\");");
		g("i--;if(i<0)return (\"+1 projectile (+4 if Archer)\");");
		g("i--;if(i<0)return (\"+5 range and LOS\");");
		g("i--;if(i<0)return (\"+1 favour round end\");");
		g("i--;if(i<0)return (\"+1/3 spell recharge speed\");");
	g("}");
	g("bool isBossType(int type = -1){");
		g("if(type == "+getUnitIdFromName("Argus")+") return (true);");
		g("if(type == "+getUnitIdFromName("Medusa")+") return (true);");
		g("if(type == "+getUnitIdFromName("Monkey King")+") return (true);");
		g("if(type == "+getUnitIdFromName("Nereid")+") return (true);");
		g("if(type == "+getUnitIdFromName("Carcinos")+") return (true);");
		g("if(type == "+getUnitIdFromName("Scylla")+") return (true);");
		g("if(type == "+getUnitIdFromName("Frost Giant")+") return (true);");
		g("if(type == "+getUnitIdFromName("White Tiger")+") return (true);");
		g("if(type == "+getUnitIdFromName("Cyclops")+") return (true);");
		g("if(type == "+getUnitIdFromName("Mummy")+") return (true);");
		g("if(type == "+getUnitIdFromName("Sphinx")+") return (true);");
		g("if(type == "+getUnitIdFromName("Petsuchos")+") return (true);");
		g("if(type == "+getUnitIdFromName("Lampades")+") return (true);");
		g("if(type == "+getUnitIdFromName("Lazer Bear")+") return (true);");
		g("if(type == "+getUnitIdFromName("Chimera")+") return (true);");
		g("if(type == "+getUnitIdFromName("Arkantos God")+") return (true);");
		g("if(type == "+getUnitIdFromName("Fire Giant")+") return (true);");
		g("return (false);");
	g("}");
	// ### AREAS
	g("void generateHeroChoose(){");
		g("normalise(\"CliffGreekA\", 10);");
		g("paintCircleHeight2(toTiles(0.5), toTiles(0.5), toTiles(0.4), \"GrassB\", 0);");
		g("smooth(3);");
		g("replaceTerrainAboveHeightMax(\"GrassB\", \"CliffGreekB\", 0.1);");
		g("refreshPassability();");
		g("heroOffset = trGetNextUnitScenarioNameNumber();");
		g("for(i = 0; < heroCount){");
			g("float posX = circleX(toMetres(0.5), i, heroCount, toMetres(0.3), 0);");
			g("float posZ = circleZ(toMetres(0.5), i, heroCount, toMetres(0.3), 0);");
			g("deployLocHeading(posX, posZ, \"Cinematic Block\", "+a+", (1.0 * i) / heroCount * 360.0 - 135.0);");
			g("paintCircle(posX / 2, posZ / 2, toMetres(0.01), \"GaiaCreepA\");");
		g("}");
		g("for(i = 0; < heroCount){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+(i+heroOffset));");
			g("trUnitChangeProtoUnit(heroUnit(i));");
			g("if(i == 0){");
				g("trUnitOverrideAnimation(4, 0, true, true, -1);");
			g("} else if(i == 7 || i == 11 || i == 2){");
				g("trUnitOverrideAnimation(12, 0, true, true, -1);");
			g("} else if(i == 1 || i == 12){");
				g("trUnitOverrideAnimation(1, 0, true, true, -1);");
			g("} else if(i == 8){");
				g("trUnitOverrideAnimation(52, 0, true, true, -1);");
			g("} else {");
				g("trUnitOverrideAnimation(25, 0, true, true, -1);");
			g("}");
		g("}");
		g("dC(toMetres(0.5), toMetres(0.5), \"Bush\", 0, 3, 10.0, 30, toMetres(0.4));");
		g("dC(toMetres(0.5), toMetres(0.5), \"Flowers\", 0, 8, 10.0, 10, toMetres(0.4));");
		g("dC(toMetres(0.5), toMetres(0.5), \"Blowing Leaves\", 0, 2, 10.0, 3, toMetres(0.4));");
		g("dC(toMetres(0.5), toMetres(0.5), \"Gaia Forest Tree\", 0, 3, 3.0, 20, toMetres(0.4));");
		g("dC(toMetres(0.5), toMetres(0.5), \"Hawk\", 0, 1, 0.0, 5, toMetres(0.4));");
	g("}");
	g("void generateChinese(){");
		g("normalise(\"PlainDirt50\", 0);");
		g("trCoverTerrainWithWater(3.0, 3.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"PlainDirt50\");");
		g("trPaintWaterColor(vector(1.0, 1.0, 0.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 6) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircleHeight(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"PlainA\", 3.0);");
			g("}");
		g("}");
		g("for(i = 0; < 5) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.02), \"ForestfloorJungle\");");
			g("}");
		g("}");
		g("for(i = 0; < 30) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.01), \"ForestfloorJungle\");");
			g("}");
		g("}");
		g("for(i = 0; < 3) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircleHeight(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"ShorelinePlainB\", -3.0);");
			g("}");
		g("}");
		g("changeTerrainHeight(3.5);");
		g("smooth(3);");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorJungle\", \"Jungle Tree\");");
		g("dM(\"Grass\", 0, 5, 10.0, 30);");
		g("dM(\"Berry Bush\", 0, 3, 5.0, 10);");
		g("float daySlider = randomFloat(0.0, 1.0);");
		g("sunColor(255.0, clampColor(interpolate(500.0, 100.0, daySlider)), interpolate(255.0, 0.0, daySlider));");
		g("ambientVector(vectorMultiply(vector(1.0, 1.0, 1.0), interpolate(255.0, 50.0, daySlider)));");
		g("trSetSunPosition(interpolate(10.0, 70.0, daySlider), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateIsland(){");
		g("normalise(\"ShorelineJungleA\", 0);");
		g("trCoverTerrainWithWater(0.0, 4.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"ShorelineJungleA\");");
		g("trPaintWaterColor(vector(0.3, 0.6, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("centrePosX = randomInt(toTiles(0.4), toTiles(0.6));");
		g("centrePosZ = randomInt(toTiles(0.4), toTiles(0.6));");
		g("for(i = 0; < 10) {");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, 20.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.04), \"ShorelineJungleC\", 1.0);");
			g("}");
		g("}");
		g("smooth(30);");
		g("replaceTerrainAboveHeightMax(\"ShorelineJungleA\", \"ShorelineJungleB\", -2.0);");
		g("for(i = 0; < 30) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.01), \"ShorelineJungleC\", \"ForestfloorJungle\");");
			g("}");
		g("}");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorJungle\", \"Jungle Palm\");");
		g("dM(\"Bush\", 0, 5, 10.0, 30);");
		g("dM(\"Rock Limestone Big\", 0, 3, 5.0, 10);");
		g("sunColor(255, 255, 255);");
		g("ambientColor(100, 100, 100);");
		g("trSetSunPosition(randomFloat(5, 20), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateMountains(){");
		g("normalise(\"SnowGrass75\", 0);");
		g("centrePosX = randomInt(toTiles(0.4), toTiles(0.6));");
		g("centrePosZ = randomInt(toTiles(0.4), toTiles(0.6));");
		g("for(i = 0; < 40) {");
			g("tempV = randomOutsideCircleLocBrokenLegacy(centrePosX, centrePosZ, 20.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.06), \"SnowB\", 10.0);");
			g("}");
		g("}");
		g("smooth(2);");
		g("replaceTerrainBelowHeightMin(\"SnowB\", \"CliffNorseA\", 9.0);");
		g("for(i = 0; < 20) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"SnowGrass75\", \"ForestfloorPine\");");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"SnowB\", \"ForestfloorPineSnow\");");
			g("}");
		g("}");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorPine\", \"Pine\");");
		g("paintTrees(\"ForestfloorPineSnow\", \"Pine Snow\");");
		g("paintUnit(\"SnowB\", \"Snow Drift Tower\", 0, 0.1);");
		g("paintUnit(\"SnowGrass75\", \"Rock Limestone Small\", 0, 0.04);");
		g("float intensity = randomFloat(0.5, 1.0);");
		g("float intensity2 = randomFloat(0.2, 1.0);");
		g("sunColor(0, 30 * randomFloat(0.5, 1.0), randomFloat(0.5, 1.0) * 8200 * randomFloat(0.5, 1.0));");
		g("ambientColor(160 * intensity2, 160 * intensity2, 160 * intensity2);");
		g("trSetSunPosition(randomFloat(40, 70), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateDesert(){");
		g("normalise(\"SandA\", 10);");
		g("for(i = 0; < 10) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(centrePosX, centrePosZ, 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.06), \"SandC\", 15.0);");
			g("}");
		g("}");
		g("smooth(5);");
		g("for(i = 0; < 4) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(centrePosX, centrePosZ, 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.06), \"CliffEgyptianA\", 0.0);");
			g("}");
		g("}");
		g("smooth(2);");
		g("replaceTerrainBelowHeightMax(\"CliffEgyptianA\", \"ForestfloorSavannah\", 2.0);");
		g("for(i = 0; < 20) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"SandA\", \"ForestfloorPalm\");");
			g("}");
		g("}");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorSavannah\", \"Savannah Tree\");");
		g("paintTrees(\"ForestfloorPalm\", \"Palm\");");
		g("paintUnit(\"SandA\", \"Rock Sandstone Big\", 0, 0.01);");
		g("paintUnit(\"SandC\", \"Sand Drift Patch\", 0, 0.01);");
		g("float red = randomFloat(100.0, 255.0);");
		g("float green = randomFloat(50.0, red);");
		g("sunColor(red, green, randomFloat(0.0, 50.0));");
		g("ambientColor(100, 50, 25);");
		g("trSetSunPosition(randomFloat(20, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateDarkForest(){");
		g("normalise(\"ForestFloorPine\", 0);");
		g("trCoverTerrainWithWater(0.0, 4.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"ForestFloorPine\");");
		g("trPaintWaterColor(vector(0.0, 0.0, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 20) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.06), \"ForestFloorPine\", 1.0);");
			g("}");
		g("}");
		g("for(i = 0; < 10) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.03), \"OlympusTile\", 1.0);");
			g("}");
		g("}");
		g("for(i = 0; < 10) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.01), \"CliffNorseA\", 5.0);");
			g("}");
		g("}");
		g("smooth(1);");
		g("replaceTerrainBelowHeightMin(\"OlympusTile\", \"CliffGreekA\", -1.0);");
		g("replaceTerrainBelowHeightMin(\"ForestFloorPine\", \"CliffGreekA\", -1.0);");
		g("refreshPassability();");
		g("paintUnit(\"ForestFloorPine\", \"Pine\", 0, 0.05);");
		g("paintUnit(\"OlympusTile\", \"Columns\", 0, 0.2);");
		g("paintUnit(\"OlympusTile\", \"Mist\", 0, 0.1);");
		g("paintUnit(\"OlympusTile\", \"Ruins\", 0, 0.0025);");
		g("paintUnit(\"OlympusTile\", \"Shrine\", 0, 0.00125);");
		g("paintUnit(\"OlympusTile\", \"Underworld Passage SPC\", 0, 0.000625);");
		g("dM(\"Pine\", 0, 5, 10.0, 30);");
		g("sunVector(randomHue());");
		g("ambientColor(60, 60, 60);");
		g("trSetSunPosition(randomFloat(30, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateHell(){");
		g("normalise(\"HadesBuildable2\", 15);");
		g("centrePosX = randomInt(toTiles(0.4), toTiles(0.6));");
		g("centrePosZ = randomInt(toTiles(0.4), toTiles(0.6));");
		g("for(i = 0; < 10) {");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, 20.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 6.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.03), \"HadesBuildable1\", 10.0);");
			g("}");
		g("}");
		g("smooth(5);");
		g("for(i = 0; < 40) {");
			g("tempV = randomOutsideCircleLocBrokenLegacy(centrePosX, centrePosZ, 20.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.06), \"Hades7\", -5.0);");
			g("}");
		g("}");
		g("smooth(1);");
		g("replaceTerrainAboveHeightMin(\"Hades7\", \"Hades3\", -4.0);");
		g("replaceTerrainBelowHeightMin(\"HadesBuildable1\", \"Hades3\", 9.9);");
		g("replaceTerrainBelowHeightMin(\"HadesBuildable2\", \"Hades3\", 9.9);");
		g("paintUnit(\"Hades7\", \"Smoke Big\", 0, 0.1);");
		g("paintUnit(\"Hades7\", \"Underworld Smoke\", 0, 0.1);");
		g("refreshPassability();");
		g("dM(\"Pine Dead\", 0, 3, 5.0, 30);");
		g("dM(\"Pine Dead\", 0, 10, 5.0, 10);");
		g("sunColor(randomFloat(100.0, 255.0), randomFloat(100.0, 200.0), 20);");
		g("ambientColor(100, 50, 20);");
		g("trSetSunPosition(randomFloat(45, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateMarsh(){");
		g("normalise(\"MarshC\", 0);");
		g("trCoverTerrainWithWater(-2.0, 5.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"MarshC\");");
		g("trPaintWaterColor(vector(0, 0.5, 0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("centrePosX = randomInt(toTiles(0.4), toTiles(0.6));");
		g("centrePosZ = randomInt(toTiles(0.4), toTiles(0.6));");
		g("for(i = 0; < 40) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 18.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.06), \"MarshB\", 1.0);");
			g("}");
		g("}");
		g("smooth(4);");
		g("for(i = 0; < 10) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 38.0);");
			g("for(j = 0; < 4) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.06), \"ForestfloorMarsh\", 5.0);");
			g("}");
		g("}");
		g("for(i = 0; < 100) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 34.0);");
			g("for(j = 0; < 4) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.02), \"ForestfloorMarsh\", 5.0);");
			g("}");
		g("}");
		g("for(i = 0; < 30) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 28.0);");
			g("for(j = 0; < 4) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.01), \"ForestfloorMarsh\");");
			g("}");
		g("}");
		g("smooth(4);");
		g("replaceTerrainAboveHeightMin(\"MarshB\", \"MarshD\", 0.0);");
		g("replaceTerrainAboveHeightMin(\"MarshD\", \"MarshE\", 3.0);");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorMarsh\", \"Marsh Tree\");");
		g("paintUnit(\"MarshC\", \"Pestilence Sfx1\", 0, 0.04);");
		g("paintUnit(\"MarshB\", \"Mist\", 0, 0.04);");
		g("paintUnit(\"MarshB\", \"Water Reeds\", 0, 0.04);");
		g("paintUnit(\"MarshD\", \"Bush\", 0, 0.04);");
		g("paintUnit(\"MarshD\", \"Rotting Log\", 0, 0.01);");
		g("paintUnit(\"MarshD\", \"Oak Tree\", 0, 0.02);");
		g("float shift = randomFloat(255.0);");
		g("sunColor(shift, 255.0, 255.0 - shift);");
		g("ambientColor(100.0, 100.0, 100.0);");
		g("trSetSunPosition(randomFloat(10, 45), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateAtlantis(){");
		g("normalise(\"CityTileAtlantisCoral\", 0, 3);");
		g("trCoverTerrainWithWater(5.0, 10.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"CityTileAtlantisCoral\");");
		g("trPaintWaterColor(vector(0.0, 1.0, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("centrePosX = randomInt(toTiles(0.4), toTiles(0.6));");
		g("centrePosZ = randomInt(toTiles(0.4), toTiles(0.6));");
		g("for(i = 0; < 30) {");
			g("tempV = xsVectorSet(randomFloat(0, toTiles(1.0)), 0.0, randomFloat(0, toTiles(1.0)));");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.04), ");
						g("\"CityTileAtlantisCoral\", randomFloatWeighted(4.9, -5.0, 4));");
			g("}");
		g("}");
		g("int sideChosen = randomInt(0, 3);");
		g("for(i = 0; < 5) {");
			g("if(sideChosen == 0)tempV = xsVectorSet(randomFloat(0, toTiles(1.0)), 0.0, randomFloat(toTiles(0.7), toTiles(1.0)));");
			g("if(sideChosen == 1)tempV = xsVectorSet(randomFloat(toTiles(0.7), toTiles(1.0)), 0.0, randomFloat(0, toTiles(1.0)));");
			g("if(sideChosen == 2)tempV = xsVectorSet(randomFloat(0, toTiles(1.0)), 0.0, randomFloat(0, toTiles(0.3)));");
			g("if(sideChosen == 3)tempV = xsVectorSet(randomFloat(0, toTiles(0.3)), 0.0, randomFloat(0, toTiles(1.0)));");
			g("for(j = 0; < 20) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.04), ");
						g("\"CityTileA\", randomFloatWeighted(8.0, 15.0, 2));");
			g("}");
		g("}");
		g("smooth(10);");
		g("replaceTerrainBelowHeightMax(\"CityTileAtlantisCoral\", \"coralC\", 3.75);");
		g("replaceTerrainBelowHeightMax(\"coralC\", \"coralB\", 2.0);");
		g("replaceTerrainBelowHeightMax(\"coralB\", \"coralA\", 1.0);");
		g("replaceTerrainBelowHeightMax(\"coralA\", \"blackrock\", 0.0);");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorJungle\", \"Jungle Palm\");");
		g("paintUnit(\"CityTileA\", \"Atlantis Wall Long\", "+a+", 0.005);");
		g("paintUnit(\"CityTileA\", \"Atlantis Wall Connector\", "+a+", 0.01);");
		g("paintUnit(\"CityTileA\", \"Fountain\", "+a+", 0.01);");
		g("paintUnit(\"CityTileA\", \"Columns\", 0, 0.02);");
		g("paintUnit(\"CityTileAtlantisCoral\", \"Columns Fallen\", 0, 0.005);");
		g("paintUnit(\"CityTileAtlantisCoral\", \"Columns Broken\", 0, 0.005);");
		g("dM(\"Jungle Palm\", 0, 5, 5.0, 10);");
		g("dM(\"Parrot\", 0, 1, 0.0, 6);");
		g("float lightRedness = randomFloat(155.0);");
		g("sunColor(100.0 + randomFloat(155.0), 100.0, 100.0);");
		g("ambientColor(100.0 + randomFloat(155.0), 100.0, 100.0);");
		g("trSetSunPosition(randomFloat(70, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateTundra(){");
		g("normalise(\"CliffNorseA\", 0, 2);");
		g("trCoverTerrainWithWater(0.0, 5.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"CliffNorseA\");");
		g("trPaintWaterColor(vector(1.0, 1.0, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 20){");
			g("tempV = xsVectorSet(toTiles(randomFloat(0.0, 1.0)), 0.0, toTiles(randomFloat(0.0, 1.0)));");
			g("tempF = randomFloat(0.0, 15.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.06), \"CliffNorseA\", tempF);");
			g("}");
		g("}");
		g("smooth(4);");
		g("replaceTerrainAtMaxSteepness(\"CliffNorseA\", \"TundraGrassB\", 1.0);");
		g("replaceTerrainAtMaxSteepness(\"CliffNorseA\", \"TundraRockB\", 3.0);");
		g("for(i = 0; < 40){");
			g("tempV = randomOutsideCircleLoc(toTiles(0.5), toTiles(0.5), 10.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 12.0);");
				g("replaceCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), randomIntWeighted(0,2,4), ");
						g("\"TundraGrassB\", \"ForestfloorTundra\");");
			g("}");
		g("}");
		g("refreshPassability();");
		g("replaceTerrainAboveHeightMin(\"TundraGrassB\", \"TundraGrassA\", 5.0);");
		g("replaceTerrainBelowHeightMax(\"TundraGrassB\", \"ShorelineNorwegianB\", 0.0);");
		g("replaceTerrainBelowHeightMax(\"TundraRockB\", \"ShorelineNorwegianB\", 0.0);");
		g("paintTrees(\"ForestfloorTundra\", \"Tundra Tree\");");
		g("paintUnit(\"TundraGrassB\", \"Villager Greek\", "+a+", 0.005);");
		g("paintUnit(\"TundraGrassB\", \"Villager Egyptian\", "+a+", 0.02);");
		g("paintUnit(\"TundraGrassA\", \"Villager Norse\", "+a+", 0.02);");
		g("float lightness = randomFloat(50.0, 255.0);");
		g("sunColor(20.0, 20.0, 20.0);");
		g("ambientColor(lightness, lightness, lightness);");
		g("trSetSunPosition(randomFloat(10, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateMaze(){");
		g("normalise(\"CliffGreekA\", 0, 1);");
		g("for(i = 0; < 100){");
			g("tempV = xsVectorSet(toTiles(randomFloat(0.0, 1.0)), 0.0, toTiles(randomFloat(0.0, 1.0)));");
			g("tempF = randomInt(0, 2) * 10 - 5;");
			g("for(j = 0; < 4) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.1), \"CliffGreekA\", tempF);");
			g("}");
		g("}");
		g("smooth(4);");
		g("replaceTerrainAtMaxSteepness(\"CliffGreekA\", \"CliffEgyptianA\", 0.8);");
		g("trChangeTerrainHeight(0, 0, "+(getMapSize() / 2)+", "+(getMapSize() / 2)+", 0, false);");
		g("setTerrainHeightForTerrain(\"CliffEgyptianA\", 5.0);");
		g("smooth(2);");
		g("setTerrainHeightForTerrain(\"CliffGreekA\", 0.0);");
		g("replaceTerrainAboveHeightMin(\"CliffEgyptianA\", \"ForestfloorPalm\", 5.0);");
		g("refreshPassability();");
		g("paintUnit(\"ForestfloorPalm\", \"Temple\", "+a+", 0.005);");
		g("paintUnit(\"ForestfloorPalm\", \"Barracks\", "+a+", 0.005);");
		g("paintUnit(\"ForestfloorPalm\", \"Granary\", "+a+", 0.01);");
		g("paintUnit(\"ForestfloorPalm\", \"Lumber Camp\", "+a+", 0.01);");
		g("paintUnit(\"ForestfloorPalm\", \"House\", "+a+", 0.05);");
		g("paintTrees(\"ForestfloorPalm\", \"Palm\");");
		g("replaceTerrainBelowHeightMax(\"CliffEgyptianA\", \"SandC\", 0.0);");
		g("replaceTerrainBelowHeightMax(\"CliffGreekA\", \"SandC\", 0.0);");
		g("refreshPassability();");
		g("paintUnit(\"SandC\", \"Savannah Tree\", 0, 0.01);");
		g("paintUnit(\"SandC\", \"Rock Sandstone Sprite\", 0, 0.05);");
		g("dM(\"Vulture\", "+a+", 1, 0.0, 3);");
		g("dM(\"Statue Pharaoh\", "+a+", 1, 0.0, 8);");
		g("float extraRedLight = randomFloat(0.0, 155.0);");
		g("float extraGreenLight = randomFloat(0.0, extraRedLight);");
		g("sunColor(100.0 + extraRedLight, 100.0 + extraGreenLight, 50.0);");
		g("ambientColor(100.0, 50.0, 100.0);");
		g("trSetSunPosition(randomFloat(45, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateDeepForest(){");
		g("normalise(\"GrassA\", 0);");
		g("for(i = 0; < 30) {");
			g("tempV = xsVectorSet(toTiles(randomFloat(0.0, 1.0)), 0.0, toTiles(randomFloat(0.0, 1.0)));");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.02), \"GrassDirt25\");");
			g("}");
		g("}");
		g("for(i = 0; < 30) {");
			g("tempV = xsVectorSet(toTiles(randomFloat(0.0, 1.0)), 0.0, toTiles(randomFloat(0.0, 1.0)));");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.01), \"GrassDirt50\");");
			g("}");
		g("}");
		g("centrePosX = randomInt(toTiles(0.4), toTiles(0.6));");
		g("centrePosZ = randomInt(toTiles(0.4), toTiles(0.6));");
		g("for(i = 0; < 5) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 30.0);");
			g("for(j = 0; < 30) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.08), \"ForestfloorOak\");");
			g("}");
		g("}");
		g("for(i = 0; < 30) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 20.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.02), \"ForestfloorOak\");");
			g("}");
		g("}");
		g("for(i = 0; < 30) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 15.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.01), \"ForestfloorOak\");");
			g("}");
		g("}");
		g("refreshPassability();");
		g("paintUnit(\"ForestfloorOak\", \"Blowing Leaves\", 0, 0.02);");
		g("paintUnit(\"GrassA\", \"Grass\", 0, 0.1);");
		g("paintUnit(\"GrassA\", \"Flowers\", 0, 0.05);");
		g("paintUnit(\"GrassA\", \"Rotting Log\", 0, 0.02);");
		g("paintTrees(\"ForestfloorOak\", \"Oak Autumn\");");
		g("float ambientLightness = randomFloat(50.0, 255.0);");
		g("sunColor(255.0, 255.0, 255.0);");
		g("ambientColor(ambientLightness, ambientLightness, ambientLightness);");
		g("trSetSunPosition(randomFloat(10, 40), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateUnderworld(){");
		g("normalise(\"HadesBuildable1\", 0);");
		g("trCoverTerrainWithWater(6.0, 3.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"HadesBuildable1\");");
		g("trPaintWaterColor(vector(0.0, 0.0, 0.1),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 20) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircleHeight(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"HadesBuildable2\", 1.0);");
			g("}");
		g("}");
		g("for(i = 0; < 3) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.02), \"ForestfloorDeadPine\");");
			g("}");
		g("}");
		g("for(i = 0; < 10) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("paintCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.01), \"ForestfloorDeadPine\");");
			g("}");
		g("}");
		g("smooth(1);");
		g("centrePosX = randomInt(toTiles(0.4), toTiles(0.6));");
		g("centrePosZ = randomInt(toTiles(0.4), toTiles(0.6));");
		g("for(i = 0; < 20) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 20.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 3.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.03), \"BlackRock\", -5.0);");
			g("}");
		g("}");
		g("for(i = 0; < 10) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 3.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.03), \"hadesCliff\", 8.0);");
			g("}");
		g("}");
		g("changeTerrainHeight(6.5);");
		g("setTerrainHeightForTerrain(\"BlackRock\", -5.0);");
		g("smooth(1);");
		g("refreshPassability();");
		g("paintUnit(\"BlackRock\", \"Transport Ship Greek\", 0, 0.04);");
		g("paintUnit(\"BlackRock\", \"Transport Ship Chinese\", 0, 0.005);");
		g("paintUnit(\"BlackRock\", \"Transport Ship Norse\", 0, 0.1);");
		g("paintUnit(\"HadesBuildable2\", \"Stalagmite\", 0, 0.01);");
		g("paintUnit(\"HadesBuildable1\", \"Taproot Large\", 0, 0.001);");
		g("paintUnit(\"HadesBuildable1\", \"Taproot\", 0, 0.001);");
		g("paintUnit(\"HadesBuildable1\", \"Taproot Small\", 0, 0.005);");
		g("paintTrees(\"ForestfloorDeadPine\", \"Pine Dead\");");
		g("tempV = randomHue();");
		g("sunVector(tempV);");
		g("ambientColor(interpolate(xsVectorGetX(tempV), 255.0, 0.5), ");
				g("interpolate(xsVectorGetY(tempV), 255.0, 0.5), interpolate(xsVectorGetZ(tempV), 255.0, 0.5));");
		g("trSetSunPosition(randomFloat(30, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateBambooMaze(){");
		g("normalise(\"JungleB\", 0);");
		g("trCoverTerrainWithWater(16.0, 1.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("trPaintWaterColor(vector(1.0, 0.5, 0.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("paintMap(\"JungleB\");");
		g("for(i = 0; < 100){");
			g("tempV = xsVectorSet(toTiles(randomFloat(0.0, 1.0)), 0.0, toTiles(randomFloat(0.0, 1.0)));");
			g("tempF = randomInt(0, 2) * 10 - 5;");
			g("for(j = 0; < 4) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.1), \"JungleB\", tempF);");
			g("}");
		g("}");
		g("smooth(8);");
		g("replaceTerrainAtMaxSteepness(\"JungleB\", \"ShorelinePlainA\", 0.2);");
		g("trChangeTerrainHeight(0, 0, "+(getMapSize() / 2)+", "+(getMapSize() / 2)+", 0, false);");
		g("setTerrainHeightForTerrain(\"ShorelinePlainA\", -5.0);");
		g("smooth(2);");
		g("setTerrainHeightForTerrain(\"JungleB\", 0.0);");
		g("smooth(2);");
		g("replaceTerrainAboveHeightMin(\"ShorelinePlainA\", \"ForestfloorJungle\", -3.0);");
		g("replaceTerrainBelowHeightMin(\"JungleB\", \"ForestfloorJungle\", -0.1);");
		g("for(i = 0; < 18){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorJungle\", \"Bamboo Tree\");");
		g("paintUnit(\"JungleB\", \"Panda Bear\", "+a+", 0.002);");
		g("paintUnit(\"ShorelinePlainA\", \"Water Lilly\", 0, 0.05);");
		g("sunColor(0.0, 0.0, 0.0);");
		g("float green = randomFloat(100.0, 255.0);");
		g("float red = randomFloat(100.0, green);");
		g("float blue = randomFloat(100.0, green);");
		g("ambientColor(red, green, blue);");
		g("trSetSunPosition(randomFloat(30, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateCoast(){");
		g("normalise(\"CliffGreekB\", 0);");
		g("trCoverTerrainWithWater(16.25, 1.25,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"CliffGreekB\");");
		g("trPaintWaterColor(vector(0.0, 0.0, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; <= 10){");
			g("tempV = randomOutsideCircleLoc(toTiles(0.5), toTiles(0.5), toTiles(0.4));");
			g("for(j = 0; <= 10){");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.5));");
				g("for(k = 0; <= 8){");
					g("tempV3 = randomCircleLoc(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.08));");
					g("paintCircleHeight2(xsVectorGetX(tempV3), xsVectorGetZ(tempV3), toTiles(randomFloat(0.01, 0.1)), \"ShorelineAegeanA\", 1.5);");
				g("}");
			g("}");
		g("}");
		g("smooth(2);");
		g("setTerrainHeightForTerrain(\"CliffGreekB\", 15.0);");
		g("replaceTerrainAtMinSteepness(\"ShorelineAegeanA\", \"CliffA\", 0.5);");
		g("for(i = 0; <= 10){");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; <= 10){");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, toTiles(0.2));");
				g("for(k = 0; <= 10){");
					g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.03));");
					g("replaceCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.01, 0.03)), ");
							g("\"ShorelineAegeanA\", \"CoralC\");");
				g("}");
			g("}");
		g("}");
		g("for(i = 0; <= 4){");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; <= 4){");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, toTiles(0.2));");
				g("for(k = 0; <= 4){");
					g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.03));");
					g("replaceCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.01, 0.03)), ");
							g("\"CoralC\", \"CoralA\");");
				g("}");
			g("}");
		g("}");
		g("setTerrainHeightForTerrain(\"CoralC\", -1.0);");
		g("setTerrainHeightForTerrain(\"CoralA\", -3.0);");
		g("smooth(1);");
		g("replaceTerrainBelowHeightMin(\"CoralC\", \"CoralB\", -1.1);");
		g("for(i = 0; < 16){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("refreshPassability();");
		g("paintUnit(\"ShorelineAegeanA\", \"Palm\", 0, 0.02);");
		g("paintUnit(\"CliffGreekB\", \"Oak Tree\", 0, 0.1);");
		g("paintUnit(\"CliffGreekB\", \"Seagull\", 0, 0.01);");
		g("paintUnit(\"CoralC\", \"Rock River Grassy\", 0, 0.01);");
		g("float sunRed = randomFloat(100.0, 255);");
		g("float sunGreen = randomFloat(0.0, sunRed);");
		g("sunColor(sunRed, sunGreen, 0.0);");
		g("float ambientBlue = randomFloat(150.0, 255.0);");
		g("float ambientRed = randomFloat(100.0, ambientBlue);");
		g("ambientColor(ambientRed, 50.0, ambientBlue);");
		g("trSetSunPosition(randomFloat(45, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateDesertSnow(){");
		g("normalise(\"ShorelineAegeanB\", -5.0);");
		g("int sidePair = randomInt(0, 1);");
		g("for(i = 0; < 100){");
			g("if(randomInt(0, 1) == 0){");
				g("tempF = randomFloat(0.0, 0.25);");
			g("} else {");
				g("tempF = randomFloat(0.75, 1.0);");
			g("}");
			g("if(sidePair == 0){");
				g("paintCircleHeight2(toTiles(randomFloat(0.0, 1.0)), toTiles(tempF), toTiles(0.05), \"SnowSand75\", 0.0);");
			g("} else {");
				g("paintCircleHeight2(toTiles(tempF), toTiles(randomFloat(0.0, 1.0)), toTiles(0.05), \"SnowSand75\", 0.0);");
			g("}");
		g("}");
		g("for(i = 0; < 50){");
			g("if(randomInt(0, 1) == 0){");
				g("tempF = randomFloat(0.0, 0.15);");
			g("} else {");
				g("tempF = randomFloat(0.85, 1.0);");
			g("}");
			g("if(sidePair == 0){");
				g("paintCircleHeight2(toTiles(randomFloat(0.0, 1.0)), toTiles(tempF), toTiles(0.05), \"SnowSand50\", 7.0);");
			g("} else {");
				g("paintCircleHeight2(toTiles(tempF), toTiles(randomFloat(0.0, 1.0)), toTiles(0.05), \"SnowSand50\", 7.0);");
			g("}");
		g("}");
		g("for(i = 0; < 25){");
			g("if(randomInt(0, 1) == 0){");
				g("tempF = randomFloat(0.0, 0.05);");
			g("} else {");
				g("tempF = randomFloat(0.95, 1.0);");
			g("}");
			g("if(sidePair == 0){");
				g("paintCircleHeight2(toTiles(randomFloat(0.0, 1.0)), toTiles(tempF), toTiles(0.05), \"SnowSand25\", 15.0);");
			g("} else {");
				g("paintCircleHeight2(toTiles(tempF), toTiles(randomFloat(0.0, 1.0)), toTiles(0.05), \"SnowSand25\", 15.0);");
			g("}");
		g("}");
		g("smooth(2);");
		g("replaceTerrainAtMinSteepness(\"ShorelineAegeanB\", \"CliffNorseA\", 0.5);");
		g("replaceTerrainAtMinSteepness(\"SnowSand75\", \"CliffNorseA\", 0.5);");
		g("replaceTerrainAtMinSteepness(\"SnowSand50\", \"CliffNorseA\", 0.5);");
		g("replaceTerrainAtMinSteepness(\"SnowSand25\", \"CliffNorseA\", 0.5);");
		g("for(i = 0; < 100) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 4) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"ShorelineAegeanB\", \"SnowSand75\");");
			g("}");
		g("}");		
		g("for(i = 0; < 40) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 4) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"ShorelineAegeanB\", \"ForestfloorPalm\");");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"SnowSand75\", \"ForestfloorPalm\");");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"SnowSand50\", \"ForestfloorPineSnow\");");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"SnowSand25\", \"ForestfloorPineSnow\");");
			g("}");
		g("}");
		g("replaceTerrainBelowHeightMax(\"CliffNorseA\", \"CliffEgyptianA\", 5.0);");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorPalm\", \"Palm\");");
		g("paintTrees(\"ForestfloorPineSnow\", \"Pine Snow\");");
		g("paintUnit(\"SnowSand75\", \"Rock Granite Sprite\", 0, 0.1);");
		g("sunColor(100.0, 100.0, randomFloat(100.0, 255.0));");
		g("float ambient = randomFloat(50.0, 100.0);");
		g("ambientColor(ambient, ambient, ambient);");
		g("trSetSunPosition(randomFloat(25, 45), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateSavannah(){");
		g("normalise(\"CliffEgyptianA\", 0);");
		g("trCoverTerrainWithWater(16.0, 1.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"CliffEgyptianA\");");
		g("trPaintWaterColor(vector(0.0, 0.5, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 50){");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("paintCircleHeight2(centrePosX, centrePosZ, toTiles(randomFloat(0.01, 0.2)), \"SavannahA\", 5.0);");
		g("}");
		g("for(i = 0; < 10){");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("replaceCircle(centrePosX, centrePosZ, toTiles(randomFloat(0.01, 0.1)), \"SavannahA\", \"ShorelineSandA\");");
		g("}");
		g("setTerrainHeightForTerrain(\"ShorelineSandA\", -4.0);");
		g("replaceTerrainBelowHeightMin(\"CliffEgyptianA\", \"ShorelineSandA\", -0.1);");
		g("smooth(4);");
		g("setTerrainHeightForTerrain(\"CliffEgyptianA\", 10.0);");
		g("replaceTerrainAtMinSteepness(\"SavannahA\", \"CliffEgyptianA\", 1.0);");
		g("replaceTerrainAtMinSteepness(\"ShorelineSandA\", \"CliffEgyptianA\", 1.0);");
		g("replaceTerrainBelowHeightMax(\"CliffEgyptianA\", \"SavannahC\", 5.0);");
		g("for(i = 0; < 40) {");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; < 4) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 5.0);");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), randomInt(0, 1), \"SavannahA\", \"ForestfloorSavannah\");");
			g("}");
		g("}");
		g("for(i = 0; < 16){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorSavannah\", \"Savannah Tree\");");
		g("paintUnit(\"SavannahA\", \"Zebra\", "+a+", 0.01);");
		g("paintUnit(\"SavannahA\", \"Water Buffalo\", "+a+", 0.003);");
		g("paintUnit(\"SavannahA\", \"Elephant\", "+a+", 0.001);");
		g("float sunStrength = randomFloat(150, 255.0);");
		g("sunColor(sunStrength, sunStrength, sunStrength);");
		g("float ambient = randomFloat(50.0, 100.0);");
		g("ambientColor(ambient, ambient, ambient);");
		g("trSetSunPosition(randomFloat(5, 20), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateMistyForest(){");
		g("normalise(\"ForestfloorPine\", 10.0);");
		g("float height = 0.0;");
		g("for(i = 0; <= 8){");
			g("if(i == 0){");
				g("centrePosX = toTiles(0.5);");
				g("centrePosZ = toTiles(0.5);");
			g("} else {");
				g("centrePosX = randomInt(0, toTiles(1.0));");
				g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("}");
			g("for(j = 0; <= 5){");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, toTiles(0.2));");
				g("height = randomFloat(10.0, 15.0);");
				g("for(k = 0; <= 10){");
					g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.03));");
					g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.01, 0.03)), \"GrassB\", height);");
				g("}");
			g("}");
		g("}");
		g("smooth(10);");
		g("for(i = 0; <= 8){");
			g("centrePosX = randomInt(0, toTiles(1.0));");
			g("centrePosZ = randomInt(0, toTiles(1.0));");
			g("for(j = 0; <= 5){");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, toTiles(0.2));");
				g("height = randomFloat(-5.0, 5.0);");
				g("for(k = 0; <= 10){");
					g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.03));");
					g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.01, 0.03)), \"GrassA\", height);");
				g("}");
			g("}");
		g("}");
		g("smooth(2);");
		g("replaceTerrainAtMinSteepness(\"GrassB\", \"GaiaCreepA\", 0.5);");
		g("replaceTerrainAtMinSteepness(\"ForestfloorPine\", \"GaiaCreepA\", 0.5);");
		g("smooth(10);");
		g("paintTrees(\"ForestfloorPine\", \"Pine\");");
		g("paintUnit(\"GrassA\", \"GaiaCreepFlowers\", 2, 0.1);");
		g("paintUnit(\"GrassA\", \"Mist\", 0, 0.1);");
		g("paintUnit(\"GaiaCreepA\", \"GaiaCreepFlowers\", 2, 0.1);");
		g("paintUnit(\"GaiaCreepA\", \"Spider Door\", 0, 0.01);");
		g("paintUnit(\"GaiaCreepA\", \"Taproot Large\", 0, 0.004);");
		g("paintUnit(\"GaiaCreepA\", \"Taproot\", 0, 0.004);");
		g("paintUnit(\"GaiaCreepA\", \"Taproot Small\", 0, 0.004);");
		g("float sunSlider = randomFloat(0.0, 1.0);");
		g("float ambientSlider = randomFloat(0.0, 1.0);");
		g("sunVector(interpolateVector(vector(255.0, 0.0, 0.0), vector(0.0, 255, 0.0), sunSlider));");
		g("ambientVector(interpolateVector(vector(50.0, 50.0, 50.0), vector(150.0, 150.0, 150.0), ambientSlider));");
		g("trSetSunPosition(randomFloat(30.0, 45.0), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateVolcano(){");
		g("normalise(\"GreekRoad Burnt\", 15.0);");
		g("centrePosX = randomInt(toTiles(0.2), toTiles(0.8));");
		g("centrePosZ = randomInt(toTiles(0.2), toTiles(0.8));");
		g("for(i = 0; < 100){");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, toTiles(0.3));");
			g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"Hades3\", 10.0);");
		g("}");
		g("for(i = 0; < 50){");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, toTiles(0.2));");
			g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"Hades4\", 5.0);");
		g("}");
		g("for(i = 0; < 25){");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, toTiles(0.1));");
			g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"Hades5\", 0.0);");
		g("}");
		g("for(i = 0; < 10){");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, toTiles(0.1));");
			g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"Hades7\", -5.0);");
		g("}");
		g("for(i = 0; < 100){");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, toTiles(0.55));");
			g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"ForestfloorDeadPine\", 10.0);");
		g("}");
		g("for(i = 0; < 200){");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, toTiles(0.65));");
			g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"Hades6\", 5.0);");
		g("}");
		g("paintTrees(\"ForestfloorDeadPine\", \"Pine Dead\");");
		g("paintUnit(\"Hades3\", \"Fire Object\", 0, 0.05, true);");
		g("paintUnit(\"Hades4\", \"Fire Object Big\", 0, 0.05, true);");
		g("paintUnit(\"Hades5\", \"Hades Fire\", 0, 0.05, true);");
		g("paintUnit(\"Hades7\", \"Tartarian Gate Birth\", "+a+", 0.05, true);");
		g("smooth(1);");
		g("refreshPassability();");
		g("sunColor(randomFloat(100.0, 255.0), randomFloat(100.0, 200.0), 20);");
		g("ambientColor(100, 50, 20);");
		g("trSetSunPosition(randomFloat(45, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateGrassyCliff(){");
		g("normalise(\"GrassDirt75\", 0);");
		g("trCoverTerrainWithWater(3.0, 3.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"GrassDirt75\");");
		g("trPaintWaterColor(vector(1.0, 0.5, 0.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("centrePosX = randomInt(toTiles(0.4), toTiles(0.6));");
		g("centrePosZ = randomInt(toTiles(0.4), toTiles(0.6));");
		g("for(i = 0; < 3) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 20.0);");
			g("for(j = 0; < 5) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.02, 0.05)), \"ForestFloorOak\", 4.0);");			
				g("for(k = 0; < 10) {");
					g("tempV3 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
					g("paintCircleHeight2(xsVectorGetX(tempV3), xsVectorGetZ(tempV3), toTiles(randomFloat(0.01, 0.03)), \"ForestFloorOak\", 4.0);");
				g("}");
			g("}");
		g("}");
		g("for(i = 0; < 10) {");
			g("tempV = randomOutsideCircleLoc(centrePosX, centrePosZ, 30.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 5.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.01, 0.03)), \"CliffGreekA\", 10.0);");
			g("}");
		g("}");
		g("for(i = 0; < 20) {");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, 30.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 12.0);");
				g("replaceCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), ");
						g("toTiles(randomFloat(0.01, 0.02)), \"GrassDirt75\", \"ForestFloorOak\");");
			g("}");
		g("}");
		g("for(i = 0; < 40) {");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, 30.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 8.0);");
				g("replaceCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.02, 0.05)), \"GrassDirt75\", \"GrassDirt50\");");
			g("}");
		g("}");
		g("for(i = 0; < 20) {");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, 20.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 8.0);");
				g("paintCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.02, 0.05)), \"GrassDirt25\");");
			g("}");
		g("}");
		g("for(i = 0; < 3) {");
			g("tempV = randomCircleLoc(centrePosX, centrePosZ, 10.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 12.0);");
				g("paintCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.01, 0.02)), \"GrassB\");");
			g("}");
		g("}");
		g("setTerrainHeightForTerrain(\"GrassDirt50\", 2.0);");
		g("setTerrainHeightForTerrain(\"GrassDirt25\", 5.0);");
		g("setTerrainHeightForTerrain(\"GrassB\", 7.0);");
		g("replaceTerrainBelowHeightMax(\"GrassDirt50\", \"GrassDirt75\", 1.5);");
		g("replaceTerrainBelowHeightMax(\"GrassDirt25\", \"GrassDirt75\", 1.5);");
		g("replaceTerrainBelowHeightMax(\"ForestFloorOak\", \"GrassDirt75\", 1.5);");
		g("smooth(2);");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorOak\", \"Oak Tree\");");
		g("paintUnit(\"GrassB\", \"Grass\", 0, 0.1);");
		g("paintUnit(\"GrassDirt25\", \"Bush\", 0, 0.01);");
		g("paintUnit(\"GrassDirt50\", \"Rock River Grassy\", 0, 0.01);");
		g("float daySlider = randomFloat(0.0, 1.0);");
		g("float sunStrength = interpolate(255.0, 100.0, daySlider);");
		g("ambientColor(sunStrength, sunStrength, sunStrength);");
		g("sunColor(255.0, sunStrength, sunStrength);");
		g("trSetSunPosition(interpolate(10.0, 70.0, daySlider), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateOlympus(){");
		g("normalise(\"OlympusC\", 0);");
		g("trCoverTerrainWithWater(16.0, 16.0,\"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"OlympusC\");");
		g("vector olympusWaterColour = randomHue();");
		g("trPaintWaterColor(olympusWaterColour,0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 100) {");
			g("centrePosX = randomInt(toTiles(0.3), toTiles(0.7));");
			g("centrePosZ = randomInt(toTiles(0.3), toTiles(0.7));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"OlympusC\", randomInt(0, 2) * 10);");			
			g("}");
		g("}");
		g("smooth(5);");
		g("replaceTerrainAtMaxSteepness(\"OlympusC\", \"ForestFloorGaia\", 1.5);");
		g("for(i = randomInt(0, 2); < 3) {");
			g("centrePosX = randomInt(toTiles(0.0), toTiles(1.0));");
			g("centrePosZ = randomInt(toTiles(0.0), toTiles(1.0));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 8.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"OlympusTile\", -5.0);");			
			g("}");
		g("}");
		g("smooth(2);");
		g("replaceTerrainBelowHeightMax(\"GaiaCreepBorderSnow\", \"OlympusTile\", 0.0);");
		g("setTerrainHeightForTerrain(\"ForestFloorGaia\", 2.0);");
		g("setTerrainHeightForTerrain(\"OlympusC\", 0.0);");
		g("replaceTerrainAtMinSteepness(\"ForestFloorGaia\", \"GaiaCreepBorderSnow\", 0.5);");
		g("replaceTerrainAtMinSteepness(\"OlympusC\", \"GaiaCreepBorderSnow\", 0.5);");
		g("replaceTerrainBelowHeightMax(\"ForestFloorGaia\", \"OlympusC\", 1.0);");
		g("for(i = 0; < 17){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("refreshPassability();");
		g("olympusTreeAnimationPath = \"\"+randomInt(0,6)+\",0,0,0,0,0,0\";");
		g("paintTrees(\"ForestfloorGaia\", \"Gaia Forest Tree\");");
		g("ambientVector(olympusWaterColour);");
		g("float daySlider = randomFloat(0.0, 1.0);");
		g("float sunStrength = interpolate(255.0, 100.0, daySlider);");
		g("sunColor(sunStrength, sunStrength, sunStrength);");
		g("trSetSunPosition(interpolate(10.0, 70.0, daySlider), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateMountainTop(){");
		g("normalise(\"ForestFloorPineSnow\", -5);");
		g("for(i = 0; < 5) {");
			g("centrePosX = randomInt(toTiles(0.1), toTiles(0.9));");
			g("centrePosZ = randomInt(toTiles(0.1), toTiles(0.9));");
			g("for(j = 0; < 20) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 15.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), ");
						g("toTiles(randomFloat(0.04, 0.1)), \"SnowB\", 10.0);");			
				g("for(k = 0; < 10) {");
					g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 15.0);");
					g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), ");
							g("toTiles(randomFloat(0.01, 0.03)), \"SnowB\", 10.0);");
				g("}");
			g("}");
			g("for(j = 0; < 3) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 8.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), ");
						g("toTiles(randomFloat(0.02, 0.05)), \"CliffNorseA\", 15.0);");			
				g("for(k = 0; < 10) {");
					g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 3.0);");
					g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), ");
							g("toTiles(randomFloat(0.01, 0.03)), \"CliffNorseA\", 15.0);");
				g("}");
			g("}");
		g("}");
		g("smooth(1);");
		g("replaceTerrainAtMinSteepness(\"ForestFloorPineSnow\", \"CliffNorseA\", 0.5);");
		g("replaceTerrainAtMinSteepness(\"SnowB\", \"CliffNorseA\", 0.5);");
		g("for(i = 0; < 5) {");
			g("centrePosX = randomInt(toTiles(0.0), toTiles(1.0));");
			g("centrePosZ = randomInt(toTiles(0.0), toTiles(1.0));");
			g("for(j = 0; < 20) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 15.0);");		
				g("for(k = 0; < 10) {");
					g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 15.0);");
					g("replaceCircle(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), ");
							g("toTiles(randomFloat(0.01, 0.03)), \"SnowB\", \"SnowGrass25\");");
				g("}");
				g("replaceCircle(xsVectorGetX(tempV), xsVectorGetZ(tempV), ");
						g("toTiles(randomFloat(0.04, 0.1)), \"SnowB\", \"SnowGrass50\");");	
			g("}");
		g("}");
		g("paintUnit(\"ForestfloorPineSnow\", \"Icy Footprint\", 0, 0.02);");
		g("paintTrees(\"ForestfloorPineSnow\", \"Pine Snow\");");
		g("paintUnit(\"SnowB\", \"Snow Drift Tower\", 0, 0.1);");
		g("paintUnit(\"SnowGrass25\", \"Ice Block\", 0, 0.1);");
		g("paintUnit(\"SnowGrass50\", \"Pine Snow\", 0, 0.1);");
		g("refreshPassability();");
		g("float ambientStrength = randomFloat(100.0, 200.0);");
		g("ambientColor(ambientStrength, ambientStrength, ambientStrength);");
		g("sunColor(0.0, 0.0, 0.0);");
		g("trSetSunPosition(45.0, randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateDesertCliffs(){");
		g("normalise(\"CliffEgyptianA\", 0);");
		g("trCoverTerrainWithWater(16.0, 1.0, \"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"CliffEgyptianA\");");
		g("trPaintWaterColor(vector(0.4, 0.7, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 100) {");
			g("centrePosX = randomInt(toTiles(0.2), toTiles(0.8));");
			g("centrePosZ = randomInt(toTiles(0.2), toTiles(0.8));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"ShorelineAegeanC\", randomInt(0, 2) * 10);");			
			g("}");
		g("}");
		g("smooth(5);");
		g("replaceTerrainAtMaxSteepness(\"ShorelineAegeanC\", \"ShorelineAegeanA\", 1.5);");
		g("setTerrainHeightForTerrain(\"ShorelineAegeanA\", -1.0);");
		g("setTerrainHeightForTerrain(\"ShorelineAegeanC\", 2.0);");
		g("replaceTerrainAboveHeightMin(\"ShorelineAegeanA\", \"ForestfloorPalm\", 1.5);");
		g("smooth(2);");
		g("for(i = 0; < 15){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		//Some reason the extra change of height required to make game treat terrain properly as not shallow water
		g("changeGlobalHeight(-0.1);");
		g("changeTerrainHeight(0.1);");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorPalm\", \"Palm\");");
		g("sunColor(255, randomFloat(150, 255), randomFloat(150, 255));");
		g("ambientColor(100, 100, 100);");
		g("trSetSunPosition(randomFloat(5, 45), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateLakeForest(){");
		g("normalise(\"RiverGrassyB\", 0);");
		g("trCoverTerrainWithWater(16.0, 16.0, \"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"RiverGrassyB\");");
		g("trPaintWaterColor(vector(0.0, 0.2, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 400) {");
			g("centrePosX = toTiles(0.5 + (0.5 - randomFloatWeighted(0.0, 0.5, 3)) * (randomInt(0, 1)*2-1));");
			g("centrePosZ = toTiles(0.5 + (0.5 - randomFloatWeighted(0.0, 0.5, 3)) * (randomInt(0, 1)*2-1));");
			g("for(j = 0; < 10) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"GrassB\", randomInt(0, 2) * 10);");			
			g("}");
		g("}");
		g("smooth(5);");
		g("setTerrainHeightForTerrain(\"RiverGrassyB\", -5.0);");
		g("replaceTerrainAtMaxSteepness(\"GrassB\", \"ForestfloorPine\", 1.0);");
		g("setTerrainHeightForTerrain(\"GrassB\", 0.0);");
		g("setTerrainHeightForTerrain(\"ForestfloorPine\", 2.0);");
		g("smooth(2);");
		g("replaceTerrainBelowHeightMin(\"GrassB\", \"RiverGrassyC\", -1.0);");
		g("replaceTerrainBelowHeightMax(\"GrassB\", \"GrassA\", 0.5);");
		g("replaceTerrainAboveHeightMax(\"RiverGrassyB\", \"RiverGrassyC\", -1.0);");
		g("for(i = 0; < 17){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("refreshPassability();");
		g("paintTrees(\"ForestfloorPine\", \"Pine\");");
		g("paintUnit(\"RiverGrassyB\", \"Water Lilly\", 0, 0.01);");
		g("paintUnit(\"GrassA\", \"Flowers\", 0, 0.01);");
		g("sunColor(randomFloat(0, 150), randomFloat(0, 150), randomFloat(150, 255));");
		g("ambientColor(50, 50, 100);");
		g("trSetSunPosition(randomFloat(30, 75), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateHellForest(){");
		g("normalise(\"GreekRoad BurntB\", 0);");
		g("for(i = 0; < 400) {");
			g("centrePosX = randomInt(toTiles(0.1), toTiles(0.9));");
			g("centrePosZ = randomInt(toTiles(0.1), toTiles(0.9));");
			g("paintCircleHeight2(centrePosX, centrePosZ, toTiles(0.05), \"GreekRoad BurntB\", randomInt(0, 2) * 10);");			
		g("}");
		g("for(i = 0; < 100) {");
			g("centrePosX = randomInt(toTiles(0.25), toTiles(0.75));");
			g("centrePosZ = randomInt(toTiles(0.25), toTiles(0.75));");
			g("paintCircleHeight2(centrePosX, centrePosZ, toTiles(0.05), \"GreekRoad BurntB\", 0.0);");			
		g("}");
		g("smooth(5);");
		g("replaceTerrainAtMaxSteepness(\"GreekRoad BurntB\", \"ForestfloorDeadPine\", 0.7);");
		g("setTerrainHeightForTerrain(\"GreekRoad BurntB\", 0.0);");
		g("setTerrainHeightForTerrain(\"ForestfloorDeadPine\", 3.0);");
		g("for(i = 0; < 40) {");
			g("centrePosX = randomInt(toTiles(0.35), toTiles(0.65));");
			g("centrePosZ = randomInt(toTiles(0.35), toTiles(0.65));");
			g("paintCircleHeight2(centrePosX, centrePosZ, toTiles(0.05), \"HadesCliff\", 15.0);");			
		g("}");
		g("for(i = 0; < 10) {");
			g("centrePosX = randomInt(toTiles(0.45), toTiles(0.55));");
			g("centrePosZ = randomInt(toTiles(0.45), toTiles(0.55));");
			g("paintCircleHeight2(centrePosX, centrePosZ, toTiles(0.05), \"Hades7\", -5.0);");			
		g("}");
		g("smooth(2);");
		g("replaceTerrainAtMinSteepness(\"Hades7\", \"Hades3\", 1.0);");
		g("replaceTerrainAboveHeightMax(\"ForestfloorDeadPine\", \"HadesCliff\", 4.0);");
		g("replaceTerrainAboveHeightMax(\"GreekRoad BurntB\", \"HadesCliff\", 4.0);");
		g("paintTrees(\"ForestfloorDeadPine\", \"Gaia Forest Tree\");");
		g("deployLoc(toMetres(0.5), toMetres(0.5), \"Underworld Explosion\", 0);");
		g("refreshPassability();");
		g("float sunRed = randomFloat(150, 255);");
		g("float sunGreen = randomFloat(50, sunRed);");
		g("float sunBlue = randomFloat(0, sunGreen);");
		g("sunColor(sunRed, sunGreen, sunBlue);");
		g("ambientColor(100, 100, 0);");
		g("trSetSunPosition(randomFloat(10, 50), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateResilientForest(){");
		g("normalise(\"GrassB\", 0);");
		g("trCoverTerrainWithWater(16.0, 11.0, \"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"GrassB\");");
		g("trPaintWaterColor(vector(0.5, 1.0, 0.5),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("cinematicForestMap = true;");
		g("for(i = 0; < 100) {");
			g("tempV = randomOutsideCircleLoc(toTiles(0.5), toTiles(0.5), toTiles(0.5 - randomFloatWeighted(0.0, 0.5, 3)));");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.05), \"ForestFloorOak\", randomInt(0, 2) * 10);");			
			g("}");
		g("}");
		g("smooth(5);");
		g("replaceTerrainAtMinSteepness(\"ForestFloorOak\", \"CliffGreekB\", 1.0);");
		g("int poolX = toTiles(0.1 + 0.8 * randomInt(0, 1));");
		g("int poolZ = toTiles(0.1 + 0.8 * randomInt(0, 1));");
		g("for(i = 0; < 50){");
			g("tempV = randomCircleLoc(poolX, poolZ, 20.0);");
			g("for(j = 0; < 20) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), ");
						g("toTiles(randomFloat(0.01, 0.03)), \"RiverMarshC\", -5.0);");
			g("}");
		g("}");
		g("smooth(10);");
		g("setTerrainHeightForTerrain(\"GrassB\", 2.0);");
		g("setTerrainHeightForTerrain(\"CliffGreekB\", 5.0);");
		g("setTerrainHeightForTerrain(\"ForestFloorOak\", 0.0);");
		g("smooth(2);");
		g("replaceTerrainAtMinSteepness(\"CliffGreekB\", \"ForestFloorOak\", 1.5);");
		g("for(i = 0; < 17){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("refreshPassability();");
		g("int beforeTree = trGetNextUnitScenarioNameNumber();");
		g("paintTrees(\"ForestFloorOak\", \"Oak Tree\");");
		g("int afterTree = trGetNextUnitScenarioNameNumber();");
		g("for(i = beforeTree; < afterTree){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+i, true);");
			g("trUnitChangeProtoUnit(\"Ajax\");");
			g("trUnitChangeProtoUnit(\"Spy Eye\");");
			g("trMutateSelected("+getUnitIdFromName("Cinematic Trees")+");");
			g("if(randomInt(0, 1) == 0){");
				g("trUnitSetAnimationPath(\"0,0,0,0,0,0,0\");");
			g("} else {");
				g("trUnitSetAnimationPath(\"1,0,0,0,0,0,0\");");
			g("}");
			g("int otherTree = trGetNextUnitScenarioNameNumber() - 2;");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+otherTree, true);");
			g("trUnitChangeProtoUnit(\"Oak Tree\");");
			g("trSetSelectedScale(1.0, 0.0, 0.0);");
		g("}");
		g("paintUnit(\"GrassB\", \"Flowers\", 0, 0.01);");
		g("paintUnit(\"CliffGreekB\", \"Rock Limestone Small\", 0, 0.01);");
		g("paintUnit(\"CliffGreekB\", \"Grass\", 0, 0.01);");
		g("int sunRed = randomInt(0, 255);");
		g("int sunBlue = randomInt(sunRed / 2, 255);");
		g("int sunGreen = randomInt(sunBlue / 2, 255);");
		g("sunColor(sunRed, sunGreen, sunBlue);");
		g("ambientColor(100, 100, 100);");
		g("trSetSunPosition(randomFloat(20, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateWaterCity(){");
		g("normalise(\"GrassA\", 0);");
		g("trCoverTerrainWithWater(16.25, 21.0, \"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"GrassA\");");
		g("trPaintWaterColor(vector(0.5, 0.0, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("int smallTileRadius = toTiles(0.04);");
		g("bool skip = true;");
		g("for(i = 0; < 9){");
			g("for(j = 0; < 9){");
				g("if(skip){");
					g("skip = false;");
				g("} else {");
					g("skip = true;");
					g("if(randomInt(0, 4) != 0 || (xsAbs(4 - i) <= 1 && xsAbs(4 - j) <= 1)){");
						g("int smallTileLocX = toTiles(0.1 + 0.1 * i);");
						g("int smallTileLocZ = toTiles(0.1 + 0.1 * j);");
						g("trChangeTerrainHeight(smallTileLocX - smallTileRadius, smallTileLocZ - smallTileRadius, ");
								g("smallTileLocX + smallTileRadius, smallTileLocZ + smallTileRadius, randomInt(-2, 2), false);");		
					g("}");
				g("}");
			g("}");
		g("}");
		g("int tileRadius = toTiles(0.06);");
		g("for(i = 0; < 5){");
			g("for(j = 0; < 5){");
				g("if(randomInt(0, 4) != 0 || (xsAbs(2 - i) + xsAbs(2 - j) <= 1)){");
					g("int tileLocX = toTiles(0.1 + 0.2 * i);");
					g("int tileLocZ = toTiles(0.1 + 0.2 * j);");
					g("trChangeTerrainHeight(tileLocX - tileRadius, tileLocZ - tileRadius, ");
							g("tileLocX + tileRadius, tileLocZ + tileRadius, 2, false);");
				g("}");
			g("}");
		g("}");
		g("replaceTerrainBelowHeightMin(\"GrassA\", \"CliffGreekA\", -4.0);");
		g("replaceTerrainBelowHeightMax(\"CliffGreekA\", \"ShorelineMediterraneanC\", -1.0);");
		g("replaceTerrainBelowHeightMax(\"GrassA\", \"ShorelineMediterraneanC\", -1.0);");
		g("replaceTerrainBelowHeightMax(\"ShorelineMediterraneanC\", \"ShorelineMediterraneanB\", -2.0);");
		g("replaceTerrainAtMinSteepness(\"GrassA\", \"ShorelineMediterraneanD\", 2.5);");
		g("replaceTerrainAtMinSteepness(\"GrassA\", \"GrassDirt50\", 0.5);");
		g("for(i = 0; < 17){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("refreshPassability();");
		g("paintUnit(\"CliffGreekA\", \"Palm\", 0, 0.05);");
		g("paintUnit(\"CliffGreekA\", \"Columns\", 0, 0.01);");
		g("paintUnit(\"ShorelineMediterraneanB\", \"Fishing Ship Atlantean\", 0, 0.02);");
		g("unitTransform(\"Fishing Ship Atlantean\", \"Mist\");");
		g("sunColor(255, 0, randomFloat(0, 255));");
		g("int ambientStrength = randomInt(100, 255);");
		g("ambientColor(ambientStrength, ambientStrength, ambientStrength);");
		g("trSetSunPosition(randomFloat(10, 40), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateSnowRivers(){");
		g("normalise(\"CliffNorseA\", 0);");
		g("trCoverTerrainWithWater(16.0, 16.0, \"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"CliffNorseA\");");
		g("trPaintWaterColor(vector(1.0, 1.0, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 100) {");
			g("tempV = randomOutsideCircleLoc(toTiles(0.5), toTiles(0.5), toTiles(0.5 - randomFloatWeighted(0.0, 0.5, 3)));");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 10.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(0.05), ");
						g("\"ForestFloorPineSnow\", randomInt(0, 2) * 10);");			
			g("}");
		g("}");
		g("smooth(5);");
		g("replaceTerrainAtMinSteepness(\"ForestFloorPineSnow\", \"SnowB\", 0.5);");
		g("replaceTerrainBelowHeightMin(\"SnowB\", \"ShorelineTundraD\", 5.0);");
		g("setTerrainHeightForTerrain(\"CliffNorseA\", 15.0);");
		g("setTerrainHeightForTerrain(\"ForestFloorPineSnow\", 0.0);");
		g("setTerrainHeightForTerrain(\"SnowB\", 0.0);");
		g("setTerrainHeightForTerrain(\"ShorelineTundraD\", -5.0);");
		g("smooth(2);");
		g("replaceTerrainAtMinSteepness(\"CliffNorseA\", \"SnowB\", 0.5);");
		g("setTerrainHeightForTerrain(\"SnowB\", 0.0);");
		g("smooth(1);");
		g("replaceTerrainAtMinSteepness(\"SnowB\", \"CliffNorseA\", 2.0);");
		g("replaceTerrainBelowHeightMax(\"SnowB\", \"ShorelineTundraB\", -1.0);");
		g("replaceTerrainAboveHeightMin(\"ShorelineTundraD\", \"SnowB\", -1.0);");
		g("replaceTerrainBelowHeightMax(\"SnowB\", \"ShorelineTundraD\", -1.0);");
		g("replaceTerrainBelowHeightMax(\"ForestFloorPineSnow\", \"ShorelineTundraD\", -1.0);");
		g("for(i = 0; < 200) {");
			g("centrePosX = randomInt(toTiles(0.0), toTiles(1.0));");
			g("centrePosZ = randomInt(toTiles(0.0), toTiles(1.0));");
			g("replaceCircle(centrePosX, centrePosZ, toTiles(randomFloat(0.01, 0.04)), \"SnowB\", \"ShorelineTundraA\");");
		g("}");
		g("for(i = 0; < 100) {");
			g("centrePosX = randomInt(toTiles(0.0), toTiles(1.0));");
			g("centrePosZ = randomInt(toTiles(0.0), toTiles(1.0));");
			g("replaceCircle(centrePosX, centrePosZ, toTiles(randomFloat(0.01, 0.04)), \"SnowB\", \"ShorelineTundraB\");");
		g("}");
		g("for(i = 0; < 17){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("refreshPassability();");
		g("paintTrees(\"ForestFloorPineSnow\", \"Pine Snow\");");
		g("sunColor(randomFloat(100.0, 255.0), randomFloat(100.0, 255.0), randomFloat(100.0, 255.0));");
		g("float ambientStrength = randomFloat(50.0, 255);");
		g("ambientColor(ambientStrength, ambientStrength, ambientStrength);");
		g("trSetSunPosition(randomFloat(20, 70), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateDesertForest(){");
		g("normalise(\"ForestFloorPalm\", 0);");
		g("for(i = 0; < 15) {");
			g("centrePosX = randomInt(toTiles(0.0), toTiles(1.0));");
			g("centrePosZ = randomInt(toTiles(0.0), toTiles(1.0));");
			g("for(j = 0; < 20){");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 20.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"SandC\", 5.0);");
			g("}");
			g("for(j = 0; < 5){");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 20.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"CliffEgyptianA\", 10.0);");
			g("}");
		g("}");
		g("smooth(2);");
		g("replaceTerrainAtMinSteepness(\"SandC\", \"ForestFloorSavannah\", 1.0);");
		g("replaceTerrainAtMinSteepness(\"SandC\", \"SavannahB\", 0.01);");
		g("paintTrees(\"ForestFloorPalm\", \"Palm\");");
		g("paintTrees(\"ForestFloorSavannah\", \"Savannah Tree\");");
		g("paintUnit(\"SandC\", \"Rock Sandstone Sprite\", 0, 0.01);");
		g("paintUnit(\"SavannahB\", \"Rock Sandstone Small\", 0, 0.01);");
		g("refreshPassability();");
		g("sunColor(randomFloat(100.0, 255.0), randomFloat(150.0, 255.0), randomFloat(50.0, 100.0));");
		g("ambientColor(randomFloat(50.0, 100.0), randomFloat(0.0, 50.0), randomFloat(50.0, 100.0));");
		g("trSetSunPosition(randomFloat(10, 40), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateForestCliffs(){");
		g("normalise(\"CliffGreekA\", 0);");
		g("trCoverTerrainWithWater(16.0, 16.0, \"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"CliffGreekA\");");
		g("trPaintWaterColor(vector(0.0, 0.0, 1.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 15) {");
			g("centrePosX = randomInt(toTiles(0.0), toTiles(1.0));");
			g("centrePosZ = randomInt(toTiles(0.0), toTiles(1.0));");
			g("float generateHeight = 20.0 * randomInt(0, 1);");
			g("for(j = 0; < 20) {");
				g("tempV = randomCircleLoc(centrePosX, centrePosZ, 20.0);");
				g("paintCircleHeight2(xsVectorGetX(tempV), xsVectorGetZ(tempV), toTiles(0.05), \"ForestFloorGaia\", generateHeight);");
			g("}");
		g("}");
		g("smooth(5);");
		g("replaceTerrainAtMinSteepness(\"CliffGreekA\", \"GaiaCreepBorder\", 2.0);");
		g("replaceTerrainAtMinSteepness(\"ForestFloorGaia\", \"GaiaCreepBorder\", 0.5);");
		g("setTerrainHeightForTerrain(\"CliffGreekA\", 15.0);");
		g("setTerrainHeightForTerrain(\"ForestFloorGaia\", 5.0);");
		g("setTerrainHeightForTerrain(\"GaiaCreepBorder\", 0.0);");
		g("smooth(2);");
		g("replaceTerrainBelowHeightMin(\"ForestFloorGaia\", \"ForestFloorOak\", 4.0);");
		g("replaceTerrainAtMaxSteepness(\"ForestFloorGaia\", \"RiverGrassyB\", 0.1);");
		g("replaceTerrainAboveHeightMin(\"ForestFloorOak\", \"ForestFloorGaia\", -999.0);");
		g("setTerrainHeightForTerrain(\"RiverGrassyB\", -5.0);");
		g("for(i = 0; < 17){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		g("for(i = 0; < 4){");
			g("changeTerrainHeight(-1.0);");
			g("changeGlobalHeight(1.0);");
		g("}");
		g("setTerrainHeightForTerrain(\"RiverGrassyB\", 1.0);");
		g("replaceTerrainBelowHeightMin(\"CliffGreekA\", \"RiverGrassyB\", 2.0);");
		g("replaceTerrainBelowHeightMin(\"RiverGrassyB\", \"GaiaCreepBorder\", 0.9);");
		g("smooth(1);");
		g("replaceTerrainAtMinSteepness(\"GaiaCreepBorder\", \"GrassDirt25\", 0.5);");
		g("replaceTerrainAtMinSteepness(\"GaiaCreepBorder\", \"GrassA\", 0.1);");
		g("refreshPassability();");
		g("int beforeTree = trGetNextUnitScenarioNameNumber();");
		g("paintTrees(\"ForestFloorGaia\", \"Pine\");");
		g("unitTransform(\"Pine\", \"Gaia Forest Tree\");");
		g("int afterTree = trGetNextUnitScenarioNameNumber();");
		g("for(i = beforeTree; < afterTree){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+i, true);");
			g("if(randomInt(0, 1) == 0){");
				g("trUnitSetAnimationPath(\"0,0,0,0,0,0,0\");");
			g("} else {");
				g("trUnitSetAnimationPath(\"2,0,0,0,0,0,0\");");
			g("}");
		g("}");
		g("paintUnit(\"ForestFloorGaia\", \"Blowing Leaves\", 0, 0.01);");
		g("int beforeFlowers = trGetNextUnitScenarioNameNumber();");
		g("paintUnit(\"GaiaCreepBorder\", \"GaiaCreepFlowers\", 0, 0.1);");
		g("int afterFlowers = trGetNextUnitScenarioNameNumber();");
		g("for(i = beforeFlowers; < afterFlowers){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+i, true);");
			g("trUnitConvert(randomInt(1, 3));");
			g("float flowerScale = randomFloat(1.0, 4.0);");
			g("trSetSelectedScale(flowerScale, flowerScale, flowerScale);");
		g("}");
		g("sunColor(randomFloat(0.0, 255.0), randomFloat(0.0, 255.0), 0);");
		g("int ambientStrength = randomFloat(150.0, 255.0);");
		g("ambientColor(ambientStrength, ambientStrength, ambientStrength);");
		g("trSetSunPosition(randomFloat(5, 70), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateCharredForest(){");
		g("normalise(\"HadesBuildable2\", 0);");
		g("trCoverTerrainWithWater(16.0, 21.0, \"Aegean Sea\");");
		g("waterMap = true;");
		g("paintMap(\"HadesBuildable2\");");
		g("trPaintWaterColor(vector(0.5, 0.5, 0.5),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("for(i = 0; < 40){");
			g("tempV = randomOutsideCircleLoc(toTiles(0.5), toTiles(0.5), 10.0);");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 12.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), toTiles(randomFloat(0.02, 0.06)), \"HadesBuildable1\", 0.0);");
			g("}");
		g("}");
		g("smooth(2);");
		g("for(i = 0; < 20){");
			g("tempV = randomOutsideCircleLoc(toTiles(0.5), toTiles(0.5), randomFloatWeighted(20.0, 40.0, 2));");
			g("for(j = 0; < 10) {");
				g("tempV2 = randomCircleLoc(xsVectorGetX(tempV), xsVectorGetZ(tempV), 12.0);");
				g("paintCircleHeight(xsVectorGetX(tempV2), xsVectorGetZ(tempV2), ");
						g("toTiles(randomFloat(0.01, 0.03)), \"ForestFloorDeadPine\", 5.0);");
			g("}");
		g("}");
		g("smooth(1);");
		g("replaceTerrainAtMinSteepness(\"ForestFloorPine\", \"HadesCliff\", 1.0);");
		g("replaceTerrainAtMinSteepness(\"HadesBuildable1\", \"HadesCliff\", 1.0);");
		g("replaceTerrainAtMinSteepness(\"HadesBuildable2\", \"HadesCliff\", 1.0);");
		g("replaceTerrainBelowHeightMax(\"HadesCliff\", \"HadesBuildable2\", 0.0);");
		g("for(i = 0; < 17){");
			g("changeGlobalHeight(-1.0);");
			g("changeTerrainHeight(1.0);");
		g("}");
		//Some reason the extra change of height required to make game treat terrain properly as not shallow water
		g("changeGlobalHeight(-0.1);");
		g("changeTerrainHeight(0.1);");
		g("refreshPassability();");
		g("modifyProtounitAbsolute(\"Medusa\", "+a+", 1, 0.0);");
		g("modifyProtounitAbsolute(\"Medusa\", "+a+", 2, 3.0);");
		g("modifyProtounitAbsolute(\"Medusa\", "+a+", 11, 0.0);");
		g("modifyProtounitAbsolute(\"Medusa\", "+a+", 13, 0.0);");
		g("int beforeMedusa = trGetNextUnitScenarioNameNumber();");
		g("paintUnit(\"ForestFloorDeadPine\", \"Medusa\", "+h+", 0.15);");
		g("paintUnit(\"HadesBuildable1\", \"Medusa\", "+h+", 0.02);");
		g("int afterMedusa = trGetNextUnitScenarioNameNumber();");
		g("for(i = beforeMedusa; < afterMedusa){");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+i, true);");
			g("trUnitChangeProtoUnit(\"Ajax\");");
			g("int burningTree = trGetNextUnitScenarioNameNumber() - 1;");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+burningTree, true);");
			g("trUnitChangeProtoUnit(\"Pine Burning\");");
			g("addToTimebaseAnytime(\"BurningTree\", burningTree);");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+i, true);");
			g("trUnitChangeProtoUnit(\"Ajax\");");
			g("trUnitChangeProtoUnit(\"Old Man\");");
			g("trMutateSelected("+getUnitIdFromName("Medusa")+");");
			g("trSetSelectedScale(0.0, 0.0, 0.0);");
			g("addToTimebaseAnytime(\"StoneTreeReal\", i);");
			g("int medusaTarget = trGetNextUnitScenarioNameNumber() - 2;");
			g("trUnitSelectClear();");
			g("trUnitSelect(\"\"+medusaTarget, true);");
			g("trUnitChangeProtoUnit(\"Villager Chinese\");");
			g("trUnitConvert("+c+");");
			g("trSetSelectedScale(0.0, 0.0, 0.0);");
			g("addToTimebaseAnytime(\"StoneTree\", medusaTarget);");
		g("}");
		g("paintUnit(\"ForestFloorDeadPine\", \"Smoke\", 0, 0.01);");
		g("paintUnit(\"HadesBuildable1\", \"Cinematic Rocks\", 0, 0.01);");
		g("sunVector(randomHue());");
		g("int ambientStrength = randomFloat(150.0, 255.0);");
		g("ambientColor(ambientStrength, ambientStrength, ambientStrength);");
		g("trSetSunPosition(randomFloat(30, 60), randomFloat(0.0, 360.0), false);");
	g("}");
	g("void generateShop(){");
		g("normalise(\"CliffJungleA\", 0);");
		g("trCoverTerrainWithWater(8.0, 1.0,\"Aegean Sea\");");
		g("trChangeTerrainHeight(0, 0, "+(getMapSize() / 2)+", "+(getMapSize() / 2)+", -5.0, false);");
		g("waterMap = true;");
		g("paintMap(\"CliffJungleA\");");
		g("trPaintWaterColor(vector(0.0, 0.5, 0.0),0,0,toTiles(1.0)+1,toTiles(1.0)+1);");
		g("if(activePlayers == 1){");
			g("setShopX(0, 0.5); setShopZ(0, 0.5);");
		g("} else if(activePlayers == 2){");
			g("setShopX(0, 0.3); setShopZ(0, 0.3);");
			g("setShopX(1, 0.7); setShopZ(1, 0.7);");
		g("} else if(activePlayers == 3){");
			g("setShopX(0, 0.16); setShopZ(0, 0.16);");
			g("setShopX(1, 0.5); setShopZ(1, 0.5);");
			g("setShopX(2, 0.84); setShopZ(2, 0.84);");
		g("} else if(activePlayers == 4){");
			g("setShopX(0, 0.3); setShopZ(0, 0.3);");
			g("setShopX(1, 0.7); setShopZ(1, 0.3);");
			g("setShopX(2, 0.3); setShopZ(2, 0.7);");
			g("setShopX(3, 0.7); setShopZ(3, 0.7);");
		g("} else if(activePlayers == 5){");
			g("setShopX(0, 0.16); setShopZ(0, 0.16);");
			g("setShopX(1, 0.84); setShopZ(1, 0.16);");
			g("setShopX(2, 0.16); setShopZ(2, 0.84);");
			g("setShopX(3, 0.84); setShopZ(3, 0.84);");
			g("setShopX(4, 0.5); setShopZ(4, 0.5);");
		g("} else if(activePlayers == 6){");
			g("setShopX(0, 0.16); setShopZ(0, 0.3);");
			g("setShopX(1, 0.5); setShopZ(1, 0.16);");
			g("setShopX(2, 0.84); setShopZ(2, 0.3);");
			g("setShopX(3, 0.16); setShopZ(3, 0.7);");
			g("setShopX(4, 0.5); setShopZ(4, 0.84);");
			g("setShopX(5, 0.84); setShopZ(5, 0.7);");
		g("} else if(activePlayers == 7){");
			g("setShopX(0, 0.16); setShopZ(0, 0.3);");
			g("setShopX(1, 0.5); setShopZ(1, 0.16);");
			g("setShopX(2, 0.84); setShopZ(2, 0.3);");
			g("setShopX(3, 0.5); setShopZ(3, 0.5);");
			g("setShopX(4, 0.16); setShopZ(4, 0.7);");
			g("setShopX(5, 0.5); setShopZ(5, 0.84);");
			g("setShopX(6, 0.84); setShopZ(6, 0.7);");
		g("} else if(activePlayers == 8){");
			g("setShopX(0, 0.16); setShopZ(0, 0.16);");
			g("setShopX(1, 0.5); setShopZ(1, 0.16);");
			g("setShopX(2, 0.84); setShopZ(2, 0.16);");
			g("setShopX(3, 0.3); setShopZ(3, 0.5);");
			g("setShopX(4, 0.7); setShopZ(4, 0.5);");
			g("setShopX(5, 0.16); setShopZ(5, 0.84);");
			g("setShopX(6, 0.5); setShopZ(6, 0.84);");
			g("setShopX(7, 0.84); setShopZ(7, 0.84);");
		g("} else if(activePlayers == 9){");
			g("setShopX(0, 0.16); setShopZ(0, 0.16);");
			g("setShopX(1, 0.5); setShopZ(1, 0.16);");
			g("setShopX(2, 0.84); setShopZ(2, 0.16);");
			g("setShopX(3, 0.16); setShopZ(3, 0.5);");
			g("setShopX(4, 0.5); setShopZ(4, 0.5);");
			g("setShopX(5, 0.84); setShopZ(5, 0.5);");
			g("setShopX(6, 0.16); setShopZ(6, 0.84);");
			g("setShopX(7, 0.5); setShopZ(7, 0.84);");
			g("setShopX(8, 0.84); setShopZ(8, 0.84);");
		g("} else if(activePlayers == 10){");
			g("setShopX(0, 0.13); setShopZ(0, 0.13);");
			g("setShopX(1, 0.5); setShopZ(1, 0.13);");
			g("setShopX(2, 0.87); setShopZ(2, 0.13);");
			g("setShopX(3, 0.3); setShopZ(3, 0.38);");
			g("setShopX(4, 0.7); setShopZ(4, 0.38);");
			g("setShopX(5, 0.13); setShopZ(5, 0.62);");
			g("setShopX(6, 0.5); setShopZ(6, 0.62);");
			g("setShopX(7, 0.87); setShopZ(7, 0.62);");
			g("setShopX(8, 0.3); setShopZ(8, 0.87);");
			g("setShopX(9, 0.7); setShopZ(9, 0.87);");
		g("}");
		g("for(i = 0; < activePlayers){");
			g("paintCircleHeight(toTiles(getShopX(i)), toTiles(getShopZ(i)), toTiles(0.20), \"ForestfloorMarsh\", 0.0);");
		g("}");
		g("smooth(1);");
		g("float shopCircleSize = 0.13;");
		g("if(activePlayers < 10){");
			g("shopCircleSize = 0.14;");
		g("}");
		g("for(i = 0; < activePlayers){");
			g("paintCircleHeight(toTiles(getShopX(i)), toTiles(getShopZ(i)), toTiles(shopCircleSize), \"MarshA\", 5.0);");
		g("}");
		g("changeTerrainHeight(5.0);");
		g("changeGlobalHeight(-5.0);");
		g("changeTerrainHeight(5.0);");
		g("smooth(1);");
		g("replaceTerrainAboveHeightMax(\"ForestFloorMarsh\", \"CliffJungleA\", 8.0);");
		g("replaceTerrainAtMinSteepness(\"ForestFloorMarsh\", \"CliffJungleA\", 1.5);");
		g("paintTrees(\"ForestfloorMarsh\", \"Marsh Tree\");");
		g("int index = 0;");
		g("int p = 0;");
		g("for(p = 1; <= "+h+"){");
			g("if(kbIsPlayerResigned(p) == false){");
				g("setShopPlayer(index, p);");
				g("index++;");
			g("}");
		g("}");
		g("int shopItems = passiveCount + abilityCount;");
		g("while(index > 0){");
			g("index--;");
			g("int chosen = randomInt(0, index);");
			g("p = getShopPlayer(chosen);");
			g("setShopPlayer(chosen, getShopPlayer(index));");
			g("setShopOffset(p, trGetNextUnitScenarioNameNumber());");
			g("setShopIndex(p, index);");
			g("deployLocHeading(toMetres(getShopX(index)), toMetres(getShopZ(index)), \"Old man\", p, -135.0);");
			g("float posX = 0.0;");
			g("float posZ = 0.0;");
			g("for(i = 0; < shopItems){");
				g("posX = circleX(toMetres(getShopX(index)), i, shopItems, toMetres(shopCircleSize - 0.01), "+a+");");
				g("posZ = circleZ(toMetres(getShopZ(index)), i, shopItems, toMetres(shopCircleSize - 0.01), "+a+");");
				g("deployLocHeading(posX, posZ, \"Cinematic Block\", "+a+", (1.0 * i) / shopItems * 360.0 - 135.0);");
			g("}");
			g("for(i = 0; < passiveCount){");
				g("trUnitSelectClear();");
				g("trUnitSelect(\"\"+(getShopOffset(p) + 1 + i), true);");
				g("trUnitChangeProtoUnit(passiveUnit(i));");
				g("xsEnableRule(\"_selectPassive\"+i+\"p\"+p+\"\");");
				g("xsEnableRule(\"_buyPassive\"+i+\"p\"+p+\"\");");
			g("}");
			g("for(i = 0; < abilityCount){");
				g("trUnitSelectClear();");
				g("trUnitSelect(\"\"+(getShopOffset(p) + 1 + passiveCount + i), true);");
				g("trUnitChangeProtoUnit(heroUnit(getHeroIndex(p)));");
				g("xsEnableRule(\"_selectAbility\"+i+\"p\"+p+\"\");");
				g("xsEnableRule(\"_buyAbility\"+i+\"p\"+p+\"\");");
				g("if(activePlayers == 10 && i == 4){"); //Correction for 10 players shop item
					g("posX = circleX(toMetres(getShopX(index)), i + passiveCount, shopItems, toMetres(shopCircleSize - 0.01), "+a+");");
					g("posZ = circleZ(toMetres(getShopZ(index)), i + passiveCount, shopItems, toMetres(shopCircleSize - 0.01), "+a+");");
					g("trUnitTeleport(posX, 0.0, posZ);");
				g("}");
			g("}");
			g("deployLoc(toMetres(getShopX(index)), toMetres(getShopZ(index)), \"Revealer\", "+a+");");
		g("}");
		g("refreshPassability();");
		g("for(i = 0; < passiveCount){");
			g("xsEnableRule(\"_selectPassive"+i+"\");");
		g("}");
		g("for(j = 0; < heroCount){");
			g("for(i = 0; < abilityCount){");
				g("xsEnableRule(\"_selectAbility"+j+"i"+i+"\");");
			g("}");
		g("}");
		g("if(aiIsMultiplayer() == false){");
			g("for(p = 1; <= "+h+"){");
				g("xsEnableRule(\"_ChangePlayerOldMan\"+p);");
			g("}");
		g("}");
		g("trUnitSelectClear();");
		g("trUnitSelect(\"0\");");
		g("trMutateSelected("+getUnitIdFromName("Revealer to Player")+");");
		g("hideHeroes();");
		g("trPlayerResetBlackMapForAllPlayers();");
		g("for(p = 1; <= "+h+"){");
			g("trPlayerGrantResources(p, \"Favor\", (round + 3) * 2);");
			g("grantGodPowerNoRechargeNextPosition(p, \"Nidhogg\", 1);");
			g("trPlayerGrantResources(p, \"Gold\", -999999);");
			g("trPlayerGrantResources(p, \"Wood\", -999999);");
		g("}");
		g("grantGodPowerNoRechargeNextPosition(1, \"Audrey\", 1);");
		g("xsEnableRule(\"_everyoneFinishedWithShop\");");
		g("float green = randomFloat(150, 255);");
		g("float red = randomFloat(0, green);");
		g("float blue = randomFloat(0, green);");
		g("sunColor(red, green, blue);");
		g("ambientColor(50, 100, 50);");
		g("trSetSunPosition(randomFloat(10.0, 45), randomFloat(0.0, 360.0));");
		g("inShop = true;");
	g("}");
	g("void generateFinalArena(){");
		g("normalise(\"Black\", -5);");
		g("paintCircleHeight2(toTiles(0.5), toTiles(0.5), toTiles(0.25), \"CoralA\", 15);");
		g("smooth(1);");
		g("replaceTerrainAboveHeightMax(\"Black\", \"CliffGreekA\", -1);");
		g("replaceTerrainBelowHeightMin(\"CoralA\", \"CliffGreekA\", 14.0);");
		g("refreshPassability();");
		g("teleportUnitsToMiddle();");
		g("sunVector(randomHue());");
		g("ambientColor(100, 100, 100);");
		g("trSetSunPosition(56, randomFloat(0.0, 360.0), false);");
	g("}");
	//Music handler
	g("void musicHandler(int id = -1){");
		g("if(id == 2){");
			g("xsEnableRule(\"_nextMusicTrack\");");
		g("}");
	g("}");
	globalEnd();
	
	defineTrigger("t", true, false, true);
	code("trEventSetHandler(2, \"musicHandler\");");
	
	defineTrigger("nextMusicTrack", false, false, false);
	code("if(musicType == 0){");
		//Standard music
		code("trPlayNextMusicTrack();");
	code("} else if(musicType == 1){");
		//Battle music
		code("tempI = aiRandInt(6);");
		code("if(tempI == 0){");
			playMusic("music\fight\i wish i could throw shapes.mp3");
		code("} else if(tempI == 1){");
			playMusic("music\fight\li'l drips.mp3");
		code("} else if(tempI == 2){");
			playMusic("music\fight\meatier shower.mp3");
		code("} else if(tempI == 3){");
			playMusic("music\fight\oi, that pops!!!.mp3");
		code("} else if(tempI == 4){");
			playMusic("music\fight\rot loaf.mp3");
		code("} else if(tempI == 5){");
			playMusic("music\fight\the fire brigade.mp3");
		code("}");
	code("}");
	
	defineTrigger("timerHelper", true, true, false);
	code("if(trTimeMS() >= time250Target){");
		code("time250 = true;");
		code("time250Target = time250Target + 250;");
	code("} else {");
		code("time250 = false;");
	code("}");

	defineTrigger("initialise", true, false, true);
	code("calculateDifficulty();");
	code("trSetObscuredUnits(false);");
	code("trSetDisableGPBlocking(true);");
	code("deployLocHeading(toMetres(0.5), toMetres(0.5), \"Revealer\", 0, 0.0);");
	code("for(p = 1; <= "+h+"){");
		code("deployLocHeading(circleX(toMetres(0.5), p-1, "+h+", toMetres(0.1), 0),",
				" circleZ(toMetres(0.5), p-1, "+h+", toMetres(0.1), 0),",
				" \"Old Man\", p, (1.0 * (p - 1)) / "+h+" * 360.0 - 135.0);");
	code("}");
	for(p = 1; <= h){
		addToDatabaseAnytime("Hero", p);
		addToDatabaseAnytime("Player", p);
		code("setPlayerName("+p+", \""+rmGetPlayerName(p)+"\");");
	}
	code("for(p = 1; <= "+c+"){");
		code("deployLocHeading(circleX(toMetres(0.5), p-1, "+c+", toMetres(0.2), 0),",
				" circleZ(toMetres(0.5), p-1, "+c+", toMetres(0.2), 0),",
				" \"Victory Marker\", p, (1.0 * (p - 1)) / "+c+" * 360.0 - 135.0);");
	code("}");
	code("for(p = 1; <= "+h+"){");
		code("trSetCivAndCulture(p, 9, 3);");
		code("if(trCurrentPlayer()==p)trPlayerSetActive(p);");
		code("for(q = 1; <= "+h+"){");
			code("trPlayerSetDiplomacy(p, q, \"Ally\");");
		code("}");
		code("trPlayerSetDiplomacy(p, "+a+", \"Ally\");");
		code("trPlayerSetDiplomacy("+a+", p, \"Ally\");");
		code("trPlayerSetDiplomacy(p, "+c+", \"Enemy\");");
		code("trPlayerSetDiplomacy("+c+", p, \"Enemy\");");
	code("}");
	code("trSetCivAndCulture("+a+", 0, 0);");
	code("trSetCivAndCulture("+c+", 0, 0);");
	code("trPlayerSetDiplomacy("+a+", "+c+", \"Enemy\");");
	code("trPlayerSetDiplomacy("+c+", "+a+", \"Neutral\");");
	code("aiSet(\"NoAI\", "+a+");");
	code("aiSet(\"NoAI\", "+c+");");
	code("xsSetContextPlayer("+a+");");
	code("aiSetAttackResponseDistance(0.0);");
	code("xsSetContextPlayer("+c+");");
	code("aiSetAttackResponseDistance(1000.0);");
	code("for(i = 0; <= 5){");
		code("setBossVariation(i, randomInt(0, 2));");
	code("}");
	
	defineTrigger("initialiseDelayed", true, false, false);
	code("volatileDestroy = false;");
	code("generateHeroChoose();");
	code("switchToVolatile = true;");
	modifyProtounitAbsolute("Revealer", 0, 0, 999999999.0);
	modifyProtounitAbsolute("Revealer", 0, 2, 999.0);
	modifyProtounitAbsolute("Shrine", 0, 4, 0.0);
	modifyProtounitAbsolute("Guardian XP", 0, 0, 999999999.0);
	modifyProtounitAbsolute("Fire Hades", 0, 0, 999999999.0);
	modifyProtounitAbsolute("Shrine", 0, 4, 0.0);
	modifyProtounitAbsolute("Tartarian gate", c, 55, 4.0);
	modifyProtounitAbsolute("Tartarian gate placement", c, 55, 4.0);
	modifyProtounitAbsolute("Acid Pool", 0, 8, 3.0);
	modifyProtounitAbsolute("Jungle Tree Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Jungle Palm Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Palm Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Savannah Tree Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Pine Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Pine Snow Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Pine Dead Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Marsh Tree Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Oak Tree Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Oak Autumn Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Tundra Tree Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Gaia Forest Tree Burning", 0, 8, 20.0);
	modifyProtounitAbsolute("Jungle Tree", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Jungle Palm", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Palm", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Savannah Tree", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Pine", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Pine Snow", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Pine Dead", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Marsh Tree", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Oak Tree", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Oak Autumn", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Tundra Tree", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Gaia Forest Tree", 0, 0, 1000000.0);
	modifyProtounitAbsolute("Pestilence Sfx1", 0, 55, 2.0);
	modifyProtounitAbsolute("Axeman", 0, 0, 999999999.0);
	modifyProtounitAbsolute("Axeman", 0, 1, 0.0);
	modifyProtounitAbsolute("Axeman", 0, 2, 0.0);
	modifyProtounitAbsolute("Axeman", 0, 24, 0.0);
	modifyProtounitAbsolute("Relic", 0, 0, 999999999.0);
	modifyProtounitAbsolute("Camera Start", 0, 999999999.0);
	modifyProtounitAbsolute("Camera Start", 0, 1, 0.0);
	modifyProtounitAbsolute("Ajax", 0, 999999999.0);
	modifyProtounitAbsolute("Chicken Exploding", 0, 0, 999999999.0);
	modifyProtounitAbsolute("Chicken Exploding", 0, 8, 10.0);
	modifyProtounitAbsolute("Gaia Forest Tree", 0, 21, 200.0);
	modifyProtounitAbsolute("Pine", 0, 21, 150.0);
	modifyProtounitAbsolute("Relic", 0, 0, 999999999999999999.0);
	modifyProtounitAbsolute("Gold Mine Dwarven", 0, 20, 6000.0);
	modifyProtounitAbsolute("Tamarisk Tree", 0, 0, 999999999999999999.0);
	modifyProtounitAbsolute("Inferno Fire Ground", 0, 0, 999999999999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Revealer", 2, 32.0);
	modifyProtounitAbsoluteAllHumanPlayers("Old Man", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Old Man", 2, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Old Man", 1, 10.0);
	modifyProtounitAbsoluteAllHumanPlayers("Arkantos God Out", 8, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tremor", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tremor", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tremor", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Bolt Strike", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Bolt Strike", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Bolt Strike", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Lightning Strike", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Lightning Strike", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Lightning Strike", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Barrage", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Barrage", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Barrage", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Priest Projectile", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Spear", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Arrow Flaming", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Arrow", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Axe", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Fire Lance Projectile", 1, 10.0);
	modifyProtounitAbsoluteAllHumanPlayers("Fire Lance Projectile", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Animal Attractor", 55, 4.0);
	modifyProtounitAbsoluteAllHumanPlayers("Geyser", 8, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Implode Sphere Effect", 8, 2.0);
	modifyProtounitAbsoluteAllHumanPlayers("Forest Fire Attack", 8, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Forest Fire Attack", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Forest Fire Attack", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Forest Fire Attack", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Earth Dragon", 55, 4.0);
	modifyProtounitAbsoluteAllHumanPlayers("Earth Dragon Hole", 55, 4.0);
	modifyProtounitAbsoluteAllHumanPlayers("Catapult Shot", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Meteor", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Meteor", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Meteor", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Mummy Flies", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Manticore Barb", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Lampades Bolt", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Sling Stone", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("SPCMeteor", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("SPCMeteor", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("SPCMeteor", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tornado", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tornado", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tornado", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tsunami", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tsunami", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tsunami", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Inferno Field", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Inferno Field", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Inferno Field", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Flood", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Flood", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Flood", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Ball of Fire", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Ball of Fire Invisible", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Ballista Shot", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Implode", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Implode", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Implode", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Petrobolos Shot", 8, 0.000001);
	modifyProtounitAbsoluteAllHumanPlayers("Tower Mirror", 0, 999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Volcano", 2, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Volcano", 4, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Volcano", 27, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Volcano", 28, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Volcano", 29, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Meteorite", 2, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Animal Attractor", 0, 999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Nereid", 55, 3.0);
	modifyProtounitAbsoluteAllHumanPlayers("Servant", 55, 3.0);
	modifyProtounitAbsoluteAllHumanPlayers("Carcinos", 55, 3.0);
	modifyProtounitAbsoluteAllHumanPlayers("Jormund Elver", 55, 3.0);
	modifyProtounitAbsoluteAllHumanPlayers("Scylla", 55, 3.0);
	modifyProtounitAbsoluteAllHumanPlayers("Pirate Ship", 8, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Pirate Ship", 55, 3.0);
	modifyProtounitAbsoluteAllHumanPlayers("Kraken", 55, 3.0);
	modifyProtounitAbsoluteAllHumanPlayers("Guild", 16, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Guild", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tower", 16, 50.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tower", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tower", 10, 9999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Wall Connector", 16, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Wall Short", 16, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Wall Medium", 16, 10.0);
	modifyProtounitAbsoluteAllHumanPlayers("Wall Long", 16, 15.0);
	modifyProtounitAbsoluteAllHumanPlayers("Gate", 16, 25.0);
	modifyProtounitAbsoluteAllHumanPlayers("Sky passage", 16, 100.0);
	modifyProtounitAbsoluteAllHumanPlayers("Sky passage", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Sky passage", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Temple", 5, 999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Temple", 16, 150.0);
	modifyProtounitAbsoluteAllHumanPlayers("Temple", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Temple", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Sky passage", 10, 9999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Farm", 16, 100.0);
	modifyProtounitAbsoluteAllHumanPlayers("Farm", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Farm", 55, 4.0);
	modifyProtounitAbsoluteAllHumanPlayers("Manor", 16, 150.0);
	modifyProtounitAbsoluteAllHumanPlayers("Manor", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Manor", 55, 4.0);
	modifyProtounitAbsoluteAllHumanPlayers("Dock", 16, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Dock", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Bireme", 6, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Bireme", 16, 50.0);
	modifyProtounitAbsoluteAllHumanPlayers("Bireme", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Armory", 16, 100.0);
	modifyProtounitAbsoluteAllHumanPlayers("Armory", 17, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Reginleif", 14, 200.0);
	modifyProtounitAbsoluteAllHumanPlayers("Reginleif", 15, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Setna", 14, 200.0);
	modifyProtounitAbsoluteAllHumanPlayers("Setna", 15, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Pharaoh", 14, 200.0);
	modifyProtounitAbsoluteAllHumanPlayers("Pharaoh", 15, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Flying Medic", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Flying Medic", 14, 200.0);
	modifyProtounitAbsoluteAllHumanPlayers("Flying Medic", 15, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Zhi", 14, 200.0);
	modifyProtounitAbsoluteAllHumanPlayers("Zhi", 15, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Priest", 14, 200.0);
	modifyProtounitAbsoluteAllHumanPlayers("Priest", 15, 5.0);
	modifyProtounitAbsoluteAllHumanPlayers("Obelisk", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tartarian Gate", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tower", 12, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Nidhogg", 2, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Geyser", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Excavation", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Vision Revealer", 2, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("TimberHarvest", 8, 1.0);
	modifyProtounitAbsoluteAllHumanPlayers("Increase Prosperity Large", 8, 1.0);
	modifyProtounitAbsoluteAllHumanPlayers("Archer Atlantean Hero", 13, 2.0);
	modifyProtounitAbsoluteAllHumanPlayers("Archer Atlantean", 13, 2.0);
	modifyProtounitAbsoluteAllHumanPlayers("Obelisk", 4, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Audrey", 8, 60.0);
	modifyProtounitAbsoluteAllHumanPlayers("Dryad", 8, 60.0);
	modifyProtounitAbsoluteAllHumanPlayers("Phoenix Egg", 55, 4.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tunnel", 0, 10000.0);
	modifyProtounitAbsoluteAllHumanPlayers("Sentinel Main", 2, 15.0);
	modifyProtounitAbsoluteAllHumanPlayers("Sentinel Main", 11, 10.0);
	modifyProtounitAbsoluteAllHumanPlayers("Sentinel Main", 8, 60.0);
	modifyProtounitAbsoluteAllHumanPlayers("Imperial Examination", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Well of Urd", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Victory Marker", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Camera Start", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Camera Start", 1, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Roc", 0, 999999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Roc", 5, 999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Ape of Set", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Gazelle of Set", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Hyena of Set", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Crocodile of Set", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Giraffe of Set", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Hippo of Set", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Rhinoceros of Set", 19, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Ape of Set", 6, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Gazelle of Set", 6, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Hyena of Set", 6, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Crocodile of Set", 6, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Giraffe of Set", 6, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Hippo of Set", 6, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Rhinoceros of Set", 6, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Pharaoh", 7, 999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Eitri", 20, 999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Dwarf", 20, 999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Eitri", 21, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Dwarf", 21, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Atlantis Wall Connector", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Relic", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Harpy", 0, 999999999);
	modifyProtounitAbsoluteAllHumanPlayers("Harpy", 1, 3);
	modifyProtounitAbsoluteAllHumanPlayers("Eagle", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Eagle", 1, 3);
	modifyProtounitAbsoluteAllHumanPlayers("Earth Dragon", 8, 0);
	modifyProtounitAbsoluteAllHumanPlayers("Earth Dragon Hole", 8, 0);
	modifyProtounitAbsoluteAllHumanPlayers("Kronny Flying", 0, 0);
	modifyProtounitAbsoluteAllHumanPlayers("Ajax", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Osiris", 0, 1.0);
	modifyProtounitAbsoluteAllHumanPlayers("Osiris", 8, 10.0);
	modifyProtounitAbsoluteAllHumanPlayers("Osiris", 24, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Osiris", 25, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Osiris", 26, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Meteor Impact Ground", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Acid Pool", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Runestone", 0, 999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Relic", 0, 999999999999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Inferno Fire Ground", 0, 999999999999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Kronny Birth", 0, 999999999999999999.0);
	modifyProtounitAbsoluteAllHumanPlayers("Titan Atlantean", 55, 4.0);
	modifyProtounitAbsoluteAllHumanPlayers("Fimbulwinter Wolf", 22, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Ape of Set", 22, 0.0);
	modifyProtounitAbsoluteAllHumanPlayers("Tamarisk Tree", 0, 999999999999999999.0);
	modifyProtounitAbsolute("Egyptian Vulture", a, 1, 10.0);
	modifyProtounitAbsolute("Egyptian Vulture", a, 55, 1.0);
	code("for(i = 0; < passiveCount){");
		code("modifyProtounitAbsolute(passiveUnit(i), "+a+", 0, 999999999.0);");
	code("}");
	modifyProtounitAbsolute("Atlantis Wall Connector", a, 4, 0.0);
	modifyProtounitAbsolute("Atlantis Wall Long", a, 4, 0.0);
	modifyProtounitAbsolute("Fountain", a, 4, 0.0);
	modifyProtounitAbsolute("Barracks", a, 4, 0.0);
	modifyProtounitAbsolute("Temple", a, 4, 0.0);
	modifyProtounitAbsolute("Lumber Camp", a, 4, 0.0);
	modifyProtounitAbsolute("Granary", a, 4, 0.0);
	modifyProtounitAbsolute("House", a, 4, 0.0);
	modifyProtounitAbsolute("Statue Pharaoh", a, 4, 0.0);
	modifyProtounitAbsolute("Longhouse", a, 4, 0.0);
	modifyProtounitAbsolute("Tent", a, 4, 0.0);
	modifyProtounitAbsolute("Camera Start", a, 0, 999999999.0);
	modifyProtounitAbsolute("Camera Start", a, 1, 0.0);
	modifyProtounitAbsolute("Roc", a, 5, 1000.0);
	modifyProtounitAbsolute("Ajax", a, 0, 999999999.0);
	modifyProtounitAbsolute("Flying Medic", a, 1, 0.0);
	modifyProtounitAbsolute("Roc Tent", a, 0, 999999999.0);
	modifyProtounitAbsolute("Roc Tent", a, 4, 0.0);
	modifyProtounitAbsolute("Camera Start", c, 0, 999999999.0);
	modifyProtounitAbsolute("Camera Start", c, 1, 0.0);
	modifyProtounitAbsolute("Villager Chinese", c, 0, 999999999.0);
	modifyProtounitAbsolute("Villager Chinese", c, 1, 0.0);
	modifyProtounitAbsolute("Oar Footprint", c, 55, 4.0);
	modifyProtounitAbsolute("Palace", c, 4, 1.0);
	modifyProtounitAbsolute("Palace", c, 8, 20.0);
	modifyProtounitAbsolute("Palace", c, 55, 4.0);
	code("for(i = 0; < heroCount){");
		code("modifyProtounitAbsolute(heroUnit(i), "+a+", 0, 999999999.0);");
	code("}");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"0\");");
	code("trDamageUnitPercent(-100.0);");
	code("for(p = 1; <= "+h+"){");
		code("trPlayerGrantResources(p, \"gold\", -10000000.0);");
		code("trPlayerGrantResources(p, \"food\", -10000000.0);");
		code("trPlayerGrantResources(p, \"wood\", -10000000.0);");
		code("trPlayerGrantResources(p, \"favor\", -10000000.0);");
		code("trTechSetStatus(p, 0, 4);");
		code("trTechSetStatus(p, 1, 4);");
		code("trTechSetStatus(p, 2, 4);");
		code("trTechSetStatus(p, 116, 4);");
		code("trTechSetStatus(p, 27, 4);");
		code("trTechSetStatus(p, 28, 0);");
		code("trTechSetStatus(p, 29, 0);");
		code("trTechSetStatus(p, 30, 0);");
		code("trTechSetStatus(p, 350, 4);");
		code("trTechSetStatus(p, 126, 0);");
		code("trTechSetStatus(p, 140, 0);");
		code("trTechSetStatus(p, 127, 0);");
		code("trTechSetStatus(p, 446, 0);");
		code("trTechSetStatus(p, 304, 0);");
		code("trTechSetStatus(p, 101, 0);");
		code("trTechSetStatus(p, 9, 0);");
		code("trTechSetStatus(p, 34, 0);");
		code("trTechSetStatus(p, 35, 0);");
		code("trTechSetStatus(p, 10, 0);");
		code("trTechSetStatus(p, 446, 4);");
		code("trTechSetStatus(p, 446, 4);");
		code("trTechSetStatus(p, 245, 0);");
		code("trTechSetStatus(p, 65, 0);");
		code("trTechSetStatus(p, 66, 0);");
		code("trTechSetStatus(p, 270, 0);");
		code("trTechSetStatus(p, 448, 0);");
		code("trTechSetStatus(p, 269, 0);");
		code("trTechSetStatus(p, 415, 0);");
		code("trTechSetStatus(p, 12, 0);");
		code("trTechSetStatus(p, 15, 0);");
		code("trTechSetStatus(p, 18, 0);");
		code("trTechSetStatus(p, 32, 0);");
		code("trForbidProtounit(p, \"Settlement Level 1\");");
		code("trForbidProtounit(p, \"Dock\");");
		code("trForbidProtounit(p, \"Farm\");");
		code("trForbidProtounit(p, \"Manor\");");
		code("trForbidProtounit(p, \"Wonder\");");
		code("trForbidProtounit(p, \"Temple\");");
		code("trForbidProtounit(p, \"Oracle Scout\");");
		code("trForbidProtounit(p, \"Tower\");");
		code("trForbidProtounit(p, \"Wall Connector\");");
		code("trForbidProtounit(p, \"Ulfsark\");");
		code("trForbidProtounit(p, \"Fishing Ship Atlantean\");");
		code("trForbidProtounit(p, \"Archer Atlantean Hero\");");
		code("trUnforbidProtounit(p, \"Guild\");");
		code("trUnforbidProtounit(p, \"Sky Passage\");");
	code("}");
	code("trTechSetStatus("+c+", 27, 4);");
	code("gadgetUnreal(\"tributedlg-sendButton\");");
	code("gadgetUnreal(\"tributedlg-clearButton\");");
	
	for(i = 0; < heroCount){
		defineTrigger("selectHero"+i, true, true, false);
		con("unitSelected(heroOffset+"+i+")");
		code("uiClearSelection();");
		code("modeEnter(\"pregame\");");
		code("trLetterBox(true);");
		code("modeEnter(\"simulation\");");
		code("trSoundPlayFN(\"\",\"1\",-1,heroName("+i+")+\":\"+heroDescription("+i+"),\"\"+heroIcon("+i+"));");
		code("xsEnableRule(\"_endHeroDescription\");");
		code("createCameraTrack(4000);");
		code("cameraLookAt(kbGetBlockPosition(\"\"+(heroOffset+"+i+")), 30.0, (1.0 * "+i+") / heroCount * -360.0 + 30.0, 30.0);");
		code("addCameraTrackWaypoint();");
		code("cameraLookAt(kbGetBlockPosition(\"\"+(heroOffset+"+i+")), 50.0, (1.0 * "+i+") / heroCount * -360.0 + 60.0, 30.0);");
		code("addCameraTrackWaypoint();");
		code("cameraLookAt(kbGetBlockPosition(\"\"+(heroOffset+"+i+")), 30.0, (1.0 * "+i+") / heroCount * -360.0 + 30.0, 30.0);");
		code("playCameraTrack();");
	}
	
	defineTrigger("initialiseDelayed1", true, false, false);
	con("(trTime()-cActivationTime) >= 1");
	code("for(p = 1; <= "+h+"){");
		code("trPlayerModifyLOS(p, false, "+a+");");
		code("trPlayerModifyLOS(p, false, "+c+");");
	code("}");
	
	defineTrigger("otherFastLoops", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("trModifyProtounit(\"Audrey\", p, 9, 1.0);");
	code("}");
	code("allowDebris = true;");
	
	defineTrigger("fadeOutMusic", true, true, false);
	con("musicType != 0");
	code("trFadeOutMusic(0.0);");
	
	defineTrigger("purgeDeadVolatileEntries", true, true, false);
	con("(trTime()-cActivationTime) >= 30");
	databaseSearchStart("VolatileDestroy");
	databaseSearchEnd();
	databaseSearchStart("Summon");
	databaseSearchEnd();
	
	defineTrigger("GuildIncome", true, true, false);
	con("(trTime()-cActivationTime) >= 1");
	code("for(p = 1; <= "+h+"){");
		code("trPlayerGrantResources(p, \"Gold\", trPlayerUnitCountSpecific(p, \"Guild\"));");
		code("trPlayerGrantResources(p, \"Gold\", 2.0 * trPlayerUnitCountSpecific(p, \"Dock\"));");
	code("}");
	
	defineTrigger("endHeroDescription", false, false, false);
	con("(trTime()-cActivationTime) >= 4");
	code("trLetterBox(false);");
	code("createCameraTrack(1);");
	code("cameraLookAt(kbGetBlockPosition(\"\"+trCurrentPlayer()), 120, 45.0, 45.0);");
	code("addCameraTrackWaypoint();");
	code("addCameraTrackWaypoint();");
	code("playCameraTrack();");
	
	for(p = 1; <= h){
		int randomHero = rmRandInt(0, heroCount - 1);
		for(i = 0; < heroCount){
			defineTrigger("pickHero"+i+"p"+p, true, false, false);
			con("heroNearby("+p+", 5.0, heroOffset+"+i+") || (heroDead("+p+") && "+i+" == "+randomHero+")");
			con("getHeroIndex("+p+") == -1");
			code("setHeroIndex("+p+", "+i+");");
			code("applyStartingStats("+p+");");
			code("applyHealth("+p+");");
			code("applyAttack("+p+");");
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+p+"\");");
			code("trUnitChangeProtoUnit(\"Argus\");");
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+p+"\");");
			code("trDamageUnitPercent(-100.0);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+p+"\");");
			code("trUnitChangeProtoUnit(heroUnit("+i+"));");
			code("trChatSendSpoofed("+p+", heroName("+i+") + \" chosen\");");
			code("heroesChosen = heroesChosen + 1;");
			code("drawStats();");
			if(i == 0){
				code("trUnforbidProtounit("+p+", \"Wall Connector\");");
				code("trUnforbidProtounit("+p+", \"Tower\");");
			}
			if(i == 15){
				code("trUnforbidProtounit("+p+", \"Farm\");");
			}
		}
	}
	
	defineTrigger("allChosen", true, false, false);
	con("heroesChosen == "+h);
	code("for(i = 0; < heroCount){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+(i+heroOffset));");
		code("trUnitChangeProtoUnit(\"Arkantos God Out\");");
	code("}");
	code("trLetterBox(false);");
	code("createCameraTrack(1);");
	code("cameraLookAt(kbGetBlockPosition(\"\"+trCurrentPlayer()), 120, 45.0, 45.0);");
	code("addCameraTrackWaypoint();");
	code("addCameraTrackWaypoint();");
	code("playCameraTrack();");
	code("xsDisableRule(\"_endHeroDescription\");");
	code("xsEnableRule(\"_shopIntro2\");");
	code("xsEnableRule(\"_shopIntro7\");");
	code("xsEnableRule(\"_shopIntro12\");");
	code("xsEnableRule(\"_shopIntro17\");");
	
	for(p = 1; <= h){
		defineTrigger("die"+p, true, true, false);
		con("heroDead("+p+") || (kbIsPlayerResigned("+p+") && kbGetUnitBaseTypeID("+p+") != "+getUnitIdFromName("Victory Marker")+")");
		code("int spyIndex = getSpyEye0("+p+");");
		code("if(spyIndex >= 0){");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+spyIndex, true);");
			code("trUnitDestroy();");
		code("}");
		code("setSpyEye0("+p+", -1);");
		code("spyIndex = getSpyEye1("+p+");");
		code("if(spyIndex >= 0){");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+spyIndex, true);");
			code("trUnitDestroy();");
		code("}");
		code("setSpyEye1("+p+", -1);");
		code("int markerCount = 0;");
		databaseSearchStart("CollectGold");
		code("if(getOwner(trQuestVarGet(\"ySearchUnit\")) == "+p+"){");
			code("trUnitChangeProtoUnit(\"Hero Death\");");
			removeFromDatabase("CollectGold");
		code("}");
		databaseSearchEnd();
		databaseSearchStart("DeathMarker");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner == "+p+"){");
			code("markerCount = markerCount + 1;");
			code("if(markerCount == 1){");
				code("trUnitChangeProtoUnit(\"Roc\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\""+p+"\");");
				code("trUnitChangeProtoUnit(\"Argus\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\""+p+"\");");
				code("trDamageUnitPercent(-10.0);");
				code("trImmediateUnitGarrison(\"\"+(1*trQuestVarGet(\"ySearchUnit\")));");
				code("trUnitSelectClear();");
				code("trUnitSelect(\""+p+"\");");
				code("trUnitChangeProtoUnit(heroUnit(getHeroIndex("+p+")));");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
				code("trUnitChangeProtoUnit(\"Recreation\");");
				code("if("+p+" == trCurrentPlayer()){");
					code("trSoundPlayPaused(\"xpack\xcinematics\12_b\staffdrop.mp3\",\"-1\",-1,\"\",\"\");");
				code("}");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+owner);");
				code("trTechInvokeGodPower(0, \"Spy\");");
				code("trTechInvokeGodPower(0, \"Spy\");");
				code("if(trCurrentPlayer() == "+p+"){");
					code("trBlockAllSounds(false);");
					code("uiFindType(heroUnit(getHeroIndex("+p+")));");
					code("trUnblockAllSounds();");
				code("}");
				code("setMarkerCount("+p+", getMarkerCount("+p+") - 1);");
				removeFromDatabase("DeathMarker");
			code("}");
		code("}");
		databaseSearchEnd();
		code("if(markerCount <= 0){");
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+p+"\");");
			code("trUnitChangeProtoUnit(\"Argus\");");
			code("trUnitSelectClear();");
			code("trUnitSelect(\""+p+"\");");
			code("trDamageUnitPercent(-100.0);");
			code("if(kbIsPlayerResigned("+p+") == false){");
				code("trUnitChangeProtoUnit(\"Obelisk\");");
			code("} else {");
				code("trUnitChangeProtoUnit(\"Victory Marker\");");
			code("}");
			code("if(getDead("+p+") == false){");
				code("setDead("+p+", true);");
				code("dead = dead + 1;");
				code("trPlayerKillAllGodPowers("+p+");");
				code("if(kbIsPlayerResigned("+p+") == false){");
					code("if(kbGetUnitBaseTypeID(kbGetBlockID(\""+p+"\")) < 0){");
						code("trChatSendSpoofed("+p+", \"<color={playercolor("+p+")}>{playername("+p+")} has fallen off map</color>\");");
						code("trChatSendSpoofed("+p+", \"<color={playercolor("+p+")}>Secret god mode activated!</color>\");");
						code("trSoundPlayPaused(\"xpack\xcinematics\12_b\arkantosarrive.mp3\",\"-1\",-1,\"\",\"\");");
						code("grantGodPowerNoRechargeNextPosition("+p+", \"Tremor\", 10);");
						code("grantGodPowerNoRechargeNextPosition("+p+", \"Restoration\", 10);");
						code("grantGodPowerNoRechargeNextPosition("+p+", \"Gaia Forest SPC\", 5);");
						code("grantGodPowerNoRechargeNextPosition("+p+", \"Underworld Passage\", 4);");
					code("} else {");
						code("trChatSendSpoofed("+p+", \"<color={playercolor("+p+")}>{playername("+p+")} has fallen!</color>\");");
						code("trSoundPlayPaused(\"dialog\en\skul062.mp3\",\"-1\",-1,\"\",\"\");");
						code("if(getFirstDeath("+p+") == true){");
							code("setFirstDeath("+p+", false);");
							code("if(trCurrentPlayer() == "+p+" && kbIsPlayerResigned("+p+") == false){");
								code("trMessageSetText(\"You have died! - If remaining players survive the round you will be revived!\", 10000);");
							code("}");
						code("}");
					code("}");
				code("}");
			code("}");
		code("}");
	}
	
	defineTrigger("lose", true, false, false);
	con("dead >= "+h);
	code("trSoundPlayPaused(\"cinematics\15_in\gong.wav\",\"1\",-1,\"\",\"\");");
	code("trSoundPlayPaused(\"xpack\xdialog\ko\xkri075.mp3\",\"1\",-1,\"\",\"\");");
	code("for(p = 1; <= "+h+"){");
		code("trSetPlayerDefeated(p);");
	code("}");
	code("trShowWinLose(\"All players have fallen!\", \"\");");
	playMusic("cinematics\9_out\music.mp3");
	code("trEndGame();");
	
	for(p = 1; <= h){
		defineTrigger("levelUp"+p, true, true, false);
		con("getKills("+p+") >= getKillTarget("+p+")");
		code("setLevel("+p+", getLevel("+p+") + 1);");
		code("trPlayerGrantResources("+p+", \"Favor\", 2);");
		code("trChatSendSpoofed("+p+", \"\"+getKillTarget("+p+")+\" kills: Stats up and +2 favour\");");
		code("setHealthMultiplier("+p+", getHealthMultiplier("+p+") + 0.1);");
		code("applyHealth("+p+");");
		code("setAttackMultiplier("+p+", getAttackMultiplier("+p+") + 0.1);");
		code("applyAttack("+p+");");
		code("setKillIncrease("+p+", getKillIncrease("+p+") + "+killIncrease+");");
		code("setKillTarget("+p+", getKillTarget("+p+") + getKillIncrease("+p+"));");
		code("drawStats();");
	}
	
	for(p = 1; <= h){
		defineTrigger("resign"+p, true, false, false);
		con("kbIsPlayerResigned("+p+")");
		code("activePlayers = activePlayers - 1;");
		code("trChatSend(0, \"<color=1,0.5,0>Player resigned: </color> Future round difficulty adjusted\");");
		code("calculateDifficulty();");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"0\");");
		code("trUnitChangeInArea("+p+", "+p+", \"Old Man\", \"Fimbulwinter Sfx\", 999.0);");
		code("if(getHeroIndex("+p+") < 0)heroesChosen = heroesChosen + 1;");
	}
	
	defineTrigger("countUpKillsAndDisplay", true, true, false);
	code("for(p = 1; <= "+h+"){");
		code("int diff = trGetStatValue(p, 2) + trGetStatValue(p, 3) - getStatKills(p);");
		code("setStatKills(p, getStatKills(p) + diff);");
		code("setKills(p, getKills(p) + diff);");
		code("trSetCivilizationNameOverride(p, \"\"+getKills(p)+\"/\"+getKillTarget(p));");
	code("}");
	code("gadgetRefresh(\"unitStatPanel\");");
	
	for(i = 0; < passiveCount){
		for(p = 1; <= h){
			defineTrigger("selectPassive"+i+"p"+p, false, true, false);
			con("unitSelected(getShopOffset("+p+") + 1 + "+i+", true)");
			code("uiClearSelection();");
			code("trMessageSetText(passiveName("+i+") + \" - Cost \" + passiveCost("+i+") + \" favour\", 5000);");
			
			defineTrigger("buyPassive"+i+"p"+p, false, true, false);
			con("(trTime()-cActivationTime) >= 3");
			con("shopOldManNear(getShopOffset("+p+"), 3.0, getShopOffset("+p+") + 1 + "+i+")");
			con("trPlayerResourceCount("+p+", \"Favor\") >= passiveCost("+i+")");
			code("trPlayerGrantResources("+p+", \"Favor\", 0.0 - passiveCost("+i+"));");
			code("trChatSendToPlayer(0, "+p+", \"<color=1,0,0>PURCHASED:</color> \" + passiveName("+i+"));");
			if(i == 0){
				code("setHealthMultiplier("+p+", getHealthMultiplier("+p+") + 0.2);");
				code("applyHealth("+p+");");
				code("drawStats();");
			} else if(i == 1){
				code("setAttackMultiplier("+p+", getAttackMultiplier("+p+") + 0.2);");
				code("applyAttack("+p+");");
				code("drawStats();");
			} else if(i == 2){
				code("trModifyProtounit(heroUnit(getHeroIndex("+p+")), "+p+", 1, 0.5);");
				code("for(i = 0; < playerUnitCount){");
					code("trModifyProtounit(unitList(i), "+p+", 1, 0.5);");
				code("}");
				code("drawStats();");
			}
			code("if(trPlayerResourceCount("+p+", \"Favor\") <= 0){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"0\");");
				code("trUnitChangeInArea("+p+", "+p+", \"Old Man\", \"Fimbulwinter Sfx\", 999.0);");
				code("grantGodPowerNoRechargeNextPosition("+p+", \"Nidhogg\", -1);");
			code("}");
		}
	}
	
	for(i = 0; < abilityCount){
		for(p = 1; <= h){
			defineTrigger("selectAbility"+i+"p"+p, false, true, false);
			con("unitSelected(getShopOffset("+p+") + 1 + passiveCount + "+i+", true)");
			code("uiClearSelection();");
			code("trMessageSetText(abilityName(getHeroIndex("+p+"), "+i+") ",
					"+ \" - Cost \" + abilityCost(getHeroIndex("+p+"), "+i+") + \" favour\", 5000);");
		
			defineTrigger("buyAbility"+i+"p"+p, false, true, false);
			con("(trTime()-cActivationTime) >= 3");
			con("shopOldManNear(getShopOffset("+p+"), 3.0, getShopOffset("+p+") + passiveCount + 1 + "+i+")");
			con("trPlayerResourceCount("+p+", \"Favor\") >= abilityCost("+j+", "+i+")");
			code("trPlayerGrantResources("+p+", \"Favor\", 0.0 - abilityCost(getHeroIndex("+p+"), "+i+"));");
			code("trChatSendToPlayer(0, "+p+", \"<color=1,0,0>PURCHASED:</color> \" + abilityName(getHeroIndex("+p+"), "+i+"));");
			code("if(getHeroIndex("+p+") == 0){");
				if(i == 0){
					code("setBuilderGuildLimit("+p+", getBuilderGuildLimit("+p+") + 1);");
					code("modifyProtounitAbsolute(\"Guild\", "+p+", 10, getBuilderGuildLimit("+p+"));");
				} else if(i == 1){
					code("setBuilderRange("+p+", getBuilderRange("+p+") + 2);");
					code("modifyProtounitAbsolute(\"Tower\", "+p+", 2, getBuilderRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Tower\", "+p+", 11, getBuilderRange("+p+"));");
					code("modifyProtounitAbsolute(\"Bireme\", "+p+", 2, getBuilderRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Bireme\", "+p+", 11, getBuilderRange("+p+"));");
				} else if(i == 2){
					code("setBuilderProjectiles("+p+", getBuilderProjectiles("+p+") + 1);");
					code("modifyProtounitAbsolute(\"Tower\", "+p+", 13, getBuilderProjectiles("+p+"));");
					code("modifyProtounitAbsolute(\"Bireme\", "+p+", 13, getBuilderProjectiles("+p+"));");
				} else if(i == 3){
					code("if(getBuilderTempleUnlocked("+p+") == false){");
						code("setBuilderTempleUnlocked("+p+", true);");
						code("trUnforbidProtounit("+p+", \"Temple\");");
					code("} else {");
						code("setBuilderHealSpeed("+p+", getBuilderHealSpeed("+p+") + 1);");
					code("}");
				} else if(i == 4){
					code("if(getBuilderMineUnlocked("+p+") == false){");
						code("setBuilderMineUnlocked("+p+", true);");
						code("trUnforbidProtounit("+p+", \"Manor\");");
					code("} else {");
						code("setBuilderMineBlastMultiplier("+p+", getBuilderMineBlastMultiplier("+p+") + 1);");
					code("}");
				} else if(i == 5){
					code("if(getBuilderMagicHazeUnlocked("+p+") == false){");
						code("setBuilderMagicHazeUnlocked("+p+", true);");
						code("trUnforbidProtounit("+p+", \"Farm\");");
					code("} else {");
						code("setBuilderMagicHazeLifespan("+p+", getBuilderMagicHazeLifespan("+p+") + 10);");
					code("}");
				} else if(i == 6){
					code("if(getBuilderDockUnlocked("+p+") == false){");
						code("setBuilderDockUnlocked("+p+", true);");
						code("trUnforbidProtounit("+p+", \"Dock\");");
						code("trUnforbidProtounit("+p+", \"Bireme\");");
					code("} else {");
						code("setBuilderDockLimit("+p+", getBuilderDockLimit("+p+") + 1);");
						code("modifyProtounitAbsolute(\"Dock\", "+p+", 10, getBuilderDockLimit("+p+"));");
					code("}");
				} else if(i == 7){
					code("if(getBuilderArmoryUnlocked("+p+") == false){");
						code("setBuilderArmoryUnlocked("+p+", true);");
						code("trUnforbidProtounit("+p+", \"Armory\");");
					code("} else {");
						code("setBuilderArmoryFood("+p+", getBuilderArmoryFood("+p+") + 1);");
					code("}");
				}
			code("} else if(getHeroIndex("+p+") == 1){");
				if(i == 0){
					code("setPaladinJumpDamageMultiplier("+p+", getPaladinJumpDamageMultiplier("+p+") + 1);");
				} else if(i == 1){
					code("setPaladinRechargeTime("+p+", getPaladinRechargeTime("+p+") * 0.75);");
					code("setPaladinRechargeReduction("+p+", getPaladinRechargeReduction("+p+") + 1);");
					code("modifyProtounitAbsolute(\"Hero Greek Bellerophon\", "+p+", 9, getPaladinRechargeTime("+p+"));");
				} else if(i == 2){
					code("setPaladinReviveChance("+p+", getPaladinReviveChance("+p+") + 10);");
				} else if(i == 3){
					code("setPaladinDeathTeleportCount("+p+", getPaladinDeathTeleportCount("+p+") + 1);");
				} else if(i == 4){
					code("if(getPaladinReviveUnlocked("+p+") == false){");
						code("setPaladinReviveUnlocked("+p+", true);");
					code("} else {");
						code("setPaladinReviveTime("+p+", getPaladinReviveTime("+p+") + 30);");
						code("setPaladinReviveCount("+p+", getPaladinReviveCount("+p+") + 1);");
					code("}");
				} else if(i == 5){
					code("setPaladinHealCount("+p+", getPaladinHealCount("+p+") + 1);");
				} else if(i == 6){
					code("setPaladinTrampleDamagePercent("+p+", getPaladinTrampleDamagePercent("+p+") + 20);");
				} else if(i == 7){
					code("setPaladinTeleportCount("+p+", getPaladinTeleportCount("+p+") + 1);");
				}
			code("} else if(getHeroIndex("+p+") == 2){");
				if(i == 0){
					code("setSummonerLifespan("+p+", getSummonerLifespan("+p+") + 20.0);");
					code("modifyProtounitAbsolute(\"Minotaur\", "+p+", 8, getSummonerLifespan("+p+"));");
					code("modifyProtounitAbsolute(\"Wadjet\", "+p+", 8, getSummonerLifespan("+p+"));");
					code("modifyProtounitAbsolute(\"Stymphalian Bird\", "+p+", 8, getSummonerLifespan("+p+"));");
				} else if(i == 1){
					code("setSummonerRange("+p+", getSummonerRange("+p+") + 2);");
					code("modifyProtounitAbsolute(\"Hero Greek Chiron\", "+p+", 2, getSummonerRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Hero Greek Chiron\", "+p+", 11, getSummonerRange("+p+"));");
					code("modifyProtounitAbsolute(\"Wadjet\", "+p+", 2, getSummonerRange("+p+") + losRangeOffset - minionRangePenalty);");
					code("modifyProtounitAbsolute(\"Wadjet\", "+p+", 11, getSummonerRange("+p+") - minionRangePenalty);");
					code("modifyProtounitAbsolute(\"Stymphalian Bird\", "+p+", 2, getSummonerRange("+p+") + losRangeOffset - minionRangePenalty);");
					code("modifyProtounitAbsolute(\"Stymphalian Bird\", "+p+", 11, getSummonerRange("+p+") - minionRangePenalty);");
				} else if(i == 2){
					code("setSummonerCallToArmsChance("+p+", getSummonerCallToArmsChance("+p+") + 3);");
				} else if(i == 3){
					code("setSummonerMinotaur("+p+", getSummonerMinotaur("+p+") + 2);");
				} else if(i == 4){
					code("setSummonerWadjet("+p+", getSummonerWadjet("+p+") + 2);");
				} else if(i == 5){
					code("setSummonerBird("+p+", getSummonerBird("+p+") + 2);");
				} else if(i == 6){
					code("setSummonerHealCount("+p+", getSummonerHealCount("+p+") + 1);");
				} else if(i == 7){
					code("if(getSummonerChangeUnlocked("+p+") == false){");
						code("setSummonerChangeUnlocked("+p+", true);");
					code("} else {");
						code("setSummonerChangeBonus("+p+", getSummonerChangeBonus("+p+") + 2);");
					code("}");
				}
			code("} else if(getHeroIndex("+p+") == 3){");
				if(i == 0){
					code("setAmazonPoisonChance("+p+", getAmazonPoisonChance("+p+") + 10);");
				} else if(i == 1){
					code("setAmazonCarnivoraChance("+p+", getAmazonCarnivoraChance("+p+") + 2);");
				} else if(i == 2){
					code("setAmazonOvergrowCount("+p+", getAmazonOvergrowCount("+p+") + 1);");
				} else if(i == 3){
					code("setAmazonDryad("+p+", getAmazonDryad("+p+") + 1);");
				} else if(i == 4){
					code("setAmazonGeyserCount("+p+", getAmazonGeyserCount("+p+") + 1);");
				} else if(i == 5){
					code("if(getAmazonForestFireUnlocked("+p+") == false){");
						code("setAmazonForestFireUnlocked("+p+", true);");
					code("} else {");
						code("setAmazonForestFireDamageMultiplier("+p+", getAmazonForestFireDamageMultiplier("+p+") + 1);");
					code("}");
				} else if(i == 6){
					code("if(getAmazonLifebondUnlocked("+p+") == false){");
						code("setAmazonLifebondUnlocked("+p+", true);");
					code("} else {");
						code("setAmazonLifebondDistance("+p+", getAmazonLifebondDistance("+p+") + 3);");
					code("}");
				} else if(i == 7){
					code("setAmazonRange("+p+", getAmazonRange("+p+") + 2);");
					code("modifyProtounitAbsolute(\"Reginleif\", "+p+", 2, getAmazonRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Reginleif\", "+p+", 11, getAmazonRange("+p+"));");
				}
			code("} else if(getHeroIndex("+p+") == 4){");
				if(i == 0){
					code("setWizardRange("+p+", getWizardRange("+p+") + 2);");
					code("modifyProtounitAbsolute(\"Setna\", "+p+", 2, getWizardRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Setna\", "+p+", 11, getWizardRange("+p+"));");
				} else if(i == 1){
					code("setWizardBlastCount("+p+", getWizardBlastCount("+p+") + 1);");
				} else if(i == 2){
					code("setWizardTeleportCount("+p+", getWizardTeleportCount("+p+") + 1);");
				} else if(i == 3){
					code("setWizardHealCount("+p+", getWizardHealCount("+p+") + 1);");
				} else if(i == 4){
					code("setWizardFlashChance("+p+", getWizardFlashChance("+p+") + 2);");
				} else if(i == 5){
					code("if(getWizardLightningStormUnlocked("+p+") == false){");
						code("setWizardLightningStormUnlocked("+p+", true);");
					code("} else {");
						code("setWizardLightningStormDamagePercent("+p+", getWizardLightningStormDamagePercent("+p+") + 25);");
					code("}");
				} else if(i == 6){
					code("setWizardTwoForOneChance("+p+", getWizardTwoForOneChance("+p+") + 10);");
				} else if(i == 7){
					code("setWizardProjectile("+p+", getWizardProjectile("+p+") + 4);");
				}
			code("} else if(getHeroIndex("+p+") == 5){");
				if(i == 0){
					code("if(getMaidenTauntUnlocked("+p+") == false){");
						code("setMaidenTauntUnlocked("+p+", true);");
					code("} else {");
						code("setMaidenTauntRadius("+p+", getMaidenTauntRadius("+p+") + 4);");
					code("}");
				} else if(i == 1){
					code("setMaidenPercentageDamageTakenReflectBack("+p+", getMaidenPercentageDamageTakenReflectBack("+p+") + 5);");
				} else if(i == 2){
					code("setMaidenHealChance("+p+", getMaidenHealChance("+p+") + 2);");
				} else if(i == 3){
					code("setMaidenBoltChance("+p+", getMaidenBoltChance("+p+") + 4);");
				} else if(i == 4){
					code("setMaidenBlinkChance("+p+", getMaidenBlinkChance("+p+") + 4);");
				} else if(i == 5){
					code("setMaidenTeleportCount("+p+", getMaidenTeleportCount("+p+") + 1);");
				} else if(i == 6){
					code("setMaidenSelfDamageCount("+p+", getMaidenSelfDamageCount("+p+") + 1);");
				} else if(i == 7){
					code("setMaidenHealRetaliationChance("+p+", getMaidenHealRetaliationChance("+p+") + 10);");
				}
			code("} else if(getHeroIndex("+p+") == 6){");
				if(i == 0){
					code("setNecromancerLifespan("+p+", getNecromancerLifespan("+p+") + 15.0);");
					code("modifyProtounitAbsolute(\"Minion\", "+p+", 8, getNecromancerLifespan("+p+"));");
					code("modifyProtounitAbsolute(\"Jiangshi\", "+p+", 8, getNecromancerLifespan("+p+"));");
				} else if(i == 1){
					code("setNecromancerRaiseDeadRadius("+p+", getNecromancerRaiseDeadRadius("+p+") + 2);");
				} else if(i == 2){
					code("setNecromancerCryDamagePercent("+p+", getNecromancerCryDamagePercent("+p+") + 40);");
				} else if(i == 3){
					code("setNecromancerCryMinions("+p+", getNecromancerCryMinions("+p+") + 2);");
				} else if(i == 4){
					code("setNecromancerRecharge("+p+", getNecromancerRecharge("+p+") * 0.75);");
					code("setNecromancerRechargeReduction("+p+", getNecromancerRechargeReduction("+p+") + 1);");
					code("modifyProtounitAbsolute(\"Arkantos\", "+p+", 9, getNecromancerRecharge("+p+"));");
				} else if(i == 5){
					code("setNecromancerPowerfulMinionChance("+p+", getNecromancerPowerfulMinionChance("+p+") + 10);");
				} else if(i == 6){
					code("setNecromancerRuneCount("+p+", getNecromancerRuneCount("+p+") + 1);");
				} else if(i == 7){
					code("if(getNecromancerSacrificeUnlocked("+p+") == false){");
						code("setNecromancerSacrificeUnlocked("+p+", true);");
					code("} else {");
						code("setNecromancerSacrificeMultiplier("+p+", getNecromancerSacrificeMultiplier("+p+") + 1);");
					code("}");
				}
			code("} else if(getHeroIndex("+p+") == 7){");
				if(i == 0){
					code("setArcherProjectiles("+p+", getArcherProjectiles("+p+") + 1);");
					code("modifyProtounitAbsolute(\"Archer Atlantean Hero\", "+p+", 13, getArcherProjectiles("+p+"));");
					code("modifyProtounitAbsolute(\"Archer Atlantean\", "+p+", 13, getArcherProjectiles("+p+"));");
				} else if(i == 1){
					code("setArcherRange("+p+", getArcherRange("+p+") + 2);");
					code("modifyProtounitAbsolute(\"Archer Atlantean Hero\", "+p+", 2, getArcherRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Archer Atlantean Hero\", "+p+", 11, getArcherRange("+p+"));");
					code("modifyProtounitAbsolute(\"Archer Atlantean\", "+p+", 2, getArcherRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Archer Atlantean\", "+p+", 11, getArcherRange("+p+"));");
				} else if(i == 2){
					code("setArcherMagicArrowChance("+p+", getArcherMagicArrowChance("+p+") + 1);");
				} else if(i == 3){
					code("setArcherShockwaveArrowChance("+p+", getArcherShockwaveArrowChance("+p+") + 1);");
				} else if(i == 4){
					code("setArcherBurningArrowChance("+p+", getArcherBurningArrowChance("+p+") + 1);");
				} else if(i == 5){
					code("if(getArcherBarrageUnlocked("+p+") == false){");
						code("setArcherBarrageUnlocked("+p+", true);");
					code("} else {");
						code("setArcherBarrageAttackMultiplier("+p+", getArcherBarrageAttackMultiplier("+p+") + 1);");
					code("}");
				} else if(i == 6){
					code("setArcherApprenticeCount("+p+", getArcherApprenticeCount("+p+") + 1);");
				} else if(i == 7){
					code("setArcherSpecialMultiplier("+p+", getArcherSpecialMultiplier("+p+") + 1);");
				}
			code("} else if(getHeroIndex("+p+") == 8){");
				if(i == 0){
					code("setShamanDamagePercent("+p+", getShamanDamagePercent("+p+") + 50);");
				} else if(i == 1){
					code("setShamanHealingRate("+p+", getShamanHealingRate("+p+") + 1);");
				} else if(i == 2){
					code("setShamanRange("+p+", getShamanRange("+p+") + 3);");
				} else if(i == 3){
					code("setShamanRadius("+p+", getShamanRadius("+p+") + 1);");
				} else if(i == 4){
					code("if(getShamanScareUnlocked("+p+") == false){");
						code("setShamanScareUnlocked("+p+", true);");
					code("} else {");
						code("setShamanScareRadius("+p+", getShamanScareRadius("+p+") + 10);");
					code("}");
				} else if(i == 5){
					code("setShamanSentinelCount("+p+", getShamanSentinelCount("+p+") + 1);");
				} else if(i == 6){
					code("setShamanAuraCarryTime("+p+", getShamanAuraCarryTime("+p+") + 3);");
				} else if(i == 7){
					code("setShamanTeleportCount("+p+", getShamanTeleportCount("+p+") + 1);");
				}
			code("} else if(getHeroIndex("+p+") == 9){");
				if(i == 0){
					code("setAssassinPercentHealth("+p+", getAssassinPercentHealth("+p+") + 1);");
				} else if(i == 1){
					code("if(getAssassinFlareUnlocked("+p+") == false){");
						code("setAssassinFlareUnlocked("+p+", true);");
					code("} else {");
						code("setAssassinFlarePercentDamage("+p+", getAssassinFlarePercentDamage("+p+") + 25);");
					code("}");
				} else if(i == 2){
					code("if(getAssassinGhostWalkUnlocked("+p+") == false){");
						code("setAssassinGhostWalkUnlocked("+p+", true);");
					code("} else {");
						code("setAssassinGhostWalkDuration("+p+", getAssassinGhostWalkDuration("+p+") + 5);");
					code("}");
				} else if(i == 3){
					code("if(getAssassinRageUnlocked("+p+") == false){");
						code("setAssassinRageUnlocked("+p+", true);");
					code("} else {");
						code("setAssassinRageDuration("+p+", getAssassinRageDuration("+p+") + 5);");
					code("}");
				} else if(i == 4){
					code("setAssassinShockwaveCount("+p+", getAssassinShockwaveCount("+p+") + 1);");
				} else if(i == 5){
					code("setAssassinPoisonCount("+p+", getAssassinPoisonCount("+p+") + 1);");
				} else if(i == 6){
					code("setAssassinReduceCount("+p+", getAssassinReduceCount("+p+") + 1);");
				} else if(i == 7){
					code("setAssassinAttackBoostCount("+p+", getAssassinAttackBoostCount("+p+") + 1);");
				}
			code("} else if(getHeroIndex("+p+") == 10){");
				if(i == 0){
					code("if(getWitchMeleeDamageUnlocked("+p+") == false){");
						code("setWitchMeleeDamageUnlocked("+p+", true);");
					code("} else {");
						code("setWitchMeleeDamageMultiplier("+p+", getWitchMeleeDamageMultiplier("+p+") + 1);");
					code("}");
				} else if(i == 1){
					code("setWitchShockwaveChance("+p+", getWitchShockwaveChance("+p+") + 10);");
				} else if(i == 2){
					code("setWitchCurseCount("+p+", getWitchCurseCount("+p+") + 1);");
				} else if(i == 3){
					code("if(getWitchArmageddonUnlocked("+p+") == false){");
						code("setWitchArmageddonUnlocked("+p+", true);");
					code("} else {");
						code("setWitchArmageddonMultiplier("+p+", getWitchArmageddonMultiplier("+p+") + 1);");
					code("}");
				} else if(i == 4){
					code("setWitchCloneCount("+p+", getWitchCloneCount("+p+") + 1);");
				} else if(i == 5){
					code("if(getWitchDuplicateUnlocked("+p+") == false){");
						code("setWitchDuplicateUnlocked("+p+", true);");
					code("} else {");
						code("setWitchDuplicateDuration("+p+", getWitchDuplicateDuration("+p+") + 30);");
					code("}");
				} else if(i == 6){
					code("setWitchCloneEnemyCount("+p+", getWitchCloneEnemyCount("+p+") + 1);");
				} else if(i == 7){
					code("setWitchManaFlareChance("+p+", getWitchManaFlareChance("+p+") + 10);");
				}
			code("} else if(getHeroIndex("+p+") == 11){");
				if(i == 0){
					code("setRogueRange("+p+", getRogueRange("+p+") + 5);");
					code("modifyProtounitAbsolute(\"Hero Greek Hippolyta\", "+p+", 2, getRogueRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Hero Greek Hippolyta\", "+p+", 11, getRogueRange("+p+"));");
					code("modifyProtounitAbsolute(\"Arrow Flaming\", "+p+", 1, getRogueRange("+p+") + arrowSpeedOffset);");
				} else if(i == 1){
					code("setRogueBirdCount("+p+", getRogueBirdCount("+p+") + 1);");
				} else if(i == 2){
					code("setRogueHealChance("+p+", getRogueHealChance("+p+") + 10);");
				} else if(i == 3){
					code("setRogueObliteratingChance("+p+", getRogueObliteratingChance("+p+") + 1);");
				} else if(i == 4){
					code("setRogueStealCount("+p+", getRogueStealCount("+p+") + 1);");
				} else if(i == 5){
					code("if(getRogueForestExplosionUnlocked("+p+") == false){");
						code("setRogueForestExplosionUnlocked("+p+", true);");
					code("} else {");
						code("setRogueForestExplosionAttackMultiplier("+p+", getRogueForestExplosionAttackMultiplier("+p+") + 1);");
					code("}");
				} else if(i == 6){
					code("setRogueProjectileChance("+p+", getRogueProjectileChance("+p+") + 1);");
				} else if(i == 7){
					code("if(getRogueObeliskUnlocked("+p+") == false){");
						code("setRogueObeliskUnlocked("+p+", true);");
					code("} else {");
						code("setRogueObeliskHitpointPercent("+p+", getRogueObeliskHitpointPercent("+p+") + 20);");
						code("applyHealth("+p+");");
					code("}");
				}
			code("} else if(getHeroIndex("+p+") == 12){");
				if(i == 0){
					code("setBirdProjectileChance("+p+", getBirdProjectileChance("+p+") + 10);");
				} else if(i == 1){
					code("setBirdProjectileKill("+p+", getBirdProjectileKill("+p+") + 1);");
				} else if(i == 2){
					code("if(getBirdRavenUnlocked("+p+") == false){");
						code("setBirdRavenUnlocked("+p+", true);");
					code("} else {");
						code("setBirdRavenDamageMultiplier("+p+", getBirdRavenDamageMultiplier("+p+") + 1);");
					code("}");
				} else if(i == 3){
					code("setBirdRocCount("+p+", getBirdRocCount("+p+") + 1);");
				} else if(i == 4){
					code("if(getBirdHealingEagleUnlocked("+p+") == false){");
						code("setBirdHealingEagleUnlocked("+p+", true);");
					code("} else {");
						code("setBirdHealingEagleSpeed("+p+", getBirdHealingEagleSpeed("+p+") + 1);");
					code("}");
				} else if(i == 5){
					code("if(getBirdCeaseFireUnlocked("+p+") == false){");
						code("setBirdCeaseFireUnlocked("+p+", true);");
					code("} else {");
						code("setBirdCeaseFireDuration("+p+", getBirdCeaseFireDuration("+p+") + 10);");
					code("}");
				} else if(i == 6){
					code("if(getBirdBombHarpyUnlocked("+p+") == false){");
						code("setBirdBombHarpyUnlocked("+p+", true);");
					code("} else {");
						code("setBirdBombHarpyCount("+p+", getBirdBombHarpyCount("+p+") + 1);");
					code("}");
				} else if(i == 7){
					code("setBirdDoubleShotChance("+p+", getBirdDoubleShotChance("+p+") + 10);");
				}
			code("} else if(getHeroIndex("+p+") == 13){");
				if(i == 0){
					code("int oldCarryLimitInt = 1*globalCarryLimit;");
					code("globalCarryLimit = globalCarryLimit + 0.25;");
					code("int newCarryLimitInt = 1*globalCarryLimit;");
					code("if(oldCarryLimitInt != newCarryLimitInt){");
						code("for(p = 1; <= "+h+"){");
							code("trModifyProtounit(heroUnit(getHeroIndex(p)), p, 5, 1);");
						code("}");
						code("trSoundPlayPaused(\"ageadvance.wav\",\"-1\",-1,\"\",\"\");");
						code("trChatSend(0, \"<color=1,0,0.5>Relic carry limit: <color=1,1,1>\" + newCarryLimitInt);");
						code("trChatSend(0, \"The artificers have risen the global relic carry limit from purchasing upgrades!\");");
					code("}");
					code("setArtificerTime("+p+", getArtificerTime("+p+") * 0.8);");
					code("modifyProtounitAbsolute(\"Ape of Set\", "+p+", 3, getArtificerTime("+p+"));");
					code("modifyProtounitAbsolute(\"Gazelle of Set\", "+p+", 3, getArtificerTime("+p+"));");
					code("modifyProtounitAbsolute(\"Hyena of Set\", "+p+", 3, getArtificerTime("+p+"));");
					code("modifyProtounitAbsolute(\"Crocodile of Set\", "+p+", 3, getArtificerTime("+p+"));");
					code("modifyProtounitAbsolute(\"Giraffe of Set\", "+p+", 3, getArtificerTime("+p+"));");
					code("modifyProtounitAbsolute(\"Hippo of Set\", "+p+", 3, getArtificerTime("+p+"));");
					code("modifyProtounitAbsolute(\"Rhinoceros of Set\", "+p+", 3, getArtificerTime("+p+"));");
					code("setArtificerTimeReduction("+p+", getArtificerTimeReduction("+p+") + 1);");
					code("setArtificerRelicExtraCarry("+p+", getArtificerRelicExtraCarry("+p+") + 1);");
					code("trModifyProtounit(heroUnit(getHeroIndex("+p+")), "+p+", 5, 1);");
				} else if(i == 1){
					code("setArtificerAttackCount("+p+", getArtificerAttackCount("+p+") + 1);");
					code("trUnforbidProtounit("+p+", \"Ape of Set\");");
				} else if(i == 2){
					code("setArtificerProjectileCount("+p+", getArtificerProjectileCount("+p+") + 1);");
					code("trUnforbidProtounit("+p+", \"Gazelle of Set\");");
				} else if(i == 3){
					code("setArtificerRangeCount("+p+", getArtificerRangeCount("+p+") + 1);");
					code("trUnforbidProtounit("+p+", \"Hyena of Set\");");
				} else if(i == 4){
					code("setArtificerFavourCount("+p+", getArtificerFavourCount("+p+") + 1);");
					code("trUnforbidProtounit("+p+", \"Crocodile of Set\");");
				} else if(i == 5){
					code("setArtificerRechargeCount("+p+", getArtificerRechargeCount("+p+") + 1);");
					code("trUnforbidProtounit("+p+", \"Giraffe of Set\");");
				} else if(i == 6){
					code("if(getArtificerMiningCampUnlocked("+p+") == false){");
						code("setArtificerMiningCampUnlocked("+p+", true);");
						code("trUnforbidProtounit("+p+", \"Hippo of Set\");");
					code("} else {");
						code("setArtificerMiningCampSpeed("+p+", getArtificerMiningCampSpeed("+p+") + 1);");
					code("}");
				} else if(i == 7){
					code("if(getArtificerLighthouseUnlocked("+p+") == false){");
						code("setArtificerLighthouseUnlocked("+p+", true);");
						code("trUnforbidProtounit("+p+", \"Rhinoceros of Set\");");
					code("} else {");
						code("setArtificerLighthouseSpeed("+p+", getArtificerLighthouseSpeed("+p+") + 1);");
					code("}");
				}
			code("} else if(getHeroIndex("+p+") == 14){");
				if(i == 0){
					code("setWarlockFireTornadoChance("+p+", getWarlockFireTornadoChance("+p+") + 10);");
				} else if(i == 1){
					code("setWarlockFireTornadoLifespan("+p+", getWarlockFireTornadoLifespan("+p+") + 1);");
				} else if(i == 2){
					code("setWarlockTeleportCount("+p+", getWarlockTeleportCount("+p+") + 1);");
				} else if(i == 3){
					code("if(getWarlockFireWallUnlocked("+p+") == false){");
						code("setWarlockFireWallUnlocked("+p+", true);");
					code("} else {");
						code("setWarlockFireWallTime("+p+", getWarlockFireWallTime("+p+") + 10);");
					code("}");
				} else if(i == 4){
					code("setWarlockTridentCount("+p+", getWarlockTridentCount("+p+") + 1);");
				} else if(i == 5){
					code("setWarlockFireballTowerCount("+p+", getWarlockFireballTowerCount("+p+") + 1);");
				} else if(i == 6){
					code("setWarlockDeathFireChance("+p+", getWarlockDeathFireChance("+p+") + 10);");
				} else if(i == 7){
					code("setWarlockFireRingHealth("+p+", getWarlockFireRingHealth("+p+") + 10);");
				}
			code("} else if(getHeroIndex("+p+") == 15){");
				if(i == 0){
					code("setMinerGoldMineCount("+p+", getMinerGoldMineCount("+p+") + 1);");
				} else if(i == 1){
					code("setMinerMiningSpeed("+p+", getMinerMiningSpeed("+p+") + 1);");
				} else if(i == 2){
					code("setMinerDwarfCount("+p+", getMinerDwarfCount("+p+") + 1);");
				} else if(i == 3){
					code("setMinerUnitRange("+p+", getMinerUnitRange("+p+") + 2);");
					code("modifyProtounitAbsolute(\"Throwing Axeman\", "+p+", 2, getMinerUnitRange("+p+") + losRangeOffset);");
					code("modifyProtounitAbsolute(\"Throwing Axeman\", "+p+", 11, getMinerUnitRange("+p+"));");
				} else if(i == 4){
					code("setMinerForestCount("+p+", getMinerForestCount("+p+") + 1);");
				} else if(i == 5){
					code("setMinerPassageCount("+p+", getMinerPassageCount("+p+") + 1);");
				} else if(i == 6){
					code("setMinerProjectileCount("+p+", getMinerProjectileCount("+p+") + 1);");
					code("modifyProtounitAbsolute(\"Throwing Axeman\", "+p+", 13, getMinerProjectileCount("+p+"));");
				} else if(i == 7){
					code("setMinerTwoForOneChance("+p+", getMinerTwoForOneChance("+p+") + 10);");
				}
			code("}");
			code("drawStats();");
			code("if(trPlayerResourceCount("+p+", \"Favor\") <= 0){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"0\");");
				code("trUnitChangeInArea("+p+", "+p+", \"Old Man\", \"Fimbulwinter Sfx\", 999.0);");
				code("grantGodPowerNoRechargeNextPosition("+p+", \"Nidhogg\", -1);");
			code("}");
		}
	}
	
	defineTrigger("everyoneFinishedWithShop", false, false, false);
	for(p = 1; <= h){
		con("trPlayerUnitCountSpecific("+p+", \"Old Man\") <= 0");
	}
	code("xsEnableRule(\"_everyoneFinishedWithShop2\");");
	
	defineTrigger("everyoneFinishedWithShop2", false, false, false);
	con("(trTime()-cActivationTime) >= 2");
	code("trUIFadeToColor(0,0,0,4000, 2000, false);");
	code("trOverlayTextColour(255, 255, 255);");
	code("round = round + 1;");
	code("volatileDestroy = false;");
	code("int variation = randomInt(0, 4);");
	code("if(round == 0){");
		code("if(variation == 0){");
			code("trOverlayText(\"Entering marshy jungle...\", 4.0);");
			code("generateChinese();");
		code("} else if(variation == 1){");
			code("trOverlayText(\"Entering swampy marsh...\", 4.0);");
			code("generateMarsh();");
		code("} else if(variation == 2) {");
			code("trOverlayText(\"Entering bamboo paths...\", 4.0);");
			code("generateBambooMaze();");
		code("} else if(variation == 3) {");
			code("trOverlayText(\"Entering oak forest...\", 4.0);");
			code("generateGrassyCliff();");
		code("} else {");
			code("trOverlayText(\"Entering resilient forest...\", 4.0);");
			code("generateResilientForest();");
		code("}");
	code("} else if(round == 1){");
		code("if(variation == 0){");
			code("trOverlayText(\"Entering tropical island...\", 4.0);");
			code("generateIsland();");
		code("} else if(variation == 1){");
			code("trOverlayText(\"Entering coastal ruins...\", 4.0);");
			code("generateAtlantis();");
		code("} else if(variation == 2) {");
			code("trOverlayText(\"Entering rocky cliffs...\", 4.0);");
			code("generateCoast();");
		code("} else if(variation == 3) {");
			code("trOverlayText(\"Entering strange olympus...\", 4.0);");
			code("generateOlympus();");
		code("} else {");
			code("trOverlayText(\"Entering water city...\", 4.0);");
			code("generateWaterCity();");
		code("}");
	code("} else if(round == 2){");
		code("if(variation == 0){");
			code("trOverlayText(\"Entering mountainous highlands...\", 4.0);");
			code("generateMountains();");
		code("} else if(variation == 1){");
			code("trOverlayText(\"Entering barren tundra...\", 4.0);");
			code("generateTundra();");
		code("} else if(variation == 2) {");
			code("trOverlayText(\"Entering mountain pass...\", 4.0);");
			code("generateDesertSnow();");
		code("} else if(variation == 3) {");
			code("trOverlayText(\"Entering mountain top...\", 4.0);");
			code("generateMountainTop();");
		code("} else {");
			code("trOverlayText(\"Entering frozen rivers...\", 4.0);");
			code("generateSnowRivers();");
		code("}");
	code("} else if(round == 3){");
		code("if(variation == 0){");
			code("trOverlayText(\"Entering windy desert...\", 4.0);");
			code("generateDesert();");
		code("} else if(variation == 1){");
			code("trOverlayText(\"Entering lost maze...\", 4.0);");
			code("generateMaze();");
		code("} else if(variation == 2) {");
			code("trOverlayText(\"Entering prosperous savannah...\", 4.0);");
			code("generateSavannah();");
		code("} else if(variation == 3) {");
			code("trOverlayText(\"Entering soaked clearing...\", 4.0);");
			code("generateDesertCliffs();");
		code("} else {");
			code("trOverlayText(\"Entering desert forest...\", 4.0);");
			code("generateDesertForest();");
		code("}");
	code("} else if(round == 4){");
		code("if(variation == 0){");
			code("trOverlayText(\"Entering dark forest...\", 4.0);");
			code("generateDarkForest();");
		code("} else if(variation == 1){");
			code("trOverlayText(\"Entering deep forest...\", 4.0);");
			code("generateDeepForest();");
		code("} else if(variation == 2) {");
			code("trOverlayText(\"Entering misty forest...\", 4.0);");
			code("generateMistyForest();");
		code("} else if(variation == 3) {");
			code("trOverlayText(\"Entering lake forest...\", 4.0);");
			code("generateLakeForest();");
		code("} else {");
			code("trOverlayText(\"Entering magic forest...\", 4.0);");
			code("generateForestCliffs();");
		code("}");
	code("} else if(round == 5){");
		code("if(variation == 0){");
			code("trOverlayText(\"Entering fiery hell...\", 4.0);");
			code("generateHell();");
		code("} else if(variation == 1){");
			code("trOverlayText(\"Entering magical underworld...\", 4.0);");
			code("generateUnderworld();");
		code("} else if(variation == 2) {");
			code("trOverlayText(\"Entering explosive volcano...\", 4.0);");
			code("generateVolcano();");
		code("} else if(variation == 3) {");
			code("trOverlayText(\"Entering prosperous volcano...\", 4.0);");
			code("generateHellForest();");
		code("} else {");
			code("trOverlayText(\"Entering charred forest...\", 4.0);");
			code("generateCharredForest();");
		code("}");
	code("}");
	code("switchToVolatile = true;");
	code("xsEnableRule(\"_startDelayed\");");
	code("vector loc = teleportUnitsToMiddle();");
	code("generateSpawnPoints(loc, 3 + round / 2);");
	code("gameTime = 0;");
	code("for(p = 1; <= "+h+"){");
		code("setPlayerGameTime(p, 0);");
	code("}");
	code("roundActive = true;");
	code("xsEnableRule(\"_gameTimer\");");
	code("xsEnableRule(\"_beginRound\");");
	code("xsDisableRule(\"_OldManTimeout\");");
	//Tech management
	code("if(round == 0 || round == 5){");
		code("for(p = 1; <= "+c+"){");
			code("trTechSetStatus(p, 102, 4);");
		code("}");
	code("} else if(round == 1){");
		code("for(p = 1; <= "+c+"){");
			code("trTechSetStatus(p, 102, 0);");
		code("}");
	code("}");
	//MELEE                     Unit                   HP         Speed     LOS        Attack
	code("if(round == 0){");
		code("enemyStatsMelee(\"Axeman\"              ,50.0      ,4.0      ,10.0      ,15.0);");
		code("enemyStatsMelee(\"Raiding Cavalry\"     ,75.0      ,5.0      ,10.0      ,25.0);");
		code("enemyStatsMelee(\"Apep\"                ,200.0     ,4.0      ,10.0      ,30.0);");
		code("enemyStatsMelee(\"Griffon\"             ,300.0     ,5.0      ,10.0      ,25.0);");
		code("enemyStatsMelee(\"Argus\"               ,4000.0    ,4.0      ,10.0      ,200.0);");
		code("enemyStatsMelee(\"Walking Woods Jungle Tree\",400.0,4.0      ,10.0      ,40.0);");
		code("enemyStatsMelee(\"Pharaoh of Osiris\"   ,700.0     ,4.0      ,10.0      ,60.0);");
		code("enemyStatsMelee(\"Colossus\"            ,600.0     ,3.0      ,10.0      ,20.0);");
		code("enemyStatsMelee(\"Statue of Lightning\" ,300.0     ,0.0      ,10.0      ,120.0);");
		code("enemyStatsMelee(\"Bolder Wall\"         ,500.0     ,0.0      ,0.0       ,0.0);");
		code("enemyStatsMelee(\"Monkey King\"         ,3000.0    ,5.0      ,0.0       ,300.0);");
		code("enemyStatsMelee(\"Shade of Hades\"      ,400.0     ,4.0      ,0.0       ,20.0);");
		code("enemyStatsMelee(\"Qilin\"               ,800.0     ,6.0      ,0.0       ,15.0);");
	code("} else if(round == 1){");
		code("enemyStatsMelee(\"Hydra\"               ,400.0     ,4.0      ,15.0      ,100.0);");
		code("enemyStatsMelee(\"Hippikon\"            ,120.0     ,5.0      ,15.0      ,50.0);");
		code("enemyStatsMelee(\"Automaton SPC\"       ,200.0     ,4.0      ,15.0      ,80.0);");
		code("enemyStatsMelee(\"Terracotta Soldier\"  ,300.0     ,4.0      ,15.0      ,50.0);");
		code("enemyStatsMelee(\"Nereid\"              ,8000.0    ,6.0      ,15.0      ,400.0);");
		code("enemyStatsMelee(\"Servant\"             ,400.0     ,5.0      ,15.0      ,40.0);");
		code("enemyStatsMelee(\"Carcinos\"            ,12000.0   ,5.0      ,15.0      ,300.0);");
		code("enemyStatsMelee(\"Scylla\"              ,10000.0   ,5.0      ,15.0      ,450.0);");
	code("} else if(round == 2){");
		code("enemyStatsMelee(\"Ulfsark\"             ,200.0     ,4.0      ,20.0      ,100.0);");
		code("enemyStatsMelee(\"Einheriar\"           ,500.0     ,3.5      ,20.0      ,120.0);");
		code("enemyStatsMelee(\"Battle Boar\"         ,1000.0    ,6.0      ,20.0      ,150.0);");
		code("enemyStatsMelee(\"Frost Giant\"         ,15000.0   ,5.0      ,20.0      ,600.0);");
		code("enemyStatsMelee(\"Fenris Wolf\"         ,1000.0    ,4.0      ,20.0      ,60.0);");
		code("enemyStatsMelee(\"Valkyrie\"            ,2000.0    ,5.0      ,20.0      ,100.0);");
		code("enemyStatsMelee(\"Mountain Giant\"      ,3000.0    ,4.0      ,20.0      ,40.0);");
		code("enemyStatsMelee(\"Nemean Lion\"         ,1000.0    ,5.0      ,20.0      ,150.0);");
		code("enemyStatsMelee(\"White Tiger\"         ,20000.0   ,6.0      ,20.0      ,700.0);");
		code("enemyStatsMelee(\"Cyclops\"             ,30000.0   ,4.0      ,20.0      ,400.0);");
		code("enemyStatsMelee(\"Fimbulwinter Wolf\"   ,1000.0    ,5.0      ,20.0      ,100.0);");
	code("} else if(round == 3){");
		code("enemyStatsMelee(\"Scarab\"              ,600.0     ,5.0      ,25.0      ,200.0);");
		code("enemyStatsMelee(\"War Elephant\"        ,2000.0    ,3.5      ,25.0      ,200.0);");
		code("enemyStatsMelee(\"Phoenix\"             ,100.0     ,4.0      ,25.0      ,100.0);");
		code("enemyStatsMelee(\"Avenger\"             ,1000.0    ,6.0      ,25.0      ,300.0);");
		code("enemyStatsMelee(\"Scorpion Man\"        ,1000.0    ,5.0      ,25.0      ,150.0);");
		code("enemyStatsMelee(\"Sphinx\"              ,50000.0   ,6.0      ,25.0      ,600.0);");
		code("enemyStatsMelee(\"Anubite\"             ,2000.0    ,6.0      ,25.0      ,100.0);");
		code("enemyStatsMelee(\"Pixiu\"               ,5000.0    ,5.0      ,25.0      ,200.0);");
		code("enemyStatsMelee(\"Guardian XP\"         ,3000.0    ,4.0      ,25.0      ,250.0);");
	code("} else if(round == 4){");
		code("enemyStatsMelee(\"Promethean\"          ,1000.0    ,4.0      ,30.0      ,300.0);");
		code("enemyStatsMelee(\"Colossus\"            ,4000.0    ,3.5      ,30.0      ,200.0);");
		code("enemyStatsMelee(\"Myrmidon\"            ,500.0     ,5.5      ,30.0      ,100.0);");
		code("enemyStatsMelee(\"War Salamander\"      ,2000.0    ,5.5      ,30.0      ,200.0);");
		code("enemyStatsMelee(\"Behemoth\"            ,3000.0    ,5.5      ,30.0      ,150.0);");
		code("enemyStatsMelee(\"Chimera\"             ,80000.0   ,5.0      ,30.0      ,1000.0);");
		code("enemyStatsMelee(\"Villager Atlantean\"  ,2000.0    ,6.0      ,30.0      ,0.0);");
		code("enemyStatsMelee(\"Titan Atlantean\"     ,10000.0   ,5.0      ,30.0      ,500.0);");
	code("} else if(round == 5){");
		code("enemyStatsMelee(\"Nidhogg\"             ,1000.0    ,6.0      ,35.0      ,300.0);");
		code("enemyStatsMelee(\"Heka Gigantes\"       ,2000.0    ,4.0      ,35.0      ,600.0);");
		code("enemyStatsMelee(\"Azure Dragon\"        ,5000.0    ,5.0      ,35.0      ,400.0);");
	code("}");
	//RANGED                    Unit                   HP         Speed     LOS        Range     Projectiles Attack
	code("if(round == 0){");
		code("enemyStatsRange(\"Toxotes\"             ,25.0      ,4.0      ,15.0      ,10.0     ,1.0        ,10.0);");
		code("enemyStatsRange(\"Centaur\"             ,200.0     ,4.0      ,20.0      ,15.0     ,1.0        ,30.0);");
		code("enemyStatsRange(\"Medusa\"              ,3500.0    ,4.0      ,25.0      ,20.0     ,1.0        ,100.0);");
	code("} else if(round == 1){");
		code("enemyStatsRange(\"Javelin Cavalry\"     ,100.0     ,5.0      ,20.0      ,15.0     ,1.0        ,20.0);");
		code("enemyStatsRange(\"Catapult\"            ,50.0      ,3.5      ,35.0      ,30.0     ,1.0        ,100.0);");
		code("enemyStatsRange(\"Jormund Elver\"       ,200.0     ,5.0      ,35.0      ,30.0     ,1.0        ,40.0);");
		code("enemyStatsRange(\"Pirate Ship\"         ,150.0     ,4.0      ,35.0      ,30.0     ,5.0        ,15.0);");
	code("} else if(round == 2){");
		code("enemyStatsRange(\"Bogsveigir\"          ,150.0     ,4.0      ,25.0      ,20.0     ,1.0        ,50.0);");
		code("enemyStatsRange(\"Troll\"               ,100.0     ,3.5      ,35.0      ,10.0     ,3.0        ,30.0);");
	code("} else if(round == 3){");
		code("enemyStatsRange(\"Chariot Archer\"      ,200.0     ,5.0      ,30.0      ,25.0     ,1.0        ,80.0);");
		code("enemyStatsRange(\"Mummy\"               ,40000.0   ,5.0      ,30.0      ,20.0     ,1.0        ,500.0);");
		code("enemyStatsRange(\"Manticore\"           ,5000.0    ,5.0      ,30.0      ,20.0     ,1.0        ,50.0);");
		code("enemyStatsRange(\"Petsuchos\"           ,60000.0   ,6.0      ,30.0      ,20.0     ,1.0        ,55.0);");
	code("} else if(round == 4){");
		code("enemyStatsRange(\"Vermilion Bird\"      ,300.0     ,6.0      ,30.0      ,20.0     ,1.0        ,200.0);");
		code("enemyStatsRange(\"Satyr\"               ,1000.0    ,5.0      ,30.0      ,20.0     ,3.0        ,40.0);");
		code("enemyStatsRange(\"Ballista\"            ,400.0     ,3.5      ,45.0      ,35.0     ,3.0        ,50.0);");
		code("enemyStatsRange(\"Lampades\"            ,60000.0   ,5.0      ,35.0      ,25.0     ,1.0        ,1000.0);");
		code("enemyStatsRange(\"Lazer Bear\"          ,50000.0   ,8.0      ,35.0      ,15.0     ,1.0        ,2000.0);");
		code("enemyStatsRange(\"Palace\"              ,1000.0    ,0.5      ,30.0      ,20.0     ,20.0       ,50.0);");
	code("} else if(round == 5){");
		code("enemyStatsRange(\"Fire Lance\"          ,3000.0    ,4.0      ,35.0      ,30.0     ,1.0        ,100.0);");
		code("enemyStatsRange(\"Petrobolos\"          ,1000.0    ,4.0      ,30.0      ,35.0     ,1.0        ,500.0);");
	code("}");
	
	defineTrigger("startDelayed", false, false, false);
	con("(trTime()-cActivationTime) >= 1");
	code("cameraLookAt(kbGetBlockPosition(\"\"+trCurrentPlayer()), 120, 45.0, 45.0);");
	
	defineTrigger("beginRound", false, false, false);
	con("(trTime()-cActivationTime) >= 10");
	code("revealSpawnPoints();");
	code("xsEnableRule(\"_ActivateNextRound\");");
	
	defineTrigger("endRound", false, false, false);
	con("(trTime()-cActivationTime) >= 3");
	con("enemyCount <= 0");
	code("roundActive = false;");
	code("boss0 = -1;");
	code("boss1 = -1;");
	code("boss2 = -1;");
	code("boss3 = -1;");
	code("boss4 = -1;");
	code("boss5 = -1;");
	code("boss6 = -1;");
	code("if(ceaseFireTime > 0){");
		code("ceaseFireTime = 0;");
	code("}");
	code("for(p = 1; <= "+h+"){");
		code("setBuilderArmoryBoost(p, 0.0);");
		code("setLifebondTree(p, -1);");
		code("setLifebondActive(p, false);");
		code("if(getWizardProjectileActive(p)){");
			code("setWizardProjectileActive(p, false);");
			code("trModifyProtounit(\"Setna\", p, 13, 0 - getWizardProjectile(p));");
		code("}");		
		code("if(getRogueProjectileActive(p)){");
			code("setRogueProjectileActive(p, false);");
			code("trModifyProtounit(\"Hero Greek Hippolyta\", p, 13, -50);");
		code("}");
		code("setArcherSpecialActive(p, false);");
		code("setSelfDamageCount(p, 0);");
		code("setAttackBoostActive(p, false);");
		code("applyAttack(p);");
		code("setMiningCamp(p, -1);");
		code("setLighthouse(p, -1);");
		code("setLighthouseSpawn(p, -1);");
	code("}");
	code("trOverlayTextColour(255, 0, 0);");
	code("if(round < 5){");
		code("trOverlayText(\"Round boss defeated\", 10.0);");
	code("} else {");
		code("trOverlayText(\"Round bosses defeated... Or are they?!\", 10.0);");
	code("}");
	code("trPlayerKillAllGodPowers("+a+");");
	code("trPlayerKillAllGodPowers("+c+");");
	code("for(p = 1; <= "+h+"){");
		code("trPlayerKillAllGodPowers(p);");
		code("xsDisableRule(\"_ReviveStart\"+p);");
		code("xsDisableRule(\"_ReviveWarning30\"+p);");
		code("xsDisableRule(\"_ReviveWarning20\"+p);");
		code("xsDisableRule(\"_ReviveWarning10\"+p);");
		code("xsDisableRule(\"_ReviveWarning5\"+p);");
		code("xsDisableRule(\"_ReviveEnd\"+p);");
	code("}");
	code("xsDisableRule(\"_gameTimer\");");
	code("xsEnableRule(\"_endRound1\");");
	code("xsEnableRule(\"_endRound4\");");
	code("musicType = 0;");
	playMusic("cinematics\22_out\music (wussy mix).mp3");
	for(i = 0; < 4){
		if(i == 0)relicDatabaseName = "AttackRelic";
		if(i == 1)relicDatabaseName = "ProjectileRelic";
		if(i == 2)relicDatabaseName = "RangeRelic";
		if(i == 3)relicDatabaseName = "FavourRelic";
		databaseSearchStart(relicDatabaseName);
		if(i == 3){
			code("int relicOwner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
			code("trPlayerGrantResources(relicOwner, \"Favor\", 1);");
		}
		code("trUnitChangeProtoUnit(\"Cinematic Block\");");
		code("trUnitConvert(0);");
		databaseSearchEnd();
	}
	
	defineTrigger("endRound1", false, false, false);
	code("for(p = 1; <= "+h+"){");
		code("trPlayerModifyLOS(p, false, "+a+");");
		code("trPlayerModifyLOS(p, false, "+c+");");
	code("}");
	
	defineTrigger("endRound4", false, false, false);
	con("(trTime()-cActivationTime) >= 4");
	code("if(round < 5){");
		code("volatileDestroy = false;");
		code("generateShop();");
		code("switchToVolatile = true;");
		code("xsDisableRule(\"_gameTimer\");");
		code("trBlockAllSounds(false);");
		code("uiFindType(\"Old Man\");");
		code("trUnblockAllSounds();");
	code("} else {");
		code("xsEnableRule(\"_startDelayed\");");
		code("trUIFadeToColor(0,0,0,4000, 2000, false);");
		code("trOverlayTextColour(255, 255, 255);");
		code("trOverlayText(\"Entering unknown...\", 4.0);");
		code("volatileDestroy = false;");
		code("generateFinalArena();");
		code("switchToVolatile = true;");
		code("round = round + 1;");
		code("gameTime = 0;");
		code("for(p = 1; <= "+h+"){");
			code("setPlayerGameTime(p, 0);");
		code("}");
		code("musicType = 1;");
		playMusic("xpack\xcinematics\8_in\music.mp3");
		code("xsEnableRule(\"_beginFinalBoss\");");
		//MELEE                 Unit                   HP         Speed     LOS        Attack
		code("enemyStatsMelee(\"Arkantos God\"        ,200000.0  ,5.0      ,35.0      ,5000.0);");
		code("enemyStatsMelee(\"Guardian\"            ,5000.0    ,5.0      ,35.0      ,600.0);");
		//RANGED                Unit                   HP         Speed     LOS        Range     Projectiles Attack
		code("enemyStatsRange(\"Fire Giant\"          ,9999999.0 ,4.0      ,45.0      ,40.0     ,1.0        ,2000.0);");
	code("}");
	
	defineTrigger("gameTimer", false, true, false);
	con("(trTime()-cActivationTime) >= 1");
	code("for(p = 1; <= "+h+"){");
		code("if(getDead(p) == false){");
			code("vector v = kbGetBlockPosition(\"\"+p);");
			code("if(getHeroIndex(p) == 2 && getSummonerMinotaur(p) >= randomInt(1, 100)){");
				code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Minotaur\", p, 1, 5.0, true);");
			code("}");
			code("if(getHeroIndex(p) == 2 && getSummonerWadjet(p) >= randomInt(1, 100)){");
				code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Wadjet\", p, 1, 5.0, true);");
			code("}");
			code("if(getHeroIndex(p) == 2 && getSummonerBird(p) >= randomInt(1, 100)){");
				code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Stymphalian Bird\", p, 1, 5.0, true);");
			code("}");
			code("int dryadChance = getAmazonDryad(p);");
			code("if(getLifebondActive(p)){");
				code("dryadChance = dryadChance * 2;");
			code("}");
			code("if(dryadChance >= randomInt(1, 100)){");
				code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Dryad\", p, 1, 5.0, true);");
			code("}");
			code("if(getWizardProjectile(p) > 0){");
				code("bool wizardProjectileActive = (randomInt(0, 4) == 0);");
				code("if(wizardProjectileActive && getWizardProjectileActive(p) == false){");
					code("trModifyProtounit(\"Setna\", p, 13, getWizardProjectile(p));");
				code("} else if(wizardProjectileActive == false && getWizardProjectileActive(p)){");
					code("trModifyProtounit(\"Setna\", p, 13, 0 - getWizardProjectile(p));");
				code("}");
				code("setWizardProjectileActive(p, wizardProjectileActive);");
			code("}");
			code("if(getRogueProjectileChance(p) > 0){");
				code("bool rogueProjectileActive = (getRogueProjectileChance(p) >= randomInt(1, 100));");
				code("if(rogueProjectileActive && getRogueProjectileActive(p) == false){");
					code("trModifyProtounit(\"Hero Greek Hippolyta\", p, 13, 50);");
				code("} else if(rogueProjectileActive == false && getRogueProjectileActive(p)){");
					code("trModifyProtounit(\"Hero Greek Hippolyta\", p, 13, -50);");
				code("}");
				code("setRogueProjectileActive(p, rogueProjectileActive);");
			code("}");
			databaseSearchStart("Runestone");
			code("if(randomInt(1, 100) <= 2){");
				code("int runestoneOwner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
				code("if(p == runestoneOwner){");
					code("vector runestoneLoc = getPosition(trQuestVarGet(\"ySearchUnit\"));");
					code("if(getNecromancerPowerfulMinionChance(p) >= randomInt(1, 100)){");
						code("deployCluster(xsVectorGetX(runestoneLoc), xsVectorGetZ(runestoneLoc), \"Jiangshi\", p, 1, 5.0, true);");
					code("} else {");
						code("deployCluster(xsVectorGetX(runestoneLoc), xsVectorGetZ(runestoneLoc), \"Minion\", p, 1, 5.0, true);");
					code("}");
				code("}");
			code("}");
			databaseSearchEnd();
		code("}");
	code("}");
	code("if(gameTime == 0){");
		code("for(p = 1; <= "+h+"){");
			code("if(getDead(p) == false){");
				code("if(getPaladinDeathTeleportCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", getPaladinDeathTeleportCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Teleport on death marker\");");
				code("}");
				code("if(getPaladinReviveUnlocked(p)){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getPaladinReviveCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Revive nearest fallen hero\");");
				code("}");
				code("if(getPaladinTeleportCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Audrey\", getPaladinTeleportCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Carnivora:</color> Teleport nearest player to you\");");
				code("}");
				code("if(getSummonerHealCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", getSummonerHealCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Heal and reset lifespans\");");
				code("}");
				code("if(getAssassinPoisonCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getAssassinPoisonCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Poison cloud\");");
				code("}");
				code("if(getBirdHealingEagleUnlocked(p)){");
					code("vector eagleLoc = kbGetBlockPosition(\"\"+p);");
					code("deployCluster(xsVectorGetX(eagleLoc), xsVectorGetZ(eagleLoc), \"Footprint Animal Small\", p, 1, 10.0, true);");
				code("}");
				code("if(getBirdBombHarpyUnlocked(p)){");
					code("vector harpyLoc = kbGetBlockPosition(\"\"+p);");
					code("deployCluster(xsVectorGetX(harpyLoc), xsVectorGetZ(harpyLoc), \"Footprint Cavalry\", p, 3, 10.0, true);");
				code("}");
				code("if(getBirdCeaseFireUnlocked(p)){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", 1);");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Enemy cease fire\");");
				code("}");
				code("if(getHeroIndex(p) == 13){");
					code("modifyProtounitAbsolute(\"Ape of Set\", p, 10, getArtificerAttackCount(p));");
					code("if(getArtificerAttackCount(p) > 0)trChatSendToPlayer(0, p, \"<color=0,1,1>Ape: </color> Attack\");");
					code("modifyProtounitAbsolute(\"Gazelle of Set\", p, 10, getArtificerProjectileCount(p));");
					code("if(getArtificerProjectileCount(p) > 0)trChatSendToPlayer(0, p, \"<color=0,1,1>Gazelle: </color> Projectile\");");
					code("modifyProtounitAbsolute(\"Hyena of Set\", p, 10, getArtificerRangeCount(p));");
					code("if(getArtificerRangeCount(p) > 0)trChatSendToPlayer(0, p, \"<color=0,1,1>Hyena: </color> Range and LOS\");");
					code("modifyProtounitAbsolute(\"Crocodile of Set\", p, 10, getArtificerFavourCount(p));");
					code("if(getArtificerFavourCount(p) > 0)trChatSendToPlayer(0, p, \"<color=0,1,1>Crocodile: </color> +1 favour round end\");");
					code("modifyProtounitAbsolute(\"Giraffe of Set\", p, 10, getArtificerRechargeCount(p));");
					code("if(getArtificerFavourCount(p) > 0)trChatSendToPlayer(0, p, \"<color=0,1,1>Giraffe: </color> +1/3 power recharge speed\");");
					code("modifyProtounitAbsolute(\"Hippo of Set\", p, 10, 1);");
					code("if(getArtificerMiningCampUnlocked(p))trChatSendToPlayer(0, p, \"<color=0,1,1>Hippo: </color> Mining camp\");");
					code("modifyProtounitAbsolute(\"Rhinoceros of Set\", p, 10, 1);");
					code("if(getArtificerLighthouseUnlocked(p))trChatSendToPlayer(0, p, \"<color=0,1,1>Rhinoceros: </color> Lighthouse\");");
				code("}");
				code("if(getWarlockTridentCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", getWarlockTridentCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Fire trident\");");
				code("}");
				code("if(getHeroIndex(p) == 15 && getMinerGoldMineCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"TitanGate\", getMinerGoldMineCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Titan Gate:</color> Gold mine\");");
				code("}");
				code("if(getMinerPassageCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Underworld Passage\", getMinerPassageCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Underworld Passage:</color> Tunnel\");");
				code("}");
				code("if(getHeroIndex(p) == 15){");
					code("modifyProtounitAbsolute(\"Farm\", p, 10, 1.0);");
					code("modifyProtounitAbsolute(\"Farm\", p, 16, 30.0);");
				code("}");
				code("if(getAmazonLifebondUnlocked(p)){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Hesperides\", 1);");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Hesperides:</color> Lifebond Tree\");");
				code("}");
				code("if(getArcherApprenticeCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", getArcherApprenticeCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Apprentice\");");
				code("}");
				code("if(getShamanTeleportCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", getShamanTeleportCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Teleport and concentrate\");");
				code("}");
				code("if(getAssassinReduceCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", getAssassinReduceCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Reduce enemies to 75 percent health\");");
				code("}");
				code("if(getWitchCloneEnemyCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getWitchCloneEnemyCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Clone enemies for kills\");");
				code("}");
				code("if(getNecromancerRuneCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getNecromancerRuneCount(p));");
					code("trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Summoning runestone\");");
				code("}");
				code("if(getWitchCloneCount(p) > 0){");
					code("grantGodPowerNoRechargeNextPosition(p, \"Bolt\", getWitchCloneCount(p));");
					code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Bolt:</color> Clone\");");
				code("}");
			code("}");
		code("}");
	code("}");
	code("for(p = 1; <= "+h+"){");
		code("if(getDead(p) == false){");
			code("setRelicRechargeStore(p, getRelicRechargeStore(p) + getRechargeRelicCount(p));");
			code("int extraFromRelics = getRelicRechargeStore(p) / 3;");
			code("setRelicRechargeStore(p, getRelicRechargeStore(p) - extraFromRelics * 3);");
			code("int advanceAmount = 1 + getExtraTimeAdvance(p) + extraFromRelics;");
			code("setExtraTimeAdvance(p, 0);");
			code("for(i = 0; < advanceAmount){");
				code("if(modInt(getPlayerGameTime(p), 60) == 0){");
					code("if(getWizardBlastCount(p) > 0){");
						code("for(j = 0; < getWizardBlastCount(p)){");
							code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", 1);");
							code("if(getWizardTwoForOneChance(p) >= randomInt(1, 100)){");
								code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", 1);");
							code("}");
						code("}");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Wizard blast\");");
					code("}");
					code("if(getMaidenTauntUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Taunt\");");
					code("}");
					code("if(getShamanScareUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Scare\");");
					code("}");
					code("if(getMaidenSelfDamageCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getMaidenSelfDamageCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Self damage\");");
					code("}");
					code("if(getShamanSentinelCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getShamanSentinelCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Sentinel\");");
					code("}");
					code("if(getAssassinGhostWalkUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Ghost walk\");");
					code("}");
					code("if(getAssassinShockwaveCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Tremor\", getAssassinShockwaveCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Shockwave:</color> Shockwave\");");
					code("}");
					code("if(getWitchCurseCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Spy\", getWitchCurseCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Spy:</color> Curse\");");
					code("}");
					code("if(getRogueBirdCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", 2 * getRogueBirdCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Toggle bird\");");
					code("}");
					code("if(getRogueStealCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Spy\", getRogueStealCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Spy:</color> Steal health\");");
					code("}");
					code("if(getRogueForestExplosionUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Walking Woods\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Walking Woods:</color> Forest explosion\");");
					code("}");
					code("if(getBirdBombHarpyUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", getBirdBombHarpyCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Harpy drop bomb\");");
					code("}");
					code("if(getWarlockTeleportCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", getWarlockTeleportCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Random teleport\");");
					code("}");
				code("}");
				code("if(modInt(getPlayerGameTime(p), 90) == 0){");
					code("if(getArcherBarrageUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Barrage\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Barrage:</color> Barrage\");");
					code("}");
					code("if(getWizardLightningStormUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Lightning Storm\", 1);");
						code("if(getWizardTwoForOneChance(p) >= randomInt(1, 100)){");
							code("grantGodPowerNoRechargeNextPosition(p, \"Lightning Storm\", 1);");
						code("}");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lightning Storm:</color> Lightning storm\");");
					code("}");
					code("if(getBirdRavenUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Skeleton Power\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Ancestors:</color> Hungry ravens\");");
					code("}");
				code("}");
				code("if(modInt(getPlayerGameTime(p), 120) == 0){");
					code("if(getSummonerChangeUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Change all minions to nearest\");");
					code("}");
					code("if(getAmazonOvergrowCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", getAmazonOvergrowCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Overgrow\");");
					code("}");
					code("if(getAmazonGeyserCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getAmazonGeyserCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Geyser\");");
					code("}");
					code("if(getAmazonForestFireUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Forest Fire\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Forest Fire:</color> Forest fire\");");
					code("}");
					code("if(getWizardHealCount(p) > 0){");
						code("for(j = 0; < getWizardHealCount(p)){");
							code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", 1);");
							code("if(getWizardTwoForOneChance(p) >= randomInt(1, 100)){");
								code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", 1);");
							code("}");
						code("}");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Heal heroes\");");
					code("}");
					code("if(getMaidenTeleportCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", getMaidenTeleportCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Teleport\");");
					code("}");
					code("if(getPaladinHealCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Vision\", getPaladinHealCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Vision:</color> Heal neighbouring heroes\");");
					code("}");
					code("if(getWizardTeleportCount(p) > 0){");
						code("for(j = 0; < getWizardTeleportCount(p)){");
							code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", 1);");
							code("if(getWizardTeleportCount(p) >= randomInt(1, 100)){");
								code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", 1);");
							code("}");
						code("}");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Teleport\");");
					code("}");
					code("if(getNecromancerSacrificeUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", 1);");
						code("trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Sacrifice for damage\");");
					code("}");
					code("if(getWitchDuplicateUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Duplicate self\");");
					code("}");
					code("if(getBirdRocCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getBirdRocCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Create roc\");");
					code("}");
					code("if(getRogueObeliskUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Obelisk ring\");");
					code("}");
					code("if(getWarlockFireWallUnlocked(p)){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Tsunami\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Tsunami:</color> Fire wall\");");
					code("}");
					code("if(getWarlockFireballTowerCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Earth Dragon\", getWarlockFireballTowerCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Earth Dragon:</color> Fire tower\");");
					code("}");
					code("if(getHeroIndex(p) == 15 && getMinerDwarfCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Animal Magnetism\", 1);");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Lure:</color> Dwarves\");");
					code("}");
					code("if(getMinerForestCount(p) > 0){");
						code("grantGodPowerNoRechargeNextPosition(p, \"Gaia Forest SPC\", getMinerForestCount(p));");
						code("if(gameTime==0)trChatSendToPlayer(0, p, \"<color=0,1,0>Gaia forest SPC:</color> Golden forest\");");
					code("}");
				code("}");
				code("setPlayerGameTime(p, getPlayerGameTime(p) + 1);");
			code("}");
		code("}");
	code("}");
	code("gameTime = gameTime + 1;");
	
	defineTrigger("ironMaiden", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 5 && getDead(p) == false){");
			code("xsSetContextPlayer(p);");
			code("float currentHealth = kbUnitGetHealth(p);");
			code("if(currentHealth < getIronMaidenHealth(p) || ",
					"(currentHealth > getIronMaidenHealth(p) && getMaidenHealRetaliationChance(p) > randomInt(0, 99))){");
				code("float difference = xsAbs(getIronMaidenHealth(p) - currentHealth);");
				code("vector v = kbGetBlockPosition(\"\"+p);");
				code("deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Curse Sfx\", p);");
				code("damageEnemyInVectorArea(p, v, heroBaseAttack(5) * getAttackMultiplierFinal(p), 3.0, -1);");
				code("damageEnemyInVectorArea(p, v, ",
						"difference*heroBaseHealth(5)*getHealthMultiplier(p)*0.01*getMaidenPercentageDamageTakenReflectBack(p)/difficulty, ",
						"3.0, -1);");
				code("if(getMaidenHealChance(p) >= randomInt(1, 100)){");
					code("trUnitSelect();");
					code("trUnitSelect(\"\"+p);");
					code("trDamageUnitPercent(-1.0);");
					code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), \"Recreation\", p);");
					code("if(p == trCurrentPlayer()){");
						code("trSoundPlayPaused(\"recreation.wav\",\"-1\",-1,\"\",\"\");");
					code("}");
				code("}");
				code("if(getMaidenBoltChance(p) >= randomInt(1, 100)){");
					code("int countForBolt = 0;");
					databaseSearchStart("Enemy");
					code("countForBolt = countForBolt + 1;");
					databaseSearchEnd();
					code("int chosenBolt = randomInt(0, countForBolt - 1);");
					code("countForBolt = 0;");
					databaseSearchStart("Enemy");
					code("if(countForBolt == chosenBolt){");
						code("grantGodPowerNoRechargeNextPosition("+a+", \"Bolt\", 1);");
						code("trTechInvokeGodPower("+a+", \"Bolt\");");
						code("boltCredit = p;");
					code("}");
					code("countForBolt = countForBolt + 1;");
					databaseSearchEnd();
				code("}");
				code("if(getMaidenBlinkChance(p) >= randomInt(1, 100)){");
					code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Kronny Birth Sfx\", p, 3, 10.0);");
					code("if(p == trCurrentPlayer()){");
						code("trSoundPlayPaused(\"pigout.wav\",\"-1\",-1,\"\",\"\");");
					code("}");
				code("}");
			code("}");
			code("setIronMaidenHealth(p, kbUnitGetHealth(p));");
		code("}");
	code("}");
	
	defineTrigger("HeroAnimation", true, true, false);
	code("if(time250){");
		code("for(p = 1; <= "+h+"){");
			code("setRangeBoostCalculated(p, 0);");
		code("}");
	code("}");
	code("vector v = vector(0.0, 0.0, 0.0);");
	code("for(p = 1; <= "+h+"){");
		code("int previousAction = getHeroAction(p);");
		code("int currentAction = kbUnitGetAnimationActionType(p);");
		code("if(currentAction == -1){");
			code("currentAction = previousAction;");
		code("}");
		code("if(getHeroIndex(p) == 1 && currentAction == 6){");
			code("if(time250 && getPaladinTrampleDamagePercent(p) > 0){");
				code("v = kbGetBlockPosition(\"\"+p);");
				code("damageEnemyInVectorArea(p, v, ",
							"0.0025 * getAttackMultiplierFinal(p) * heroBaseAttack(1) * getPaladinTrampleDamagePercent(p), ",
							"3.0, -1);");
				code("int unitName = deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Spy Eye\", p);");
				code("if(unitName >= 0){");
					code("trMutateSelected("+getUnitIdFromName("Walking Woods Pine")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+unitName, true);");
					code("trSetSelectedScale(0, 0, 0);");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+unitName, true);");
					code("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
					code("trQuestVarSet(\"timebaseDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), unitName);");
					code("trQuestVarSet(\"timebaseTimeDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), trTimeMS());");
					code("trQuestVarSet(\"timebaseCountDestroy1S\", trQuestVarGet(\"timebaseCountDestroy1S\") + 1);");
				code("}");
			code("}");
		code("}");
		code("if(getHeroIndex(p) == 6 && currentAction == 48 && previousAction != 48){");
			code("v = kbGetBlockPosition(\"\"+p);");
			code("for(i = 0; < getNecromancerCryMinions(p)){");
				code("if(getNecromancerPowerfulMinionChance(p) >= randomInt(1, 100)){");
					code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Jiangshi\", p, 1, 5.0, true);");
				code("} else {");
					code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Minion\", p, 1, 5.0, true);");
				code("}");
			code("}");
		code("}");
		code("if(getHeroIndex(p) == 8 && inShop == false){");
			code("v = kbGetBlockPosition(\"\"+p);");
			code("bool previousFocused = previousAction == 69 || previousAction == 16;");
			code("bool currentFocused = currentAction == 69 || currentAction == 16;");
			code("if(currentFocused && (previousFocused == false)){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+p);");
				code("trUnitOverrideAnimation(52, 0, true, true, -1, 0);");
			code("} else if((currentFocused == false) && previousFocused){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+p);");
				code("trUnitOverrideAnimation(-1, 0, true, true, -1, 0);");
			code("}");
			code("if(time250 && (currentFocused || getAuraCarryTime(p) > 0) && kbIsPlayerResigned(p) == false){");
				code("if(currentFocused){");
					code("setAuraCarryTime(p, getShamanAuraCarryTime(p) * 4);");
				code("} else {");
					code("setAuraCarryTime(p, getAuraCarryTime(p) - 1);");
				code("}");
				code("int radius = getShamanRadius(p);");
				code("if(getShamanDamagePercent(p) > 0){");
					code("damageEnemyInVectorArea(p, v, ",
							"0.0025 * getAttackMultiplierFinal(p) * heroBaseAttack(8) * getShamanDamagePercent(p), ",
							"radius, -1);");
					code("applyDamageEffect(v, radius);");
				code("}");
				code("if(getShamanHealingRate(p) > 0){");
					code("damagePlayersInVectorArea(v, ",
							"-0.0025 * getHealthMultiplier(p) * heroBaseHealth(8) * getShamanHealingRate(p), ",
							"radius, -1, false);");
					code("applyHealingEffect(v, radius);");
				code("}");
				code("if(getShamanRange(p) > 0){");
					code("applyRangeEffect(p, v, radius);");
				code("}");
			code("}");
		code("}");
		code("if(getHeroIndex(p) == 12 && inShop == false){");
			code("bool previousMoving = previousAction == 10 || previousAction == 11;");
			code("bool currentMoving = currentAction == 10 || currentAction == 11;");
			code("bool previousAttacking = previousAction == 6;");
			code("bool currentAttacking = currentAction == 6;");
			code("if(currentMoving && (previousMoving == false)){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0(p));");
				code("trUnitOverrideAnimation(15, 0, true, true, -1, 0);");
			code("} else if(currentAttacking && (previousAttacking == false)){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0(p));");
				code("trUnitOverrideAnimation(24, 0, true, true, -1, 0);");
			code("} else if((previousMoving && (currentMoving == false)) || (previousAttacking && (currentAttacking == false))){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0(p));");
				code("trUnitOverrideAnimation(-1, 0, true, true, -1, 0);");
			code("}");
		code("}");
		code("if(time250 && getHeroIndex(p) == 13 && getHeroAction(p) == 43){");
			code("if(heroNearby(p, 1.5, getMiningCamp(p))){");
				code("setGoldToGive(p, getGoldToGive(p) + 0.25 * getArtificerMiningCampSpeed(p));");
				code("int goldToAdd = 1*getGoldToGive(p);");
				code("if(goldToAdd > 0){");
					code("trPlayerGrantResources(p, \"Gold\", goldToAdd);");
					code("setGoldToGive(p, getGoldToGive(p) - goldToAdd);");
				code("}");
			code("} else if(heroNearby(p, 1.5, getLighthouse(p))){");
				code("setFoodToGive(p, getFoodToGive(p) + 0.25 * getArtificerLighthouseSpeed(p));");
				code("int foodToAdd = 1*getFoodToGive(p);");
				code("if(foodToAdd > 0){");
					code("trPlayerGrantResources(p, \"Food\", foodToAdd);");
					code("setFoodToGive(p, getFoodToGive(p) - foodToAdd);");
				code("}");
			code("}");
		code("}");
		code("setHeroAction(p, currentAction);");
	code("}");
	code("if(time250){");
		code("for(p = 1; <= "+h+"){");
			code("if(getRangeBoost(p) != getRangeBoostCalculated(p)){");
				code("applyRangeBoost(p, getRangeBoostCalculated(p) - getRangeBoost(p));");
				code("setRangeBoost(p, getRangeBoostCalculated(p));");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("detectLand", true, true, false);
	databaseSearchStart("DetectLand");
	code("tempV = getPosition(trQuestVarGet(\"ySearchUnit\"));");
	code("if(heightAboveTerrain(tempV) < 0.5){");
		code("trUnitDestroy();");
		removeFromDatabase("DetectLand");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("petAttackLaunch", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 12 && kbUnitGetAnimationActionType(p) == 6){");
			code("if(getBirdProjectileChance(p) >= randomInt(1, 100)){");
				code("launchPetAttack(p, \"PetAttack\");");
				code("if(getBirdDoubleShotChance(p) >= randomInt(1, 100)){");
					code("launchPetAttack(p, \"PetAttack\");");
				code("}");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("petAttackStart", true, true, false);
	databaseSearchStart("PetAttack");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Lampades")+");");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trUnitOverrideAnimation(2, 0, true, false, -1);");
		removeFromDatabase("PetAttack");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("petAttackEnd", true, true, false);
	startVanishbaseSearch("PetAttack");
	code("int createdObject = trGetNextUnitScenarioNameNumber();");
	code("deployLoc(x, z, \"Spy Eye\", "+a+");");
	code("float damageToDeal = 2.0 * heroBaseAttack(12) * getAttackMultiplierFinal(owner);");
	code("damageEnemyInArea(owner, x, z, damageToDeal, 3.0);");
	code("if(createdObject != trGetNextUnitScenarioNameNumber()){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trMutateSelected("+getUnitIdFromName("Automaton SPC")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trSetSelectedScale(0.0, 0.1, 0.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trUnitOverrideAnimation(18, 0, true, false, -1);");
		code("addToTimebaseAnytime(\"Destroy1S\", createdObject);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("powerPetAttackStart", true, true, false);
	databaseSearchStart("PowerPetAttack");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Lampades")+");");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trUnitOverrideAnimation(37, 0, true, false, -1);");
		removeFromDatabase("PowerPetAttack");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("powerPetAttackEnd", true, true, false);
	startVanishbaseSearch("PowerPetAttack");
	code("int createdObject = trGetNextUnitScenarioNameNumber();");
	code("deployLoc(x, z, \"Conversion Sfx\", "+a+");");
	code("float damageToDeal = 5.0 * heroBaseAttack(12) * getAttackMultiplierFinal(owner);");
	code("damageEnemyInArea(owner, x, z, damageToDeal, 3.0);");
	endVanishbaseSearch();
	
	defineTrigger("FireTowerAttackLaunch", true, true, false);
	con("time250");
	databaseSearchStart("FireTower");
	code("if(randomInt(0, 3) == 0){");
		code("int createdObject = trGetNextUnitScenarioNameNumber() + 1;");
		code("trUnitChangeProtoUnit(\"Ajax\");");
		code("trUnitChangeProtoUnit(\"Cinematic Block\");");
		code("trSetSelectedScale(1.0, 2.0, 1.0);");
		code("trMutateSelected("+getUnitIdFromName("Atlantis Wall Connector")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trUnitChangeProtoUnit(\"Anubite\");");
		code("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trDamageUnitPercent(100.0);");
		code("trSetSelectedScale(0.0, 0.9, 0.0);");
		code("float fireAngle = randomFloat(0, 360.0);");
		code("setSelectedUnitHeadingDegrees(fireAngle);");
		code("modifyProtounitAbsolute(\"Kronny Flying\", getOwner(trQuestVarGet(\"ySearchUnit\")), 1, randomFloat(3.0, 20.0));");
		code("addToDatabaseAnytime(\"FireTowerShot\", createdObject);");
		code("addToDatabaseAnytime(\"DetectLand\", createdObject);");
		code("addToVanishbaseAnytime(\"FireTowerShot\", createdObject);");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("FireTowerAttackStart", true, true, false);
	databaseSearchStart("FireTowerShot");
	code("if(trUnitDead()){");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trUnitOverrideAnimation(2, 0, true, false, -1);");
		code("trMutateSelected("+getUnitIdFromName("Fire Giant")+");");
		removeFromDatabase("FireTowerShot");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("FireTowerAttackEnd", true, true, false);
	startVanishbaseSearch("FireTowerShot");
	code("int createdObject = deployLocUsingCineBlock(x, z, \"Spy Eye\", owner);");
	code("if(createdObject != trGetNextUnitScenarioNameNumber()){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trMutateSelected("+getUnitIdFromName("Scorpion Man")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trSetSelectedScale(0.0, 1.0, 0.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trUnitOverrideAnimation(18, 0, true, false, -1);");
		code("float damageToDeal = 5.0 * heroBaseAttack(14) * getAttackMultiplierFinal(owner);");
		code("damageEnemyInVectorArea(owner, getPosition(createdObject), damageToDeal, 3.0);");
		code("addToTimebaseAnytime(\"Destroy1S\", createdObject);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("ObeliskRingStart", true, true, false);
	databaseSearchStart("ObeliskRing");
	code("if(trUnitDead()){");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trUnitOverrideAnimation(2, 0, true, false, -1);");
		code("trMutateSelected("+getUnitIdFromName("Curse Sfx")+");");
		removeFromDatabase("ObeliskRing");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("ObeliskRingEnd", true, true, false);
	startTimebaseSearch("ObeliskRingSpawn", 1000);
	removeFromTimebase("ObeliskRingSpawn");
	code("trUnitChangeProtoUnit(\"Argus\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trDamageUnitPercent(-100.0);");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trUnitChangeProtoUnit(\"Outpost\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trSetSelectedScale(-1.0, 0.4, -1.0);");
	addToDatabaseFromDatabase("Player");
	addToDatabaseFromDatabase("Building");
	endTimebaseSearch();
	
	defineTrigger("TrapRingStart", true, true, false);
	databaseSearchStart("TrapRing");
	code("if(trUnitDead()){");
		code("trUnitOverrideAnimation(2, 0, true, false, -1);");
		code("trMutateSelected("+getUnitIdFromName("Kronny Birth Sfx")+");");
		code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
		removeFromDatabase("TrapRing");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("TrapRingEnd", true, true, false);
	startTimebaseSearch("TrapRingSpawn", 1000);
	removeFromTimebase("TrapRingSpawn");
	code("trUnitChangeProtoUnit(\"Argus\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trDamageUnitPercent(-100.0);");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trUnitChangeProtoUnit(\"Atlantis Wall Connector\");");
	code("trUnitConvert("+a+");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trSetSelectedScale(-1.0, 0.4, -1.0);");
	addToTimebaseFromDatabase("Destroy15S");
	endTimebaseSearch();
	
	defineTrigger("HarpyBombStart", true, true, false);
	databaseSearchStart("HarpyBomb");
	code("if(trUnitDead()){");
		code("trSetSelectedScale(1.0, 1.0, 1.0);");
		code("trUnitOverrideAnimation(2, 0, true, false, -1);");
		code("trMutateSelected("+getUnitIdFromName("Implode Sphere")+");");
		removeFromDatabase("HarpyBomb");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("HarpyBombEnd", true, true, false);
	startVanishbaseSearch("HarpyBomb");
	code("int createdObject = deployLocUsingCineBlock(x, z, \"Spy Eye\", owner);");
	code("if(createdObject != trGetNextUnitScenarioNameNumber()){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trUnitChangeProtoUnit(\"Vortex Finish Linked\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trMutateSelected("+getUnitIdFromName("Harpy")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trUnitOverrideAnimation(1, 0, true, false, -1);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("damageEnemyInVectorArea(owner, v, 20.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(12), 5.0, -1);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("KillsProcessing", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("int currentKills = getKills(p);");
		code("int difference = currentKills - getKillsPrevious(p);");
		code("if(getHeroIndex(p) == 9){");
			code("if(difference > 0){");
				code("vector v = kbGetBlockPosition(\"\"+p);");
				code("if(getAssassinPercentHealth(p) > 0){");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+p);");
					code("trDamageUnitPercent(0.0 - getAssassinPercentHealth(p) * difference);");
					code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), \"Recreation\", p);");
				code("}");
				code("if(getAssassinFlareUnlocked(p)){");
					code("int unitName = deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Spy Eye\", p);");
					code("if(unitName >= 0){");
						code("trMutateSelected("+getUnitIdFromName("Cyclops")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+unitName, true);");
						code("trSetSelectedScale(0, 0, 0);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+unitName, true);");
						code("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
						code("trQuestVarSet(\"timebaseDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), unitName);");
						code("trQuestVarSet(\"timebaseTimeDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), trTimeMS());");
						code("trQuestVarSet(\"timebaseCountDestroy1S\", trQuestVarGet(\"timebaseCountDestroy1S\") + 1);");
					code("}");
					code("damageEnemyInVectorArea(p, v, ",
							"0.01 * heroBaseAttack(9) * getAttackMultiplierFinal(p) * getAssassinFlarePercentDamage(p), 3.0, -1);");
				code("}");
				code("if(getAssassinRageUnlocked(p) && getEnraged(p) == false && (100.0 - 100.0 * xsPow(0.9, difference) >= randomInt(1, 100))){");
					code("setEnragedTime(p, getAssassinRageDuration(p));");
				code("}");
			code("}");
		code("} else if(getHeroIndex(p) == 12){");
			code("if(difference > 0){");
				code("for(j = 0; < getBirdProjectileKill(p)){");
					code("launchPetAttack(p, \"PowerPetAttack\");");
					code("if(getBirdDoubleShotChance(p) >= randomInt(1, 100)){");
						code("launchPetAttack(p, \"PowerPetAttack\");");
					code("}");
				code("}");
			code("}");
		code("}");
		code("setKillsPrevious(p, currentKills);");
	code("}");
	
	for(p = 1; <= h){
		defineTrigger("GhostWalk"+p, true, true, false);
		con("(trTime()-cActivationTime) >= 1");
		con("getGhostWalkTime("+p+") > 0 || getGhostWalk("+p+")");
		code("if(getDead("+p+") || inShop){");
			code("setGhostWalkTime("+p+", 0);");
			code("setGhostWalk("+p+", false);");
			code("modifyProtounitAbsolute(\"Shaba Ka\", "+p+", 55, 1.0);");
			code("modifyProtounitAbsolute(\"Titan Bad\", "+p+", 55, 1.0);");
		code("} else {");
			code("if(getGhostWalk("+p+") == false){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0("+p+"));");
				code("trMutateSelected("+getUnitIdFromName("Valkyrie")+");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0("+p+"));");
				code("trSetSelectedScale(0.0, 0.0, 0.0);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0("+p+"));");
				code("trUnitOverrideAnimation(15, 0, true, false, -1);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0("+p+"));");
				code("trUnitSetAnimationPath(\"1,0,0,0,0,0,0\");");
				code("modifyProtounitAbsolute(\"Shaba Ka\", "+p+", 55, 4.0);");
				code("modifyProtounitAbsolute(\"Titan Bad\", "+p+", 55, 4.0);");
				code("setGhostWalk("+p+", true);");
			code("}");
			code("if(getGhostWalkTime("+p+") <= 0){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0("+p+"));");
				code("trMutateSelected("+getUnitIdFromName("Camera Start")+");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0("+p+"));");
				code("trSetSelectedScale(0.0, 0.0, 0.0);");
				code("modifyProtounitAbsolute(\"Shaba Ka\", "+p+", 55, 1.0);");
				code("modifyProtounitAbsolute(\"Titan Bad\", "+p+", 55, 1.0);");
				code("setGhostWalk("+p+", false);");
			code("} else {");
				code("setGhostWalkTime("+p+", getGhostWalkTime("+p+") - 1);");
			code("}");
		code("}");
	}
	
	for(p = 1; <= h){
		defineTrigger("Enraged"+p, true, true, false);
		con("(trTime()-cActivationTime) >= 1");
		con("getEnragedTime("+p+") > 0 || getEnraged("+p+")");
		code("if(getDead("+p+") || inShop){");
			code("setEnragedTime("+p+", 0);");
			code("setEnraged("+p+", false);");
		code("} else {");
			code("if(getEnraged("+p+") == false){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\""+p+"\");");
				code("trMutateSelected("+getUnitIdFromName("Titan Bad")+");");
				code("setEnraged("+p+", true);");
				code("if("+p+" == trCurrentPlayer()){");
					code("trSoundPlayPaused(\"cinematics\35_in\grunt.mp3\",\"-1\",-1,\"\",\"\");");
				code("}");
			code("}");
			code("if(getEnragedTime("+p+") <= 0){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\""+p+"\");");
				code("trMutateSelected("+getUnitIdFromName("Shaba Ka")+");");
				code("setEnraged("+p+", false);");
				code("if("+p+" == trCurrentPlayer()){");
					code("trSoundPlayPaused(\"cinematics\35_out\falling grit.mp3\",\"-1\",-1,\"\",\"\");");
				code("}");
			code("} else {");
				code("setEnragedTime("+p+", getEnragedTime("+p+") - 1);");
			code("}");
		code("}");
	}
	
	for(p = 1; <= h){
		defineTrigger("ActivateArmageddon"+p, true, true, false);
		con("getHeroIndex("+p+") == 10");
		con("getWitchArmageddonUnlocked("+p+")");
		con("getArmageddonUsed("+p+") == false");
		con("unitPercentDamaged("+p+", false) >= 60");
		con("getDead("+p+") == false");
		code("setArmageddonUsed("+p+", true);");
		code("armageddonCredit = "+p+";");
		code("grantGodPowerNoRechargeNextPosition("+a+", \"Volcano\", 1);");
		code("vector v = kbGetBlockPosition(\""+p+"\");");
		code("trTechInvokeGodPower("+a+", \"Volcano\", v, v);");
		code("int unitName = deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Spy Eye\", "+p+");");
		code("if(unitName >= 0){");
			code("trMutateSelected("+getUnitIdFromName("Vision Sfx")+");");
			code("trQuestVarSet(\"timebaseDestroy3S\"+(1*trQuestVarGet(\"timebaseCountDestroy3S\")), unitName);");
			code("trQuestVarSet(\"timebaseTimeDestroy3S\"+(1*trQuestVarGet(\"timebaseCountDestroy3S\")), trTimeMS());");
			code("trQuestVarSet(\"timebaseCountDestroy3S\", trQuestVarGet(\"timebaseCountDestroy3S\") + 1);");
		code("}");
		code("trChatSendSpoofed("+p+", \"<color=1,0,0>ARMAGEDDON!</color>\");");
		code("trSoundPlayPaused(\"cinematics\23_out\lostsouls.mp3\",\"-1\",-1,\"\",\"\");");
	}
	
	defineTrigger("search", true, true, true);
	code("for(p = 1; <= "+h+"){");
		code("setLightningTriggered(p, false);");
		code("setDuplicateTriggered(p, false);");
	code("}");
	code("bool bronzeCast = false;");
	code("int closestEnemy = -1;");
	code("float closestDistance = 0.0;");
	code("float foundDistance = 0.0;");
	code("int enemyType = -1;");
	code("vector heroLoc = vector(0.0, 0.0, 0.0);");
	//SEARCH SETUP START
    code("for(ysearchtarget = 0; > 1){}");
	code("for(type = 0; > 1){}");
    code("ysearchtarget = trGetNextUnitScenarioNameNumber();");
	code("if(trQuestVarGet(\"cow-cow\") == 0){");
		code("trQuestVarSet(\"cow\", ysearchtarget);");
		code("trQuestVarSet(\"cow-cow\", 1);");
	code("} else {");
		code("while(ysearchtarget > trQuestVarGet(\"cow\")){");
			code("type = kbGetUnitBaseTypeID(kbGetBlockID(\"\"+1*trQuestVarGet(\"cow\"), true));");
			code("if(type >= 0){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
				code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"cow\"), true);");
				code("float x = xsVectorGetX(v);");
				code("float y = xsVectorGetY(v);");
				code("float z = xsVectorGetZ(v);");
				code("int owner = getOwner(trQuestVarGet(\"cow\"));");
				//MAIN CODE
				code("bool excludeDestroy = false;");
				code("if(kbProtoUnitIsUnitType(type, 935) && type != "+getUnitIdFromName("Spider")+" && type != "+getUnitIdFromName("Villager Chinese")+"){");
					code("if(owner == "+c+" && trUnitDead() == false){");
						addToDatabase("Enemy");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Palace")+"){");
					code("if(owner == "+c+" && trUnitDead() == false){");
						addToDatabase("Enemy");
					code("}");
				code("}");
				code("if(kbProtoUnitIsUnitType(type, 935) || kbProtoUnitIsUnitType(type, 937)){");
					code("if(owner >= 1 && owner <= "+h+"){");
						addToDatabase("Player");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Gaia Forest Tree")+"){");
					code("if(round == -1){");
						code("paintCircle(0.5 * x, 0.5 * z, 0, \"ForestfloorGaia\");");
						code("trSetSelectedScale(1.0, 0.2, 1.0);");
					code("} else if(gameTime == 0){");
						code("if(round == 1){");
							code("trUnitChangeProtoUnit(\"Pine\");");
							code("trMutateSelected("+getUnitIdFromName("Gaia Forest Tree")+");");
							code("trUnitSetAnimationPath(olympusTreeAnimationPath);");
							code("trSetSelectedScale(1.5, 0.5, 1.5);");	
						code("} else if(round == 5){");
							code("trUnitChangeProtoUnit(\"Pine\");");
							code("trMutateSelected("+getUnitIdFromName("Gaia Forest Tree")+");");
							code("if(randomInt(0, 1) == 0){");
								code("trUnitSetAnimationPath(\"1,0,0,0,0,0,0\");");
							code("} else {");
								code("trUnitSetAnimationPath(\"4,0,0,0,0,0,0\");");
							code("}");
							code("float gaiaTreeSize = randomFloatWeighted(1.0, 4.0, 4);");
							code("trSetSelectedScale(gaiaTreeSize, randomFloat(0.5, gaiaTreeSize), gaiaTreeSize);");
						code("}");
					code("} else {");
						code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
						code("deployCluster(x, z, \"Axeman\", 0, 10, 3.0);");
						code("if(bronzeCast == false){");
							code("bronzeCast = true;");
							code("trTechInvokeGodPower(0, \"Bronze\", v, v);");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Axeman")+" && owner == 0){");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					addToTimebase("BronzeUnit");
				code("}");
				code("if(type == "+getUnitIdFromName("Pine Dead")+"){");
					code("paintCircle(0.5 * x, 0.5 * z, 0, \"ForestfloorDeadPine\");");
				code("}");
				code("if(type == "+getUnitIdFromName("Manor")+"){");
					addToDatabase("Manor");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Farm")+"){");
					addToDatabase("Building");
					code("if(getHeroIndex(owner) == 0){");
						addToDatabase("Farm");
					code("} else if(getHeroIndex(owner) == 15){");
						addToDatabase("FarmUnit");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Dust Small")+"){");
					code("for(p = 1; <= "+h+"){");
						code("vector heroPosDust = kbGetBlockPosition(\"\"+p);");
						code("if(getHeroIndex(p) == 1 && trUnitDistanceToPoint(xsVectorGetX(heroPosDust), 0.0, xsVectorGetZ(heroPosDust)) < 4.0){");
							code("damageEnemyInVectorArea(p, v, ",
									"1.0 * getPaladinJumpDamageMultiplier(p) * getAttackMultiplierFinal(p) * heroBaseAttack(1), ",
									"4.0, trQuestVarGet(\"cow\"));");
							code("trUnitChangeProtoUnit(\"Olympus Temple Sfx\");");
							code("if(trUnitVisToPlayer()){");
								code("trSoundPlayPaused(\"olympustemplesfx.wav\",\"-1\",-1,\"\",\"\");");
							code("}");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Spy Eye")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("if(getHeroIndex(owner) == 10){");
							code("trUnitChangeProtoUnit(\"Timeshift In\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trSetSelectedScale(0.0, 10.0, 0.0);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trSetSelectedUpVector(0.0, -0.9, 0.0);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
							addToDatabase("Curse");
						code("} else if(getHeroIndex(owner) == 11){");
							code("closestEnemy = -1;");
							code("closestDistance = toMetres(2.0);");
							databaseSearchStart("Enemy");
							code("foundDistance = trUnitDistanceToUnit(\"\"+1*trQuestVarGet(\"Cow\"));");
							code("if(foundDistance < closestDistance){");
								code("closestEnemy = 1*trQuestVarGet(\"ySearchUnit\");");
								code("closestDistance = foundDistance;");
							code("}");
							databaseSearchEnd();
							code("if(closestEnemy < 0){");
								code("if(trCurrentPlayer()==owner)trSoundPlayPaused(\"cantdothat.wav\",\"-1\",-1,\"\",\"\");");
								code("trChatSendToPlayer(0, owner, \"<color=1,0,1>No enemy to steal health!</color>\");");
								code("grantGodPowerNoRechargeNextPosition(owner, \"Spy\", 1);");
							code("} else {");
								code("enemyType = kbGetUnitBaseTypeID(kbGetBlockID(\"\"+closestEnemy, true));");
								code("xsSetContextPlayer("+c+");");
								code("float foundEnemyHealth = kbProtoUnitGetMaxHitPoints(enemyType);");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+owner);");
								code("trDamageUnit(0.0 - foundEnemyHealth);");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
								code("trMutateSelected("+getUnitIdFromName("Shade")+");");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
								code("trSetSelectedScale(0.0, 1.0, 0.0);");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
								code("trUnitOverrideAnimation(1, 0, true, false, -1, 0);");
								addToTimebase("Destroy3S");
							code("}");
						code("}");
					code("} else if(owner == 0) {");
						code("bool spyChosenPlayer = false;");
						code("for(p = 1; <= "+h+"){");
							code("if(spyChosenPlayer == false && getDead(p) == false && kbIsPlayerResigned(p) == false){");
								code("if(getSpyEye0(p) < 0){");
									code("spyChosenPlayer = true;");
									code("setSpyEye0(p, 1*trQuestVarGet(\"cow\"));");
									code("if(getGhostWalk(p)){");
										code("trMutateSelected("+getUnitIdFromName("Valkyrie")+");");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
										code("trSetSelectedScale(0.0, 0.0, 0.0);");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
										code("trUnitOverrideAnimation(15, 0, true, false, -1);");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
										code("trUnitSetAnimationPath(\"1,0,0,0,0,0,0\");");
									code("} else if(getMarkerCount(p) >= 1){");
										code("trMutateSelected("+getUnitIdFromName("Vortex Finish Linked")+");");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
									code("} else if (getHeroIndex(p) == 12) {");
										code("trUnitChangeProtoUnit(\"Flying Medic\");");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
										code("trUnitConvert("+a+");");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
										code("trSetSelectedUpVector(0.0, -1.333333, 0.0);");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
										code("trSetSelectedScale(1.0, -3.0, 1.0);");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
									code("} else {");
										code("trMutateSelected("+getUnitIdFromName("Camera Start")+");");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
										code("trSetSelectedScale(0.0, 0.0, 0.0);");
										code("trUnitSelectClear();");
										code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
									code("}");
								code("} else if(getSpyEye1(p) < 0){");
									code("spyChosenPlayer = true;");
									code("setSpyEye1(p, 1*trQuestVarGet(\"cow\"));");
									code("trUnitChangeProtoUnit(\"Camera Start\");");
									code("trUnitSelectClear();");
									code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
									code("trUnitConvert(p);");
								code("}");
							code("}");
						code("}");
						code("if(spyChosenPlayer == false){");
							code("trUnitDestroy();");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Priest Projectile")+"){");
					addToDatabase("PriestProjectile");
				code("}");
				code("if(type == "+getUnitIdFromName("Fire Lance Projectile")+"){");
					addToDatabase("FireLanceProjectile");
				code("}");
				code("if(type == "+getUnitIdFromName("Spear")+"){");
					code("if(owner == "+c+"){");
						code("excludeDestroy = true;"); //Performance
					code("}");
					addToDatabase("Spear");
				code("}");
				code("if(type == "+getUnitIdFromName("Arrow")+"){");
					addToDatabase("Arrow");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("if(getHeroIndex(owner) == 0){");
							code("excludeDestroy = true;"); //Performance
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Arrow Flaming")+"){");
					addToDatabase("ArrowFlaming");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("if(getSummonerCallToArmsChance(owner) >= randomInt(1, 100) && getDuplicateTriggered(owner) == false){");
							code("setDuplicateTriggered(owner, true);");
							code("float closestSummonDistance = toMetres(2.0);");
							code("int closestSummonType = -1;");
							databaseSearchStart("Summon");
							code("if(trUnitDead() == false && getOwner(trQuestVarGet(\"ySearchUnit\")) == owner){");
								code("float distance = trUnitDistanceToPoint(x, y, z);");
								code("if(distance < closestSummonDistance){");
									code("closestSummonDistance = distance;");
									code("closestSummonType = type;");
								code("}");
							code("}");
							databaseSearchEnd();
							code("if(closestSummonType >= 0){");
								code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), kbGetProtoUnitName(closestSummonType), owner, 1, 5.0, true);");
								code("if(trCurrentPlayer()==owner)trSoundPlayPaused(\"calltoarmscreate.wav\",\"-1\",-1,\"\",\"\");");
							code("}");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(1*trQuestVarGet(\"cow\")), true);");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Axe")+"){");
					addToDatabase("Axe");
				code("}");
				code("if(type == "+getUnitIdFromName("Animal Attractor")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("if(getHeroIndex(owner) == 1){");
							addToDatabase("DeathMarker");
							code("trMutateSelected("+getUnitIdFromName("Guardian Sleeping XP")+");");
							code("trUnitOverrideAnimation(0, 0, true, false, -1);");
							code("trSetSelectedScale(0.0, 1.0, 0.0);");
							code("trUnitSetAnimationPath(\"0,0,0,0,0,0,0\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+getSpyEye0(owner), true);");
							code("trMutateSelected("+getUnitIdFromName("Vortex Finish Linked")+");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(1*trQuestVarGet(\"cow\")), true);");
							code("setMarkerCount(owner, getMarkerCount(owner) + 1);");
						code("} else if(getHeroIndex(owner) == 2){");
							code("float closestChangeSummonDistance = toMetres(2.0);");
							code("int closestChangeSummonType = -1;");
							databaseSearchStart("Summon");
							code("if(trUnitDead() == false && getOwner(trQuestVarGet(\"ySearchUnit\")) == owner){");
								code("float changeSummonDistance = trUnitDistanceToPoint(x, y, z);");
								code("if(changeSummonDistance < closestChangeSummonDistance){");
									code("closestChangeSummonDistance = changeSummonDistance;");
									code("closestChangeSummonType = type;");
								code("}");
							code("}");
							databaseSearchEnd();
							code("if(closestChangeSummonType >= 0){");
								code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), kbGetProtoUnitName(closestChangeSummonType), ",
										"owner, getSummonerChangeBonus(owner), 5.0, true);");
							code("}");
							databaseSearchStart("Summon");
							code("if(trUnitDead() == false && getOwner(trQuestVarGet(\"ySearchUnit\")) == owner){");
								code("trMutateSelected(closestChangeSummonType);");
								code("vector changeSummonPosition = getPosition(trQuestVarGet(\"ySearchUnit\"));");
								code("deployLocUsingCineBlock(xsVectorGetX(changeSummonPosition), xsVectorGetZ(changeSummonPosition), ",
										"\"Conversion Sfx\", owner);");
							code("}");
							databaseSearchEnd();
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(1*trQuestVarGet(\"cow\")), true);");
							code("trUnitChangeProtoUnit(\"Fimbulwinter Sfx\");");
						code("} else if(getHeroIndex(owner) == 3){");
							code("trUnitChangeProtoUnit(\"Osiris Birth\");");
							code("trUnitConvert(0);");
							code("if(waterMap){");
								code("paintCircleRemovingWater(x / 2, z / 2, 5, \"GaiaCreepA\");");
							code("} else {");
								code("paintCircle(x / 2, z / 2, 5, \"GaiaCreepA\");");
							code("}");
							code("refreshPassability();");
						code("} else if(getHeroIndex(owner) == 4){");
							code("trUnitChangeProtoUnit(\"Meteor Impact Water\");");
							code("damageEnemyInVectorArea(owner, v, 4.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(4), ",
									"3.0, trQuestVarGet(\"cow\"));");
						code("} else if(getHeroIndex(owner) == 5){");
							code("trUnitChangeProtoUnit(\"Roc\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+owner);");
							code("trImmediateUnitGarrison(\"\"+(1*trQuestVarGet(\"cow\")));");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(1*trQuestVarGet(\"cow\")), true);");
							code("trMutateSelected("+getUnitIdFromName("Cinematic Block")+");");
							code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+owner);");
							code("trUnitSetStance(\"Passive\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("} else if(getHeroIndex(owner) == 6){");
							code("float minionHeroAttack = heroBaseAttack(getHeroIndex(owner)) * (getAttackMultiplierFinal(owner));");
							code("int minionDamage = 0.0;");
							databaseSearchStart("Minion");
							code("if(trUnitDead() == false && getOwner(trQuestVarGet(\"ySearchUnit\")) == owner){");
								code("if(type == "+getUnitIdFromName("Minion")+"){");
									code("minionDamage = minionDamage + minionHeroAttack * 0.25;");
								code("} else if(type == "+getUnitIdFromName("Jiangshi")+"){");
									code("minionDamage = minionDamage + minionHeroAttack * 0.5;");
								code("}");
								code("trUnitChangeProtoUnit(\"Hero Death\");");
								removeFromDatabase("Minion");
							code("}");
							databaseSearchEnd();
							code("minionDamage = minionDamage * getNecromancerSacrificeMultiplier(owner);");
							code("damageEnemyInVectorArea(owner, v, minionDamage, 5.0, trQuestVarGet(\"cow\"));");
							code("for(i = 0; < 5){");
								code("trUnitChangeProtoUnit(\"Ajax\");");
								code("trUnitSelect(\"\"+(trGetNextUnitScenarioNameNumber() - 1), true);");
								code("trUnitChangeProtoUnit(\"Olympus Temple Sfx\");");
								code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("}");
							code("trUnitChangeProtoUnit(\"Arkantos God Out\");");
							code("trUnitSetAnimationPath(\"0,0,1,1,1,0,0\");");
						code("} else if(getHeroIndex(owner) == 7){");
							code("trUnitChangeProtoUnit(\"Archer Atlantean\");");
							addToDatabase("Player");
						code("} else if(getHeroIndex(owner) == 8){");
							code("trUnitChangeProtoUnit(\"Roc\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+owner);");
							code("trMutateSelected("+getUnitIdFromName("Amanra")+");");
							code("trImmediateUnitGarrison(\"\"+(1*trQuestVarGet(\"cow\")));");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(1*trQuestVarGet(\"cow\")), true);");
							code("trMutateSelected("+getUnitIdFromName("Cinematic Block")+");");
							code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+owner);");
							code("trMutateSelected("+getUnitIdFromName("Oracle Hero")+");");
							code("trUnitOverrideAnimation(52, 0, true, true, -1, 0);");
							code("trUnitSetStance(\"Passive\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("} else if(getHeroIndex(owner) == 9){");
							code("trUnitDestroy();");
							databaseSearchStart("Enemy");
							code("if(trUnitPercentDamaged() < 25){");
								code("trDamageUnitPercent(25 - trUnitPercentDamaged());");
							code("}");
							code("vector reduceEnemyLoc = getPosition(trQuestVarGet(\"ySearchUnit\"));");
							code("deployLocUsingCineBlock(xsVectorGetX(reduceEnemyLoc), xsVectorGetZ(reduceEnemyLoc), \"Traitors Effect\", p);");
							code("trUnitSetAnimationPath(\"0,0,1,1,0,0,0\");");
							databaseSearchEnd();
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("} else if(getHeroIndex(owner) == 10){");
							code("modifyProtounitAbsolute(\"Circe\", "+a+", 8, getWitchDuplicateDuration(owner));");
							code("trUnitConvert("+a+");");
							code("trUnitChangeProtoUnit(\"Circe\");");
							code("trUnitConvert(owner);");
							code("trUnitSetStance(\"Passive\");");
							code("modifyProtounitAbsolute(\"Circe\", "+a+", 8, 0.0);");
							addToDatabase("Circe");
						code("} else if(getHeroIndex(owner) == 11){");
							code("for(i = 0; < 16){");
								code("int createdObject = trGetNextUnitScenarioNameNumber() + 1;");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
								code("trUnitChangeProtoUnit(\"Ajax\");");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+createdObject, true);");
								code("trUnitChangeProtoUnit(\"Anubite\");");
								code("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+createdObject, true);");
								code("trDamageUnitPercent(100.0);");
								code("trSetSelectedScale(0.0, 0.9, 0.0);");
								code("float fireAngle = (360.0 / 16) * i;");
								code("setSelectedUnitHeadingDegrees(fireAngle);");
								code("modifyProtounitAbsolute(\"Kronny Flying\", owner, 1, 5.0);");
								code("addToDatabaseAnytime(\"ObeliskRing\", createdObject);");
								code("addToTimebaseAnytime(\"ObeliskRingSpawn\", createdObject);");
							code("}");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trUnitChangeProtoUnit(\"Olympus Temple Sfx\");");
							code("trUnitSetAnimationPath(\"0,0,1,0,0,0,0\");");
						code("} else if(getHeroIndex(owner) == 12){");
							databaseSearchStart("Harpy");
							code("if(getOwner(trQuestVarGet(\"ySearchUnit\")) == owner){");
								code("int harpyBomb = trGetNextUnitScenarioNameNumber() + 1;");
								code("trUnitChangeProtoUnit(\"Ajax\");");
								code("trUnitChangeProtoUnit(\"Cinematic Block\");");
								code("trMutateSelected("+getUnitIdFromName("Harpy")+");");
								code("trSetSelectedScale(1.5, 1.5, 1.5);");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+harpyBomb, true);");
								code("trUnitChangeProtoUnit(\"Anubite\");");
								code("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+harpyBomb, true);");
								code("trDamageUnitPercent(100.0);");
								code("trSetSelectedScale(0.0, 0.9, 0.0);");
								code("float harpyFireAngle = randomFloat(0, 360.0);");
								code("setSelectedUnitHeadingDegrees(harpyFireAngle);");
								code("modifyProtounitAbsolute(\"Kronny Flying\", owner, 1, 1.0);");
								code("addToDatabaseAnytime(\"HarpyBomb\", harpyBomb);");
								code("addToDatabaseAnytime(\"DetectLand\", harpyBomb);");
								code("addToVanishbaseAnytime(\"HarpyBomb\", harpyBomb);");
							code("}");
							databaseSearchEnd();
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trUnitDestroy();");
						code("} else if(getHeroIndex(owner) == 14){");
							code("trUnitChangeProtoUnit(\"Spy Eye\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trMutateSelected("+getUnitIdFromName("Excavation")+");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trSetSelectedScale(0.0, 0.7, 0.0);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trUnitOverrideAnimation(0, 0, true, false, -1);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trUnitSetAnimationPath(\"0,0,0,0,0,0,0\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							addToTimebase("Trident");
						code("} else if(getHeroIndex(owner) == 15){");
							code("trUnitChangeProtoUnit(\"Increase Prosperity Large\");");
							addToTimebase("Destroy1S");
							code("deployCluster(x, z, \"Dwarf\", owner, getMinerDwarfCount(owner), 3.0);");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Dwarf")+"){");
					code("trUnitSetStance(\"Passive\");");
					addToDatabase("CollectGold");
				code("}");
				code("if(type == "+getUnitIdFromName("Lightning Sparks")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("damageEnemyInVectorArea(owner, v, ",
								"0.01 * getWizardLightningStormDamagePercent(owner) * getAttackMultiplierFinal(owner) * heroBaseAttack(4), ",
								"2.0, trQuestVarGet(\"cow\"));");
					code("}");
					code("if(owner == "+c+"){");
						code("damagePlayersInVectorArea(v, 100.0, 2.0, trQuestVarGet(\"cow\"));");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Kronny Birth Sfx")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("damageEnemyInVectorArea(owner, v, ",
								"5.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(5), ",
								"5.0, trQuestVarGet(\"cow\"));");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Bolt Scorch")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("trUnitChangeProtoUnit(\"Spy Eye\");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trMutateSelected("+getUnitIdFromName("Sentinel Main")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
						code("trSetSelectedScale(0.0, 0.0, 0.0);");
						addToTimebase("Destroy1S");
						code("closestEnemy = -1;");
						code("closestDistance = toMetres(2.0);");
						databaseSearchStart("Enemy");
						code("foundDistance = trUnitDistanceToUnit(\"\"+1*trQuestVarGet(\"Cow\"));");
						code("if(foundDistance < closestDistance){");
							code("closestEnemy = 1*trQuestVarGet(\"ySearchUnit\");");
							code("closestDistance = foundDistance;");
						code("}");
						databaseSearchEnd();
						code("if(closestEnemy < 0){");
							code("if(trCurrentPlayer()==owner)trSoundPlayPaused(\"cantdothat.wav\",\"-1\",-1,\"\",\"\");");
							code("trChatSendToPlayer(0, owner, \"<color=1,0,1>No enemy to clone!</color>\");");
							code("grantGodPowerNoRechargeNextPosition(owner, \"Bolt\", 1);");
						code("} else {");
							code("enemyType = kbGetUnitBaseTypeID(kbGetBlockID(\"\"+closestEnemy, true));");
							code("if(isBossType(enemyType)){");
								code("if(trCurrentPlayer()==owner)trSoundPlayPaused(\"cantdothat.wav\",\"-1\",-1,\"\",\"\");");
								code("trChatSendToPlayer(0, owner, \"<color=1,0,1>Cannot clone a boss unit</color>\");");
								code("grantGodPowerNoRechargeNextPosition(owner, \"Bolt\", 1);");
							code("} else {");
								code("heroLoc = kbGetBlockPosition(\"\"+owner);");
								code("trModifyProtounit(kbGetProtoUnitName(enemyType), owner, 8, 999999999.0);");
								code("deployCluster(xsVectorGetX(heroLoc), xsVectorGetZ(heroLoc), kbGetProtoUnitName(enemyType), ",
										"owner, 3, 3.0, true);");
							code("}");
						code("}");
					code("} else {");
						code("damageEnemyInVectorArea(boltCredit, v, ",
								"20.0 * getAttackMultiplierFinal(boltCredit) * heroBaseAttack(5), ",
								"2.0, trQuestVarGet(\"cow\"));");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Arkantos Boost Sfx")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("if(getNecromancerCryDamagePercent(owner) > 0){");
							code("damageEnemyInVectorArea(owner, v, ",
									"0.01 * getNecromancerCryDamagePercent(owner) * getAttackMultiplierFinal(owner) * heroBaseAttack(6), ",
									"4.0, trQuestVarGet(\"cow\"));");
							code("trUnitChangeProtoUnit(\"Spy Eye\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trMutateSelected("+getUnitIdFromName("Scorpion Man")+");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
							code("trSetSelectedScale(0.0, 0.0, 0.0);");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Barrage")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("damageEnemyInVectorArea(owner, v, ",
								"10.0 * heroBaseAttack(7) * getArcherBarrageAttackMultiplier(owner) * getAttackMultiplierFinal(owner), ",
								"4.0, trQuestVarGet(\"cow\"));");
					code("} else if(owner == "+c+"){");
						code("damagePlayersInVectorArea(v, 200.0, 4.0, trQuestVarGet(\"cow\"));");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Nidhogg")+"){");
					code("if(inShop){");
						code("trUnitChangeProtoUnit(\"Fimbulwinter Sfx\");");
						code("trUnitChangeInArea(owner, owner, \"Old Man\", \"Fimbulwinter Sfx\", 999.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Earth Dragon")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("if(getHeroIndex(owner) == 1){");
							code("int closestDeadPlayer = -1;");
							code("closestDistance = toMetres(2.0);");
							code("for(p = 1; <= "+h+"){");
								code("if(p != owner && getDead(p) && kbIsPlayerResigned(p) == false){");
									code("foundDistance = trUnitDistanceToUnit(\"\"+p);");
									code("if(foundDistance < closestDistance){");
										code("closestDeadPlayer = p;");
										code("closestDistance = foundDistance;");
									code("}");
								code("}");
							code("}");
							code("if(closestDeadPlayer > 0){");
								code("setRevivedByPlayer(closestDeadPlayer, owner);");
								code("setReviveTime(closestDeadPlayer, getPaladinReviveTime(owner));");
								code("setDead(p, false);"); //Prevent multiple revives selecting same player
								code("xsEnableRule(\"_ReviveStart\"+closestDeadPlayer);");
								code("xsEnableRule(\"_ReviveWarning30\"+closestDeadPlayer);");
								code("xsEnableRule(\"_ReviveWarning20\"+closestDeadPlayer);");
								code("xsEnableRule(\"_ReviveWarning10\"+closestDeadPlayer);");
								code("xsEnableRule(\"_ReviveWarning5\"+closestDeadPlayer);");
								code("xsEnableRule(\"_ReviveEnd\"+closestDeadPlayer);");
							code("} else {");
								code("if(trCurrentPlayer()==owner)trSoundPlayPaused(\"cantdothat.wav\",\"-1\",-1,\"\",\"\");");
								code("trChatSendToPlayer(0, owner, \"<color=1,0,1>Nobody to revive!</color>\");");
								code("grantGodPowerNoRechargeNextPosition(owner, \"Earth Dragon\", 1);");
							code("}");
							code("trUnitDestroy();");
						code("} else if(getHeroIndex(owner) == 3){");
							code("trUnitChangeProtoUnit(\"Geyser\");");
						code("} else if(getHeroIndex(owner) == 4){");					
							code("trUnitChangeProtoUnit(\"Cinematic Block\");");
							addToTimebase("Destroy3S");
						code("} else if(getHeroIndex(owner) == 5){");
							code("trUnitDestroy();");
							code("setSelfDamageCount(owner, getSelfDamageCount(owner) + 12);");
						code("} else if(getHeroIndex(owner) == 6){");
							code("trUnitChangeProtoUnit(\"Cinematic Block\");");
							code("trMutateSelected("+getUnitIdFromName("Runestone")+");");
							addToDatabase("Runestone");
						code("} else if(getHeroIndex(owner) == 8){");
							code("trUnitChangeProtoUnit(\"Sentinel Main\");");
							code("if(owner == trCurrentPlayer()){");
								code("trSoundPlayPaused(\"xsentinelbirth.wav\",\"-1\",-1,\"\",\"\");");
							code("}");
						code("} else if(getHeroIndex(owner) == 9){");
							code("trUnitChangeProtoUnit(\"Imperial Examination\");");
							addToDatabase("PoisonCloud");
						code("} else if(getHeroIndex(owner) == 10){");
							code("trUnitChangeProtoUnit(\"Traitors Effect\");");
							code("float closestEnemyCloneDistance = toMetres(2.0);");
							code("int closestEnemyCloneType = -1;");
							databaseSearchStart("Enemy");
							code("if(trUnitDead() == false){");
								code("float enemyCloneDistance = trUnitDistanceToPoint(x, y, z);");
								code("if(enemyCloneDistance < closestEnemyCloneDistance){");
									code("closestEnemyCloneDistance = enemyCloneDistance;");
									code("closestEnemyCloneType = type;");
								code("}");
							code("}");
							databaseSearchEnd();
							code("if(closestEnemyCloneType >= 0){");
								code("if(isBossType(closestEnemyCloneType)){");
									code("if(trCurrentPlayer()==owner)trSoundPlayPaused(\"cantdothat.wav\",\"-1\",-1,\"\",\"\");");
									code("trChatSendToPlayer(0, owner, \"<color=1,0,1>Cannot clone a boss!</color>\");");
									code("grantGodPowerNoRechargeNextPosition(owner, \"Earth Dragon\", 1);");
								code("} else {");
										code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), kbGetProtoUnitName(closestEnemyCloneType), ",
												""+c+", 10.0, 5.0, true);");
								code("}");
							code("} else {");
								code("if(trCurrentPlayer()==owner)trSoundPlayPaused(\"cantdothat.wav\",\"-1\",-1,\"\",\"\");");
								code("trChatSendToPlayer(0, owner, \"<color=1,0,1>No enemy to clone!</color>\");");
								code("grantGodPowerNoRechargeNextPosition(owner, \"Earth Dragon\", 1);");
							code("}");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("} else if(getHeroIndex(owner) == 12){");
							code("trUnitChangeProtoUnit(\"Roc\");");
							addToDatabase("Roc");
						code("} else if(getHeroIndex(owner) == 14){");
							code("trUnitChangeProtoUnit(\"Atlantis Wall Connector\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trSetSelectedScale(1.0, 2.0, 1.0);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							addToDatabase("FireTower");
							addToTimebase("Destroy15S");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Earth Dragon Hole")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("if(getHeroIndex(owner) == 1){");
							code("trUnitDestroy();");
						code("} else if(getHeroIndex(owner) == 3){");
							code("trUnitChangeProtoUnit(\"Spy Eye\");");
							code("trMutateSelected("+getUnitIdFromName("Guardian Sleeping XP")+");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trUnitOverrideAnimation(0, 0, true, false, -1);");
							code("trSetSelectedScale(0.0, 1.0, 0.0);");
							code("trUnitSetAnimationPath(\"2,0,0,0,0,0,0\");");
						code("} else if(getHeroIndex(owner) == 4){");
							code("trUnitChangeProtoUnit(\"Roc\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+owner);");
							code("trImmediateUnitGarrison(\"\"+(1*trQuestVarGet(\"cow\")));");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(1*trQuestVarGet(\"cow\")), true);");
							code("trMutateSelected("+getUnitIdFromName("Cinematic Block")+");");
							code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+owner);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("} else if(getHeroIndex(owner) == 5){");
							code("trUnitDestroy();");
						code("} else if(getHeroIndex(owner) == 6){");
							code("trMutateSelected("+getUnitIdFromName("Acid Pool")+");");
						code("} else if(getHeroIndex(owner) == 8){");
							code("trUnitChangeProtoUnit(\"Sentinel Base\");");
						code("} else if(getHeroIndex(owner) == 9){");
							code("trUnitChangeProtoUnit(\"Spy Eye\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trMutateSelected("+getUnitIdFromName("Well of Urd")+");");
							code("trSetSelectedScale(0.0, 1.0, 0.0);");
						code("} else if(getHeroIndex(owner) == 10){");
							code("trUnitDestroy();");
						code("} else if(getHeroIndex(owner) == 11){");
							code("trUnitDestroy();");
						code("} else if(getHeroIndex(owner) == 12){");
							code("trUnitDestroy();");
						code("} else if(getHeroIndex(owner) == 14){");
							code("trUnitChangeProtoUnit(\"Spy Eye\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trMutateSelected("+getUnitIdFromName("Outpost")+");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trSetSelectedScale(1.4, 1.8, 1.4);");
							addToTimebase("Destroy15S");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Forest Fire Attack")+"){");
					code("trUnitChangeProtoUnit(\"Spy Eye\");");
					code("if(owner == "+c+"){");
						code("trMutateSelected("+getUnitIdFromName("Underworld Explosion")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trUnitSetAnimationPath(\"0,0,1,0,0,0,0\");");
					code("} else {");
						code("trMutateSelected("+getUnitIdFromName("Titan Kronos")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trSetSelectedScale(0.0, 1.0, 0.0);");
						code("trUnitOverrideAnimation(2, 0, true, false, -1);");
						code("trUnitSetAnimationPath(\"0,0,0,0,0,0,0\");");
					code("}");
					addToDatabase("ForestFire");
				code("}");
				code("if(type == "+getUnitIdFromName("Catapult Shot")+"){");
					addToDatabase("CatapultShot");
				code("}");
				code("if(type == "+getUnitIdFromName("Terracotta Soldier Dead Replacement")+"){");
					code("trUnitChangeProtoUnit(\"Vortex Finish Linked\");");
					code("trMutateSelected("+getUnitIdFromName("Harpy")+");");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trUnitOverrideAnimation(1, 0, true, false, -1);");
					code("if(owner < "+c+"){");
						code("damageEnemyInVectorArea(owner, v, 100.0, 5.0, -1);");
					code("} else {");
						code("damagePlayersInVectorArea(v, 100.0, 5.0, -1);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Mummy Flies")+"){");
					addToDatabase("MummyFlies");
				code("}");
				code("if(type == "+getUnitIdFromName("Manticore Barb")+"){");
					addToDatabase("MummyFlies");
				code("}");
				code("if(type == "+getUnitIdFromName("Lampades Bolt")+"){");
					addToDatabase("LampadesBolt");
				code("}");
				code("if(type == "+getUnitIdFromName("Tornado")+"){");
					addToDatabase("Tornado");
				code("}");
				code("if(type == "+getUnitIdFromName("Tsunami")+"){");
					code("if(owner == "+c+"){");
						addToDatabase("Tsunami");
					code("} else {");
						code("int fireWallUnit = trGetNextUnitScenarioNameNumber() + 1;");
						code("trUnitChangeProtoUnit(\"Ajax\");");
						code("trUnitDestroy();");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+fireWallUnit, true);");
						code("trUnitChangeProtoUnit(\"Spy Eye\");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+fireWallUnit, true);");
						code("trMutateSelected("+getUnitIdFromName("Tartarian Gate Birth")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+fireWallUnit, true);");
						code("trSetSelectedScale(0.0, 0.0, 0.0);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+fireWallUnit, true);");
						code("trSetSelectedUpVector(0.0, -0.9, 0.0);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+fireWallUnit, true);");
						code("trUnitOverrideAnimation(18, 0, false, true, -1);");
						code("addToDatabaseAnytime(\"FireWall\", fireWallUnit);");
						code("addToTimebaseAnytime(\"FireWall\", fireWallUnit);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Tornado Debris")+"){");
					code("if(allowDebris){");
						code("allowDebris = false;");
						code("trUnitChangeProtoUnit(\"Spy Eye\");");
						code("trMutateSelected("+getUnitIdFromName("Circe")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trSetSelectedScale(0.0, 0.0, 0.0);");
						addToTimebase("TornadoDebris");
					code("} else {");
						code("trUnitDestroy();");
						code("excludeDestroy = true;");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Ball of Fire")+"){");
					addToDatabase("BallOfFire");
				code("}");
				code("if(type == "+getUnitIdFromName("Sling Stone")+"){");
					addToDatabase("SlingStone");
				code("}");
				code("if(type == "+getUnitIdFromName("Einheriar Boost Sfx")+"){");
					code("if(trUnitDead()){");
						code("excludeDestroy = true;"); //Performance
					code("} else {");
						code("trUnitChangeProtoUnit(\"Wall Connector Destruction Sfx\");");
						code("if(owner < "+c+"){");
							code("damageEnemyInVectorArea(owner, v, 50.0, 4.0, trQuestVarGet(\"cow\"));");
						code("} else {");
							code("damagePlayersInVectorArea(v, 50.0, 4.0, trQuestVarGet(\"cow\"));");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Inferno Unit Flame")+"){");
					code("if(round == 3){");
						code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
						code("if(owner < "+c+"){");
							code("damageEnemyInVectorArea(infernoCredit, v, 20.0, 2.0, trQuestVarGet(\"cow\"));");
						code("} else {");
							code("damagePlayersInVectorArea(v, 20.0, 2.0, trQuestVarGet(\"cow\"));");
						code("}");
					code("} else {");
						code("damagePlayersInVectorArea(v, 50.0, 2.0, trQuestVarGet(\"cow\"));");
						code("trUnitChangeProtoUnit(\"Spy Eye\");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trMutateSelected("+getUnitIdFromName("Promethean")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trUnitOverrideAnimation(18, 0, true, false, -1);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trSetSelectedScale(0.0, 0.0, 0.0);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						addToTimebase("Destroy1S");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Inferno Fire Ground")+"){");
					code("if(round != 3){");
						code("trMutateSelected("+getUnitIdFromName("Avalanche")+");");
						code("trUnitOverrideAnimation(15, 0, false, false, -1);");
						code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Inferno Field")+"){");
					code("if(round != 3){");
						code("trMutateSelected("+getUnitIdFromName("Ice Sheet")+");");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Phoenix Egg")+"){");
					code("trUnitChangeProtoUnit(\"Forest Fire Sfx\");");
					code("if(owner < "+c+"){");
						code("grantGodPowerNoRechargeNextPosition("+a+", \"Inferno\", 1);");
						code("trTechInvokeGodPower("+a+", \"Inferno\", v, v);");
						code("infernoCredit = owner;");
					code("} else {");
						code("grantGodPowerNoRechargeNextPosition("+c+", \"Inferno\", 1);");
						code("trTechInvokeGodPower("+c+", \"Inferno\", v, v);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Promethean Small")+"){");
					code("trUnitChangeProtoUnit(\"Vermilion Bird\");");
				code("}");
				code("if(type == "+getUnitIdFromName("Ballista Shot")+"){");
					code("excludeDestroy = true;"); //Performance
					addToDatabase("BallistaShot");
				code("}");
				code("if(type == "+getUnitIdFromName("Meteor")+"){");
					code("damagePlayersInVectorArea(v, 1000.0, 5.0, trQuestVarGet(\"cow\"));");
				code("}");
				code("if(type == "+getUnitIdFromName("SPCMeteor")+"){");
					code("damagePlayersInVectorArea(v, 4000.0, 5.0, trQuestVarGet(\"cow\"));");
				code("}");
				code("if(type == "+getUnitIdFromName("Petrobolos Shot")+"){");
					addToDatabase("PetrobolosShot");
				code("}");
				code("if(type == "+getUnitIdFromName("Tower Mirror")+"){");
					code("trModifyProtounit(\"Tower Mirror\", owner, 9, 999999.0);");
					addToTimebase("TowerMirror");
					addToTimebase("Destroy12S");
				code("}");
				code("if(type == "+getUnitIdFromName("Guardian Sleeping XP")+"){");
					addToTimebase("Destroy12S");
				code("}");
				code("if(type == "+getUnitIdFromName("Volcano")+"){");
					code("if(owner == "+a+"){");
						code("damageEnemyInVectorArea(armageddonCredit, v, ",
								"getAttackMultiplierFinal(armageddonCredit) * heroBaseAttack(10) * getWitchArmageddonMultiplier(armageddonCredit), ",
								"5.0, trQuestVarGet(\"cow\"));");
						code("damagePlayersInVectorArea(v, ",
								"-0.1 * getHealthMultiplier(armageddonCredit) * heroBaseHealth(10) * getWitchArmageddonMultiplier(armageddonCredit), ",
								"5.0, trQuestVarGet(\"cow\"), false);");
						code("trUnitChangeProtoUnit(\"Qilin Heal\");");
					code("} else {");
						code("if(round == 6){");
							code("damagePlayersInVectorArea(v, 5000.0, 5.0, trQuestVarGet(\"cow\"));");
						code("} else {");
							code("trUnitChangeProtoUnit(\"Lampades Blood\");");
							code("damagePlayersInVectorArea(v, 100.0, 5.0, trQuestVarGet(\"cow\"));");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Meteorite")+"){");
					code("if(owner == "+a+"){");
						code("damageEnemyInVectorArea(armageddonCredit, v, ",
								"getAttackMultiplierFinal(armageddonCredit) * heroBaseAttack(10) * getWitchArmageddonMultiplier(armageddonCredit), ",
								"5.0, trQuestVarGet(\"cow\"));");
						code("damagePlayersInVectorArea(v, ",
								"-0.1 * getHealthMultiplier(armageddonCredit) * heroBaseHealth(10) * getWitchArmageddonMultiplier(armageddonCredit), ",
								"5.0, trQuestVarGet(\"cow\"), false);");
						code("trMutateSelected("+getUnitIdFromName("Osiris Birth")+");");
						addToTimebase("Argmageddon");
					code("} else if(round != 6) {");
						code("trUnitConvert("+a+");");
						code("trMutateSelected("+getUnitIdFromName("Bolder Wall")+");");
						code("trSetSelectedScale(-1.0, 1.0, -1.0);");
						addToTimebase("Destroy12S");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Chicken Blood")+"){");
					code("damagePlayersInVectorArea(v, 5000.0, 5.0, trQuestVarGet(\"cow\"));");
				code("}");
				code("if(type == "+getUnitIdFromName("Chicken Exploding")+"){");
					code("trSetSelectedScale(3.0, 3.0, 3.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Tartarian Gate")+"){");
					code("if(owner == "+c+"){");
						code("if(round <= 5){");
							code("trUnitChangeProtoUnit(\"Cinematic Block\");");
							code("trMutateSelected("+getUnitIdFromName("Implode Sphere Effect")+");");
							code("trUnitOverrideAnimation(18, 0, true, false, -1);");
						code("} else {");
							code("trUnitChangeProtoUnit(\"Animal Attractor\");");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Tartarian Gate Spawn")+"){");
					code("if(round <= 5){");
						code("trUnitChangeProtoUnit(\"Tornado\");");
						code("trMutateSelected("+getUnitIdFromName("Vortex Finish Linked")+");");
						code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
						addToTimebase("Destroy1In30");
					code("} else {");
						code("trSetSelectedScale(2.0, 2.0, 2.0);");
						addToDatabase("GateSpawn");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Tartarian Gate Flame")+"){");
					code("if(owner == 0){");
						code("if(round <= 5){");
							code("trUnitChangeProtoUnit(\"Vortex Finish Linked\");");
							code("trUnitSetAnimationPath(\"0,0,1,0,0,0,0\");");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Tartarian Gate Birth")+"){");
					code("if(owner == 0){");
						code("if(round <= 5){");
							code("trUnitChangeProtoUnit(\"Vortex Landing\");");
							code("trUnitSetAnimationPath(\"0,0,1,0,0,0,0\");");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Old Man")+"){");
					code("if(kbIsPlayerResigned(owner)){");
						code("trUnitChangeProtoUnit(\"Fimbulwinter Sfx\");");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Vision Revealer")+"){");
					code("if(getHeroIndex(owner) == 1){");
						code("vector healHeroPos = kbGetBlockPosition(\"\"+owner);");
						code("for(p = 1; <= "+h+"){");
							code("if(getDead(p) == false){");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+p);");
								code("if(trUnitDistanceToPoint(xsVectorGetX(healHeroPos), 0.0, xsVectorGetZ(healHeroPos)) < 10.0){");
									code("trDamageUnitPercent(-30.0);");
									code("heroLoc = kbGetBlockPosition(\"\"+p);");
									code("deployLocUsingCineBlock(xsVectorGetX(heroLoc), xsVectorGetZ(heroLoc), \"Recreation\", p);");
								code("}");
							code("}");
						code("}");
					code("} else if(getHeroIndex(owner) == 2){");
						databaseSearchStart("Summon");
						code("if(trUnitDead() == false && getOwner(trQuestVarGet(\"cow\")) == owner){");
							code("if(type == "+getUnitIdFromName("Minotaur")+"){");
								code("trUnitChangeProtoUnit(\"Ajax\");");
								code("trUnitChangeProtoUnit(\"Minotaur\");");
							code("} else if(type == "+getUnitIdFromName("Wadjet")+"){");
								code("trUnitChangeProtoUnit(\"Ajax\");");
								code("trUnitChangeProtoUnit(\"Wadjet\");");
							code("} else if(type == "+getUnitIdFromName("Stymphalian Bird")+"){");
								code("trUnitChangeProtoUnit(\"Ajax\");");
								code("trUnitChangeProtoUnit(\"Stymphalian Bird\");");
							code("}");
							code("trDamageUnitPercent(-100.0);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(trGetNextUnitScenarioNameNumber() - 2), true);");
							code("trUnitChangeProtoUnit(\"Recreation\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("}");
						databaseSearchEnd();
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("} else if(getHeroIndex(owner) == 4){");
						code("for(p = 1; <= "+h+"){");
							code("if(getDead(p) == false){");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+p);");
								code("trDamageUnitPercent(-20.0);");
								code("heroLoc = kbGetBlockPosition(\"\"+p);");
								code("deployLocUsingCineBlock(xsVectorGetX(heroLoc), xsVectorGetZ(heroLoc), \"Recreation\", p);");
							code("}");
						code("}");
					code("} else if(getHeroIndex(owner) == 5){");
						code("int tauntRadius = getMaidenTauntRadius(owner);");
						code("heroLoc = kbGetBlockPosition(\"\"+owner);");
						databaseSearchStart("Enemy");
						code("if(trUnitPercentDamaged() < 100.0){");
							code("if(trUnitDistanceToPoint(xsVectorGetX(heroLoc), 0.0, xsVectorGetZ(heroLoc)) <= tauntRadius){");
								code("trUnitDoWorkOnUnit(\"\"+owner, -1);");
							code("}");
						code("}");
						databaseSearchEnd();
						code("deployLocUsingCineBlock(xsVectorGetX(heroLoc), xsVectorGetZ(heroLoc), \"TimberHarvest\", owner);");
					code("} else if(getHeroIndex(owner) == 8){");
						code("int scareRadius = getShamanScareRadius(owner);");
						code("heroLoc = kbGetBlockPosition(\"\"+owner);");
						databaseSearchStart("Enemy");
						code("if(trUnitPercentDamaged() < 100.0){");
							code("if(trUnitDistanceToPoint(xsVectorGetX(heroLoc), 0.0, xsVectorGetZ(heroLoc)) <= scareRadius){");
								code("vector enemyV = getPosition(trQuestVarGet(\"ySearchUnit\"));");
								code("vector fleeV = xsVectorNormalize(xsVectorSet(xsVectorGetX(enemyV) - xsVectorGetX(heroLoc), 0.0, ",
										"xsVectorGetZ(enemyV) - xsVectorGetZ(heroLoc)));");
								code("trUnitMoveToPoint(xsVectorGetX(heroLoc) + xsVectorGetX(fleeV) * scareRadius, 0.0, ",
										"xsVectorGetZ(heroLoc) + xsVectorGetZ(fleeV) * scareRadius, -1, false);");
							code("}");
						code("}");
						databaseSearchEnd();
						code("deployLocUsingCineBlock(xsVectorGetX(heroLoc), xsVectorGetZ(heroLoc), \"Increase Prosperity Large\", owner);");
					code("} else if(getHeroIndex(owner) == 9){");
						code("setGhostWalkTime(owner, getGhostWalkTime(owner) + getAssassinGhostWalkDuration(owner));");
					code("} else if(getHeroIndex(owner) == 11){");
						code("if(kbGetUnitBaseTypeID(kbGetBlockID(\"\"+owner)) == "+getUnitIdFromName("Hero Greek Hippolyta")+"){");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+owner);");
							code("trMutateSelected("+getUnitIdFromName("Raven")+");");
						code("} else if(kbGetUnitBaseTypeID(kbGetBlockID(\"\"+owner)) == "+getUnitIdFromName("Raven")+"){");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+owner);");
							code("trMutateSelected("+getUnitIdFromName("Hero Greek Hippolyta")+");");
						code("}");
					code("} else if(getHeroIndex(owner) == 12){");
						code("trSoundPlayPaused(\"ceasefirebirth.wav\",\"-1\",-1,\"\",\"\");");
						code("if(ceaseFireTime < 0){");
							code("for(p = 1; <= "+h+"){");
								code("trPlayerSetDiplomacy("+c+", p, \"Neutral\");");
							code("}");
							code("ceaseFireTime = getBirdCeaseFireDuration(owner);");
							code("dM(\"Stop Combat\", 0, 1, 0.0, 20);");
						code("} else {");
							code("ceaseFireTime = ceaseFireTime + getBirdCeaseFireDuration(owner);");
						code("}");
					code("} else if(getHeroIndex(owner) == 14){");
						code("int teleportName = trGetNextUnitScenarioNameNumber();");
						code("while(teleportName == trGetNextUnitScenarioNameNumber()){");
							code("float teleportTileX = toTiles(randomFloat(0.0, 1.0));");
							code("float teleportTileZ = toTiles(randomFloat(0.0, 1.0));");
							code("if(trGetTerrainType(teleportTileX, teleportTileZ) == 0 || trGetTerrainType(teleportTileX, teleportTileZ) == 3",
									" || trGetTerrainType(teleportTileX, teleportTileZ) == 4){");
								code("deployLoc(2.0*teleportTileX+1.0, 2.0*teleportTileZ+1.0, \"Roc\", owner);");
							code("}");
						code("}");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+owner);");
						code("trImmediateUnitGarrison(\"\"+teleportName);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+teleportName, true);");
						code("trUnitChangeProtoUnit(\"Tartarian Gate Birth\");");
						code("trSetSelectedScale(0, 0, 0);");
						code("addToTimebaseAnytime(\"Destroy1S\", teleportName);");
						code("vector teleportLoc = getPosition(teleportName);");
						code("damageEnemyInVectorArea(owner, teleportLoc, ",
								"20.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(14), 8.0, -1);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+owner);");
						code("trUnitTeleport(xsVectorGetX(teleportLoc), xsVectorGetY(teleportLoc), xsVectorGetZ(teleportLoc));");
						code("if(trCurrentPlayer() == owner){");
							code("uiZoomToProto(\"\"+heroUnit(getHeroIndex(owner)));");
						code("}");
					code("}");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
				code("}");
				code("if(type == "+getUnitIdFromName("Vision Sfx")+" && trUnitDead() == false){");
					code("trUnitDestroy();");
				code("}");
				code("if(type == "+getUnitIdFromName("Temple")+" && owner != "+a+"){");
					addToDatabase("Temple");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Audrey")+" || type == "+getUnitIdFromName("Audrey Water")+"){");
					code("if(inShop){");
						code("trUnitChangeProtoUnit(\"Fimbulwinter Sfx\");");
						code("xsEnableRule(\"_OldManTimeout\");");
						code("trOverlayTextColour(255, 255, 0);");
						code("trOverlayText(\"Host has started one minute timeout...\", 5.0);");
					code("} else {");
						code("if(owner >= 1 && owner <= "+h+"){");
							code("if(getHeroIndex(owner) == 1){");
								code("int closestAlivePlayer = -1;");
								code("closestDistance = toMetres(2.0);");
								code("for(p = 1; <= "+h+"){");
									code("if(p != owner && getDead(p) == false && kbIsPlayerResigned(p) == false){");
										code("foundDistance = trUnitDistanceToUnit(\"\"+p);");
										code("if(foundDistance < closestDistance){");
											code("closestAlivePlayer = p;");
											code("closestDistance = foundDistance;");
										code("}");
									code("}");
								code("}");
								code("if(closestAlivePlayer > 0){");
									code("trUnitSelectClear();");
									code("trUnitSelect(\"\"+getSpyEye1(owner));");
									code("trUnitChangeProtoUnit(\"Well of Urd\");");
									code("trUnitSelectClear();");
									code("trUnitSelect(\"\"+closestAlivePlayer);");
									code("trDamageUnitPercent(-100.0);");
									code("trImmediateUnitGarrison(\"\"+getSpyEye1(owner));");
									code("trUnitSelectClear();");
									code("trUnitSelect(\"\"+getSpyEye1(owner));");
									code("trMutateSelected("+getUnitIdFromName("Cinematic Block")+");");
									code("trUnitChangeProtoUnit(\"Camera Start\");");
									code("vector rescueLoc = kbGetBlockPosition(\"\"+closestAlivePlayer);");
									code("deployLocUsingCineBlock(xsVectorGetX(rescueLoc), xsVectorGetZ(rescueLoc), \"Recreation\", closestAlivePlayer);");
									code("trUnitSelectClear();");
									code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
								code("} else {");
									code("if(trCurrentPlayer()==owner)trSoundPlayPaused(\"cantdothat.wav\",\"-1\",-1,\"\",\"\");");
									code("trChatSendToPlayer(0, owner, \"<color=1,0,1>Nobody to rescue!</color>\");");
									code("grantGodPowerNoRechargeNextPosition(owner, \"Audrey\", 1);");
								code("}");
								code("trUnitChangeProtoUnit(\"Heavenlight\");");
							code("}");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Audrey Base")+" || type == "+getUnitIdFromName("Audrey Water Base")+"){");
					code("if(inShop){");
						code("trUnitChangeProtoUnit(\"Fimbulwinter Sfx\");");
					code("} else {");
						code("if(owner >= 1 && owner <= "+h+"){");
							code("if(getHeroIndex(owner) == 1){");
								code("trUnitChangeProtoUnit(\"Vortex Start Linked\");");
							code("}");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Tower")+"){");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Guild")+"){");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Sky Passage")+"){");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Wall Connector")+"){");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Wall Short")+"){");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Wall Medium")+"){");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Wall Long")+"){");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Dock")+"){");
					addToDatabase("Building");
				code("}");
				code("if(type == "+getUnitIdFromName("Bireme")+"){");
					addToDatabase("Bireme");
				code("}");
				code("if(type == "+getUnitIdFromName("Implode Pull Effect")+"){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Fimbulwinter Sfx")+"){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Stymph Bird Feather")+"){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Wadjet Spit")+"){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Monkey King")+" && trUnitDead()){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Regeneration Sfx")+"){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Cyclops")+" && trUnitDead()){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Traitors Effect")+"){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Priest Projectile")+"){");
					code("excludeDestroy = true;"); //Performance
				code("}");
				code("if(type == "+getUnitIdFromName("Titan Gaia")+"){");
					addToTimebase("Destroy5S");
				code("}");
				code("if(type == "+getUnitIdFromName("Osiris Lightning")+"){");
					code("if(owner >= 1 && owner <= "+h+"){");
						code("trMutateSelected("+getUnitIdFromName("Implode Lightning Effect")+");");
						code("trUnitSetAnimationPath(\"0,0,0,0,0,0,0\");");
						code("if(getLightningTriggered(owner) == false){");
							code("int closestCirce = owner;");
							code("closestDistance = trUnitDistanceToUnit(\"\"+owner);");
							databaseSearchStart("Circe");
							code("if(getOwner(trQuestVarGet(\"ySearchUnit\")) == owner){");
								code("foundDistance = trUnitDistanceToUnit(\"\"+1*trQuestVarGet(\"Cow\"));");
								code("if(foundDistance < closestDistance){");
									code("closestCirce = 1*trQuestVarGet(\"ySearchUnit\");");
									code("closestDistance = foundDistance;");
								code("}");
							code("}");
							databaseSearchEnd();
							code("heroLoc = kbGetBlockPosition(\"\"+closestCirce);");
							code("setLightningTriggered(owner, true);");
							code("if(getWitchMeleeDamageUnlocked(owner)){");
								code("int traitorEffect = deployLocUsingCineBlock(xsVectorGetX(heroLoc), xsVectorGetZ(heroLoc), \"Traitors Effect\", owner);");
								code("if(traitorEffect >= 0){");
									code("trUnitSelectClear();");
									code("trUnitSelect(\"\"+traitorEffect, true);");
									code("trSetSelectedUpVector(0.0, -0.9, 0.0);");
								code("}");
								code("damageEnemyInVectorArea(owner, heroLoc, ",
										"heroBaseAttack(10) * getAttackMultiplierFinal(owner) * getWitchMeleeDamageMultiplier(owner), ",
										"3.0, trQuestVarGet(\"cow\"));");
							code("}");
							code("if(getWitchShockwaveChance(owner) >= randomInt(1, 100)){");
								code("grantGodPowerNoRechargeNextPosition("+a+", \"Tremor\", 1);");
								code("trTechInvokeGodPower("+a+", \"Tremor\", v, v);");
							code("}");
						code("}");
					code("}");
				code("}");
				code("if(kbProtoUnitIsUnitType(type, 1087)){"); //Walking woods
					code("if(owner >= 1 && owner <= "+h+"){");
						code("if(getHeroIndex(owner) == 11){");
							code("if(cinematicForestMap){");
								code("trUnitChangeProtoUnit(\"Ajax\");");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+(trGetNextUnitScenarioNameNumber() - 1), true);");
								code("trUnitChangeProtoUnit(\"Oak Tree\");");
								code("trSetSelectedScale(1.0, 0.0, 0.0);");
								code("trUnitSelectClear();");
								code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("}");
							code("trUnitChangeProtoUnit(\"Vortex Finish Linked\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
							code("trMutateSelected("+getUnitIdFromName("Harpy")+");");
							code("trSetSelectedScale(0.0, 0.0, 0.0);");
							code("trUnitOverrideAnimation(1, 0, true, false, -1);");
							code("damageEnemyInVectorArea(owner, v, ",
									"5.0 * getRogueForestExplosionAttackMultiplier(owner) * getAttackMultiplierFinal(owner) * heroBaseAttack(11), 5.0, -1);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Transport Ship Greek")+"){");
					code("trUnitChangeProtoUnit(\"Anubite\");");
					code("trUnitChangeProtoUnit(\"Spy Eye\");");
					code("trMutateSelected("+getUnitIdFromName("Osiris Box Glow")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trSetSelectedUpVector(0.0, 8.0, 0.0);");
					code("trSetSelectedScale(0.0, 1.0, 0.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Transport Ship Chinese")+"){");
					code("trUnitChangeProtoUnit(\"Spy Eye\");");
					code("trMutateSelected("+getUnitIdFromName("Tornado")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trSetSelectedUpVector(0.0, 10.0, 0.0);");
					code("trSetSelectedScale(0.0, 1.0, 0.0);");
					code("trUnitOverrideAnimation(1, 0, true, false, -1);");
				code("}");
				code("if(type == "+getUnitIdFromName("Transport Ship Norse")+"){");
					code("trUnitChangeProtoUnit(\"Mist\");");
				code("}");
				code("if(type == "+getUnitIdFromName("Villager Greek")+"){");
					code("trUnitChangeProtoUnit(\"Longhouse\");");
				code("}");
				code("if(type == "+getUnitIdFromName("Villager Egyptian")+"){");
					code("trUnitChangeProtoUnit(\"Tent\");");
				code("}");
				code("if(type == "+getUnitIdFromName("Villager Norse")+"){");
					code("trUnitChangeProtoUnit(\"Torch\");");
				code("}");
				code("if(type == "+getUnitIdFromName("Minion")+" || type == "+getUnitIdFromName("Jiangshi")+"){");
					code("if(owner >= 1 && owner <= "+h+" && getHeroIndex(owner) == 6){");
						addToDatabase("Minion");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Minion")+" || type == "+getUnitIdFromName("Ghost Ship")+"){");
					code("if(owner >= 1 && owner <= "+h+" && getHeroIndex(owner) == 12){");
						code("trUnitChangeProtoUnit(\"Spy Eye\");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trMutateSelected("+getUnitIdFromName("Skult")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trUnitOverrideAnimation(25, 0, true, false, -1);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
						code("trUnitSetAnimationPath(\"6,0,0,0,0,0,0\");");
						code("damageEnemyInVectorArea(owner, v, ",
								"3.0 * getBirdRavenDamageMultiplier(owner) * getAttackMultiplierFinal(owner) * heroBaseAttack(12), 5.0, -1);");
						addToTimebase("Destroy2S");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Stop Combat")+"){");
					addToDatabase("StopCombat");
				code("}");
				code("if(type == "+getUnitIdFromName("Ape of Set")+" && owner >= 1 && owner <= "+h+" && getHeroIndex(owner) == 13){");
					code("trChatSendSpoofed(owner, \"<color=1,0,0.5>Forged:</color> \" + getRelicName(0));");
					code("trUnitChangeProtoUnit(\"Bush\");");
					code("trMutateSelected("+getUnitIdFromName("Relic")+");");
					code("trSetRelicType(461);");
					addToDatabase("AttackRelic");
					code("trModifyProtounit(\"Ape of Set\", owner, 10, -1);");
					code("if(trCurrentPlayer() == owner){");
						code("trSoundPlayPaused(\"relicselect.wav\",\"-1\",-1,\"\",\"\");");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Gazelle of Set")+"){");
					code("trChatSendSpoofed(owner, \"<color=1,0,0.5>Forged:</color> \" + getRelicName(1));");
					code("trUnitChangeProtoUnit(\"Bush\");");
					code("trMutateSelected("+getUnitIdFromName("Relic")+");");
					code("trSetRelicType(461);");
					addToDatabase("ProjectileRelic");
					code("trModifyProtounit(\"Gazelle of Set\", owner, 10, -1);");
					code("if(trCurrentPlayer() == owner){");
						code("trSoundPlayPaused(\"relicselect.wav\",\"-1\",-1,\"\",\"\");");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Hyena of Set")+"){");
					code("trChatSendSpoofed(owner, \"<color=1,0,0.5>Forged:</color> \" + getRelicName(2));");
					code("trUnitChangeProtoUnit(\"Bush\");");
					code("trMutateSelected("+getUnitIdFromName("Relic")+");");
					code("trSetRelicType(461);");
					addToDatabase("RangeRelic");
					code("trModifyProtounit(\"Hyena of Set\", owner, 10, -1);");
					code("if(trCurrentPlayer() == owner){");
						code("trSoundPlayPaused(\"relicselect.wav\",\"-1\",-1,\"\",\"\");");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Crocodile of Set")+"){");
					code("trChatSendSpoofed(owner, \"<color=1,0,0.5>Forged:</color> \" + getRelicName(3));");
					code("trUnitChangeProtoUnit(\"Bush\");");
					code("trMutateSelected("+getUnitIdFromName("Relic")+");");
					code("trSetRelicType(461);");
					addToDatabase("FavourRelic");
					code("trModifyProtounit(\"Crocodile of Set\", owner, 10, -1);");
					code("if(trCurrentPlayer() == owner){");
						code("trSoundPlayPaused(\"relicselect.wav\",\"-1\",-1,\"\",\"\");");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Giraffe of Set")+"){");
					code("trChatSendSpoofed(owner, \"<color=1,0,0.5>Forged:</color> \" + getRelicName(4));");
					code("trUnitChangeProtoUnit(\"Bush\");");
					code("trMutateSelected("+getUnitIdFromName("Relic")+");");
					code("trSetRelicType(461);");
					addToDatabase("RechargeRelic");
					code("trModifyProtounit(\"Giraffe of Set\", owner, 10, -1);");
					code("if(trCurrentPlayer() == owner){");
						code("trSoundPlayPaused(\"relicselect.wav\",\"-1\",-1,\"\",\"\");");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Hippo of Set")+"){");
					code("trUnitDestroy();");
					code("int miningCampName = trGetNextUnitScenarioNameNumber();");
					code("deployLoc(x, z, \"Mining Camp\", owner);");
					code("if(miningCampName == trGetNextUnitScenarioNameNumber()){");
						code("trChatSendToPlayer(0, owner, \"<color=1,0,1>Failed to place mining camp</color>\");");
					code("} else {");
						code("if(getMiningCamp(owner) >= 0){");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+getMiningCamp(owner), true);");
							code("if(trUnitAlive()){");
								code("trUnitChangeProtoUnit(\"Curse Sfx\");");
							code("}");
						code("}");
						code("setMiningCamp(owner, miningCampName);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+miningCampName, true);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Rhinoceros of Set")+"){");
					code("trUnitDestroy();");
					code("int lighthouseName = trGetNextUnitScenarioNameNumber();");
					code("deployLoc(x, z, \"Lighthouse\", owner);");
					code("if(lighthouseName == trGetNextUnitScenarioNameNumber()){");
						code("trChatSendToPlayer(0, owner, \"<color=1,0,1>Failed to place lighthouse</color>\");");
					code("} else {");
						code("if(getLighthouse(owner) >= 0){");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+getLighthouse(owner), true);");
							code("if(trUnitAlive()){");
								code("trUnitChangeProtoUnit(\"Curse Sfx\");");
							code("}");
						code("}");
						code("if(getLighthouseSpawn(owner) >= 0){");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+getLighthouseSpawn(owner), true);");
							code("trUnitDestroy();");
						code("}");
						code("setLighthouse(owner, lighthouseName);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+lighthouseName, true);");
						code("setLighthouseSpawn(owner, trGetNextUnitScenarioNameNumber() + 1);");
						code("trUnitChangeProtoUnit(\"Ajax\");");
						code("trMutateSelected("+getUnitIdFromName("Lighthouse")+");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+getLighthouseSpawn(owner), true);");
						code("trUnitChangeProtoUnit(\"Cinematic Block\");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+lighthouseName, true);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Fire object")+"){");
					code("if(owner == 0) {");
						code("trSetSelectedUpVector(0.0, 2.0, 0.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Fire object Big")+"){");
					code("if(owner == 0) {");
						code("trSetSelectedUpVector(0.0, 2.0, 0.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Hades Fire")+"){");
					code("if(owner == 0) {");
						code("trSetSelectedUpVector(0.0, 2.0, 0.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Tartarian Gate Birth")+"){");
					code("if(owner == 0) {");
						code("trSetSelectedScale(0.0, 0.0, 0.0);");
						code("trSetSelectedUpVector(0.0, 2.0, 0.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Taproot Large")+"){");
					code("if(round < 5){");
						code("float taprootScale = randomFloat(0.25, 0.5);");
						code("trSetSelectedScale(taprootScale, taprootScale, taprootScale);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Titan Gate")+"){");
					code("setSelectedUnitHeadingDegrees(randomFloat(0.0, 360.0));");
					code("trUnitChangeProtoUnit(\"Gold Mine\");");
				code("}");
				code("if(type == "+getUnitIdFromName("Minotaur")+"){");
					addToDatabase("Summon");
				code("}");
				code("if(type == "+getUnitIdFromName("Wadjet")+"){");
					addToDatabase("Summon");
				code("}");
				code("if(type == "+getUnitIdFromName("Stymphalian Bird")+"){");
					addToDatabase("Summon");
				code("}");
				code("if(type == "+getUnitIdFromName("Zebra")+"){");
					code("trUnitConvert("+a+");");
				code("}");
				code("if(type == "+getUnitIdFromName("Elephant")+"){");
					code("trUnitConvert("+a+");");
				code("}");
				code("if(type == "+getUnitIdFromName("Water Buffalo")+"){");
					code("trUnitConvert("+a+");");
				code("}");
				code("if(type == "+getUnitIdFromName("Oar Footprint")+"){");
					code("trUnitConvert("+a+");");
					code("trUnitChangeProtoUnit(\"Ajax\");");
					code("trUnitSelectClear();");
					code("int tornadoUnit = trGetNextUnitScenarioNameNumber() - 1;");
					code("trUnitSelect(\"\"+tornadoUnit, true);");
					code("trUnitChangeProtoUnit(\"Tornado\");");
					code("trUnitOverrideAnimation(15, 0, true, false, -1);");
					code("trMutateSelected("+getUnitIdFromName("Relic")+");");
					code("trImmediateUnitGarrison(\"\"+1*trQuestVarGet(\"cow\"));");
					code("trMutateSelected("+getUnitIdFromName("Tornado")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trMutateSelected("+getUnitIdFromName("Vulture")+");");
					code("trSetSelectedScale(0.0, 24.0, 0.0);");
					code("addToDatabaseAnytime(\"TornadoWeak\", tornadoUnit);");
				code("}");
				code("if(type == "+getUnitIdFromName("Flood")+"){");
					addToDatabase("Flood");
				code("}");
				code("if(type == "+getUnitIdFromName("Summoning Tree 2")+"){");
					addToDatabase("SummoningTree");
					addToTimebase("SummoningTreeBurn");
				code("}");
				code("if(type == "+getUnitIdFromName("Footprint Animal Large")+"){");
					code("trUnitConvert("+a+");");
					code("trUnitChangeProtoUnit(\"Ajax\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+(trGetNextUnitScenarioNameNumber() - 1), true);");
					code("addToTimebaseAnytime(\"Destroy5S\", trGetNextUnitScenarioNameNumber() - 1);");
					code("trUnitChangeProtoUnit(\"Relic\");");
					code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
					code("trImmediateUnitGarrison(\"\"+1*trQuestVarGet(\"cow\"));");
					code("trMutateSelected("+getUnitIdFromName("Osiris Box Glow")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trMutateSelected("+getUnitIdFromName("Vulture")+");");
					code("trSetSelectedScale(0.0, 27.0, 0.0);");
					addToDatabase("OsirisBoxGlow");
					addToTimebase("Destroy5S");
				code("}");
				code("if(type == "+getUnitIdFromName("Vortex Landing")+"){");
					addToDatabase("VortexSfx");
					addToTimebase("VortexLanding");
					addToTimebase("Destroy12S");
				code("}");
				code("if(type == "+getUnitIdFromName("Ball of Fire Invisible")+"){");
					addToDatabase("BallOfFireInvisible");
				code("}");
				code("if(type == "+getUnitIdFromName("Icy Footprint")+"){");
					code("trUnitChangeProtoUnit(\"Spy Eye\");");
					code("trMutateSelected("+getUnitIdFromName("Misc Stairs")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trSetSelectedScale(0.0, 0.0, 1.0);");
					code("trSetSelectedUpVector(0.0, 4.0, 0.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Plenty Flare")+"){");
					code("trUnitChangeProtoUnit(\"Cinematic Block\");");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Tamarisk Tree")+");");
					code("trUnitSetAnimationPath(\"4,0,0,0,0,0,0\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+(1*trQuestVarGet(\"cow\") - 1), true);");
					code("trUnitChangeProtoUnit(\"Anubite\");");
					code("trUnitConvert(owner);");
					code("trUnitChangeProtoUnit(\"Spy Eye\");");
					code("trMutateSelected("+getUnitIdFromName("Hesperides Tree")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("setLifebondTree(owner, 1*trQuestVarGet(\"cow\"));");
				code("}");
				code("if(type == "+getUnitIdFromName("Footprint Animal Small")+"){");
					code("trUnitChangeProtoUnit(\"Cinematic Block\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trMutateSelected("+getUnitIdFromName("Ajax")+");");
					code("int eagleRelic = trGetNextUnitScenarioNameNumber();");
					code("while(eagleRelic == trGetNextUnitScenarioNameNumber()){");
						code("dM(\"Relic\", 0, 1, 0.0, 1);");
					code("}");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+eagleRelic, true);");
					code("trImmediateUnitGarrison(\"\"+1*trQuestVarGet(\"cow\"));");
					code("trMutateSelected("+getUnitIdFromName("Garrison Flag Sky Passage")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trMutateSelected("+getUnitIdFromName("Eagle")+");");
					addToDatabase("WildEagleActivated");
				code("}");
				code("if(type == "+getUnitIdFromName("Footprint Cavalry")+"){");
					code("trUnitChangeProtoUnit(\"Cinematic Block\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trMutateSelected("+getUnitIdFromName("Harpy")+");");
					code("trSetSelectedScale(1.5, 1.5, 1.5);");
					addToDatabase("Harpy");
				code("}");
				code("if(type == "+getUnitIdFromName("Oak Tree Burning")+"){");
					code("if(cinematicForestMap){");
						code("trSetSelectedScale(0.0, 1.0, 0.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Oak Stump Burnt")+"){");
					code("if(cinematicForestMap){");
						code("trUnitChangeProtoUnit(\"Oak Tree\");");
						code("trSetSelectedScale(1.0, 0.0, 0.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Oak Stump")+"){");
					code("if(cinematicForestMap){");
						code("trUnitChangeProtoUnit(\"Oak Tree\");");
						code("trSetSelectedScale(1.0, 0.0, 0.0);");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Parrot")+"){");
					code("trUnitConvert("+a+");");
				code("}");
				code("if(type == "+getUnitIdFromName("Gold Mine Dwarven")+"){");
					addToDatabase("GoldMine");
				code("}");
				code("if(type == "+getUnitIdFromName("Lampades")+"){");
					code("trModifyProtounit(\"Lampades\", owner, 9, 999999.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Argus")+"){");
					code("trModifyProtounit(\"Argus\", owner, 9, 999999.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Mummy")+"){");
					code("trModifyProtounit(\"Mummy\", owner, 9, 999999.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Frost Giant")+"){");
					code("trModifyProtounit(\"Frost Giant\", owner, 9, 999999.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Medusa")+"){");
					code("trModifyProtounit(\"Medusa\", owner, 9, 999999.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Pine Stump")+"){");
					//Reduce lag from stumps
					code("trSetSelectedScale(-1.0, 1.0, -1.0);");
				code("}");
				code("if(type == "+getUnitIdFromName("Footprint Wheel")+"){");
					code("trUnitChangeProtoUnit(\"Cinematic Block\");");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("int rootTrap = -1;");
					code("for(i = 0; < 4){");
						code("rootTrap = trGetNextUnitScenarioNameNumber() + 1;");
						code("trUnitChangeProtoUnit(\"Ajax\");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+rootTrap, true);");
						code("setSelectedUnitHeadingDegrees(22.5 * i);");
						code("trUnitConvert("+a+");");
						code("trUnitChangeProtoUnit(\"Uproot 3x3\");");
						code("addToTimebaseAnytime(\"Kill12S\", rootTrap);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("}");
					code("for(i = 0; < 4){");
						code("rootTrap = trGetNextUnitScenarioNameNumber() + 1;");
						code("trUnitChangeProtoUnit(\"Ajax\");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+rootTrap, true);");
						code("trUnitChangeProtoUnit(\"Spy Eye\");");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+rootTrap, true);");
						code("trMutateSelected("+getUnitIdFromName("Timeshift In")+");");
						code("trUnitSetAnimationPath(\"0,0,1,1,0,0,0\");");
						code("trSetSelectedUpVector(0.0, -0.5, 0.0);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+rootTrap, true);");
						code("addToTimebaseAnytime(\"Destroy12S\", rootTrap);");
						code("trUnitSelectClear();");
						code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("}");
					code("trUnitChangeProtoUnit(\"Cinematic Block\");");
					code("trUnitSetAnimationPath(\"3,0,0,0,0,0,0\");");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Tamarisk Tree")+");");
					addToDatabase("RootTrap");
					addToTimebase("Destroy12S");
				code("}");
				code("if(type == "+getUnitIdFromName("Footprint Villager")+"){");
					code("trUnitChangeProtoUnit(\"Spy Eye\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trMutateSelected("+getUnitIdFromName("Geyser")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+1*trQuestVarGet(\"cow\"), true);");
					code("trUnitOverrideAnimation(26, 0, false, false, -1);");
					addToDatabase("GeyserTrap");
					addToTimebase("Destroy30S");
				code("}");
				code("if(type == "+getUnitIdFromName("Petosuchus Beam")+"){");
					code("if(owner == "+c+"){");
						code("vector petsuchosLoc = getPosition(boss3);");
						code("if(xsVectorGetX(petsuchosLoc) >= 0.0 && xsVectorGetZ(petsuchosLoc) >= 0){");
							code("float petsuchosDiffX = x - xsVectorGetX(petsuchosLoc);");
							code("float petsuchosDiffZ = z - xsVectorGetZ(petsuchosLoc);");
							code("float angle = xsAtan2(petsuchosDiffZ, petsuchosDiffX);");
							code("setSelectedUnitHeadingDegrees(angle*180.0/"+PI+");");
							code("trUnitChangeProtoUnit(\"Tornado\");");
							code("trMutateSelected("+getUnitIdFromName("Fire Hades")+");");
							addToDatabase("PetsuchosAttack");
							addToTimebase("Destroy30S");
						code("}");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Villager Atlantean")+"){");
					code("if(owner == "+c+"){");
						code("trUnitSetStance(\"Passive\");");
						addToDatabase("VillagerAtlantean");
					code("}");
				code("}");
				code("if(type == "+getUnitIdFromName("Titan Atlantean")+"){");
					addToDatabase("TitanAtlantean");
				code("}");
				code("if(type == "+getUnitIdFromName("Titan Gate Dead")+"){");
					code("trUnitChangeProtoUnit(\"Olympus Temple Sfx\");");
				code("}");
				//Destroy
				code("if(excludeDestroy == false){");
					code("if(volatileDestroy){");
						addToDatabase("VolatileDestroy");
					code("} else {");
						addToDatabase("Destroy");
					code("}");
				code("}");
				//SEARCH END CODE
			code("}");
			code("trQuestVarSet(\"cow\", 1*trQuestVarGet(\"cow\")+1);");
		code("}");
	code("}");
	code("if(switchToVolatile){");
		code("volatileDestroy = true;");
		code("switchToVolatile = false;");
	code("}");
	
	defineTrigger("PriestProjectile", true, true, false);
	databaseSearchStart("PriestProjectile");
	code("if(trUnitDead()){");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner >= 1 && owner <= "+h+"){");
			code("if(getHeroIndex(owner) == 4){");
				code("if(getWizardFlashChance(owner) >= randomInt(1, 100)){");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Titan Bad")+");");
					code("trUnitOverrideAnimation(25, 0, true, false, -1);");
					code("trUnitSetAnimationPath(\"2,0,0,0,0,0,0\");");
					addToVanishbaseFromDatabase("Flash");
				code("} else {");
					code("trMutateSelected("+getUnitIdFromName("Lampades")+");");
					code("trSetSelectedScale(0,0,0);");
				code("}");
			code("} else if(getHeroIndex(owner) == 13){");
				code("trMutateSelected("+getUnitIdFromName("Fimbulwinter Sfx")+");");
				code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
			code("} else if(getHeroIndex(owner) == 14){");
				code("if(getWarlockFireTornadoChance(owner) >= randomInt(1, 100)){");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Fire Siphon Fire")+");");
					addToVanishbaseFromDatabase("FireTornado");
				code("} else {");
					code("trSetSelectedScale(0,0,0);");
					code("trMutateSelected("+getUnitIdFromName("Promethean")+");");
					code("trUnitOverrideAnimation(6, 0, true, false, -1);");
				code("}");
			code("}");
		code("}");
		removeFromDatabase("PriestProjectile");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("FireLanceProjectile", true, true, false);
	databaseSearchStart("FireLanceProjectile");
	code("if(trUnitDead()){");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner == "+c+" || (owner >= 1 && owner <= "+h+" && (getHeroIndex(owner) == 1 || getHeroIndex(owner) == 10))){");
			code("int projectileType = randomInt(1, 400);");
			code("if(projectileType == 1){");
				code("trMutateSelected("+getUnitIdFromName("Osiris Birth")+");");
				addToVanishbaseFromDatabase("FireLanceProjectile1");
			code("} else if(projectileType <= 3) {");
				code("trMutateSelected("+getUnitIdFromName("Curse Sfx")+");");
				addToVanishbaseFromDatabase("FireLanceProjectile2");
			code("} else {");
				code("trMutateSelected("+getUnitIdFromName("Oracle Scout")+");");
				code("trUnitOverrideAnimation(52, 0, true, false, -1);");
				code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
				code("trSetSelectedScale(0.0, 0.0, 0.0);");
				addToVanishbaseFromDatabase("FireLanceProjectile3");
			code("}");
		code("}");
		removeFromDatabase("FireLanceProjectile");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Spear", true, true, false);
	databaseSearchStart("Spear");
	code("if(trUnitDead()){");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner >= 1 && owner <= "+h+"){");
			code("if(getHeroIndex(owner) == 3){");
				code("if(getAmazonPoisonChance(owner) >= randomInt(1, 100)){");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Troll")+");");
					code("trUnitOverrideAnimation(18, 0, true, false, -1);");
					addToVanishbaseFromDatabase("Poison");
				code("} else {");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Promethean")+");");
					code("trUnitOverrideAnimation(18, 0, true, false, -1);");
				code("}");
			code("}");
		code("}");
		removeFromDatabase("Spear");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("ArrowFlaming", true, true, false);
	databaseSearchStart("ArrowFlaming");
	code("if(trUnitDead()){");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner >= 1 && owner <= "+h+"){");
			code("int traits = 0;");
			code("if(getHeroIndex(owner) == 0){");
				code("trMutateSelected("+getUnitIdFromName("Priest Projectile")+");");
				code("trUnitSetAnimationPath(\"1,0,0,0,0,0\");");
				code("if(trPlayerUnitCountSpecific(owner, \"Armory\") > 0){");
					code("trPlayerGrantResources(owner, \"Food\", getBuilderArmoryFood(owner));");
				code("}");
			code("} else if(getHeroIndex(owner) == 2){");
				code("trMutateSelected("+getUnitIdFromName("Petsuchos")+");");
				code("trSetSelectedScale(0,0,0);");
				code("trUnitOverrideAnimation(1, 0, true, false, -1);");
			code("} else if(getHeroIndex(owner) == 7){");
				code("int specialMultiplier = 1.0;");
				code("if(getArcherSpecialActive(owner)){");
					code("specialMultiplier = specialMultiplier + getArcherSpecialMultiplier(owner);");
				code("}");
				code("if(getArcherMagicArrowChance(owner) * specialMultiplier >= randomInt(1, 100)){");
					code("traits = traits + 1;");
					addToVanishbaseFromDatabase("Magic");
				code("}");
				code("if(getArcherShockwaveArrowChance(owner) * specialMultiplier >= randomInt(1, 100)){");
					code("traits = traits + 2;");
					addToVanishbaseFromDatabase("Shockwave");
				code("}");
				code("if(getArcherBurningArrowChance(owner) * specialMultiplier >= randomInt(1, 100)){");
					code("traits = traits + 4;");
					addToDatabaseFromDatabase("Burning");
				code("}");
				code("if(traits == 0){");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Medusa")+");");
					code("trUnitOverrideAnimation(40, 0, true, false, -1);");
				code("} else if(traits == 1){");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Pharaoh of Osiris XP")+");");
					code("trUnitOverrideAnimation(50, 0, true, false, -1);");
				code("} else if(traits == 2){");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Arkantos God")+");");
					code("trUnitOverrideAnimation(26, 0, true, false, -1);");
				code("} else if(traits == 4){");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Meteorite")+");");
					code("trUnitOverrideAnimation(18, 0, true, false, -1);");
				code("} else {");
					code("trSetSelectedScale(0.0, 0.0, 0.0);");
					code("trMutateSelected("+getUnitIdFromName("Flying Purple Hippo")+");");
					code("trUnitOverrideAnimation(15, 0, true, false, -1);");
					code("if(trUnitVisToPlayer()){");
						code("trSoundPlayPaused(\"cinematics\24_in\magic.mp3\",\"-1\",-1,\"\",\"\");");
					code("}");
				code("}");
			code("} else if(getHeroIndex(owner) == 11){");
				code("if(getRogueHealChance(owner) >= randomInt(1, 100)){");
					code("traits = traits + 1;");
					addToVanishbaseFromDatabase("Heal");
				code("}");
				code("if(getRogueObliteratingChance(owner) >= randomInt(1, 100)){");
					code("traits = traits + 2;");
					addToVanishbaseFromDatabase("Obliterate");
				code("}");
				code("if(traits == 0){");
					code("trSetSelectedScale(2.0, 2.0, 2.0);");
					code("trMutateSelected("+getUnitIdFromName("Petosuchus Projectile")+");");
					code("trUnitHighlight(999999.0);");
				code("} else if(traits == 1){");
					code("trMutateSelected("+getUnitIdFromName("Curse Sfx")+");");
				code("} else if(traits >= 2){");
					code("trMutateSelected("+getUnitIdFromName("Implode Sphere")+");");
					code("trSetSelectedScale(2.0, 2.0, 2.0);");
				code("}");
			code("}");
		code("}");
		removeFromDatabase("ArrowFlaming");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Arrow", true, true, false);
	databaseSearchStart("Arrow");
	code("if(trUnitDead()){");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner >= 1 && owner <= "+h+"){");
			code("if(getHeroIndex(owner) == 0){");
				code("trMutateSelected("+getUnitIdFromName("Priest Projectile")+");");
				code("trUnitSetAnimationPath(\"1,0,0,0,0,0\");");
				code("if(trPlayerUnitCountSpecific(owner, \"Armory\") > 0){");
					code("trPlayerGrantResources(owner, \"Food\", getBuilderArmoryFood(owner));");
				code("}");
			code("} else if(getHeroIndex(owner) == 8){");
				code("trSetSelectedScale(0.0, 0.0, 0.0);");
				code("trMutateSelected("+getUnitIdFromName("Circe")+");");
				code("trUnitSetAnimationPath(\"0,1,0,0,0,0\");");
			code("}");
		code("} else if(owner == "+c+" && boss0 >= 0){");
			code("trMutateSelected("+getUnitIdFromName("Kronny Birth Sfx")+");");
			code("trUnitSetAnimationPath(\"0,1,0,0,0,0\");");
			addToVanishbaseFromDatabase("MedusaArrow");
		code("}");
		removeFromDatabase("Arrow");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("medusaArrowLand", true, true, false);
	startVanishbaseSearch("MedusaArrow");
	code("damagePlayersInArea(x, z, 200.0, 5.0);");
	code("int createdObject = deployLocUsingCineBlock(x, z, \"Arkantos God Out\", "+c+");");
	code("if(createdObject >= 0){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trUnitSetAnimationPath(\"0,1,1,0,1,0,0\");");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("Axe", true, true, false);
	databaseSearchStart("Axe");
	code("if(trUnitDead()){");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trMutateSelected("+getUnitIdFromName("Relic")+");");
		removeFromDatabase("Axe");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Burning", true, true, false);
	con("time250");
	databaseSearchStart("Burning");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Ball of Fire Impact\", owner);");
	code("damageEnemyInVectorArea(owner, v, 5.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(7), 4.0, -1);");
	databaseSearchEnd();
	
	defineTrigger("Manor", true, true, false);
	databaseSearchStart("Manor");
	code("if(trUnitPercentComplete() >= 100.0){");
		code("trUnitChangeProtoUnit(\"Spy Eye\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trMutateSelected("+getUnitIdFromName("Outpost")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trSetSelectedScale(0.0, 0.001, 0.0);");
		addToDatabaseFromDatabase("Mine");
		removeFromDatabase("Manor");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Mine", true, true, false);
	con("time250");
	databaseSearchStart("Mine");
	code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
	code("if(enemyInVectorArea(v, 3.0, trQuestVarGet(\"ySearchUnit\"))){");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("damageEnemyInVectorArea(owner, v,",
				"10.0 * getBuilderMineBlastMultiplier(owner) * getAttackMultiplierFinal(owner) * heroBaseAttack(0), ",
				"5.0, trQuestVarGet(\"ySearchUnit\"));");
		code("trUnitChangeProtoUnit(\"Argus\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trDamageUnitPercent(-100.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trUnitChangeProtoUnit(\"Cinematic Block\");");
		code("trMutateSelected("+getUnitIdFromName("Meteor Impact Ground")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("if(trUnitVisToPlayer()){");
			code("trSoundPlayPaused(\"meteorbighit.wav\",\"-1\",-1,\"\",\"\");");
		code("}");
		code("trUnitChangeInArea(0, 0, \"Jungle Tree\", \"Jungle Tree Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Jungle Palm\", \"Jungle Palm Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Palm\", \"Palm Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Savannah Tree\", \"Savannah tree Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Pine\", \"Pine Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Pine Snow\", \"Pine Snow Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Pine Dead\", \"Pine Dead Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Marsh Tree\", \"Marsh Tree Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Oak Tree\", \"Oak Tree Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Oak Autumn Tree\", \"Oak Autumn Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Tundra Tree\", \"Tundra Tree Burning\", 5.0);");
		code("trUnitChangeInArea(0, 0, \"Gaia Forest Tree\", \"Gaia Forest Tree Burning\", 5.0);");
		addToTimebaseFromDatabase("ResetMine");
		removeFromDatabase("Mine");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("ResetMine", true, true, false);
	con("time250");
	startTimebaseSearch("ResetMine", 10000);
	code("trUnitChangeProtoUnit(\"Spy Eye\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trMutateSelected("+getUnitIdFromName("Outpost")+");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trSetSelectedScale(0.0, 0.001, 0.0);");
	addToDatabaseFromDatabase("Mine");
	removeFromTimebase("ResetMine");
	endTimebaseSearch();
	
	defineTrigger("Farm", true, true, false);
	databaseSearchStart("Farm");
	code("if(trUnitPercentComplete() >= 100.0){");
		code("trUnitChangeProtoUnit(\"Spy Eye\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trMutateSelected("+getUnitIdFromName("Tartarian Gate")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trUnitOverrideAnimation(6, 0, true, false, -1, 0);");
		addToDatabaseFromDatabase("MagicHaze");
		addToTimebaseFromDatabase("MagicHaze");
		removeFromDatabase("Farm");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("MagicHaze", true, true, false);
	con("time250");
	databaseSearchStart("MagicHaze");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("damageEnemyInVectorArea(owner, getPosition(trQuestVarGet(\"ySearchUnit\")),",
			"1.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(0), 5.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("Temple", true, true, false);
	con("time250");
	databaseSearchStart("Temple");
	code("if(trUnitPercentComplete() >= 100.0){");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
		code("damagePlayersInVectorArea(v, ",
				"-0.0025 * getHealthMultiplier(owner) * heroBaseHealth(0) * getBuilderHealSpeed(owner), ",
				"10.0, -1, false, true);");
		code("applyHealingEffect(v, 10.0);");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Eagle", true, true, false);
	con("time250");
	databaseSearchStart("WildEagleActivated");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
	code("damagePlayersInVectorArea(v, ",
			"-0.005 * getHealthMultiplier(owner) * heroBaseHealth(12) * getBirdHealingEagleSpeed(owner), ",
			"10.0, -1, false, true);");
	code("applyHealingEffect(v, 10.0);");
	databaseSearchEnd();
	
	defineTrigger("Roc", true, true, false);
	con("time250");
	databaseSearchStart("Roc");
	code("trDamageUnitPercent(1.0);");
	code("if(trUnitPercentDamaged() >= 98.0){");
		code("trUnitChangeProtoUnit(\"Roc\");");
		code("trDamageUnitPercent(100.0);");
		removeFromDatabase("Roc");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("FarmUnit", true, true, false);
	databaseSearchStart("FarmUnit");
	code("if(trUnitPercentComplete() >= 100.0){");
		code("trUnitChangeProtoUnit(\"Throwing Axeman\");");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(getMinerTwoForOneChance(owner) >= randomInt(1, 100)){");
			code("int extraUnit = trGetNextUnitScenarioNameNumber();");
			code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
			code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), \"Throwing Axeman\", owner);");
			code("if(extraUnit != trGetNextUnitScenarioNameNumber()){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+extraUnit, true);");
				code("trUnitChangeProtoUnit(\"Ajax\");");
				code("trUnitChangeProtoUnit(\"Throwing Axeman\");");
				code("int extraUnitEffect = trGetNextUnitScenarioNameNumber() - 2;");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+extraUnitEffect, true);");
				code("trUnitChangeProtoUnit(\"Traitors Effect\");");
				code("trSetSelectedUpVector(0.0, -0.75, 0.0);");
				code("trUnitSetAnimationPath(\"0,1,1,0,0,0,0\");");
			code("}");
		code("}");
		code("trModifyProtounit(\"Farm\", getOwner(trQuestVarGet(\"ySearchUnit\")), 16, 30.0);");
		removeFromDatabase("FarmUnit");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Enemy", true, true, false);
	con("time250");
	code("enemyCount = 0;");
	code("vector v = vector(0.0, 0.0, 0.0);");
	code("for(p = 1; <= "+h+"){");
		code("setFlareAllowed(p, true);");
	code("}");
	databaseSearchStart("Enemy");
	code("if(trUnitPercentDamaged() >= 100.0){");
		code("for(p = 1; <= "+h+"){");
			code("if((getHeroIndex(p)==6 || getHeroIndex(p)==3 || getHeroIndex(p)==1 || getHeroIndex(p)==10 || getHeroIndex(p)==14) ",
					"&& getDead(p) == false){");
				code("vector heroV = kbGetBlockPosition(\"\"+p);");
				code("v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
				code("float diffX = 0.0;");
				code("float diffZ = 0.0;");
				code("float distanceSquared = 0.0;");
				code("if(getHeroIndex(p) == 6){");
					code("diffX = xsVectorGetX(heroV) - xsVectorGetX(v);");
					code("diffZ = xsVectorGetZ(heroV) - xsVectorGetZ(v);");
					code("distanceSquared = getNecromancerRaiseDeadRadius(p) * getNecromancerRaiseDeadRadius(p);");
					code("if(diffX*diffX + diffZ*diffZ <= distanceSquared){");
						code("if(getNecromancerPowerfulMinionChance(p) >= randomInt(1, 100)){");
							code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), \"Jiangshi\", p);");
						code("} else {");
							code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), \"Minion\", p);");
						code("}");
					code("}");
				code("} else if(getHeroIndex(p) == 1 && getPaladinReviveChance(p) >= randomInt(1, 100)){");
					code("diffX = xsVectorGetX(heroV) - xsVectorGetX(v);");
					code("diffZ = xsVectorGetZ(heroV) - xsVectorGetZ(v);");
					code("if(diffX*diffX + diffZ*diffZ <= 16.0){");
						code("if(kbGetProtoUnitName(type) == \"Lampades\"){");
							code("setLampades(p, trGetNextUnitScenarioNameNumber());");
						code("}");
						code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), kbGetProtoUnitName(type), p);");
					code("}");
				code("} else if(getHeroIndex(p) == 3){");
					code("int carnivoraChance = getAmazonCarnivoraChance(p);");
					code("if(getLifebondActive(p)){");
						code("carnivoraChance = carnivoraChance * 2;");
					code("}");
					code("if(carnivoraChance >= randomInt(1, 100)){");
						code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Audrey\", p, 1, 5.0, true);");
					code("}");
				code("} else if(getHeroIndex(p) == 10 && getFlareAllowed(p) && getWitchManaFlareChance(p) >= randomInt(1, 100)){");
					code("diffX = xsVectorGetX(heroV) - xsVectorGetX(v);");
					code("diffZ = xsVectorGetZ(heroV) - xsVectorGetZ(v);");
					code("if(diffX*diffX + diffZ*diffZ <= 100.0){");
						code("setFlareAllowed(p, false);");
						code("damageEnemyInVectorArea(p, v, heroBaseAttack(10) * getAttackMultiplierFinal(p), 3.0, -1);");
						code("int flareUnit = trGetNextUnitScenarioNameNumber();");
						code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), \"Promethean\", 0);");
						code("if(flareUnit != trGetNextUnitScenarioNameNumber()){");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+flareUnit, true);");
							code("trUnitChangeProtoUnit(\"Spy Eye\");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+flareUnit, true);");
							code("trMutateSelected("+getUnitIdFromName("Promethean")+");");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+flareUnit, true);");
							code("trSetSelectedScale(0, 1, 0);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+flareUnit, true);");
							code("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
							code("addToTimebaseAnytime(\"Destroy1S\", flareUnit);");
						code("}");
					code("}");
				code("} else if(getHeroIndex(p) == 14 && getWarlockDeathFireChance(p) >= randomInt(1, 100)){");
					code("diffX = xsVectorGetX(heroV) - xsVectorGetX(v);");
					code("diffZ = xsVectorGetZ(heroV) - xsVectorGetZ(v);");
					code("if(diffX*diffX + diffZ*diffZ <= 100.0){");
						code("int fireUnit = trGetNextUnitScenarioNameNumber();");
						code("deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Tartarian Gate Flame\", p);");
						code("if(fireUnit != trGetNextUnitScenarioNameNumber()){");
							code("trUnitSelectClear();");
							code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
							code("addToDatabaseAnytime(\"DeathFire\", fireUnit);");
							code("addToTimebaseAnytime(\"Destroy5S\", fireUnit);");
						code("}");
					code("}");
				code("}");
			code("}");
		code("}");
		code("trDamageUnitPercent(100.0);");
		removeFromDatabase("Enemy");
	code("} else {");
		code("if(kbUnitGetAnimationActionType(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)) == 9){");
			code("if(randomInt(0, 10) == 0){");
				code("v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
				code("float x = xsVectorGetX(v);");
				code("float z = xsVectorGetZ(v);");
				code("trUnitMoveToPoint(x + randomFloat(-20.0, 20.0),0,z + randomFloat(-20.0, 20.0), -1, true);");
			code("}");
		code("}");
		code("enemyCount = enemyCount + 1;");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Flash", true, true, false);
	startVanishbaseSearch("Flash");
	code("deployLocUsingCineBlock(x, z, \"Arkantos God Out\", owner);");
	code("if(trUnitVisToPlayer()){");
		code("trSoundPlayPaused(\"xpack\xcinematics\10_a\arrkantosleave.mp3\",\"-1\",-1,\"\",\"\");");
	code("}");
	code("damageEnemyInVectorArea(owner, v, 10.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(4), 5.0, -1);");
	endVanishbaseSearch();
	
	defineTrigger("Shockwave", true, true, false);
	startVanishbaseSearch("Shockwave");
	code("grantGodPowerNoRechargeNextPosition("+a+", \"Tremor\", 1);");
	code("trTechInvokeGodPower("+a+", \"Tremor\", v, v);");
	endVanishbaseSearch();
	
	defineTrigger("Heal", true, true, false);
	code("bool soundPlayed = false;");
	startVanishbaseSearch("Heal");
	code("damagePlayersInVectorArea(v, -0.05 * getHealthMultiplier(owner) * heroBaseHealth(11), 6.0, -1, false);");
	code("applyHealingEffect(v, 6.0, \"Recreation\");");
	code("if(trUnitVisToPlayer() && soundPlayed == false){");
		code("trSoundPlayPaused(\"recreation.wav\",\"-1\",-1,\"\",\"\");");
		code("soundPlayed = true;");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("Obliterate", true, true, false);
	startVanishbaseSearch("Obliterate");
	code("int unitName = deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Spy Eye\", owner);");
	code("if(unitName >= 0){");
		code("trMutateSelected("+getUnitIdFromName("Underworld Explosion")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+unitName, true);");
		code("trSetSelectedUpVector(0.0, -1.0, 0.0);");
		code("trQuestVarSet(\"timebaseDestroy3S\"+(1*trQuestVarGet(\"timebaseCountDestroy3S\")), unitName);");
		code("trQuestVarSet(\"timebaseTimeDestroy3S\"+(1*trQuestVarGet(\"timebaseCountDestroy3S\")), trTimeMS());");
		code("trQuestVarSet(\"timebaseCountDestroy3S\", trQuestVarGet(\"timebaseCountDestroy3S\") + 1);");
	code("}");
	code("if(trUnitVisToPlayer()){");
		code("trSoundPlayPaused(\"inferno.wav\",\"-1\",-1,\"\",\"\");");
	code("}");
	code("damageEnemyInVectorArea(owner, v, heroBaseAttack(11) * getAttackMultiplierFinal(11) * 10.0, 8.0, -1);");
	endVanishbaseSearch();
	
	defineTrigger("FireTornado", true, true, false);
	startVanishbaseSearch("FireTornado");
	code("trModifyProtounit(\"Spy Eye\", owner, 8, getWarlockFireTornadoLifespan(owner));");
	code("int unitName = deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Spy Eye\", owner);");
	code("trModifyProtounit(\"Spy Eye\", owner, 8, 0.0 - getWarlockFireTornadoLifespan(owner));");
	code("if(unitName >= 0){");
		code("trMutateSelected("+getUnitIdFromName("Tornado Vermilion Bird")+");");
		code("addToDatabaseAnytime(\"FireTornado\", unitName);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("FireTornadoDamage", true, true, false);
	con("time250");
	databaseSearchStart("FireTornado");
	code("int owner = getOwner(1*trQuestVarGet(\"ySearchUnit\"));");
	code("vector v = getPosition(1*trQuestVarGet(\"ySearchUnit\"));");
	code("damageEnemyInVectorArea(owner, v, 0.25 * getAttackMultiplierFinal(owner) * heroBaseAttack(14), 3.0, -1);");
	databaseSearchEnd();
	
	defineTrigger("DeathFire", true, true, false);
	con("time250");
	databaseSearchStart("DeathFire");
	code("int owner = getOwner(1*trQuestVarGet(\"ySearchUnit\"));");
	code("vector v = getPosition(1*trQuestVarGet(\"ySearchUnit\"));");
	code("damageEnemyInVectorArea(owner, v, 0.25 * getAttackMultiplierFinal(owner) * heroBaseAttack(14), 3.0, -1);");
	databaseSearchEnd();
	
	defineTrigger("ForestFire", true, true, false);
	con("time250");
	databaseSearchStart("ForestFire");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("if(owner == "+c+"){");
		code("if(xsVectorGetX(v) <= 0 || xsVectorGetZ(v) <= 0){");
			code("trSetSelectedUpVector(0.0, 1000.0, 0.0);");
		code("} else {");
			code("trSetSelectedUpVector(0.0, 0.0, 0.0);");
			code("damagePlayersInVectorArea(v, 100.0, 6.0, trQuestVarGet(\"ySearchUnit\"));");
		code("}");
	code("} else {");
		code("damageEnemyInVectorArea(owner, v, ",
				"heroBaseAttack(3) * getAmazonForestFireDamageMultiplier(owner) * getAttackMultiplierFinal(owner), ",
				"4.0, -1);");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("CatapultShot", true, true, false);
	databaseSearchStart("CatapultShot");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Revealer To Player")+");");
		code("trUnitOverrideAnimation(0, 0, true, false, -1);");
		code("trUnitSetAnimationPath(\"1,0,0,0,0,0,0\");");
		addToVanishbaseFromDatabase("CatapultShot");
		removeFromDatabase("CatapultShot");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("MummyFlies", true, true, false);
	databaseSearchStart("MummyFlies");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Shade")+");");
		code("trUnitOverrideAnimation(18, 0, true, false, -1);");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		addToVanishbaseFromDatabase("MummyFlies");
		removeFromDatabase("MummyFlies");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("LampadesBolt", true, true, false);
	databaseSearchStart("LampadesBolt");
	code("if(trUnitDead()){");
		code("int shotEvent = randomInt(1, 10);");
		code("if(shotEvent <= 2){");
			code("trMutateSelected("+getUnitIdFromName("Vortex Start Linked")+");");
			addToVanishbaseFromDatabase("Teleport");
		code("} else if(shotEvent == 3) {");
			code("trMutateSelected("+getUnitIdFromName("Valkyrie")+");");
			code("trUnitOverrideAnimation(15, 0, true, false, -1);");
			code("trUnitSetAnimationPath(\"1,0,0,0,0,0,0\");");
			code("trSetSelectedScale(0.0, 0.0, 0.0);");
			addToVanishbaseFromDatabase("Tornado");
		code("} else {");
			addToVanishbaseFromDatabase("Blast");
			code("trMutateSelected("+getUnitIdFromName("Promethean")+");");
			code("trUnitOverrideAnimation(6, 0, true, false, -1);");
			code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("}");
		removeFromDatabase("LampadesBolt");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("TornadoDamage", true, true, false);
	con("time250");
	databaseSearchStart("Tornado");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("if(owner == "+c+"){");
		code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 100.0, 8.0, trQuestVarGet(\"ySearchUnit\"));");
	code("} else {");
		code("damageEnemyInVectorArea(tornadoCredit, getPosition(trQuestVarGet(\"ySearchUnit\")), ",
				"100.0, 8.0, trQuestVarGet(\"ySearchUnit\"));");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("TornadoDamageWeak", true, true, false);
	con("time250");
	databaseSearchStart("TornadoWeak");
	code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 20.0, 8.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("TsunamiDamage", true, true, false);
	con("time250");
	databaseSearchStart("Tsunami");
	code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 50.0, 6.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("FloodDamage", true, true, false);
	con("time250");
	databaseSearchStart("Flood");
	code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 5.0, 20.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("OsirisBoxGlowDamage", true, true, false);
	con("time250");
	databaseSearchStart("OsirisBoxGlow");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("if(owner == "+c+"){");
		code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 100.0, 4.0, trQuestVarGet(\"ySearchUnit\"));");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("VortexSfx", true, true, false);
	con("time250");
	databaseSearchStart("VortexSfx");
	code("if(type == "+getUnitIdFromName("Osiris Birth")+"){");
		removeFromDatabase("VortexSfx");
	code("}");
	code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("int vortexId = trGetNextUnitScenarioNameNumber();");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Cinematic Block\", "+c+", randomIntWeighted(0, 1, 2), 5.0, true);");
	code("if(vortexId != trGetNextUnitScenarioNameNumber()){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+vortexId, true);");
		code("trUnitChangeProtoUnit(\"Vortex Start Linked\");");
		code("trUnitSetAnimationPath(\"0,1,0,0,0,0,0\");");
		code("trSetSelectedUpVector(0.0, 5.0, 0.0);");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("VortexLanding", true, true, false);
	con("(trTime()-cActivationTime) >= 1");
	startTimebaseSearch("VortexLanding", 10000);
	removeFromTimebase("VortexLanding");
	code("trUnitChangeProtoUnit(\"Osiris Birth\");");
	code("trSetSelectedScale(0.0, 1.0, 0.0);");
	code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("int osirisId = trGetNextUnitScenarioNameNumber();");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Cinematic Block\", "+c+", 1, 0.0, true);");
	code("if(osirisId != trGetNextUnitScenarioNameNumber()){");
	code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+osirisId, true);");
		code("trUnitChangeProtoUnit(\"Anubite\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+osirisId, true);");
		code("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+osirisId, true);");
		code("trDamageUnitPercent(100.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+osirisId, true);");
		code("trSetSelectedScale(0.0, 10.0, 0.0);");
		code("float fireAngle = randomFloat(0, 360.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+osirisId, true);");
		code("setSelectedUnitHeadingDegrees(fireAngle);");
		code("modifyProtounitAbsolute(\"Kronny Flying\", "+c+", 1, 1.0);");
		code("addToDatabaseAnytime(\"OsirisAnimation\", osirisId);");
		code("addToDatabaseAnytime(\"DetectLand\", osirisId);");
		code("addToVanishbaseAnytime(\"OsirisCreate\", osirisId);");
	code("}");
	endTimebaseSearch();
	
	defineTrigger("OsirisAnimation", true, true, false);
	databaseSearchStart("OsirisAnimation");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Osiris")+");");
		code("trSetSelectedScale(1.0, 1.0, 1.0);");
		code("trUnitOverrideAnimation(25, 0, true, false, -1);");
		removeFromDatabase("OsirisAnimation");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("OsirisCreate", true, true, false);
	startVanishbaseSearch("OsirisCreate");
	code("deployLoc(x, z, \"Osiris\", "+c+");");
	endVanishbaseSearch();
	
	defineTrigger("RootTrap", true, true, false);
	con("time250");
	databaseSearchStart("RootTrap");
	code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 25.0, 5.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("GeyserTrap", true, true, false);
	con("time250");
	databaseSearchStart("GeyserTrap");
	code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 50.0, 2.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("PetsuchosAttack", true, true, false);
	con("time250");
	databaseSearchStart("PetsuchosAttack");
	code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 200.0, 3.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("BlueFlameAttack", true, true, false);
	con("time250");
	databaseSearchStart("BlueFlameAttack");
	code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 100.0, 3.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("BallOfFire", true, true, false);
	databaseSearchStart("BallOfFire");
	code("if(trUnitDead()){");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner == "+c+"){");
			code("trMutateSelected("+getUnitIdFromName("Meteorite")+");");
			code("trUnitOverrideAnimation(6, 0, true, false, -1);");
			code("trSetSelectedScale(0.0, 0.0, 0.0);");
			addToVanishbaseFromDatabase("BallOfFire");
		code("}");
		removeFromDatabase("BallOfFire");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("BallOfFireInvisible", true, true, false);
	databaseSearchStart("BallOfFireInvisible");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Kronny Birth Sfx")+");");
		code("trUnitSetAnimationPath(\"0,0,1,0,0,0,0\");");
		removeFromDatabase("BallOfFireInvisible");
		addToVanishbaseFromDatabase("LazerLand");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("LazerLand", true, true, false);
	startVanishbaseSearch("LazerLand");
	code("damagePlayersInArea(x, z, 200.0, 5.0);");
	code("int createdObject = deployLocUsingCineBlock(x, z, \"Arkantos God Out\", "+c+");");
	code("if(createdObject >= 0){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trUnitSetAnimationPath(\"0,1,1,1,0,0,0\");");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("SlingStone", true, true, false);
	databaseSearchStart("SlingStone");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Implode Sphere")+");");
		addToVanishbaseFromDatabase("SlingStone");
		removeFromDatabase("SlingStone");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("BallistaShot", true, true, false);
	databaseSearchStart("BallistaShot");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Victory Marker")+");");
		code("trUnitOverrideAnimation(0, 0, true, false, -1);");
		code("if(randomInt(1, 50) == 1){");
			code("trUnitSetAnimationPath(\"1,0,0,0,0,0,0\");");
			addToVanishbaseFromDatabase("BallistaShot1");
		code("} else {");
			code("trUnitSetAnimationPath(\"1,1,0,0,0,0,0\");");
			addToVanishbaseFromDatabase("BallistaShot2");
		code("}");
		removeFromDatabase("BallistaShot");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("PetrobolosShot", true, true, false);
	databaseSearchStart("PetrobolosShot");
	code("if(trUnitDead()){");
		code("trMutateSelected("+getUnitIdFromName("Phoenix Egg")+");");
		code("trSetSelectedScale(2.0, 2.0, 2.0);");
		addToVanishbaseFromDatabase("PetrobolosShot");
		removeFromDatabase("PetrobolosShot");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("GateSpawn", true, true, false);
	databaseSearchStart("GateSpawn");
	code("if(kbUnitGetAnimationActionType(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)) >= 0){");
		code("trUnitChangeProtoUnit(\"Kronny Birth Sfx\");");
		code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 2500.0, 4.0, trQuestVarGet(\"ySearchUnit\"));");
		removeFromDatabase("GateSpawn");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("PoisonCloud", true, true, false);
	con("time250");
	databaseSearchStart("PoisonCloud");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("damageEnemyInVectorArea(owner, getPosition(trQuestVarGet(\"ySearchUnit\")), ",
			"0.075 * getAttackMultiplierFinal(owner) * heroBaseAttack(9), 5.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("Curse", true, true, false);
	con("time250");
	databaseSearchStart("Curse");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("damageEnemyInVectorArea(owner, getPosition(trQuestVarGet(\"ySearchUnit\")), ",
			"0.0625 * getAttackMultiplierFinal(owner) * heroBaseAttack(10), 4.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("ShowDuplicate", true, true, false);
	con("time250");
	databaseSearchStart("Circe");
	code("if(trUnitDead()){");
		removeFromDatabase("Circe");
	code("} else {");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
		code("int unitName = deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Spy Eye\", owner);");
		code("if(unitName >= 0){");
			code("trMutateSelected("+getUnitIdFromName("Einheriar Boost Sfx")+");");
			code("trQuestVarSet(\"timebaseDestroy3S\"+(1*trQuestVarGet(\"timebaseCountDestroy3S\")), unitName);");
			code("trQuestVarSet(\"timebaseTimeDestroy3S\"+(1*trQuestVarGet(\"timebaseCountDestroy3S\")), trTimeMS());");
			code("trQuestVarSet(\"timebaseCountDestroy3S\", trQuestVarGet(\"timebaseCountDestroy3S\") + 1);");
		code("}");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("CollectGold", true, true, false);
	con("(trTime()-cActivationTime) >= 1");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 15 && kbUnitGetAnimationActionType(p) == 5){");
			code("trPlayerGrantResources(p, \"Gold\", 4.0 * getMinerMiningSpeed(p));");
		code("}");
	code("}");
	databaseSearchStart("CollectGold");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("if(kbUnitGetAnimationActionType(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)) == 5){");
		code("trPlayerGrantResources(owner, \"Gold\", getMinerMiningSpeed(owner));");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Magic", true, true, false);
	startVanishbaseSearch("Magic");
	code("deployLocUsingCineBlock(x, z, \"Implode Sphere Effect\", owner);");
	code("trSetSelectedScale(0.0, 0.0, 0.0);");
	code("trUnitOverrideAnimation(6, 0, true, false, -1, 0);");
	code("if(trUnitVisToPlayer()){");
		code("trSoundPlayPaused(\"implode explode.wav\",\"-1\",-1,\"\",\"\");");
	code("}");
	code("damageEnemyInVectorArea(owner, v, 10.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(7), 6.0, -1);");
	endVanishbaseSearch();
	
	defineTrigger("CatapultShotExplosion", true, true, false);
	startVanishbaseSearch("CatapultShot");
	code("deployLocUsingCineBlock(x, z, \"Vortex Finish Linked\", owner);");
	code("trSetSelectedScale(0.0, 0.0, 0.0);");
	code("trMutateSelected("+getUnitIdFromName("Hades Door")+");");
	code("trUnitOverrideAnimation(25, 0, false, false, -1, 0);");
	code("trUnitSetAnimationPath(\"3\");");
	code("trSetUnitOrientation(xsVectorSet(0.0,1.0,0.0), xsVectorSet(1.0,0.0,0.0), true);");
	code("if(owner < "+c+"){");
		code("damageEnemyInVectorArea(owner, v, 100.0, 5.0, -1);");
	code("} else {");
		code("damagePlayersInVectorArea(v, 100.0, 5.0, -1);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("SpiderAttack", true, true, false);
	startVanishbaseSearch("MummyFlies");
	code("deployLocUsingCineBlock(x, z, \"Vortex Finish Linked\", owner);");
	code("trSetSelectedScale(2.0, 2.0, 2.0);");
	code("trMutateSelected("+getUnitIdFromName("Spider")+");");
	code("trUnitOverrideAnimation(1, 0, false, false, -1, 0);");
	code("if(owner < "+c+"){");
		code("damageEnemyInVectorArea(owner, v, 200.0, 5.0, -1);");
	code("} else {");
		code("damagePlayersInVectorArea(v, 200.0, 5.0, -1);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("Teleport", true, true, false);
	startVanishbaseSearch("Teleport");
	code("int roc = deployLocUsingCineBlock(x, z, \"Roc\", owner);");
	code("trUnitSelectClear();");
	code("if(owner < "+c+"){");
		code("trUnitSelect(\"\"+getLampades(owner), true);");
	code("} else {");
		code("trUnitSelect(\"\"+boss4, true);");
	code("}");
	code("trImmediateUnitGarrison(\"\"+roc);");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+roc, true);");
	code("trMutateSelected("+getUnitIdFromName("Cinematic Block")+");");
	code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
	code("trSoundPlayPaused(\"pigout.wav\",\"-1\",-1,\"\",\"\");");
	endVanishbaseSearch();
	
	defineTrigger("TornadoCast", true, true, false);
	startVanishbaseSearch("Tornado");
	code("if(owner < "+c+"){");
		code("grantGodPowerNoRechargeNextPosition("+a+", \"Tornado\", 1);");
		code("trTechInvokeGodPower("+a+", \"Tornado\", v, v);");
		code("tornadoCredit = owner;");
	code("} else {");
		code("grantGodPowerNoRechargeNextPosition(owner, \"Tornado\", 1);");
		code("trTechInvokeGodPower(owner, \"Tornado\", v, v);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("Blast", true, true, false);
	startVanishbaseSearch("Blast");
	code("int volcano = deployLocUsingCineBlock(x, z, \"Olympus Temple Sfx\", owner);");
	code("if(owner < "+c+"){");
		code("damageEnemyInVectorArea(owner, v, 500.0, 5.0, -1);");
	code("} else {");
		code("damagePlayersInVectorArea(v, 500.0, 5.0, -1);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("BallOfFireActivate", true, true, false);
	startVanishbaseSearch("BallOfFire");
	code("deployLocUsingCineBlock(x, z, \"Traitors Effect\", owner);");
	code("damagePlayersInVectorArea(v, 1000.0, 5.0, -1);");
	code("grantGodPowerNoRechargeNextPosition(owner, \"SPCMeteor\", 1);");
	code("trTechInvokeGodPower(owner, \"SPCMeteor\", v, v);");
	endVanishbaseSearch();
	
	defineTrigger("SlingStoneActivate", true, true, false);
	startVanishbaseSearch("SlingStone");
	code("deployLocUsingCineBlock(x, z, \"Tartarian Gate Flame\", owner);");
	code("if(owner < "+c+"){");
		code("damageEnemyInVectorArea(owner, v, 30.0, 3.0, -1);");
	code("} else {");
		code("damagePlayersInVectorArea(v, 30.0, 3.0, -1);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("BallistaShotImplode", true, true, false);
	startVanishbaseSearch("BallistaShot1");
	code("if(inShop == false){");
		code("if(owner < "+c+"){");
			code("grantGodPowerNoRechargeNextPosition("+a+", \"Implode\", 1);");
			code("trTechInvokeGodPower("+a+", \"Implode\", v, v);");
		code("} else {");
			code("grantGodPowerNoRechargeNextPosition(owner, \"Implode\", 1);");
			code("trTechInvokeGodPower(owner, \"Implode\", v, v);");
		code("}");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("BallistaShotVanish", true, true, false);
	startVanishbaseSearch("BallistaShot2");
	code("deployLocUsingCineBlock(x, z, \"Crab Blood\", owner);");
	endVanishbaseSearch();
	
	defineTrigger("FireLanceProjectile1", true, true, false);
	startVanishbaseSearch("FireLanceProjectile1");
	code("if(owner < "+c+"){");
		code("grantGodPowerNoRechargeNextPosition("+a+", \"Restoration\", 1);");
		code("trTechInvokeGodPower("+a+", \"Restoration\", v, v);");
	code("} else {");
		code("grantGodPowerNoRechargeNextPosition(owner, \"Restoration\", 1);");
		code("trTechInvokeGodPower(owner, \"Restoration\", v, v);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("FireLanceProjectile2", true, true, false);
	startVanishbaseSearch("FireLanceProjectile2");
	code("if(owner == "+c+") {");
		code("grantGodPowerNoRechargeNextPosition(owner, \"Call to Arms\", 1);");
		code("trTechInvokeGodPower(owner, \"Call to Arms\", v, v);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("FireLanceProjectile3", true, true, false);
	startVanishbaseSearch("FireLanceProjectile3");
	code("if(owner < "+c+"){");
		code("damageEnemyInVectorArea(owner, v, 100.0, 3.0, -1);");
	code("} else {");
		code("damagePlayersInVectorArea(v, 100.0, 3.0, -1);");
	code("}");
	code("deployLocUsingCineBlock(x, z, \"Conversion Sfx\", owner);");
	endVanishbaseSearch();
	
	defineTrigger("PetrobolosShotActivate", true, true, false);
	startVanishbaseSearch("PetrobolosShot");
	code("int spyEye = deployLocUsingCineBlock(x, z, \"Spy Eye\", owner);");
	code("deployLocUsingCineBlock(x, z, \"Tower Mirror\", owner);");
	code("trSetSelectedScale(1.0, 0.35, 1.0);");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+spyEye, true);");
	code("trMutateSelected("+getUnitIdFromName("Guardian Sleeping Xp")+");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+spyEye, true);");
	code("trSetSelectedScale(0.0, 1.0, 0.0);");
	code("trUnitOverrideAnimation(0, 0, true, false, -1);");
	code("trUnitSetAnimationPath(\"2,0,0,0,0,0,0\");");
	endVanishbaseSearch();
	
	defineTrigger("Poison", true, true, false);
	startVanishbaseSearch("Poison");
	code("deployLoc(x, z, \"Lampades Blood\", owner);");
	code("damageEnemyInVectorArea(owner, v, getAttackMultiplierFinal(owner) * heroBaseAttack(3), 5.0, ",
		"trQuestVarGet(\"ySearchUnit\"));");
	endVanishbaseSearch();
	
	defineTrigger("TornadoDebris", true, true, false);
	startTimebaseSearch("TornadoDebris", 10000);
	code("trUnitChangeProtoUnit(\"Regeneration Sfx\");");
	removeFromTimebase("TornadoDebris");
	endTimebaseSearch();
	
	defineTrigger("TowerMirror", true, true, false);
	startTimebaseSearch("TowerMirror", 3000);
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Olympus Temple Sfx\", "+c+");");
	code("if(owner < "+c+"){");
		code("damageEnemyInVectorArea(owner, v, 1000.0, 4.0, -1);");
	code("} else {");
		code("damagePlayersInVectorArea(v, 1000.0, 4.0, -1);");
	code("}");
	endTimebaseSearch();
	
	defineTrigger("FireWall", true, true, false);
	con("time250");
	databaseSearchStart("FireWall");
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("damageEnemyInVectorArea(owner, getPosition(trQuestVarGet(\"ySearchUnit\")),",
			"0.25 * getAttackMultiplierFinal(owner) * heroBaseAttack(14), 3.0, trQuestVarGet(\"ySearchUnit\"));");
	databaseSearchEnd();
	
	defineTrigger("RocTent", true, true, false);
	startTimebaseSearch("RocTent", 2000);
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trUnitChangeProtoUnit(\"Vortex Finish Linked\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trMutateSelected("+getUnitIdFromName("Harpy")+");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trSetSelectedScale(0.0, 0.0, 0.0);");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trUnitOverrideAnimation(1, 0, true, false, -1);");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("damagePlayersInVectorArea(v, 1000.0, 8.0, -1);");
	removeFromTimebase("RocTent");
	endTimebaseSearch();
	
	defineTrigger("Destroy1S", true, true, false);
	startTimebaseSearch("Destroy1S", 1000);
	code("trUnitDestroy();");
	removeFromTimebase("Destroy1S");
	endTimebaseSearch();
	
	defineTrigger("Destroy2S", true, true, false);
	startTimebaseSearch("Destroy2S", 2000);
	code("trUnitDestroy();");
	removeFromTimebase("Destroy2S");
	endTimebaseSearch();
	
	defineTrigger("Destroy3S", true, true, false);
	startTimebaseSearch("Destroy3S", 3000);
	code("trUnitDestroy();");
	removeFromTimebase("Destroy3S");
	endTimebaseSearch();
	
	defineTrigger("Destroy5S", true, true, false);
	startTimebaseSearch("Destroy5S", 5000);
	code("trUnitDestroy();");
	removeFromTimebase("Destroy5S");
	endTimebaseSearch();
	
	defineTrigger("Destroy12S", true, true, false);
	startTimebaseSearch("Destroy12S", 12000);
	code("trUnitDestroy();");
	removeFromTimebase("Destroy12S");
	endTimebaseSearch();
	
	defineTrigger("Kill12S", true, true, false);
	startTimebaseSearch("Kill12S", 12000);
	code("trDamageUnitPercent(100.0);");
	removeFromTimebase("Kill12S");
	endTimebaseSearch();
	
	defineTrigger("Destroy15S", true, true, false);
	startTimebaseSearch("Destroy15S", 15000);
	code("trUnitDestroy();");
	removeFromTimebase("Destroy15S");
	endTimebaseSearch();
	
	defineTrigger("Destroy30S", true, true, false);
	startTimebaseSearch("Destroy30S", 30000);
	code("trUnitDestroy();");
	removeFromTimebase("Destroy30S");
	endTimebaseSearch();
	
	defineTrigger("Destroy1In30", true, true, false);
	startTimebaseSearch("Destroy1In30", 1000);
	code("if(randomInt(0, 29) == 0){");
		code("trUnitDestroy();");
		removeFromTimebase("Destroy1In30");
	code("}");
	endTimebaseSearch();
	
	defineTrigger("DestroyMagicHaze", true, true, false);
	startTimebaseSearchCustom("MagicHaze", "1000 * getBuilderMagicHazeLifespan(getOwner(trQuestVarGet(\"ySearchUnit\")))");
	code("trUnitDestroy();");
	removeFromTimebase("MagicHaze");
	endTimebaseSearch();
	
	defineTrigger("DestroyFireWall", true, true, false);
	startTimebaseSearchCustom("FireWall", "1000 * getWarlockFireWallTime(getOwner(trQuestVarGet(\"ySearchUnit\")))");
	code("trUnitDestroy();");
	removeFromTimebase("FireWall");
	endTimebaseSearch();
	
	defineTrigger("Argmageddon", true, true, false);
	startTimebaseSearch("Argmageddon", 1500);
	code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
	code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("damageEnemyInVectorArea(owner, v, ",
			"getAttackMultiplierFinal(owner) * heroBaseAttack(10) * getWitchArmageddonMultiplier(owner), ",
			"5.0, trQuestVarGet(\"ySearchUnit\"));");
	code("damagePlayersInVectorArea(v, ",
			"-0.1 * getHealthMultiplier(owner) * heroBaseHealth(10) * getWitchArmageddonMultiplier(owner), ",
			"5.0, trQuestVarGet(\"ySearchUnit\"), false);");
	code("trUnitChangeProtoUnit(\"Qilin Heal\");");
	removeFromTimebase("Argmageddon");
	endTimebaseSearch();
	
	defineTrigger("Trident", true, true, false);
	startTimebaseSearch("Trident", 5000);
	code("trUnitChangeProtoUnit(\"Anubite\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
	code("trDamageUnitPercent(100.0);");
	code("trSetSelectedScale(0.0, 30.0, 0.0);");
	code("setSelectedUnitHeadingDegrees(randomFloat(0, 360.0));");
	code("modifyProtounitAbsolute(\"Kronny Flying\", getOwner(trQuestVarGet(\"ySearchUnit\")), 1, 0.1);");
	addToDatabaseFromDatabase("Trident");
	addToDatabaseFromDatabase("DetectLand");
	addToVanishbaseFromDatabase("Trident");
	removeFromTimebase("Trident");
	endTimebaseSearch();
	
	defineTrigger("BronzeUnit", true, true, false);
	startTimebaseSearch("BronzeUnit", 1000);
	code("trMutateSelected("+getUnitIdFromName("Gaia Forest Tree")+");");
	code("trUnitOverrideAnimation(18, 0, false, true, -1, 0);");
	code("trSetSelectedScale(1.0, 1.0, 1.0);");
	addToTimebaseFromDatabase("ForestDisappear");
	removeFromTimebase("BronzeUnit");
	endTimebaseSearch();
	
	defineTrigger("ForestDisappear", true, true, false);
	startTimebaseSearch("ForestDisappear", 20000);
	code("trUnitChangeProtoUnit(\"Curse Sfx\");");
	removeFromTimebase("ForestDisappear");
	endTimebaseSearch();
		
	defineTrigger("TridentStart", true, true, false);
	databaseSearchStart("Trident");
	code("if(trUnitDead()){");
		code("trSetSelectedScale(3.0, 3.0, 3.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trUnitOverrideAnimation(2, 0, true, false, -1);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trMutateSelected("+getUnitIdFromName("Trident")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("trSetUnitOrientation(vector(1.0, 0.0, 0.0), vector(0.0, 0.0, -1.0), true);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		removeFromDatabase("Trident");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("TridentEnd", true, true, false);
	startVanishbaseSearch("Trident");
	code("int createdObject = deployLocUsingCineBlock(x, z, \"Spy Eye\", owner);");
	code("if(createdObject >= 0){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject);");
		code("damageEnemyInVectorArea(owner, v, ",
				"20.0 * getAttackMultiplierFinal(owner) * heroBaseAttack(14), 5.0, createdObject);");
		code("trMutateSelected("+getUnitIdFromName("Harpy")+");");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trUnitOverrideAnimation(1, 0, true, false, -1);");
		code("addToTimebaseAnytime(\"Destroy1S\", createdObject);");
	code("}");
	code("deployLocUsingCineBlock(x, z, \"Meteor Impact Ground\", owner);");
	code("grantGodPowerNoRechargeNextPosition("+a+", \"Tremor\", 1);");
	code("trTechInvokeGodPower("+a+", \"Tremor\", v, v);");
	code("if(trUnitVisToPlayer()){");
		code("trSoundPlayPaused(\"meteorbighit.wav\",\"-1\",-1,\"\",\"\");");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("DestroyBiremes", true, true, false);
	con("(trTime()-cActivationTime) >= 1");
	code("for(p = 1; <= "+h+"){");
		code("if(trPlayerUnitCountSpecific(p, \"Bireme\") > 0 && trPlayerUnitCountSpecific(p, \"Dock\") <= 0){");
			databaseSearchStart("Bireme");
				code("if(getOwner(trQuestVarGet(\"ySearchUnit\")) == p){");
					code("trUnitChangeProtoUnit(\"Fimbulwinter Sfx\");");
					removeFromDatabase("Bireme");
				code("}");
			databaseSearchEnd();
		code("}");
	code("}");
	
	defineTrigger("GrantBaseAttack", true, true, false);
	con("(trTime()-cActivationTime) >= 1");
	code("bool playSound = true;");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 0){");
			code("while(trPlayerResourceCount(p, \"Food\") >= 1000){");
				code("trPlayerGrantResources(p, \"Food\", -1000);");
				code("setBuilderArmoryBoost(p, getBuilderArmoryBoost(p) + 0.1);");
				code("applyAttack(p);");
				code("if(trCurrentPlayer() == p && playSound){");
					code("trSoundPlayPaused(\"researchcomplete.wav\",\"-1\",-1,\"\",\"\");");
					code("playSound = false;");
				code("}");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("TreeLifebond", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 3){");
			code("if(getLifebondTree(p) >= 0){");
				code("if(getDead(p) == false && heroNearby(p, getAmazonLifebondDistance(p), getLifebondTree(p))){");
					code("if(getLifebondActive(p) == false){");
						code("setLifebondActive(p, true);");
						code("trModifyProtounit(\"Reginleif\", p, 13, 1.0);");
					code("}");
					code("int lifebondUnit = trGetNextUnitScenarioNameNumber() + 1;");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+getSpyEye0(p));");
					code("trUnitChangeProtoUnit(\"Ajax\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+getSpyEye0(p));");
					code("trUnitChangeProtoUnit(\"Camera Start\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+lifebondUnit, true);");
					code("trUnitChangeProtoUnit(\"Spy Eye\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+lifebondUnit, true);");
					code("trMutateSelected("+getUnitIdFromName("Sphinx")+");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+lifebondUnit, true);");
					code("trSetSelectedScale(0, 0, 0);");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+lifebondUnit, true);");
					code("trUnitOverrideAnimation(2, 0, true, false, -1, 0);");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+lifebondUnit, true);");
					code("trUnitSetAnimationPath(\"0,0,1,0,0,0,0\");");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
					code("trQuestVarSet(\"timebaseDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), lifebondUnit);");
					code("trQuestVarSet(\"timebaseTimeDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), trTimeMS());");
					code("trQuestVarSet(\"timebaseCountDestroy1S\", trQuestVarGet(\"timebaseCountDestroy1S\") + 1);");
				code("} else if(getLifebondActive(p)) {");
					code("setLifebondActive(p, false);");
					code("trModifyProtounit(\"Reginleif\", p, 13, -1.0);");
				code("}");
			code("} else if(getLifebondActive(p)){");
				code("setLifebondActive(p, false);");
				code("trModifyProtounit(\"Reginleif\", p, 13, -1.0);");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("SelfDamage", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("if(getSelfDamageCount(p) > 0){");
			code("setSelfDamageCount(p, getSelfDamageCount(p) - 1);");
			code("if(getDead(p) == false){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+p);");
				code("trDamageUnit(0.01 * heroBaseHealth(getHeroIndex(p)));");
				code("int selfDamageUnit = trGetNextUnitScenarioNameNumber() + 1;");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0(p));");
				code("trUnitChangeProtoUnit(\"Ajax\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0(p));");
				code("trUnitChangeProtoUnit(\"Camera Start\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+selfDamageUnit, true);");
				code("trUnitChangeProtoUnit(\"Spy Eye\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+selfDamageUnit, true);");
				code("trMutateSelected("+getUnitIdFromName("Einheriar")+");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+selfDamageUnit, true);");
				code("trSetSelectedScale(0, 0, 0);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+selfDamageUnit, true);");
				code("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
				code("trQuestVarSet(\"timebaseDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), selfDamageUnit);");
				code("trQuestVarSet(\"timebaseTimeDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), trTimeMS());");
				code("trQuestVarSet(\"timebaseCountDestroy1S\", trQuestVarGet(\"timebaseCountDestroy1S\") + 1);");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("ArcherSpecial", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 7 && getArcherSpecialMultiplier(p) > 0){");
			code("if(getDead(p) == false && unitPercentDamaged(p, false) >= 50.0){");
				code("setArcherSpecialActive(p, true);");
				code("int specialUnit = trGetNextUnitScenarioNameNumber() + 1;");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0(p));");
				code("trUnitChangeProtoUnit(\"Ajax\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye0(p));");
				code("trUnitChangeProtoUnit(\"Camera Start\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trUnitChangeProtoUnit(\"Spy Eye\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trMutateSelected("+getUnitIdFromName("Arkantos Boost Sfx")+");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trSetSelectedScale(0, 0, 0);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trUnitOverrideAnimation(2, 0, true, false, -1, 0);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
				code("trQuestVarSet(\"timebaseDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), specialUnit);");
				code("trQuestVarSet(\"timebaseTimeDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), trTimeMS());");
				code("trQuestVarSet(\"timebaseCountDestroy1S\", trQuestVarGet(\"timebaseCountDestroy1S\") + 1);");
			code("} else {");
				code("setArcherSpecialActive(p, false);");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("AttackBoost", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 9 && getAssassinAttackBoostCount(p) > 0){");
			code("if(getDead(p) == false && unitPercentDamaged(p, false) >= 50.0){");
				code("if(getAttackBoostActive(p) == false){");
					code("setAttackBoostActive(p, true);");
					code("applyAttack(p);");
				code("}");
				code("int specialUnit = trGetNextUnitScenarioNameNumber() + 1;");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye1(p));");
				code("trUnitChangeProtoUnit(\"Ajax\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye1(p));");
				code("trUnitChangeProtoUnit(\"Camera Start\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trUnitConvert("+c+");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trUnitChangeProtoUnit(\"Spy Eye\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trMutateSelected("+getUnitIdFromName("Shade")+");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trSetSelectedScale(0, 0, 0);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+specialUnit, true);");
				code("trUnitSetAnimationPath(\"0,0,1,0,0,0,0\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+(1*trQuestVarGet(\"ySearchUnit\")), true);");
				code("trQuestVarSet(\"timebaseDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), specialUnit);");
				code("trQuestVarSet(\"timebaseTimeDestroy1S\"+(1*trQuestVarGet(\"timebaseCountDestroy1S\")), trTimeMS());");
				code("trQuestVarSet(\"timebaseCountDestroy1S\", trQuestVarGet(\"timebaseCountDestroy1S\") + 1);");
			code("} else {");
				code("if(getAttackBoostActive(p)){");
					code("setAttackBoostActive(p, false);");
					code("applyAttack(p);");
				code("}");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("FireRing", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 14){");
			code("if(getDead(p) == false && (100.0 - unitPercentDamaged(p, false)) <= getWarlockFireRingHealth(p)){");
				code("if(getFireRingActive(p) == false){");
					code("setFireRingActive(p, true);");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+getSpyEye0(p));");
					code("trMutateSelected("+getUnitIdFromName("Inferno Fire Ground")+");");
				code("}");
				code("damageEnemyInVectorAreaRing(p, kbGetBlockPosition(\"\"+p), ",
						"0.25 * getAttackMultiplierFinal(p) * heroBaseAttack(14), 8.0, 12.0, -1);");
			code("} else {");
				code("if(getFireRingActive(p)){");
					code("setFireRingActive(p, false);");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+getSpyEye0(p));");
					code("trUnitChangeProtoUnit(\"Camera Start\");");
				code("}");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("StoneTree", true, true, false);
	startTimebaseSearch("BurningTree", 10000);
	code("trUnitDestroy();");
	removeFromTimebase("BurningTree");
	endTimebaseSearch();
	startTimebaseSearch("StoneTree", 10000);
	code("trUnitConvert(0);");
	code("trMutateSelected("+getUnitIdFromName("Pine")+");");
	code("trSetSelectedScale(1.0, 1.0, 1.0);");
	code("trUnitOverrideAnimation(2, 0, true, false, -1, 0);");
	removeFromTimebase("StoneTree");
	endTimebaseSearch();
	startTimebaseSearch("StoneTreeReal", 10000);
	code("trUnitConvert(0);");
	code("trUnitChangeProtoUnit(\"Pine\");");
	code("trSetSelectedScale(1.0, 0.0, 0.0);");
	removeFromTimebase("StoneTreeReal");
	endTimebaseSearch();

	defineTrigger("goldMineSearch", true, true, false);
	con("(trTime()-cActivationTime) >= 10");
	databaseSearchStart("GoldMine");
	code("trUnitChangeProtoUnit(\"Gold Mine Dwarven\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("trMutateSelected("+getUnitIdFromName("Gold Mine Dwarven")+");");
	databaseSearchEnd();
		
	defineTrigger("GrantPriest", true, true, false);
	con("(trTime()-cActivationTime) >= 1");
	code("for(p = 1; <= "+h+"){");
		code("if(getHeroIndex(p) == 13){");
			code("vector heroLoc = kbGetBlockPosition(\"\"+p);");
			code("while(trPlayerResourceCount(p, \"Gold\") >= 40){");
				code("trPlayerGrantResources(p, \"Gold\", -40);");
				code("deployCluster(xsVectorGetX(heroLoc), xsVectorGetZ(heroLoc), \"Priest\", p, 1, 5.0, true);");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("LighthouseAttackLaunch", true, true, false);
	con("time250");
	code("for(p = 1; <= "+h+"){");
		code("if(getLighthouse(p) >= 0){");
			code("while(trPlayerResourceCount(p, \"Food\") >= 4){");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getLighthouseSpawn(p), true);");
				code("trPlayerGrantResources(p, \"Food\", -4);");
				code("int createdObject = trGetNextUnitScenarioNameNumber() + 1;");
				code("trUnitChangeProtoUnit(\"Ajax\");");
				code("trUnitChangeProtoUnit(\"Cinematic Block\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+createdObject, true);");
				code("trUnitChangeProtoUnit(\"Anubite\");");
				code("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+createdObject, true);");
				code("trDamageUnitPercent(100.0);");
				code("trSetSelectedScale(0.0, 0.9, 0.0);");
				code("float fireAngle = randomFloat(0, 360.0);");
				code("setSelectedUnitHeadingDegrees(fireAngle);");
				code("modifyProtounitAbsolute(\"Kronny Flying\", p, 1, randomFloat(10.0, 40.0));");
				code("addToDatabaseAnytime(\"LighthouseShot\", createdObject);");
				code("addToDatabaseAnytime(\"DetectLand\", createdObject);");
				code("addToVanishbaseAnytime(\"LighthouseShot\", createdObject);");
			code("}");
		code("}");
	code("}");
	
	defineTrigger("LighthouseAttackStart", true, true, false);
	databaseSearchStart("LighthouseShot");
	code("if(trUnitDead()){");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("trUnitOverrideAnimation(2, 0, true, false, -1);");
		code("trMutateSelected("+getUnitIdFromName("Arkantos Boost Sfx")+");");
		removeFromDatabase("LighthouseShot");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("LighthouseAttackEnd", true, true, false);
	startVanishbaseSearch("LighthouseShot");
	code("int createdObject = deployLocUsingCineBlock(x, z, \"Spy Eye\", owner);");
	code("if(createdObject != trGetNextUnitScenarioNameNumber()){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trMutateSelected("+getUnitIdFromName("Osiris Birth")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("float damageToDeal = 50.0 * heroBaseAttack(13) * getAttackMultiplierFinal(owner);");
		code("damageEnemyInVectorArea(owner, getPosition(createdObject), damageToDeal, 5.0);");
		code("addToTimebaseAnytime(\"Destroy1S\", createdObject);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("Boss0AnimationAttacks", false, true, false);
	con("boss0 >= 0");
	con("kbUnitGetAnimationActionType(kbGetBlockID(\"\"+boss0, true)) == 6");
	con("(trTime()-cActivationTime) >= 10");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+boss0, true);");
	code("trUnitOverrideAnimation(40, 0, false, true, -1);");
	code("vector v = getPosition(boss0);");
	code("damagePlayersInVectorArea(v, 500.0, 5.0, -1);");
	code("deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Lampades Blood\", "+c+");");
	databaseSearchStart("Player");
	code("if(trUnitDistanceToPoint(xsVectorGetX(v), 0.0, xsVectorGetZ(v)) <= 5.0){");
		code("deployLocUsingCineBlock(xsVectorGetX(v), xsVectorGetZ(v), \"Acid Pool\", 0);");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("Boss4AnimationAttacks", false, true, false);
	con("boss4 >= 0");
	con("kbUnitGetAnimationActionType(kbGetBlockID(\"\"+boss4, true)) == 6");
	con("(trTime()-cActivationTime) >= 2");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+boss0, true);");
	code("trUnitOverrideAnimation(40, 0, false, true, -1);");
	code("vector v = getPosition(boss4);");
	code("damagePlayersInVectorArea(v, 1000.0, 5.0, -1);");
	
	defineTrigger("Boss5AnimationAttacks", true, true, false);
	con("boss5 >= 0");
	code("int currentBossAction = kbUnitGetAnimationActionType(kbGetBlockID(\"\"+boss5, true));");
	code("if(currentBossAction == 65 && currentBossAction != bossAction){");
		code("grantGodPowerNoRechargeNextPosition("+c+", \"Lightning Storm\", 1);");
		code("vector v = getPosition(boss5);");
		code("trTechInvokeGodPower("+c+", \"Lightning Storm\", v, v);");
	code("}");
	code("bossAction = currentBossAction;");
	
	defineTrigger("villagerBuild", true, true, false);
	con("(trTime()-cActivationTime) >= 1");
	databaseSearchStart("VillagerAtlantean");
	code("if(kbUnitGetAnimationActionType(kbGetBlockID(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true)) == 9){");
		code("if(randomInt(0, 5) == 0){");
			code("int towerId = trGetNextUnitScenarioNameNumber();");
			code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
			code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Palace\", "+c+", 1, 10.0);");
			code("if(towerId != trGetNextUnitScenarioNameNumber()){");
				code("trUnitDoWorkOnUnit(\"\"+towerId, -1);");
			code("}");
		code("}");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("titanDamage", true, true, false);
	con("time250");
	databaseSearchStart("TitanAtlantean");
	code("if(trUnitDead()){");
		removeFromDatabase("TitanAtlantean");
	code("} else {");
		code("int taprootStart = trGetNextUnitScenarioNameNumber();");
		code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
		code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Spy Eye\", "+c+", 1, 5.0);");
		code("int taprootEnd = trGetNextUnitScenarioNameNumber() - 1;");
		code("for(i = taprootStart; <= taprootEnd){");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+i, true);");
			code("trMutateSelected("+getUnitIdFromName("Traitors Effect")+");");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+i, true);");
			code("trUnitSetAnimationPath(\"0,0,1,1,0,0,0\");");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+i, true);");
			code("trSetSelectedUpVector(0.0, 0.0, 0.0);");
			code("addToTimebaseAnytime(\"Destroy3S\", i);");
		code("}");
		code("int owner = getOwner(trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner == "+c+"){");
			code("damagePlayersInVectorArea(getPosition(trQuestVarGet(\"ySearchUnit\")), 50.0, 8.0, trQuestVarGet(\"ySearchUnit\"));");
		code("} else {");
			code("damageEnemyInVectorArea(tornadoCredit, getPosition(trQuestVarGet(\"ySearchUnit\")), ",
					"100.0, 8.0, trQuestVarGet(\"ySearchUnit\"));");
		code("}");
	code("}");
	databaseSearchEnd();
	
	//Round timelines
	
	defineTrigger("ActivateNextRound", false, false, false);
	code("roundEventCount = 0;");
	code("roundTime = 0;");
	code("if(round == 0){");
		code("addTimelineEntry(2, \"Axeman\", 10);");
		code("addTimelineEntry(5, \"Toxotes\", 15);");
		code("addTimelineEntry(20, \"Axeman\", 20);");
		code("addTimelineEntry(30, \"Raiding Cavalry\", 20);");
		code("addTimelineEntry(50, \"Axeman\", 30);");
		code("addTimelineEntry(55, \"Apep\", 10);");
		code("addTimelineEntry(60, \"Griffon\", 10);");
		code("addTimelineEntry(90, \"Raiding Cavalry\", 30);");
		code("addTimelineEntry(100, \"Toxotes\", 30);");
		code("addTimelineEntry(100, \"Griffon\", 5);");
		code("addTimelineEntry(120, \"Apep\", 20);");
		code("addTimelineEntry(140, \"Toxotes\", 50);");
		code("addTimelineEntry(150, \"Centaur\", 40);");
	code("} else if(round == 1){");
		code("addTimelineEntry(2, \"Hydra\", 5);");
		code("addTimelineEntry(5, \"Hippikon\", 20);");
		code("addTimelineEntry(20, \"Javelin Cavalry\", 20);");
		code("addTimelineEntry(30, \"Catapult\", 3);");
		code("addTimelineEntry(50, \"Automaton SPC\", 40);");
		code("addTimelineEntry(55, \"Javelin Cavalry\", 30);");
		code("addTimelineEntry(60, \"Hippikon\", 25);");
		code("addTimelineEntry(90, \"Terracotta Soldier\", 10);");
		code("addTimelineEntry(100, \"Catapult\", 5);");
		code("addTimelineEntry(120, \"Hydra\", 20);");
		code("addTimelineEntry(140, \"Terracotta Soldier\", 20);");
		code("addTimelineEntry(150, \"Catapult\", 20);");
	code("} else if(round == 2){");
		code("addTimelineEntry(2, \"Bogsveigir\", 20);");
		code("addTimelineEntry(5, \"Ulfsark\", 20);");
		code("addTimelineEntry(20, \"Troll\", 10);");
		code("addTimelineEntry(30, \"Einheriar\", 5);");
		code("addTimelineEntry(50, \"Bogsveigir\", 30);");
		code("addTimelineEntry(55, \"Battle Boar\", 10);");
		code("addTimelineEntry(60, \"Ulfsark\", 25);");
		code("addTimelineEntry(90, \"Einheriar\", 10);");
		code("addTimelineEntry(100, \"Bogsveigir\", 20);");
		code("addTimelineEntry(120, \"Troll\", 20);");
		code("addTimelineEntry(140, \"Battle Boar\", 20);");
		code("addTimelineEntry(150, \"Einheriar\", 30);");
	code("} else if(round == 3){");
		code("addTimelineEntry(2, \"Chariot Archer\", 30);");
		code("addTimelineEntry(5, \"Scarab\", 10);");
		code("addTimelineEntry(20, \"War Elephant\", 10);");
		code("addTimelineEntry(30, \"Phoenix\", 5);");
		code("addTimelineEntry(50, \"Avenger\", 20);");
		code("addTimelineEntry(55, \"War Elephant\", 15);");
		code("addTimelineEntry(60, \"Scarab\", 20);");
		code("addTimelineEntry(90, \"Chariot Archer\", 20);");
		code("addTimelineEntry(100, \"Phoenix\", 10);");
		code("addTimelineEntry(120, \"Chariot Archer\", 20);");
		code("addTimelineEntry(140, \"Scarab\", 20);");
		code("addTimelineEntry(150, \"Avenger\", 30);");
	code("} else if(round == 4){");
		code("addTimelineEntry(2, \"Promethean\", 10);");
		code("addTimelineEntry(5, \"Satyr\", 20);");
		code("addTimelineEntry(20, \"Ballista\", 5);");
		code("addTimelineEntry(30, \"Colossus\", 20);");
		code("addTimelineEntry(50, \"Myrmidon\", 40);");
		code("addTimelineEntry(55, \"Satyr\", 30);");
		code("addTimelineEntry(60, \"Myrmidon\", 40);");
		code("addTimelineEntry(90, \"Promethean\", 20);");
		code("addTimelineEntry(100, \"Colossus\", 20);");
		code("addTimelineEntry(120, \"Satyr\", 30);");
		code("addTimelineEntry(140, \"Colossus\", 20);");
		code("addTimelineEntry(150, \"Ballista\", 20);");
	code("} else if(round == 5){");
		code("addTimelineEntry(2, \"Nidhogg\", 10);");
		code("addTimelineEntry(5, \"Fire Lance\", 5);");
		code("addTimelineEntry(20, \"Heka Gigantes\", 10);");
		code("addTimelineEntry(30, \"Azure Dragon\", 10);");
		code("addTimelineEntry(50, \"Petrobolos\", 5);");
		code("addTimelineEntry(55, \"Azure Dragon\", 15);");
		code("addTimelineEntry(60, \"Fire Lance\", 10);");
		code("addTimelineEntry(90, \"Azure Dragon\", 20);");
		code("addTimelineEntry(100, \"Nidhogg\", 20);");
		code("addTimelineEntry(120, \"Fire Lance\", 15);");
		code("addTimelineEntry(140, \"Petrobolos\", 10);");
		code("addTimelineEntry(150, \"Heka Gigantes\", 30);");
	code("}");
	code("roundEventCountToDo = roundEventCount;");
	code("xsEnableRule(\"_EnemyTimeline\");");
	
	defineTrigger("deployBoss", false, false, false);
	con("enemyCount <= 0");
	code("xsDisableRule(\"_EnemyTimeline\");");
	code("bossAction = -1;");
	code("if(round == 0 || round == 5){");
		code("if(getBossVariation(0) == 0){");
			code("boss0 = deployRandomSpawnPoint(\"Argus\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss0);");
			code("trSetSelectedScale(4.0, 4.0, 4.0);");
			code("xsEnableRule(\"_ArgusRetaliation25\");");
			code("xsEnableRule(\"_ArgusRetaliation50\");");
			code("xsEnableRule(\"_ArgusRetaliation75\");");
			code("xsEnableRule(\"_Boss0AnimationAttacks\");");
		code("} else if(getBossVariation(0) == 1){");
			code("boss0 = deployRandomSpawnPoint(\"Medusa\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss0);");
			code("trSetSelectedScale(4.0, 4.0, 4.0);");
			code("xsEnableRule(\"_MedusaRetaliation25\");");
			code("xsEnableRule(\"_MedusaRetaliation50\");");
			code("xsEnableRule(\"_MedusaRetaliation75\");");
		code("} else if(getBossVariation(0) == 2){");
			code("boss0 = deployRandomSpawnPoint(\"Monkey King\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss0);");
			code("trSetSelectedScale(4.0, 4.0, 4.0);");
			code("xsEnableRule(\"_MonkeyKingRetaliation25\");");
			code("xsEnableRule(\"_MonkeyKingRetaliation50\");");
			code("xsEnableRule(\"_MonkeyKingRetaliation75\");");
		code("}");
	code("}");
	code("if(round == 1 || round == 5){");
		code("if(getBossVariation(1) == 0){");
			code("boss1 = deployRandomSpawnPoint(\"Nereid\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss1);");
			code("trSetSelectedScale(4.0, 4.0, 4.0);");
			code("xsEnableRule(\"_NereidRetaliation25\");");
			code("xsEnableRule(\"_NereidRetaliation50\");");
			code("xsEnableRule(\"_NereidRetaliation75\");");
		code("} else if(getBossVariation(1) == 1){");
			code("boss1 = deployRandomSpawnPoint(\"Carcinos\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss1);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_CarcinosRetaliation25\");");
			code("xsEnableRule(\"_CarcinosRetaliation50\");");
			code("xsEnableRule(\"_CarcinosRetaliation75\");");
			code("xsEnableRule(\"_CarcinosRetaliationDead\");");
		code("} else if(getBossVariation(1) == 2){");
			code("boss1 = deployRandomSpawnPoint(\"Scylla\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss1);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_ScyllaRetaliation25\");");
			code("xsEnableRule(\"_ScyllaRetaliation50\");");
			code("xsEnableRule(\"_ScyllaRetaliation75\");");
			code("xsEnableRule(\"_ScyllaRetaliationDead\");");
		code("}");
	code("}");
	code("if(round == 2 || round == 5){");
		code("if(getBossVariation(2) == 0){");
			code("boss2 = deployRandomSpawnPoint(\"Frost Giant\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss2);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_FrostGiantRetaliation25\");");
			code("xsEnableRule(\"_FrostGiantRetaliation50\");");
			code("xsEnableRule(\"_FrostGiantRetaliation75\");");
		code("} else if(getBossVariation(2) == 1){");
			code("boss2 = deployRandomSpawnPoint(\"White Tiger\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss2);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_WhiteTigerRetaliation25\");");
			code("xsEnableRule(\"_WhiteTigerRetaliation50\");");
			code("xsEnableRule(\"_WhiteTigerRetaliation75\");");
		code("} else if(getBossVariation(2) == 2){");
			code("boss2 = deployRandomSpawnPoint(\"Cyclops\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss2);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_CyclopsRetaliation25\");");
			code("xsEnableRule(\"_CyclopsRetaliation50\");");
			code("xsEnableRule(\"_CyclopsRetaliation75\");");
		code("}");
	code("}");
	code("if(round == 3 || round == 5){");
		code("if(getBossVariation(3) == 0){");
			code("boss3 = deployRandomSpawnPoint(\"Mummy\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss3);");
			code("trSetSelectedScale(4.0, 4.0, 4.0);");
			code("xsEnableRule(\"_MummyRetaliation25\");");
			code("xsEnableRule(\"_MummyRetaliation50\");");
			code("xsEnableRule(\"_MummyRetaliation75\");");
		code("} else if(getBossVariation(3) == 1){");
			code("boss3 = deployRandomSpawnPoint(\"Sphinx\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss3);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_SphinxRetaliation25\");");
			code("xsEnableRule(\"_SphinxRetaliation50\");");
			code("xsEnableRule(\"_SphinxRetaliation75a\");");
			code("xsEnableRule(\"_SphinxRetaliation75b\");");
		code("} else if(getBossVariation(3) == 2){");
			code("boss3 = deployRandomSpawnPoint(\"Petsuchos\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss3);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_PetsuchosRetaliation25\");");
			code("xsEnableRule(\"_PetsuchosRetaliation50\");");
			code("xsEnableRule(\"_PetsuchosRetaliation75\");");
		code("}");
	code("}");
	code("if(round == 4 || round == 5){");
		code("if(getBossVariation(4) == 0){");
			code("boss4 = deployRandomSpawnPoint(\"Lampades\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss4);");
			code("trSetSelectedScale(4.0, 4.0, 4.0);");
			code("xsEnableRule(\"_LampadesRetaliation25\");");
			code("xsEnableRule(\"_LampadesRetaliation50\");");
			code("xsEnableRule(\"_LampadesRetaliation75\");");
		code("} else if(getBossVariation(4) == 1){");
			code("boss4 = deployRandomSpawnPoint(\"Lazer Bear\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss4);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_LazerBearRetaliation25\");");
			code("xsEnableRule(\"_LazerBearRetaliation50\");");
			code("xsEnableRule(\"_LazerBearRetaliation75\");");
		code("} else if(getBossVariation(4) == 2){");
			code("boss4 = deployRandomSpawnPoint(\"Chimera\", 1);");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+boss4);");
			code("trSetSelectedScale(3.0, 3.0, 3.0);");
			code("xsEnableRule(\"_ChimeraRetaliation25\");");
			code("xsEnableRule(\"_ChimeraRetaliation50\");");
			code("xsEnableRule(\"_ChimeraRetaliation75\");");
		code("}");
	code("}");
	code("xsEnableRule(\"_endRound\");");
	code("musicType = 1;");
	playMusic("cinematics\35_out\music2.mp3");
	
	defineTrigger("EnemyTimeline", false, true, false);
	con("(trTime()-cActivationTime) >= 1");
	code("if(roundEventCountToDo <= 0){");
		code("xsEnableRule(\"_deployBoss\");");
	code("}");
	code("for(i = 0; < roundEventCount){");
		code("if(getRoundUnitTime(i) == roundTime){");
			code("deployRandomSpawnPoint(getRoundUnitType(i), getRoundUnitCount(i));");
			code("roundEventCountToDo = roundEventCountToDo - 1;");
		code("}");
	code("}");
	code("roundTime = roundTime + 1;");
	
	defineTrigger("ArgusRetaliation25", false, false, false);
	con("unitPercentDamaged(boss0) >= 25");
	code("vector v = getPosition(boss0);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Walking Woods Jungle Tree\", "+c+", 20, 20.0, true);");
	
	defineTrigger("ArgusRetaliation50", false, false, false);
	con("unitPercentDamaged(boss0) >= 50");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Restoration\", 1);");
	code("vector v = getPosition(boss0);");
	code("trTechInvokeGodPower("+c+", \"Restoration\", v, v);");
	
	defineTrigger("ArgusRetaliation75", false, false, false);
	con("unitPercentDamaged(boss0) >= 75");	
	code("vector v = getPosition(boss0);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Pharaoh of Osiris\", "+c+", 8, 10.0, true);");
	
	defineTrigger("MedusaRetaliation25", false, false, false);
	con("unitPercentDamaged(boss0) >= 25");
	code("vector v = getPosition(boss0);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Statue of Lightning\", "+c+", 8, 20.0, true);");
	
	defineTrigger("MedusaRetaliation50", false, false, false);
	con("unitPercentDamaged(boss0) >= 50");
	code("vector v = getPosition(boss0);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Colossus\", "+c+", 20, 20.0, true);");
	
	defineTrigger("MedusaRetaliation75", false, false, false);
	con("unitPercentDamaged(boss0) >= 75");	
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Volcano\", 1);");
	code("vector v = getPosition(boss0);");
	code("trTechInvokeGodPower("+c+", \"Volcano\", v, v);");
	
	defineTrigger("MonkeyKingRetaliation25", false, false, false);
	con("unitPercentDamaged(boss0) >= 25");
	code("vector v = getPosition(boss0);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Shade of Hades\", "+c+", 20, 30.0, true);");
	
	defineTrigger("MonkeyKingRetaliation50", false, true, false);
	con("(trTime()-cActivationTime) >= 10");
	con("unitPercentDamaged(boss0) >= 50");
	con("unitPercentDamaged(boss0) < 100");
	con("round == 0 || round == 5");
	code("vector v = getPosition(boss0);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Footprint Wheel\", "+c+", 1, 20.0, true);");
	
	defineTrigger("MonkeyKingRetaliation75", false, false, false);
	con("unitPercentDamaged(boss0) >= 75");	
	code("vector v = getPosition(boss0);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Qilin\", "+c+", 10, 30.0, true);");
	
	defineTrigger("NereidRetaliation25", false, false, false);
	con("unitPercentDamaged(boss1) >= 25");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Lightning Storm\", 1);");
	code("vector v = getPosition(boss1);");
	code("trTechInvokeGodPower("+c+", \"Lightning Storm\", v, v);");
	
	defineTrigger("NereidRetaliation50", false, false, false);
	con("unitPercentDamaged(boss1) >= 50");
	code("vector v = getPosition(boss1);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Servant\", "+c+", 20, 30.0, true);");
	
	defineTrigger("NereidRetaliation75", false, false, false);
	con("unitPercentDamaged(boss1) >= 75");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Meteor\", 1);");
	code("vector v = getPosition(boss1);");
	code("trTechInvokeGodPower("+c+", \"Meteor\", v, v);");
	
	defineTrigger("CarcinosRetaliation25", false, false, false);
	con("unitPercentDamaged(boss1) >= 25");
	code("vector v = getPosition(boss1);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Jormund Elver\", "+c+", 20, 30.0, true);");
	
	defineTrigger("CarcinosRetaliation50", false, false, false);
	con("unitPercentDamaged(boss1) >= 50");
	code("dM(\"Oar Footprint\", "+c+", 1, 0.0, 1);");
	
	defineTrigger("CarcinosRetaliation75", false, false, false);
	con("unitPercentDamaged(boss1) >= 75");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Flood\", 1);");
	code("vector v = getPosition(boss1);");
	code("trTechInvokeGodPower("+c+", \"Flood\", v, v);");
	
	defineTrigger("CarcinosRetaliationDead", false, false, false);
	con("unitPercentDamaged(boss1) >= 100");
	databaseSearchStart("TornadoWeak");
	removeFromDatabase("TornadoWeak");
	code("trUnitDestroy();");
	databaseSearchEnd();
	
	defineTrigger("ScyllaRetaliation25", false, true, false);
	con("(trTime()-cActivationTime) >= 5");
	con("unitPercentDamaged(boss1) >= 25");
	con("unitPercentDamaged(boss1) < 100");
	con("round == 1 || round == 5");
	code("vector v = getPosition(boss1);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Footprint Villager\", "+c+", 1, 20.0, true);");
	
	defineTrigger("ScyllaRetaliation50", false, false, false);
	con("unitPercentDamaged(boss1) >= 50");
	code("vector v = getPosition(boss1);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Pirate Ship\", "+c+", 20, 30.0, true);");
	
	defineTrigger("ScyllaRetaliation75", false, false, false);
	con("unitPercentDamaged(boss1) >= 75");
	code("xsEnableRule(\"_ScyllaRetaliation75part2\");");
	code("if(round == 1){");
		code("trSoundPlayPaused(\"cinematics\23_out\ankh.mp3\",\"-1\",-1,\"\",\"\");");
		code("trUIFadeToColor(0, 0, 255, 2000, 0, true);");
	code("}");
	
	defineTrigger("ScyllaRetaliation75part2", false, false, false);
	con("(trTime()-cActivationTime) >= 2");
	code("if(round == 1 && unitPercentDamaged(boss1) < 100){");
		code("trUIFadeToColor(255, 255, 255, 2000, 0, false);");
		code("trCoverTerrainWithWater(9.0, 5.0,\"Aegean Sea\");");
		code("paintMap(\"UnderwaterRockC\");");
	code("}");
	code("vector v = getPosition(boss1);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Kraken\", "+c+", 10, 30.0, true);");
	code("waterRiseCount = 0;");
	code("xsEnableRule(\"_ScyllaRetaliation75part3\");");
	
	defineTrigger("ScyllaRetaliation75part3", false, true, false);
	con("time250");
	con("unitPercentDamaged(boss1) < 100");
	con("unitPercentDamaged(boss1) >= 75");
	code("if(round == 1){");
		code("changeGlobalHeight(-0.125);");
		code("changeTerrainHeight(0.125);");
		code("waterRiseCount++;");
		code("if(waterRiseCount == 36){");
			code("refreshPassability();");
		code("}");
	code("}");
	
	defineTrigger("ScyllaRetaliationDead", false, false, false);
	con("unitPercentDamaged(boss1) >= 100");
	code("if(round == 1){");
		code("paintMap(\"ShorelineAegeanA\");");
		code("changeGlobalHeight(-20.0);");
		code("changeGlobalHeight(9.0);");
		code("refreshPassability();");
	code("}");
	
	defineTrigger("FrostGiantRetaliation25", false, false, false);
	con("unitPercentDamaged(boss2) >= 25");
	code("if(round == 2)trRenderSnow(0.01);");
	databaseSearchStart("Hero");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Barrage\", 1);");
	code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
	code("trTechInvokeGodPower("+c+", \"Barrage\", v, v);");
	databaseSearchEnd();
	
	defineTrigger("FrostGiantRetaliation50", false, false, false);
	con("unitPercentDamaged(boss2) >= 50");
	code("if(round == 2)trRenderSnow(0.1);");
	code("vector v = getPosition(boss2);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Fenris Wolf\", "+c+", 30, 30.0, true);");
	
	defineTrigger("FrostGiantRetaliation75", false, false, false);
	con("unitPercentDamaged(boss2) >= 75");
	code("if(round == 2)trRenderSnow(1.0);");
	databaseSearchStart("Hero");
	code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
	code("int unitName = trGetNextUnitScenarioNameNumber();");
	code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), \"Ice Sheet\", "+c+");");
	code("if(unitName != trGetNextUnitScenarioNameNumber()){");
		code("addToTimebaseAnytime(\"Destroy15S\", unitName);");
	code("}");
	databaseSearchEnd();
	code("iceCount = 5;");
	code("xsEnableRule(\"_FrostEnemies\");");
	
	defineTrigger("CreateIce", true, true, false);
	con("time250");
	con("iceCount > 0");
	code("iceCount--;");
	code("int from = trGetNextUnitScenarioNameNumber();");
	databaseSearchStart("Hero");
	code("vector v = getPosition(trQuestVarGet(\"ySearchUnit\"));");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Cinematic Block\", "+c+", 3, 5.0);");
	databaseSearchEnd();
	code("int to = trGetNextUnitScenarioNameNumber();");
	code("for(i = from; < to){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+i, true);");
		code("trUnitChangeProtoUnit(\"Ajax\");");
		code("trMutateSelected("+getUnitIdFromName("Ice Block")+");");
		code("trSetSelectedScale(3.0, 3.0, 3.0);");
		code("trUnitOverrideAnimation(18, 0, false, false, -1, 0);");
		code("addToTimebaseAnytime(\"Kill12S\", i);");
		code("trUnitSelectClear();");
		code("int blocking = trGetNextUnitScenarioNameNumber() - 1;");
		code("trUnitSelect(\"\"+blocking, true);");
		code("trUnitChangeProtoUnit(\"Pots\");");
		code("trMutateSelected("+getUnitIdFromName("Great Box")+");");
		code("trSetSelectedScale(0.0, 0.0, 0.0);");
		code("addToTimebaseAnytime(\"Destroy12S\", blocking);");
	code("}");
	
	defineTrigger("FrostEnemies", false, false, false);
	con("(trTime()-cActivationTime) >= 3");
	code("vector v = getPosition(boss2);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Valkyrie\", "+c+", 20, 30.0, true);");
	
	defineTrigger("WhiteTigerRetaliation25", false, false, false);
	con("unitPercentDamaged(boss2) >= 25");
	code("vector v = getPosition(boss2);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Mountain Giant\", "+c+", 15, 30.0, true);");
	
	defineTrigger("WhiteTigerRetaliation50", false, true, false);
	con("(trTime()-cActivationTime) >= 1");
	con("unitPercentDamaged(boss2) >= 50");
	con("unitPercentDamaged(boss2) < 100");
	con("round == 2 || round == 5");
	code("if(randomInt(0, 7) == 0){");
		code("int treeId = trGetNextUnitScenarioNameNumber();");
		code("dM(\"Cinematic Block\", "+c+", 1, 0.0, 1);");
		code("if(treeId != trGetNextUnitScenarioNameNumber()){");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+treeId, true);");
			code("trUnitChangeProtoUnit(\"Spy Eye\");");
			code("trMutateSelected("+getUnitIdFromName("Summoning Tree 2")+");");
			code("trSetSelectedScale(0.0, 0.0, 0.0);");
			code("trUnitOverrideAnimation(18, 0, true, false, -1, 0);");
		code("}");
	code("}");
	
	defineTrigger("SummoningTreeSpawn", true, true, false);
	con("time250");
	databaseSearchStart("SummoningTree");
	code("if(type != "+getUnitIdFromName("Summoning tree 2")+"){");
		removeFromDatabase("SummoningTree");
	code("} else {");
		code("vector v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Pine Snow\", 0, randomInt(0, 5), 5.0);");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("SummoningTreeBurn", true, true, false);
	con("(trTime()-cActivationTime) >= 1");
	startTimebaseSearch("SummoningTreeBurn", 5000);
	removeFromTimebase("SummoningTreeBurn");
	code("trUnitChangeProtoUnit(\"Pine Snow\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Forest Fire\", 1);");
	code("trTechInvokeGodPower("+c+", \"Forest Fire\");");
	endTimebaseSearch();
	
	defineTrigger("WhiteTigerRetaliation75", false, false, false);
	con("unitPercentDamaged(boss2) >= 75");
	code("xsEnableRule(\"_WhiteTigerRetaliation75part2\");");
	code("if(round == 2){");
		code("trSoundPlayPaused(\"cinematics\17_in\weirdthing.mp3\",\"-1\",-1,\"\",\"\");");
		code("trUIFadeToColor(255, 255, 255, 2000, 0, true);");
	code("}");
	
	defineTrigger("WhiteTigerRetaliation75part2", false, false, false);
	con("(trTime()-cActivationTime) >= 2");
	code("if(round == 2){");
		code("trUIFadeToColor(255, 255, 255, 2000, 0, false);");
		code("trRenderSnow(1.0);");
		code("trPaintTerrain(0, 0, "+(getMapSize() / 2)+" - 1, "+(getMapSize() / 2)+" - 1, getTerrainType(\"SnowB\"), getTerrainSubType(\"SnowB\"), true);");
	code("}");
	code("vector v = getPosition(boss2);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Nemean Lion\", "+c+", 35, 30.0, true);");
	
	defineTrigger("CyclopsRetaliation25", false, false, false);
	con("unitPercentDamaged(boss2) >= 25");
	code("vector v = getPosition(boss2);");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Inferno\", 1);");
	code("trTechInvokeGodPower("+c+", \"Inferno\", v, v);");
	
	defineTrigger("CyclopsRetaliation50", false, false, false);
	con("unitPercentDamaged(boss2) >= 50");
	code("rocksToDrop = 100;");
	code("xsEnableRule(\"_CyclopsDropRocks\");");
	
	defineTrigger("CyclopsDropRocks", false, true, false);
	con("time250");
	con("unitPercentDamaged(boss2) >= 50");
	con("unitPercentDamaged(boss2) < 100");
	con("rocksToDrop > 0");
	code("rocksToDrop--;");
	code("int rockId = trGetNextUnitScenarioNameNumber();");
	code("vector v = getPosition(boss2);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Cinematic Block\", "+c+", 1, 30.0, true);");
	code("if(rockId != trGetNextUnitScenarioNameNumber()){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+rockId, true);");
		code("trUnitChangeProtoUnit(\"Anubite\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+rockId, true);");
		code("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+rockId, true);");
		code("trDamageUnitPercent(100.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+rockId, true);");
		code("trSetSelectedScale(0.0, 10.0, 0.0);");
		code("float fireAngle = randomFloat(0, 360.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+rockId, true);");
		code("setSelectedUnitHeadingDegrees(fireAngle);");
		code("modifyProtounitAbsolute(\"Kronny Flying\", "+c+", 1, randomFloat(5.0, 5.0));");
		code("addToDatabaseAnytime(\"CyclopsRock\", rockId);");
		code("addToDatabaseAnytime(\"DetectLand\", rockId);");
		code("addToVanishbaseAnytime(\"CyclopsRock\", rockId);");
	code("}");
	
	defineTrigger("CyclopsRockStart", true, true, false);
	databaseSearchStart("CyclopsRock");
	code("if(trUnitDead()){");
		code("trUnitOverrideAnimation(2, 0, true, false, -1);");
		code("trSetSelectedScale(2.0, 2.0, 2.0);");
		code("trMutateSelected("+getUnitIdFromName("Recreation")+");");
		code("trUnitSetAnimationPath(\"0,0,1,1,0,0,0\");");
		removeFromDatabase("CyclopsRock");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("CyclopsRockEnd", true, true, false);
	startVanishbaseSearch("CyclopsRock");
	code("int createdObject = trGetNextUnitScenarioNameNumber();");
	code("deployLoc(x, z, \"Spy Eye\", "+c+");");
	code("damagePlayersInArea(x, z, 1000.0, 5.0);");
	code("if(createdObject != trGetNextUnitScenarioNameNumber()){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trMutateSelected("+getUnitIdFromName("Sentinel Main")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trUnitOverrideAnimation(18, 0, true, false, -1);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject, true);");
		code("trSetSelectedScale(0.0, 1.0, 0.0);");
		code("addToTimebaseAnytime(\"Destroy1S\", createdObject);");
	code("}");
	endVanishbaseSearch();
	
	defineTrigger("CyclopsRetaliation75", false, false, false);
	con("unitPercentDamaged(boss2) >= 75");
	code("vector v = getPosition(boss2);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Fimbulwinter Wolf\", "+c+", 60, 40.0, true);");
	code("trSoundPlayPaused(\"wolfpack.wav\",\"-1\",-1,\"\",\"\");");
	code("trRenderSnow(100.0);");
	
	defineTrigger("MummyRetaliation25", false, false, false);
	con("unitPercentDamaged(boss3) >= 25");
	code("vector v = getPosition(boss3);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Scorpion Man\", "+c+", 30, 30.0, true);");
	
	defineTrigger("MummyRetaliation50", false, true, false);
	con("(trTime()-cActivationTime) >= 1");
	con("unitPercentDamaged(boss3) >= 50");
	con("unitPercentDamaged(boss3) < 100");
	con("round == 3 || round == 5");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"SPCMeteor\", 1);");
	code("vector v = xsVectorSet(toMetres(randomFloat(0.0, 1.0)), 0.0, toMetres(randomFloat(0.0, 1.0)));");
	code("trTechInvokeGodPower("+c+", \"SPCMeteor\", v, v);");
	
	defineTrigger("MummyRetaliation75", false, false, false);
	con("unitPercentDamaged(boss3) >= 75");
	code("vector v = getPosition(boss3);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Manticore\", "+c+", 4, 10.0, true);");
	
	defineTrigger("SphinxRetaliation25", false, true, false);
	con("(trTime()-cActivationTime) >= 1");
	con("unitPercentDamaged(boss3) >= 25");
	con("unitPercentDamaged(boss3) < 100");
	con("round == 3 || round == 5");
	code("if(randomInt(0, 4) == 0){");
		code("vector v = getPosition(boss3);");
		code("deployLoc(xsVectorGetX(v), xsVectorGetZ(v), \"Footprint Animal Large\", "+c+");");
	code("}");
	
	defineTrigger("SphinxRetaliation50", false, false, false);
	con("unitPercentDamaged(boss3) >= 50");
	code("vector v = getPosition(boss3);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Anubite\", "+c+", 20, 10.0, true);");
	
	defineTrigger("SphinxRetaliation75a", false, false, false);
	con("unitPercentDamaged(boss3) >= 75");
	code("vector v = getPosition(boss3);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Pixiu\", "+c+", 14, 10.0, true);");
	
	defineTrigger("SphinxRetaliation75b", false, true, false);
	con("(trTime()-cActivationTime) >= 10");
	con("unitPercentDamaged(boss3) >= 50");
	con("unitPercentDamaged(boss3) < 100");
	con("round == 3 || round == 5");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Sandstorm\", 1);");
	code("vector v1 = getPosition(boss3);");
	code("vector v2 = kbGetBlockPosition(\"\"+randomInt(1, "+h+"));");
	code("trTechInvokeGodPower("+c+", \"Sandstorm\", v1, v2);");
	
	defineTrigger("PetsuchosRetaliation25", false, false, false);
	con("unitPercentDamaged(boss3) >= 25");
	code("modifyProtounitAbsolute(\"Kronny Flying\", "+c+", 1, 5.0);");
	code("for(p = 1; <= "+h+"){");
		code("if(getDead(p) == false){");
			code("for(i = 0; < 16){");
				code("int createdObject = trGetNextUnitScenarioNameNumber() + 1;");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+getSpyEye1(p));");
				code("trUnitChangeProtoUnit(\"Ajax\");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+createdObject, true);");
				code("trUnitChangeProtoUnit(\"Anubite\");");
				code("trMutateSelected("+getUnitIdFromName("Kronny Flying")+");");
				code("trUnitSelectClear();");
				code("trUnitSelect(\"\"+createdObject, true);");
				code("trDamageUnitPercent(100.0);");
				code("trSetSelectedScale(0.0, 0.9, 0.0);");
				code("float fireAngle = (360.0 / 16) * i;");
				code("setSelectedUnitHeadingDegrees(fireAngle);");
				code("addToDatabaseAnytime(\"TrapRing\", createdObject);");
				code("addToTimebaseAnytime(\"TrapRingSpawn\", createdObject);");
			code("}");
			code("trUnitSelectClear();");
			code("trUnitSelect(\"\"+getSpyEye1(p));");
			code("trUnitChangeProtoUnit(\"Camera Start\");");
		code("}");
	code("}");
	
	defineTrigger("PetsuchosRetaliation50", false, false, false);
	con("unitPercentDamaged(boss3) >= 50");
	code("vector v = getPosition(boss3);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Guardian XP\", "+c+", 20, 20.0, true);");
	
	defineTrigger("PetsuchosRetaliation75", false, true, false);
	con("(trTime()-cActivationTime) >= 2");
	con("unitPercentDamaged(boss3) >= 75");
	con("unitPercentDamaged(boss3) < 100");
	con("round == 3 || round == 5");
	code("int createdObject = trGetNextUnitScenarioNameNumber();");
	code("vector v = getPosition(boss3);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Roc Tent\", "+a+", 1, 30.0, true);");
	code("if(createdObject != trGetNextUnitScenarioNameNumber()){");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+createdObject);");
		code("trUnitOverrideAnimation(25, 0, true, true, -1);");
		code("addToTimebaseAnytime(\"RocTent\", createdObject);");
	code("}");
	
	defineTrigger("LampadesRetaliation25", false, false, false);
	con("unitPercentDamaged(boss4) >= 25");
	code("vector v = getPosition(boss4);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"War Salamander\", "+c+", 30, 30.0, true);");
	
	defineTrigger("LampadesRetaliation50", false, true, false);
	con("(trTime()-cActivationTime) >= 5");
	con("unitPercentDamaged(boss4) >= 50");
	con("round == 4 || round == 5");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Tsunami\", 1);");
	code("vector v = xsVectorSet(toMetres(randomFloat(0.0, 1.0)), 0.0, toMetres(randomFloat(0.0, 1.0)));");
	code("vector v2 = xsVectorSet(toMetres(randomFloat(0.0, 1.0)), 0.0, toMetres(randomFloat(0.0, 1.0)));");
	code("xsSetContextPlayer("+c+");");
	code("aiCastGodPowerAtPositionFacingPosition(598, v, v2);");
	
	defineTrigger("LampadesRetaliation75", false, false, false);
	con("unitPercentDamaged(boss4) >= 75");
	databaseSearchStart("Hero");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Meteor\", 1);");
	code("vector v = xsVectorSet(toMetres(randomFloat(0.0, 1.0)), 0.0, toMetres(randomFloat(0.0, 1.0)));");
	code("trTechInvokeGodPower("+c+", \"Meteor\", v, v);");
	databaseSearchEnd();
	
	defineTrigger("LazerBearRetaliation25", false, false, false);
	con("unitPercentDamaged(boss4) >= 25");
	code("vector v = getPosition(boss4);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Behemoth\", "+c+", 30, 30.0, true);");
	
	defineTrigger("LazerBearRetaliation50", false, true, false);
	con("(trTime()-cActivationTime) >= 10");
	con("unitPercentDamaged(boss4) >= 50");
	con("unitPercentDamaged(boss4) < 100");
	con("round == 4 || round == 5");
	code("vector v = getPosition(boss4);");
	code("dM(\"Vortex Landing\", "+c+", 1, 0.0, 1);");
	
	defineTrigger("LazerBearRetaliation75", false, true, false);
	con("(trTime()-cActivationTime) >= 5");
	con("unitPercentDamaged(boss4) >= 75");
	con("unitPercentDamaged(boss4) < 100");
	con("round == 4 || round == 5");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Tornado\", 1);");
	code("vector v = xsVectorSet(toMetres(randomFloat(0.0, 1.0)), 0.0, toMetres(randomFloat(0.0, 1.0)));");
	code("trTechInvokeGodPower("+c+", \"Tornado\", v, v);");
	
	defineTrigger("ChimeraRetaliation25", false, false, false);
	con("unitPercentDamaged(boss4) >= 25");
	code("vector v = getPosition(boss4);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Villager Atlantean\", "+c+", 20, 20.0, true);");
	
	defineTrigger("ChimeraRetaliation50", false, false, false);
	con("unitPercentDamaged(boss4) >= 50");
	con("unitPercentDamaged(boss4) < 100");
	con("round == 4 || round == 5");
	code("for(i = 0; < 4){");
		code("grantGodPowerNoRechargeNextPosition("+c+", \"Tartarian Gate\", 1);");
		code("vector v = getPosition(boss4);");
		code("v = randomCircleLoc(xsVectorGetX(v), xsVectorGetZ(v), 20.0);");
		code("trTechInvokeGodPower("+c+", \"Tartarian Gate\", v, v);");
	code("}");
	
	defineTrigger("ChimeraRetaliation75", false, false, false);
	con("unitPercentDamaged(boss4) >= 75");
	code("vector v = getPosition(boss4);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Titan Atlantean\", "+c+", 10, 30.0, true);");
	
	defineTrigger("beginFinalBoss", false, false, false);
	con("(trTime()-cActivationTime) >= 5");
	code("roundActive = true;");
	code("boss5 = trGetNextUnitScenarioNameNumber();");
	code("while(boss5 == trGetNextUnitScenarioNameNumber()){");
		code("deployCluster(toMetres(0.5), toMetres(0.5), \"Arkantos God\", "+c+", 1, toMetres(0.2));");
	code("}");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+boss5, true);");
	code("trSetSelectedScale(4.0, 4.0, 4.0);");
	code("xsEnableRule(\"_FinalBossRetaliation20\");");
	code("xsEnableRule(\"_FinalBossRetaliation40\");");
	code("xsEnableRule(\"_FinalBossRetaliation60\");");
	code("xsEnableRule(\"_FinalBossRetaliation80\");");
	code("xsEnableRule(\"_FinalBossRetaliation100\");");
	code("xsEnableRule(\"_FallOutArena\");");
	code("gameTime = 0;");
	code("for(p = 1; <= "+h+"){");
		code("setPlayerGameTime(p, 0);");
	code("}");
	code("xsEnableRule(\"_gameTimer\");");
	
	defineTrigger("FallOutArena", false, true, false);
	con("time250");
	code("vector v = vector(0.0, 0.0, 0.0);");
	code("int terrainId = -1;");
	code("int terrainSubId = -1;");
	databaseSearchStart("Player");
	code("if(trUnitGetIsContained(\"All\") == false && type != "+getUnitIdFromName("Harpy")+" && type != "+getUnitIdFromName("Eagle")+"){");
		code("v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
		code("terrainId = trGetTerrainType(xsVectorGetX(v) / 2, xsVectorGetZ(v) / 2);");
		code("if(terrainId == 5){");
			code("terrainSubId = trGetTerrainSubType(xsVectorGetX(v) / 2, xsVectorGetZ(v) / 2);");
			code("if(terrainSubId == 4){");
				code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
				removeFromDatabase("Player");
			code("}");
		code("}");
	code("}");
	databaseSearchEnd();
	databaseSearchStart("Enemy");
	code("v = kbGetBlockPosition(\"\"+1*trQuestVarGet(\"ySearchUnit\"), true);");
	code("terrainId = trGetTerrainType(xsVectorGetX(v) / 2, xsVectorGetZ(v) / 2);");
	code("if(terrainId == 5){");
		code("terrainSubId = trGetTerrainSubType(xsVectorGetX(v) / 2, xsVectorGetZ(v) / 2);");
		code("if(terrainSubId == 4){");
			code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
			removeFromDatabase("Enemy");
		code("}");
	code("}");
	databaseSearchEnd();
	
	defineTrigger("FinalBossRetaliation20", false, false, false);
	con("unitPercentDamaged(boss5) >= 20");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Volcano\", 1);");
	code("vector v = getPosition(boss5);");
	code("trTechInvokeGodPower("+c+", \"Volcano\", v, v);");
	
	defineTrigger("FinalBossRetaliation40", false, true, false);
	con("unitPercentDamaged(boss5) >= 40");
	con("(trTime()-cActivationTime) >= 5");
	code("vector v = getPosition(boss5);");
	code("deployCluster(xsVectorGetX(v), xsVectorGetZ(v), \"Guardian\", "+c+", 1, 5.0, true);");
	
	defineTrigger("FinalBossRetaliation60", false, false, false);
	con("unitPercentDamaged(boss5) >= 60");
	con("(trTime()-cActivationTime) >= 10");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Tartarian Gate\", 1);");
	code("vector v = getPosition(boss5);");
	code("trTechInvokeGodPower("+c+", \"Tartarian Gate\", v, v);");
	
	defineTrigger("FinalBossRetaliation80", false, false, false);
	con("unitPercentDamaged(boss5) >= 80");
	code("grantGodPowerNoRechargeNextPosition("+c+", \"Chicken Storm\", 1);");
	code("vector v = getPosition(boss5);");
	code("trTechInvokeGodPower("+c+", \"Chicken Storm\", v, v);");
	
	defineTrigger("FinalBossRetaliation100", false, false, false);
	con("unitPercentDamaged(boss5) >= 100");
	code("boss6 = boss5;");
	code("boss5 = -1;");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+boss6);");
	code("trUnitChangeProtoUnit(\"Argus\");");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+boss6);");
	code("trDamageUnitPercent(-100.0);");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+boss6);");
	code("trUnitChangeProtoUnit(\"Fire Giant\");");
	code("trSetSelectedScale(4.0,4.0,4.0);");
	code("xsEnableRule(\"_DefeatFinalBoss\");");
	code("trQuestVarSet(\"yDatabaseEnemy\"+(1*trQuestVarGet(\"yCountEnemy\")), boss6);");
	code("trQuestVarSet(\"yCountEnemy\", trQuestVarGet(\"yCountEnemy\") + 1);");
	
	defineTrigger("DefeatFinalBoss", false, false, false);
	con("kbGetBlockID(\"\"+boss6, true) < 0");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"0\");");
	code("trUnitChangeInArea("+c+", "+c+", \"Guardian\", \"Fimbulwinter Sfx\", 999.0);");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"\"+boss6);");
	code("trUnitChangeProtoUnit(\"Osiris Box Glow\");");
	code("trOverlayTextColour(0, 255, 0);");
	code("trOverlayText(\"THE FINAL BOSS HAS BEEN DEFEATED CONGRATULATIONS!\", 10.0);");
	code("trSoundPlayPaused(\"xpack\xcinematics\12_b\gaiabye4.mp3\",\"-1\",-1,\"\",\"\");");
	code("xsEnableRule(\"_sparkles\");");
	code("xsEnableRule(\"_endGame\");");
	code("musicType = 0;");
	playMusic("cinematics\35_out\music.mp3");
	
	defineTrigger("sparkles", false, true, false);
	con("time250");
	code("for(i = 0; < 30){");
		code("deployLoc(toMetres(randomFloat(0.0, 1.0)), toMetres(randomFloat(0.0, 1.0)), \"Curse Sfx\", "+c+");");
	code("}");
	
	defineTrigger("endGame", false, false, false);
	con("(trTime()-cActivationTime) >= 10");
	code("trSetPlayerDefeated("+a+");");
	code("trSetPlayerDefeated("+c+");");
	code("for(p = 1; <= "+h+"){");
		code("trSetPlayerWon(p);");
	code("}");
	
	defineTrigger("intro", true, false, true);
	code("trUIFadeToColor(0, 0, 0, 4000, 4000, false);");
	code("trLetterBox(true);");
	code("trOverlayTextColour(0, 255, 0);");
	code("trOverlayText(\"Gladiator Worlds - By Nottud\", 5.0);");
	code("if(trGetWorldDifficulty() == 0)trSoundPlayFN(\"\",\"1\",-1,\"EASY DIFFICULTY:Enemies have 1X power\",\"\");");
	code("if(trGetWorldDifficulty() == 1)trSoundPlayFN(\"\",\"1\",-1,\"MODERATE DIFFICULTY:Enemies have 1.5X power\",\"\");");
	code("if(trGetWorldDifficulty() == 2)trSoundPlayFN(\"\",\"1\",-1,\"HARD DIFFICULTY:Enemies have 2X power\",\"\");");
	code("if(trGetWorldDifficulty() == 3)trSoundPlayFN(\"\",\"1\",-1,\"TITAN DIFFICULTY:Enemies have 3X power\",\"\");");
	
	defineTrigger("intro2", true, false, true);
	code("trBlockAllSounds(false);");
	code("uiFindType(\"Old Man\");");
	code("trUnblockAllSounds();");
	playMusic("xpack\xcinematics\10_a\music.mp3");
	
	defineTrigger("intro4", true, false, false);
	con("(trTime()-cActivationTime) >= 4");
	code("trLetterBox(false);");
	code("trOverlayTextColour(255, 0, 0);");
	code("trOverlayText(\"Choose a hero to begin - click them to find out more!\", 5.0);");
	code("trChatSend(0, \"<color=1,0,0>Delete old man for random pick</color>\");");
	
	defineTrigger("shopIntro2", false, false, false);
	con("(trTime()-cActivationTime) >= 2");
	code("generateShop();");
	code("trLetterBox(true);");
	characterDialog("Nottud", "Welcome to the shop - spend favour on unlocking new skills and improving your character.", "icons\special g minotaur icon 64");
	playMusic("xpack\xcinematics\2_in\music.mp3");
	code("int index = getShopIndex(trCurrentPlayer());");
	code("float shopPosX = toMetres(getShopX(index));");
	code("float shopPosZ = toMetres(getShopZ(index));");
	code("float rotation = 45.0;");
	code("createCameraTrack(12000);");
	code("cameraLookAt(xsVectorSet(shopPosX - toMetres(0.15), 50.0, shopPosZ - toMetres(0.15)), 70.0, rotation, 80.0);");
	code("addCameraTrackWaypoint();");
	code("cameraLookAt(xsVectorSet(shopPosX - toMetres(0.1), 30.0, shopPosZ - toMetres(0.1)), 50.0, rotation, 40.0);");
	code("addCameraTrackWaypoint();");
	code("cameraLookAt(xsVectorSet(shopPosX, 12.0, shopPosZ), 30.0, rotation, 20.0);");
	code("addCameraTrackWaypoint();");
	code("cameraLookAt(xsVectorSet(shopPosX - toMetres(0.15), 50.0, shopPosZ - toMetres(0.15)), 70.0, rotation, 80.0);");
	code("playCameraTrack();");
	
	defineTrigger("shopIntro7", false, false, false);
	con("(trTime()-cActivationTime) >= 7");
	characterDialog("Nottud", "Select an item to see what it does and the price, and move the old man to item to buy.", "icons\special g minotaur icon 64");
	
	defineTrigger("shopIntro12", false, false, false);
	con("(trTime()-cActivationTime) >= 12");
	characterDialog("Nottud", "Old man will disappear when all favour is spent, if you wish to save favour cast Nidhogg.", "icons\special g minotaur icon 64");
	
	defineTrigger("shopIntro17", false, false, false);
	con("(trTime()-cActivationTime) >= 17");
	code("trLetterBox(false);");
	code("createCameraTrack(1);");
	code("int index = getShopIndex(trCurrentPlayer());");
	code("float shopPosX = toMetres(getShopX(index));");
	code("float shopPosZ = toMetres(getShopZ(index));");
	code("cameraLookAt(xsVectorSet(shopPosX, 5.0, shopPosZ), 120, 45.0, 45.0);");
	code("addCameraTrackWaypoint();");
	code("addCameraTrackWaypoint();");
	code("playCameraTrack();");
	code("uiClearSelection();");
	code("trChatSendToPlayer(0, 1, \"Cast Carnivora for a 1 minute timeout if a player goes AFK.\");");
	
	defineTrigger("OldManTimeout", false, false, false);
	con("(trTime()-cActivationTime) >= 60");
	code("trUnitSelectClear();");
	code("trUnitSelect(\"0\");");
	code("for(p = 1; <= "+h+"){");
		code("trUnitChangeInArea(p, p, \"Old Man\", \"Fimbulwinter Sfx\", 999.0);");
	code("}");
	
	for(p = 1; <= h){
		defineTrigger("ReviveStart"+p, false, false, false);
		code("trOverlayTextColour("+playerColor(p, 1)+", "+playerColor(p, 2)+", "+playerColor(p, 3)+");");
		code("tempS = getPlayerName(getRevivedByPlayer("+p+"));");
		code("trOverlayText(tempS+\" has revived \"+getPlayerName("+p+")+\" for \"+getReviveTime("+p+")+\" seconds!\", 5.0);");
		code("trSoundPlayPaused(\"cinematics\15_in\gong.wav\",\"1\",-1,\"\",\"\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\""+p+"\");");
		code("trUnitChangeProtoUnit(\"Argus\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\""+p+"\");");
		code("trDamageUnitPercent(-100.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\""+p+"\");");
		code("trUnitChangeProtoUnit(heroUnit(getHeroIndex("+p+")));");
		code("dead = dead - 1;");
		code("setDead("+p+", false);");
		code("vector heroLoc = kbGetBlockPosition(\""+p+"\");");
		code("int gaia = deployLocUsingCineBlock(xsVectorGetX(heroLoc), xsVectorGetZ(heroLoc), \"Spy Eye\", "+p+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+gaia);");
		code("trMutateSelected("+getUnitIdFromName("Titan Gaia")+");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\"\"+gaia);");
		code("trSetSelectedScale(0.0, 1.0, 0.0);");
		code("trUnitOverrideAnimation(25, 0, true, false, -1, 0);");
		code("trUnitSetAnimationPath(\"2,0,0,0,0,0,0\");");
		code("trUnitSelectClear();");
		code("trUnitSelect(\""+p+"\");");
		code("trTechInvokeGodPower(0, \"Spy\");");
		code("trTechInvokeGodPower(0, \"Spy\");");
	}
	
	for(p = 1; <= h){
		defineTrigger("ReviveWarning30"+p, false, false, false);
		con("(trTime()-cActivationTime) >= getReviveTime("+p+") - 30");
		con("getDead("+p+") == false");
		code("trChatSendSpoofed("+p+", \"<color=0,1,0>30 seconds left</color>\");");
	}
	
	for(p = 1; <= h){
		defineTrigger("ReviveWarning20"+p, false, false, false);
		con("(trTime()-cActivationTime) >= getReviveTime("+p+") - 20");
		con("getDead("+p+") == false");
		code("trChatSendSpoofed("+p+", \"<color=1,1,0>20 seconds left</color>\");");
	}
	
	for(p = 1; <= h){
		defineTrigger("ReviveWarning10"+p, false, false, false);
		con("(trTime()-cActivationTime) >= getReviveTime("+p+") - 10");
		con("getDead("+p+") == false");
		code("trChatSendSpoofed("+p+", \"<color=1,0.6,0>10 seconds left</color>\");");
	}	
	
	for(p = 1; <= h){
		defineTrigger("ReviveWarning5"+p, false, false, false);
		con("(trTime()-cActivationTime) >= getReviveTime("+p+") - 5");
		con("getDead("+p+") == false");
		code("trChatSendSpoofed("+p+", \"<color=1,0.3,0>5 seconds left</color>\");");
	}
	
	for(p = 1; <= h){
		defineTrigger("ReviveEnd"+p, false, false, false);
		con("(trTime()-cActivationTime) >= getReviveTime("+p+")");
		con("getDead("+p+") == false");
		code("trOverlayTextColour("+playerColor(p, 1)+", "+playerColor(p, 2)+", "+playerColor(p, 3)+");");
		code("trOverlayText(\"\"+getPlayerName(getRevivedByPlayer("+p+"))+\"'s revival of \"+getPlayerName("+p+")+\" has ended!\", 5.0);");
		code("trUnitSelectClear();");
		code("trUnitSelect(\""+p+"\");");
		code("trDamageUnitPercent(100.0);");
		code("trChatSendSpoofed("+p+", \"<color=1,0,0>TIME UP</color>\");");
	}
	
	defineTrigger("CeaseFire", true, true, false);
	con("ceaseFireTime >= 0");
	con("(trTime()-cActivationTime) >= 1");
	code("if(ceaseFireTime == 0){");
		code("for(p = 1; <= "+h+"){");
			code("trPlayerSetDiplomacy("+c+", p, \"Enemy\");");
		code("}");
		databaseSearchStart("StopCombat");
		removeFromDatabase("StopCombat");
		code("trUnitDestroy();");
		databaseSearchEnd();
	code("}");
	code("ceaseFireTime = ceaseFireTime - 1;");
	
	defineTrigger("RelicHandling", true, true, false);
	con("time250");
	code("int owner = -1;");
	code("int diff = -1;");
	for(i = 0; < 5){
		if(i == 0)relicDatabaseName = "AttackRelic";
		if(i == 1)relicDatabaseName = "ProjectileRelic";
		if(i == 2)relicDatabaseName = "RangeRelic";
		if(i == 3)relicDatabaseName = "FavourRelic";
		if(i == 4)relicDatabaseName = "RechargeRelic";
		code("for(p = 1; <= "+h+"){");
			code("setRelicTypeCount(p, 0);");
		code("}");
		databaseSearchStart(relicDatabaseName);
		code("if(unitSelected(1*trQuestVarGet(\"ySearchUnit\"))){");
			code("uiClearSelection();");
			code("trMessageSetText(getRelicName("+i+"), 5000);");
		code("}");
		code("if(trUnitGetIsContained(\"Temple\")){");
			code("trUnitChangeProtoUnit(\"Bush\");");
			code("trMutateSelected("+getUnitIdFromName("Relic")+");");
			code("trImmediateUnitGarrison(\"\"+(1*trUnitPercentDamaged() + 1) / 3);");
		code("}");
		code("owner = getOwner(1*trQuestVarGet(\"ySearchUnit\"));");
		code("if(owner == 0){");
			code("trSetSelectedScale(1.0, 1.0, 1.0);");
			code("trDamageUnitPercent(-100.0);");
			code("trSetUnitOrientation(xsVectorSet(1.0,0.0,0.0), xsVectorSet(0.0,1.0,0.0), true);");
		code("} else {");
			code("trDamageUnitPercent(-100.0);");
			code("trDamageUnitPercent(3 * owner);");
			code("trSetSelectedScale(0.0, 1.0, 0.0);");
			code("setRelicTypeCount(owner, getRelicTypeCount(owner) + 1);");
		code("}");
		databaseSearchEnd();
		code("for(p = 1; <= "+h+"){");
			code("diff = (getRelicTypeCount(p) - get"+relicDatabaseName+"Count(p));");
			code("set"+relicDatabaseName+"Count(p, getRelicTypeCount(p));");
			code("if(diff != 0){");
				code("if(diff > 0){");
					code("if(roundActive){");
						code("trChatSendToPlayer(0, p, \"<color=0,1,0>Gained:</color> \" + diff + \"x \" + getRelicName("+i+"));");
						code("if(trCurrentPlayer() == p){");
							code("trSoundPlayPaused(\"researchcomplete.wav\",\"-1\",-1,\"\",\"\");");
						code("}");
					code("}");
				code("} else {");
					code("if(roundActive){");
						code("trChatSendToPlayer(0, p, \"<color=1,0,0>Lost:</color> \" + (0 - diff) + \"x \" + getRelicName("+i+"));");
						code("if(trCurrentPlayer() == p){");
							code("trSoundPlayPaused(\"foot.wav\",\"-1\",-1,\"\",\"\");");
						code("}");
					code("}");
					code("trUnitSelectClear();");
					code("trUnitSelect(\"\"+p);");
					code("trMutateSelected(kbGetUnitBaseTypeID(kbGetBlockID(\"\"+p)));");
				code("}");
				if(i == 0){
					code("applyAttack(p);");
				}
				if(i == 1){
					code("for(i = 0; < playerRangedUnitCount){");
						code("trModifyProtounit(allRangedUnitList(i), p, 13, 1.0 * diff);");
					code("}");
					code("trModifyProtounit(\"Archer Atlantean Hero\", p, 13, 3.0 * diff);");
					code("trModifyProtounit(\"Archer Atlantean\", p, 13, 3.0 * diff);");
				}
				if(i == 2){
					code("for(i = 0; < playerRangedUnitCount){");
						code("trModifyProtounit(allRangedUnitList(i), p, 2, 5.0 * diff);");
						code("trModifyProtounit(allRangedUnitList(i), p, 11, 5.0 * diff);");
					code("}");
				}
			code("}");
		code("}");
	}
	
	defineTrigger("SoloMessage", true, false, false);
	con("(trTime()-cActivationTime) >= 10");
	code("if(aiIsMultiplayer() == false){");
		code("trOverlayTextColour(0, 255, 255);");
		code("tempS = \"Solo Mode: Host with any number of No AI allies and click their hero or old men to switch to that player.\";");
		code("trOverlayText(tempS, 10.0);");
	code("}");
	
	defineTrigger("ChangePlayerOrDrawStats", true, true, false);
	code("int selectedPlayer = -1;");
	code("for(p = 1; <= "+h+"){");
		code("if(trCurrentPlayer() != p){");
			code("if(unitSelected(p, false) || unitSelected(getShopOffset(p), true)){");
				code("selectedPlayer = p;");
			code("}");
		code("}");
	code("}");
	code("if(selectedPlayer >= 1){");
		code("if(aiIsMultiplayer()){");
			code("statsPlayerOverride = selectedPlayer;");
			code("drawStats();");
		code("} else {");
			code("trPlayerSetActive(selectedPlayer);");
			code("drawStats();");
		code("}");
	code("} else {");
		code("if(statsPlayerOverride >= 1){");
			code("statsPlayerOverride = -1;");
			code("drawStats();");
		code("}");
	code("}");
	
	rmSetStatusText("",1.00);
}